(function( $ ) {
	'use strict';
	
    function AppointyAdmin() {
        var self = this;
        self.init();
    };
    AppointyAdmin.prototype = {
        /**
         *  Initialize
         */
        init: function() {
            var self = this;
			
			self.loadLocations();
        },
		
		toggleLoading: function( status = '' ) {
			if(status === 'show') {
				$('.ap-loading-area').show();
			} else if(status === 'hide') {
				$('.ap-loading-area').hide();	
			}
		},
		
		togglePanelLoading: function( status = '' ) {
			if(status === 'show') {
				$('.panel-loading-area').show();
			} else if(status === 'hide') {
				$('.panel-loading-area').hide();	
			}
		},
		
		resetForm: function( formid = '' ) {
			 if( formid != '' ) {
				 $('#'+formid).trigger('reset');
				 $('#'+formid+' select').val('');
			 }
		},
		
		renderValidationMessage: function( msg = '' ) {
			$('.appointy-error li').remove();
			$('.appointy-error').append('<li class="error">'+msg+'</li>').show();
			$(".sf-alert-box-wrap").show('slow');
			$('.sf-alert-box-wrap').animate({right: '0'} , 1000);
		},
		
		renderSuccessMessage: function( msg = '' ) {
			$('.sf-success-msg').html(msg).show();
			$(".sf-sucess-box").show('slow');
			$('.sf-sucess-box').animate({right: '0'} , 1000);
		},
		
		hideSuccessMessage: function() {
			$('body').on('click', '.sf-sucess-box', function() {
				jQuery(this).hide('slow');
			});
		},
		
		hideValidationMessage: function() {
			$('body').on('click', '.sf-alert-box-wrap', function() {
				jQuery(this).hide('slow');
			});
		},
		
		loadLocations: function() {
			var self = this;
			
			if ( $('select[name="state"]').length > 0 ) {
				$('body').on('change', '#addtag select[name="country"], #edittag select[name="country"]', function() {
					var $this = $(this);
					
					var country = jQuery(this).val();
					
					$.ajax({
						url: ajaxurl,
						type:'POST',
						dataType: 'json',
						beforeSend: self.toggleLoading('show'),
						data: "action=appointy_load_states_terms_ids&country="+country
					}).done(function(response) {
						self.toggleLoading('hide');
						if ( response.success ) {
							jQuery('select[name="state"]').html(response.data);
						}
					});
				});
			}
			
			
		}
    }
	
    $.AppointyAdmin = AppointyAdmin.prototype;
    
    $(document).ready(function() {
        // Initialize script
        new AppointyAdmin();
    });
// > page loader function by = custom.js ========================= //		
	function pageLoader() {
		jQuery('.ap-loading-area').fadeOut(1000);
	}	
/*--------------------------------------------------------------------------------------------
	Window Load START
---------------------------------------------------------------------------------------------*/
	jQuery(window).on('load', function () {
		
		//page loader function by = custom.js		
		pageLoader();
		
});
})( jQuery );
