(function( $ ) {
	'use strict';
	
	var savedServices = appointy_options.savedServices || {};
	//alert(JSON.stringify(savedServices, null, 4));
	// Listen for changes on the checkboxes
    $('input[name="appointy_room_extra_services[]"]').change(function() {
        // Get the selected checkbox ID (taxonomy term ID)
        var serviceId = $(this).val();

        // Define the input fields for price and max quantity
        var priceField = '<div class="service-options service-' + serviceId + '"><label>'+appointy_options.lable_price+':</label><input type="number" name="service_price[' + serviceId + ']" class="service-price" placeholder="'+appointy_options.enter_price+'" /><br>';
        var quantityField = '<label>'+appointy_options.label_max_quantity+':</label><input type="number" name="service_quantity[' + serviceId + ']" class="service-quantity" placeholder="'+appointy_options.enter_max_quantity+'" /><br></div>';

        if ($(this).is(':checked')) {
            // If the checkbox is checked, append the fields
            $(this).closest('li').append(priceField + quantityField);
        } else {
            // If the checkbox is unchecked, remove the fields
            $(this).closest('li').find('.service-' + serviceId).remove();
        }
    });

    // Load pre-existing values in edit mode
    $('input[name="appointy_room_extra_services[]"]:checked').each(function() {
        var serviceId = $(this).val();
		
		var price = savedServices[serviceId] ? savedServices[serviceId].service_price : '';
        var quantity = savedServices[serviceId] ? savedServices[serviceId].service_quantity : '';
		
        var priceField = '<div class="service-options service-' + serviceId + '"><label>'+appointy_options.lable_price+':</label><input type="number" name="service_price[' + serviceId + ']" class="service-price" placeholder="'+appointy_options.enter_price+'" value="' + price + '"/><br>';
        var quantityField = '<label>'+appointy_options.label_max_quantity+':</label><input type="number" name="service_quantity[' + serviceId + ']" class="service-quantity" placeholder="'+appointy_options.enter_max_quantity+'" value="' + quantity + '"/><br></div>';

        $(this).closest('li').append(priceField + quantityField);
    });
	
	$('form#post').submit(function(e) {
        var isValid = true;
		
        // Loop through all the price and quantity fields
        $('input[name^="service_price"], input[name^="service_quantity"]').each(function() {
            var fieldValue = $(this).val();
            
            // Check if the field value is a number
            if (isNaN(fieldValue) || fieldValue == '') {
                isValid = false;
                $(this).css('border', '1px solid red'); // Highlight invalid field
            } else {
                $(this).css('border', ''); // Remove any previous border
            }
        });

        // If any field is invalid, prevent form submission
        if (!isValid) {
            alert('Please ensure all price and quantity fields contain valid numbers.');
            e.preventDefault();
        }
    });
	
})( jQuery );