<?php

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://aonetheme.com/
 * @since      1.0.0
 *
 * @package    Appointy
 * @subpackage Appointy/admin/partials
 */
?>



<ul class="side-menu">
    <?php 
	$route_name = Appointy_Router_Helper::get_request_param('menu_item', Appointy_Router_Helper::generate_route_name('dashboard', 'index'));
	
    foreach( Appointy_Side_Menu_Helper::get_side_menu_items() as $menu_item ) {
        $sub_menu_html = '';
		
        $is_active = Appointy_Router_Helper::link_has_route($route_name, $menu_item['link']);
		
        if( isset($menu_item['children']) ) { 
            $sub_menu_html.= '<ul class="side-sub-menu">';
            foreach($menu_item['children'] as $child_menu_item){
                if(Appointy_Router_Helper::link_has_route($route_name, $child_menu_item['link'])){
                    $is_active = true;
                    $sub_item_active_class = 'sub-item-is-active';
                }else{
                    $sub_item_active_class = '';
                }
				
                $highlight_class = (isset($child_menu_item['show_notice']) && $child_menu_item['show_notice']) ? ' latepoint-show-notice ' : '';
                $sub_menu_html.= '<li class="'.$highlight_class.$sub_item_active_class.'"><a href="'.$child_menu_item['link'].'"><span>'.$child_menu_item['label'].'</span></a></li>';
            }
            $sub_menu_html.= '</ul>';
        }else{
            $sub_menu_html.= '<ul class="side-sub-menu only-menu-header">';
            $sub_menu_html.= '</ul>';
        }
        ?>
        <li class="<?php if(isset($menu_item['show_notice']) && $menu_item['show_notice']) echo ' latepoint-show-notice ' ;?><?php if(isset($menu_item['children'])) echo ' has-children'; ?><?php if($is_active) echo ' menu-item-is-active'; ?>">
            <a href="<?php echo $menu_item['link']; ?>">
                <i class="<?php echo $menu_item['icon']; ?>"></i>
                <span><?php echo $menu_item['label']; ?></span>
            </a>
            <?php echo $sub_menu_html; ?>
        </li>
    <?php } ?>
    <?php if( current_user_can( 'administrator' ) ){ ?>
        <li class="back-to-wp-item">
            <a href="<?php echo get_admin_url(); ?>"><i class="latepoint-icon latepoint-icon-wordpress"></i><span><?php _e('Back to WordPress', 'appointy'); ?></span></a>
        </li>
    <?php } ?>
</ul>
