<?php

/**

 * The plugin bootstrap file

 *

 * This file is read by WordPress to generate the plugin information in the plugin

 * admin area. This file also includes all of the dependencies used by the plugin,

 * registers the activation and deactivation functions, and defines a function

 * that starts the plugin.

 *

 * @link              https://aonetheme.com/

 * @since             1.0.0

 * @package           Appointy

 *

 * @wordpress-plugin

 * Plugin Name:       Appointy

 * Plugin URI:        https://aonetheme.com/appointy

 * Description:       Appointy is a powerful and user-friendly service booking plugin for WordPress. It's designed to help businesses to offer their services for booking with clients online.

 * Version:           1.2.0

 * Author:            Aone Team

 * Author URI:        https://aonetheme.com/

 * License:           GPL-2.0+

 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt

 * Text Domain:       appointy

 * Domain Path:       /languages

 */



// If this file is called directly, abort.

if ( ! defined( 'WPINC' ) ) {

	die;

}



/**

 * Currently plugin version.

 */

define( 'APPOINTY_VERSION', '2.0.0' );

define( 'APPOINTY_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );

define( 'APPOINTY_PLUGIN_URL', plugin_dir_url( __FILE__ ) );

define( 'APPOINTY_IMAGE_URL', APPOINTY_PLUGIN_URL.'assets/images/' );

define( 'APPOINTY_GCAL_REDIRECT_URI', add_query_arg( array( 'action' => 'googleoauth-callback' ), home_url() ) );



/**

 * The code that runs during plugin activation.

 * This action is documented in includes/class-appointy-activator.php

 */

function appointy_activate() {

	require_once plugin_dir_path( __FILE__ ) . 'includes/class-appointy-activator.php';

	Appointy_Activator::activate();

}



/**

 * The code that runs during plugin deactivation.

 * This action is documented in includes/class-appointy-deactivator.php

 */

function appointy_deactivate() {

	require_once plugin_dir_path( __FILE__ ) . 'includes/class-appointy-deactivator.php';

	Appointy_Deactivator::deactivate();

}



register_activation_hook( __FILE__, 'appointy_activate' );

register_deactivation_hook( __FILE__, 'appointy_deactivate' );



/**

 * The core plugin class that is used to define internationalization,

 * admin-specific hooks, and public-facing site hooks.

 */

require plugin_dir_path( __FILE__ ) . 'includes/class-appointy.php';



/**

 * Begins execution of the plugin.

 *

 * Since everything within the plugin is registered via hooks,

 * then kicking off the plugin from this point in the file does

 * not affect the page life cycle.

 *

 * @since    1.0.0

 */

function appointy_run() {



	$plugin = new Appointy();

	$plugin->run();



}

appointy_run();