(function ($) {
    "use strict";
	
    if (!$.appointyExtensions)
        $.appointyExtensions = {};
    
    function AppointyControl() {
        var self = this;
        self.init();
    };

    AppointyControl.prototype = {
        /**
         *  Initialize
         */
        init: function() {
            var self = this;
			
			self.showRating();
			
			self.miscFunctions();
			
        },
		
		showRating: function() {
			if( jQuery('.showrating').length > 0 ){
				$('.showrating').each(function(){
				var $this = $(this);
				var ratingNumber = $this.data('rating');
				var reviewId = $this.data('reviewid');

				$('#showrating-'+reviewId).jRate({
					rating: ratingNumber,
					readOnly: true,
					min: 0,
					max: 5,
					precision: 1,
					startColor: '#ff8a00',
					endColor: '#ff8a00',
					width: 20,
					height: 20,
					touch: true,
					backgroundColor: '#DFDFE0',
				});
				
			} );
			}
		},
		
		miscFunctions: function() {
			if( jQuery('.appointy-srh-outer').length > 0 ){
				var totalActiveFields = jQuery('.appointy-srh-outer').data('totalactivefields');
				
				if( parseInt(totalActiveFields, 10) > 4 ) {
					jQuery('.appointy-srh-outer').closest('section').addClass('search-outer-wrapper');	
				}
			}
			
			if( jQuery('.appointy-pass-wrap').length > 0 ){
				var pass1Row = $( '.appointy-pass-wrap' );
				var pass1 = $('#old_password');
				var toggleButton = pass1Row.find('.showhidepass');
				
				toggleButton.show().on( 'click', function () {
					var fieldId = $(this).data('fieldid');
					pass1 = $('#'+fieldId);
					
					if ( 'password' === pass1.attr( 'type' ) ) {
						pass1.attr( 'type', 'text' );
						$(this).find('i').removeClass('feather-eye').addClass('feather-eye-off');
					} else {
						pass1.attr( 'type', 'password' );
						$(this).find('i').removeClass('feather-eye-off').addClass('feather-eye');
					}
				});
			}
		},
		
    }

    $.AppointyControl = AppointyControl.prototype;
    
    $(document).ready(function() {
        // Initialize script
        new AppointyControl();

    });
    
})(jQuery);

