<?php 
class Appointy_Booking_Form_Helper {

	/**

     * Initialize the class

     *

     * @since     1.0.0

     */

    public function __construct() {

		add_action('wp_ajax_appointy_load_service_staff', array($this, 'load_service_staff'));

		add_action('wp_ajax_nopriv_appointy_load_service_staff', array($this, 'load_service_staff'));

		add_action('wp_ajax_appointy_load_booking_slots', array($this, 'load_booking_slots'));

		add_action('wp_ajax_nopriv_appointy_load_booking_slots', array($this, 'load_booking_slots'));

		add_action('wp_ajax_appointy_verify_coupon', array($this, 'verify_coupon'));

		add_action('wp_ajax_nopriv_appointy_verify_coupon', array($this, 'verify_coupon'));

		add_action('wp_ajax_appointy_verify_voucher', array($this, 'verify_voucher'));

		add_action('wp_ajax_nopriv_appointy_verify_voucher', array($this, 'verify_voucher'));

		add_action('wp_ajax_addto_free_booking', [ $this, 'save_nopayment_appointment' ] );

		add_action('wp_ajax_nopriv_addto_free_booking', [ $this, 'save_nopayment_appointment' ] );

		add_action('wp_ajax_appointy_get_service_details', array($this, 'get_service_details'));

		add_action('wp_ajax_nopriv_appointy_get_service_details', [ $this, 'get_service_details' ] );

		add_action('wp_ajax_appointy_load_hourly_service', array($this, 'load_hourly_service'));

		add_action('wp_ajax_nopriv_appointy_load_hourly_service', array($this, 'load_hourly_service'));

		add_action('wp_ajax_appointy_load_service_locations', array($this, 'load_service_locations'));

		add_action('wp_ajax_nopriv_appointy_load_service_locations', array($this, 'load_service_locations'));

		add_action('wp_ajax_appointy_get_repeat_appointment', array($this, 'get_repeat_appointment'));

		add_action('wp_ajax_nopriv_appointy_get_repeat_appointment', array($this, 'get_repeat_appointment'));

		add_action('wp_ajax_appointy_load_extra_services', array($this, 'load_extra_services'));

		add_action('wp_ajax_nopriv_appointy_load_extra_services', array($this, 'load_extra_services'));

		add_action('wp_ajax_appointy_load_blocked_dates', array($this, 'load_blocked_dates'));

		add_action('wp_ajax_nopriv_appointy_load_blocked_dates', array($this, 'load_blocked_dates'));

		add_action('wp_ajax_addto_free_hotel_booking', [ $this, 'save_nopayment_hotel_booking' ] );

		add_action('wp_ajax_nopriv_addto_free_hotel_booking', [ $this, 'save_nopayment_hotel_booking' ] );

    }

	

	/**

	 * Process verify voucher

	 *

	 * @return array

	 */

	public static function verify_voucher() {

	global $wpdb;

	

	$vouchernumber = Appointy_Router_Helper::get_request_data( $_POST, 'vouchernumber' );

	$voucherpin = Appointy_Router_Helper::get_request_data( $_POST, 'voucherpin' );

	$totalamount = Appointy_Router_Helper::get_request_data( $_POST, 'totalamount' );

	

	$row = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM `'.$wpdb->prefix.'postmeta` WHERE `meta_key` = "code" AND `meta_value` = %s',$vouchernumber));

	

	

	if(!empty($row)) {

		$postid = Appointy_Router_Helper::get_request_data( $row, 'post_id' );

		$pin = get_post_meta( $postid, 'pin', true );

		$expirydate = get_post_meta( $postid, 'expirydate', true );

		$voucheramount = get_post_meta( $postid, 'amount', true );

		$spentamount = get_post_meta( $postid, 'spent', true );

		

		$spentamount = ($spentamount != '') ? $spentamount : 0;

		

		$voucheramount = floatval($voucheramount) - floatval($spentamount);

		

		if(trim($pin) != trim($voucherpin)){

			$response = array('message' => esc_html__('Sorry, Voucher pin is not matched.','appointy'));

			wp_send_json_error($response);

			exit;

		}

		

		if(strtotime($expirydate) < time()){

			$response = array('message' => esc_html__('Sorry, Voucher code has expired.','appointy'));

			wp_send_json_error($response);

			exit;

		}

		

		if(floatval($voucheramount) <= 0){

			$response = array('message' => esc_html__('Voucher already used.','appointy'));

			wp_send_json_error($response);

			exit;

		}

		

		$voucheramount = floatval($voucheramount);

		$totalamount = floatval($totalamount);

		

		if($voucheramount >= $totalamount) {

			$voucherbalanceamount = $voucheramount - $totalamount;

			$aftervoucherapplied_totalamount = 0;

		} else {

			$aftervoucherapplied_totalamount = $totalamount - $voucheramount;

			$voucherbalanceamount = 0;

		}

		

		$response = array(

						'voucherapplied'   => 'yes',

						'voucheramount'   => $voucheramount,

						'vouchernumber'      => $vouchernumber,

						'message' => esc_html__('Voucher applied successfully.', 'appointy'),

					);

		wp_send_json_success($response);

		

		exit;

	} else {

		$response = array(

						'message' => esc_html__('Voucher you\'ve used is incorrect', 'appointy'),

					);

		wp_send_json_error($response);

	}

	}

	

	/**

	 * Process verify coupon

	 *

	 * @return array

	 */

	public static function verify_coupon() {

		global $wpdb;

		

		$couponcode = Appointy_Router_Helper::get_request_data( $_POST, 'couponcode' );

		$couponcode_for = Appointy_Router_Helper::get_request_data( $_POST, 'couponcode_for' );

		$couponserviceid = Appointy_Router_Helper::get_request_data( $_POST, 'couponserviceid' );

		$serviceprice = Appointy_Router_Helper::get_request_data( $_POST, 'couponserviceprice' );

		$booking_date = date('Y-m-d');

		$booking_date = date("Y-m-d H:i:s", strtotime($booking_date.' 00:00:01'));

		$booking_day = date('l',strtotime($booking_date));

		$booking_day = strtolower($booking_day);

		

		if($couponcode_for === 'booking') {

			$row = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM `'.$wpdb->prefix.'postmeta` WHERE `meta_key` = "coupon_code" AND `meta_value` = %s',$couponcode));

		} elseif($couponcode_for === 'eachservice') {

			$couponcode_available = self::has_couponcode_available_for_service($couponserviceid,$couponcode);

			

			if($couponcode_available === true) {

				$row = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM `'.$wpdb->prefix.'postmeta` WHERE `meta_key` = "coupon_code" AND `meta_value` = %s',$couponcode));

			} else {

				$row = [];

			}

		}

		

		if(!empty($row)) {

			$post_id = Appointy_Router_Helper::get_request_data( $row, 'post_id' );

			

			$discountvalue = get_post_meta( $post_id, 'discount', true );

			$discounttype = get_post_meta( $post_id, 'discount_type', true );

			$applies_date_from = get_post_meta( $post_id, 'applies_date_from', true );

			$applies_date_to = get_post_meta( $post_id, 'applies_date_to', true );

			$maxusage = get_post_meta( $post_id, 'maxusage', true );

			$services = get_post_meta( $post_id, 'services', true );

			

			if($maxusage > 0) {

				$servicerow = $wpdb->get_row($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_booked_services` WHERE `couponcode` = %s',$couponcode));	

				

				if(!empty($servicerow)) {

					$totaluses = count($servicerow);

					

					if($maxusage <= $totaluses) {

						$response = esc_html__('Sorry, you are late, this coupon code was redeemed by the maximum number of users defined.','appointy');

						wp_send_json_error($response);

						exit;

					}

				}

			}

			

			if(strtotime($applies_date_from) >= strtotime($booking_date)) {

				$response = sprintf(esc_html__('Coupon code can be used after %s','appointy'),Appointy_Misc_Helper::get_date_format($applies_date_from));

				wp_send_json_error($response);

				exit;

			}

			

			if(strtotime($applies_date_to) < strtotime($booking_date)) {

				$response = esc_html__('Coupon code has been expired','appointy');

				wp_send_json_error($response);

				exit;

			}

			

			$discountedprice = floatval($serviceprice);

			if($discounttype === 'fixed') {

				$discountedprice = floatval($serviceprice) - floatval($discountvalue);

			} elseif($discounttype === 'percent') {

				$discountamount = (floatval($discountvalue)/100 ) * floatval($serviceprice);

				$discountedprice = floatval($serviceprice) - floatval($discountamount);

			}

			

			$message = esc_html__('Congratulations! The coupon code you used is applied successfully.','appointy');

			 

			$response = array(

								'oldprice'   => $serviceprice,

								'discountedprice'   => $discountedprice,

								'message'      => $message,

								'couponcode'   => $couponcode,

								'discounttype'   => $discounttype,

								'discountvalue'   => $discountvalue,

							);

			wp_send_json_success($response);

		}else

		{

			$response = esc_html__('Coupon code you\'ve used is incorrect','appointy');

			

			wp_send_json_error($response);

		}

		exit;

	}

	

	/**

	 * Process save appointment

	 *

	 * @return array

	 */

	public static function save_appointment($woopostdata = array(),$order_id = 0,$item_id = 0) {

		global $wpdb, $current_user;

		$order = new \WC_Order( $order_id );

				

		$payment_method = $order->get_payment_method();

		$order_status = $order->get_status();

	

		if ( $woopostdata && ! isset ( $woopostdata['processed'] ) ) {

			

			if($order_status === 'on-hold'){

				$status = 'on-hold';

				$booking_amount_status = 'unpaid';

			}elseif($order_status === 'completed' || $order_status === 'processing'){

				$status = 'processing';

				$booking_amount_status = 'paid';

			}

			

			$existingbooking = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM '.$wpdb->prefix.'postmeta WHERE `meta_key` = "order_id" AND `meta_value` = %s',$order_id));

			if(!empty($existingbooking)) {

				$appointment_id = Appointy_Router_Helper::get_request_data( $existingbooking, 'post_id' );

				

				$booking_post = array(

					'ID'           => $appointment_id,

					'post_status'  => $status,

				);

				wp_update_post( $booking_post );

				

				update_post_meta($appointment_id,'booking_amount_status',$booking_amount_status);

				

				$update_booked_services['booking_amount_status']	= $booking_amount_status;

					

				$where = array(

					'appointment_id' => $appointment_id

				);

				$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($update_booked_services),$where);

				return;

			}

			

			$totalamount = 0;

			$booked_services = ( !empty( $woopostdata['booked_services'] ) ) ? (array) $woopostdata['booked_services'] : array();

			//echo '<pre>';print_r($booked_services);echo '</pre>';

			$updated_services = array();

			

			if( !empty( $booked_services ) ) {

				foreach( $booked_services as $key => $value ) {

					if( !empty( $value ) ) {

						$updated_services[$key] = $value;

						

						if( !empty( $value['selected_multiple_dates'] ) ) {

							$selected_number_of_multiple_dates = count($value['selected_multiple_dates']);

							$totalamount += (floatval(sanitize_text_field($value['service_price'])) * intval($selected_number_of_multiple_dates));

						}else{

							$totalamount += floatval(sanitize_text_field($value['service_price']));

						}

						

						if( !empty( $value['selected_extra_services'] ) ) {

							foreach( $value['selected_extra_services'] as $selected_extra_service ) {

								$extra_service_price = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_price');

								$extra_service_quantity = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_quantity');
	
								$totalamount += floatval($extra_service_price) * floatval($extra_service_quantity);

							}

						}

					}

				}

			}

			

			if( !empty( $booked_services['selected_extra_services'] ) ) {

				foreach( $booked_services['selected_extra_services'] as $selected_extra_service ) {

					$extra_service_price = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_price');

					$extra_service_quantity = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_quantity');

					$totalamount += floatval($extra_service_price) * floatval($extra_service_quantity);

				}

			}

			

			$booking_coupon_code = Appointy_Router_Helper::get_sanitize_data($woopostdata,'booking_coupon_code');

			$booking_coupon_discounted_price = Appointy_Router_Helper::get_sanitize_data($woopostdata,'booking_coupon_discounted_price',0);

			$booking_coupon_applied = Appointy_Router_Helper::get_sanitize_data($woopostdata,'booking_coupon_applied','no');

			$couponcode_for = Appointy_Router_Helper::get_sanitize_data($woopostdata,'couponcode_for');

			$serviceperformat = Appointy_Router_Helper::get_sanitize_data($woopostdata,'serviceperformat');

			$address = Appointy_Router_Helper::get_sanitize_data($woopostdata,'address');

			$description = Appointy_Router_Helper::get_sanitize_data($woopostdata,'description');

			

			

			$taxdata = ( !empty( $woopostdata['taxdata'] ) ) ? (array) $woopostdata['taxdata'] : array();

			

			$voucheramount = Appointy_Router_Helper::get_sanitize_data($woopostdata,'voucheramount');

			$voucher_applied = Appointy_Router_Helper::get_sanitize_data($woopostdata,'voucher_applied');

			$vouchernumber = Appointy_Router_Helper::get_sanitize_data($woopostdata,'vouchernumber');

			$voucheramountused = Appointy_Router_Helper::get_sanitize_data($woopostdata,'voucheramountused');

			

			$deposit_options = Appointy_Router_Helper::get_sanitize_data($woopostdata,'deposit_options');

			$deposit_type = Appointy_Router_Helper::get_sanitize_data($woopostdata,'deposit_type');

			$deposit_amount = Appointy_Router_Helper::get_sanitize_data($woopostdata,'deposit_amount');

			$due_amount = Appointy_Router_Helper::get_sanitize_data($woopostdata,'due_amount');

			

			$discountamount = 0;

			

			if($couponcode_for === 'booking') {

				if($booking_coupon_applied === 'yes') {

					$discountamount = floatval($totalamount) - floatval($booking_coupon_discounted_price);

					$totalamount = $booking_coupon_discounted_price;

				}

			}

			

			$meta_fields['description'] = $description;

			$meta_fields['serviceperformat'] = $serviceperformat;

			$meta_fields['address'] = $address;

			$meta_fields['taxdata'] = $taxdata;

			$meta_fields['couponcode'] = $booking_coupon_applied;

			$meta_fields['couponcode_for'] = $couponcode_for;

			$meta_fields['discountamount'] = $discountamount;

			

			if($deposit_options === 'deposit_only') {

			$meta_fields['deposit_options'] = $deposit_options;

			$meta_fields['deposit_type'] = $deposit_type;

			$meta_fields['deposit_amount'] = $deposit_amount;

			$meta_fields['due_amount'] = $due_amount;

			$meta_fields['deposit_payment_status'] = 'deposit_only';

			}

			

			if(!empty($woopostdata['booking_attachments'])) {

				$meta_fields['booking_attachments'] = $woopostdata['booking_attachments'];

			}

			

			if($voucher_applied === 'yes') {

			

				$meta_fields['voucher_applied'] = 'yes';

				$meta_fields['vouchernumber'] = $vouchernumber;

				$meta_fields['voucheramount'] = $voucheramount;

				$meta_fields['voucheramountused'] = $voucheramountused;

				

				$voucherrow = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM `'.$wpdb->prefix.'postmeta` WHERE `meta_key` = "code" AND `meta_value` = %s',$vouchernumber));

				if(!empty($voucherrow)) {

					$postid = Appointy_Router_Helper::get_sanitize_data( $voucherrow, 'post_id' );

					$totalspent = get_post_meta($postid,'spent',true);

					$totalspent = ($totalspent != '' ) ? floatval($totalspent) : 0;

					

					$totalspent = floatval($totalspent) + floatval($voucheramountused);

					update_post_meta($postid,'spent',$totalspent);

				}

			}

			

			$meta_fields['appointment_ref_id'] = self::get_appointment_ref_id();

			$meta_fields['booked_services'] = $updated_services;

			$meta_fields['totalamount'] = $totalamount;

			$meta_fields['order_id'] = $order_id;

			$meta_fields['payment_type'] = 'woocommerce';

			$meta_fields['payment_method'] = $payment_method;

			$meta_fields['booking_amount_status']	= $booking_amount_status;

			$meta_fields['bookingtype'] = 'booking';
			

			$email = Appointy_Router_Helper::get_request_data($woopostdata,'email');

			$email = sanitize_email($email);

			

			

			if(is_user_logged_in()) {

				$meta_fields['booking_customer_id'] = $current_user->ID;

			}else{

				if(email_exists($email)){

					$existing_user = get_user_by( 'email', $email );

					if(!empty($existing_user)){

						$meta_fields['booking_customer_id'] = $existing_user->ID;

					}

				} else {

					$user_id = self::create_new_user($woopostdata);

					$meta_fields['booking_customer_id'] = $user_id;

				}

			}

			

			$customer_fields = self::appointment_form_fields();

                        

			if( !empty($customer_fields) ) {

				foreach( $customer_fields as $key => $field ) {

					$meta_fields[$key] = $woopostdata[$key];

				}

			}

			$booking_post = array(

				'post_title' => 'Booking',

				'post_status' => $status,

				'post_type' => 'appointy_appointment',

				'post_author' => 1,

				'meta_input'   => $meta_fields

			);

			$appointment_id = wp_insert_post( $booking_post );

			

			$k = 0;

			

			if( !empty( $updated_services ) ) {

				foreach( $updated_services as $service ) {

					if( !empty( $service ) ){

						$booking_start_time = Appointy_Router_Helper::get_sanitize_data($service,'booking_start_time');

						$service_period = Appointy_Router_Helper::get_sanitize_data($service,'service_period');
						
						$service_period = ($service_period != '') ? $service_period : 0;
					
						$minutesToAdd = $service_period;
						
						$dateTime = new DateTime($booking_start_time);
						
						$dateTime->modify("+{$minutesToAdd} minutes");
						
						$booking_end_time = $dateTime->format('H:i:s');
						
						$buffer_time = Appointy_Misc_Helper::get_settings( 'booking_settings', 'buffer_time' );
						
						if($buffer_time != '') {
							$minutesToAdd = intval($service_period) + intval($buffer_time);	
							
							$dateTime = new DateTime($booking_start_time);
						
							$dateTime->modify("+{$minutesToAdd} minutes");
							
							$booking_end_time_with_buffer = $dateTime->format('H:i:s');
						}else{
							$booking_end_time_with_buffer = $booking_end_time;
						}
						//$booking_end_time = Appointy_Router_Helper::get_sanitize_data($service,'booking_end_time');

						$service_id = Appointy_Router_Helper::get_sanitize_data($service,'service_id');

						$booking_date = Appointy_Router_Helper::get_sanitize_data($service,'booking_date');

						$member_id = Appointy_Router_Helper::get_sanitize_data($service,'member_id');

						$locationid = Appointy_Router_Helper::get_sanitize_data($service,'locationid');

						

						$service_price = Appointy_Router_Helper::get_request_data($service,'service_price',0);

						

						if(!empty($service['selected_multiple_dates'])) {

							$selected_multiple_dates = $service['selected_multiple_dates'];

							

							foreach($selected_multiple_dates as $selected_multiple_date){

								$multiple_dates['appointment_id'] 	= $appointment_id;

								$multiple_dates['service_id'] 		= $service_id;

								$multiple_dates['date'] 			= $selected_multiple_date;

								$multiple_dates['time'] 			= $booking_start_time;

								

								$wpdb->insert($wpdb->prefix.'appointy_multiple_dates',wp_unslash($multiple_dates));

								

								$bookingdata['appointment_id'] 		= $appointment_id;

								$bookingdata['service_id'] 		= $service_id;

								

								$bookingdata['type'] 			= 'booking';

								$bookingdata['date'] 			= $selected_multiple_date;

								

								if(Appointy_Router_Helper::get_sanitize_data($service,'fullday_timeslots') === 'full_day'){

								$bookingdata['dayoff_type'] 	= 'fullday';	

								}else{

								$bookingdata['start_time'] 		= $booking_start_time;

								$bookingdata['end_time'] 		= $booking_end_time_with_buffer;

								$bookingdata['dayoff_type'] 	= 'timeslot';

								}

								

								if($member_id > 0) {

								$bookingdata['member_id'] 		= $member_id;

								}

								if($locationid > 0) {

								$bookingdata['branch_id'] 		= $locationid;

								}

								

								$wpdb->insert($wpdb->prefix.'appointy_blocked_schedule',wp_unslash($bookingdata));

							}

						}else{

							$bookingdata['appointment_id'] 		= $appointment_id;

							$bookingdata['service_id'] 		= $service_id;

							$bookingdata['dayoff_type'] 	= 'timeslot';

							$bookingdata['type'] 			= 'booking';

							$bookingdata['date'] 			= $booking_date;

							$bookingdata['start_time'] 		= $booking_start_time;

							$bookingdata['end_time'] 		= $booking_end_time_with_buffer;

							if($member_id > 0) {

							$bookingdata['member_id'] 		= $member_id;

							}

							if($locationid > 0) {

							$bookingdata['branch_id'] 		= $locationid;

							}

							

							$wpdb->insert($wpdb->prefix.'appointy_blocked_schedule',wp_unslash($bookingdata));

						}

						

						$total_extra_service_amount = 0;

						if(!empty($service['selected_extra_services'])) {

							$selected_extra_services = $service['selected_extra_services'];

							

							foreach($selected_extra_services as $selected_extra_service){

								$extra_service_price = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_price');

								$extra_service_quantity = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_quantity');
	
								$total_extra_service_amount = floatval($total_extra_service_amount) + (floatval($extra_service_price) * floatval($extra_service_quantity));

								

								$extra_service['appointment_id'] 		= $appointment_id;

								$extra_service['service_id'] 			= $service_id;

								$extra_service['extra_service_id'] 		= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'extra_post_id');

								$extra_service['extra_service_name'] 	= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_name');

								$extra_service['extra_service_unit_price'] 	= $extra_service_price;
	
								$extra_service['extra_service_quantity'] 	= $extra_service_quantity;
	
								$extra_service['extra_service_price'] 	= floatval($extra_service_price) * floatval($extra_service_quantity);

								$extra_service['hours'] 				= intval(Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'hours'));

								$extra_service['minutes'] 				= intval(Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'minutes'));

								$extra_service['display_service_period']= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'display_service_period');

								$extra_service['service_period'] 		= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_period');

								

								$wpdb->insert($wpdb->prefix.'appointy_extra_services',wp_unslash($extra_service));

							}

						}

						

						$active_repeat_service_id = 0;

						if(Appointy_Router_Helper::get_sanitize_data($service,'repeat_appointments') === 'yes') {

							$service_taxamount = Appointy_Appointments_Helper::get_service_price_tax($appointment_id,$service_price);

							

							$total_service_amount = floatval($service_taxamount) + floatval($service_price) + floatval($total_extra_service_amount);

							

							$active_repeat_schedule['appointment_id'] 		= $appointment_id;

							$active_repeat_schedule['service_id'] 			= $service_id;

							$active_repeat_schedule['frequency'] 			= Appointy_Router_Helper::get_sanitize_data($service,'frequency');

							$active_repeat_schedule['selected_weekday'] 	= intval(Appointy_Router_Helper::get_sanitize_data($service,'selected_weekday',0));

							$active_repeat_schedule['day_of_month'] 		= intval(Appointy_Router_Helper::get_sanitize_data($service,'day_of_month'));

							$active_repeat_schedule['num_times'] 			= intval(Appointy_Router_Helper::get_sanitize_data($service,'num_times'));

							$active_repeat_schedule['date'] 				= $booking_date;

							$active_repeat_schedule['start_time'] 			= $booking_start_time;

							$active_repeat_schedule['end_time'] 			= $booking_end_time;

							$active_repeat_schedule['status'] 				= 'active';

							$active_repeat_schedule['payment_status'] 		= 'default';

							$active_repeat_schedule['service_price'] 		= $service_price;

							$active_repeat_schedule['extra_service_total'] 	= $total_extra_service_amount;

							$active_repeat_schedule['tax_amount'] 			= $service_taxamount;

							$active_repeat_schedule['total_amount'] 		= $total_service_amount;

							

							

							$wpdb->insert($wpdb->prefix.'appointy_repeat_schedule',wp_unslash($active_repeat_schedule));

							$active_repeat_service_id = $wpdb->insert_id;

						

							if(!empty($service['schedule_dates'])) {

								foreach($service['schedule_dates'] as $schedule_date){

									$repeat_schedule['appointment_id'] 		= $appointment_id;

									$repeat_schedule['service_id'] 			= $service_id;

									$repeat_schedule['frequency'] 			= Appointy_Router_Helper::get_sanitize_data($service,'frequency');

									$repeat_schedule['selected_weekday'] 	= intval(Appointy_Router_Helper::get_sanitize_data($service,'selected_weekday',0));

									$repeat_schedule['day_of_month'] 		= intval(Appointy_Router_Helper::get_sanitize_data($service,'day_of_month'));

									$repeat_schedule['num_times'] 			= intval(Appointy_Router_Helper::get_sanitize_data($service,'num_times'));

									$repeat_schedule['date'] 				= wp_date('Y-m-d', strtotime($schedule_date));

									$repeat_schedule['start_time'] 			= $booking_start_time;

									$repeat_schedule['end_time'] 			= $booking_end_time;

									$repeat_schedule['status'] 				= 'upcoming';

									$repeat_schedule['payment_status'] 		= 'pending';

									$repeat_schedule['service_price'] 		= $service_price;

									$repeat_schedule['extra_service_total'] = $total_extra_service_amount;

									$repeat_schedule['tax_amount'] 			= $service_taxamount;

									$repeat_schedule['total_amount'] 		= $total_service_amount;

									

									$wpdb->insert($wpdb->prefix.'appointy_repeat_schedule',wp_unslash($repeat_schedule));

									$repeat_service_id = $wpdb->insert_id;

									

									/*Block schedule for repeat schedules*/

									$block_repeat_schedule['appointment_id'] 		= $appointment_id;

									$block_repeat_schedule['service_id'] 		= $service_id;

									$block_repeat_schedule['dayoff_type'] 	= 'timeslot';

									$block_repeat_schedule['type'] 			= 'booking';

									$block_repeat_schedule['date'] 			= wp_date('Y-m-d', strtotime($schedule_date));

									$block_repeat_schedule['start_time'] 	= $booking_start_time;

									$block_repeat_schedule['end_time'] 		= $booking_end_time;

									if($member_id > 0) {

									$block_repeat_schedule['member_id'] 		= $member_id;

									}

									if($locationid > 0) {

									$block_repeat_schedule['branch_id'] 		= $locationid;

									}

									

									$block_repeat_schedule['repeat_service_id'] = $repeat_service_id;

									

									$wpdb->insert($wpdb->prefix.'appointy_blocked_schedule',wp_unslash($block_repeat_schedule));

								}

							}

						}

						

						/*booked services save to db*/

						

						$booked_services = array();

						$booked_services['date'] 		= date('Y-m-d H:i:s');

						$booked_services['appointment_id'] 	= $appointment_id;

						$booked_services['has_repeat'] 		= (Appointy_Router_Helper::get_sanitize_data($service,'repeat_appointments') === 'yes') ? 'yes' : 'no';

						$booked_services['repeat_service_id'] = $active_repeat_service_id;

						$booked_services['repeat_service_payment'] = 'default';

						$booked_services['service_id'] 	= $service_id;

						$booked_services['service_name']	=  Appointy_Router_Helper::get_sanitize_data($service,'service_name');

						$booked_services['servicetype'] 	=  Appointy_Router_Helper::get_sanitize_data($service,'servicetype');

						$booked_services['service_period'] 	=  Appointy_Router_Helper::get_sanitize_data($service,'service_period');

						$booked_services['variation_name'] 	=  Appointy_Router_Helper::get_sanitize_data($service,'variation_name');

						$booked_services['hours'] 			=  Appointy_Router_Helper::get_sanitize_data($service,'hours');

						$booked_services['minutes'] 		=  Appointy_Router_Helper::get_sanitize_data($service,'minutes');

						$booked_services['display_service_period'] 	= Appointy_Router_Helper::get_sanitize_data($service,'display_service_period');

						$booked_services['show_branches'] 			= Appointy_Router_Helper::get_sanitize_data($service,'show_branches');

						$booked_services['members_available'] 		= Appointy_Router_Helper::get_sanitize_data($service,'members_available');

						$booked_services['branch_id'] 		= Appointy_Router_Helper::get_sanitize_data($service,'locationid');

						$booked_services['member_id'] 		= Appointy_Router_Helper::get_sanitize_data($service,'member_id');

						$booked_services['booking_date'] 	= Appointy_Router_Helper::get_sanitize_data($service,'booking_date');

						$booked_services['booking_start_time'] 	= Appointy_Router_Helper::get_sanitize_data($service,'booking_start_time');

						$booked_services['booking_end_time']	= $booking_end_time;

						$booked_services['parent_category']	= Appointy_Router_Helper::get_sanitize_data($service,'parent_category');

						$booked_services['service_status']	= 'pending';

						$booked_services['service_price']	= $service_price;

						$booked_services['booking_amount_status']	= $booking_amount_status;

						$booked_services['customeremail']	= Appointy_Router_Helper::get_sanitize_email($woopostdata,'email');

						$booked_services['customerid']		= (is_user_logged_in()) ? $current_user->ID : 0;

						$booked_services['oldserviceprice']	= Appointy_Router_Helper::get_sanitize_data($service,'old_service_price');

						

						if($couponcode_for === 'booking' && $k === 0) {

							if($booking_coupon_applied === true) {

								$totalamount = $booking_coupon_discounted_price;

								$booked_services['couponcode']		= $booking_coupon_code;

							}

							

						} else {

							$booked_services['couponcode']		= $booking_coupon_code;

						}

						

						$wpdb->insert($wpdb->prefix.'appointy_booked_services',wp_unslash($booked_services));

						$appointment_service_id = $wpdb->insert_id;

						if( is_plugin_active( 'video-conferencing-with-zoom-api/video-conferencing-with-zoom-api.php' ) ) {

							Appointy_Zoom_Helper::create_zoom_link($appointment_id,$appointment_service_id,$booked_services);

						}

						

						if (PHP_VERSION_ID >= 80100) {

						if($member_id > 0) {

						Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$member_id,$booked_services);

						}

						

						

						$user_roles = Appointy_Misc_Helper::get_user_roles($current_user->ID);

						if(in_array('appointy_customer',$user_roles)) {

							Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$current_user->ID,$booked_services);

						}

						

						$gcal_admin_id = Appointy_Misc_Helper::get_gcal_admin_id();

						if( $gcal_admin_id > 0 ) {

							Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$gcal_admin_id,$booked_services);

						}

						}

						

						$arg = array(

							'current_date'	=> ( !empty($service['booking_date']) ) ? $service['booking_date'] : '',

							'user_id'	=> $user_id,

							'member_id'	=> ( !empty($service['member_id']) ) ? $service['member_id'] : '',

							'branch_id'	=> ( !empty($service['locationid']) ) ? $service['locationid'] : '',

							'service_id'	=> ( !empty($service['service_id']) ) ? $service['service_id'] : '',

							'service_period'	=> ( !empty($service['service_period']) ) ? $service['service_period'] : ''

						);

						

						$k++;

					}

				}

			}

			

			Appointy_Send_Email_Notification_Helper::send_new_appointment_email_notifications($appointment_id);

			

			} else {

			

			$existingbooking = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM '.$wpdb->prefix.'postmeta WHERE `meta_key` = "order_id" AND `meta_value` = %s',$order_id));		

			

			if(!empty($existingbooking) && ($order_status === 'completed' || $order_status === 'processing') && $woopostdata && ! isset ( $woopostdata['completed'] ) && ! isset ( $woopostdata['cancelled'] )) {

				

				$appointment_id = Appointy_Router_Helper::get_sanitize_data( $existingbooking, 'post_id' );

				

				$status = 'processing';

				

				$booking_post = array(

					'ID'           => $appointment_id,

					'post_status'  => $status

				);

				wp_update_post( $booking_post );

				

				update_post_meta($appointment_id,'booking_amount_status','paid');

				

				$booked_services['booking_amount_status']	= 'paid';

				

				$where = array(

					'appointment_id' => $appointment_id

				);

				

				$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($booked_services),$where);

			}	

		}

		

	}

	

	/**

	 * Process save appointment

	 *

	 * @return array

	 */

	public static function save_hotel_booking($woopostdata = array(),$order_id = 0,$item_id = 0) {

		global $wpdb, $current_user;

		$order = new \WC_Order( $order_id );

				

		$payment_method = $order->get_payment_method();

		$order_status = $order->get_status();

	

		if ( $woopostdata && ! isset ( $woopostdata['processed'] ) ) {

			

			if($order_status === 'on-hold'){

				$status = 'on-hold';

				$booking_amount_status = 'unpaid';

			}elseif($order_status === 'completed' || $order_status === 'processing'){

				$status = 'processing';

				$booking_amount_status = 'paid';

			}

			

			$existingbooking = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM '.$wpdb->prefix.'postmeta WHERE `meta_key` = "order_id" AND `meta_value` = %s',$order_id));

			if(!empty($existingbooking)) {

				$appointment_id = Appointy_Router_Helper::get_request_data( $existingbooking, 'post_id' );

				

				$booking_post = array(

					'ID'           => $appointment_id,

					'post_status'  => $status,

				);

				wp_update_post( $booking_post );

				

				update_post_meta($appointment_id,'booking_amount_status',$booking_amount_status);

				

				$update_booked_services['booking_amount_status']	= $booking_amount_status;

					

				$where = array(

					'appointment_id' => $appointment_id

				);

				$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($update_booked_services),$where);

				return;

			}

			

			$totalamount = 0;

			$booked_services = ( !empty( $woopostdata['booked_services'] ) ) ? (array) $woopostdata['booked_services'] : array();

			//echo '<pre>';print_r($booked_services);echo '</pre>';exit;

			$updated_services = array();

			

			if( !empty( $booked_services ) ) {

				foreach( $booked_services as $key => $value ) {

					if( !empty( $value ) ) {

						$updated_services[$key] = $value;

						

						if( !empty( $value['selected_multiple_dates'] ) ) {

							$selected_number_of_multiple_dates = count($value['selected_multiple_dates']);

							$totalamount += (floatval(sanitize_text_field($value['service_price'])) * intval($selected_number_of_multiple_dates));

						}else{

							$totalamount += floatval(sanitize_text_field($value['service_price']));

						}

						

						if( !empty( $value['selected_extra_services'] ) ) {

							foreach( $value['selected_extra_services'] as $selected_extra_service ) {

								$extra_service_price = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_price');

								$extra_service_quantity = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_quantity');

								$totalamount += floatval($extra_service_price) * floatval($extra_service_quantity);

							}

						}

					}

				}

			}

			

			if( !empty( $booked_services['selected_extra_services'] ) ) {

				foreach( $booked_services['selected_extra_services'] as $selected_extra_service ) {

					$extra_service_price = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_price');

					$extra_service_quantity = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_quantity');

					$totalamount += floatval($extra_service_price) * floatval($extra_service_quantity);

				}

			}

			

			$booking_coupon_code = Appointy_Router_Helper::get_sanitize_data($woopostdata,'booking_coupon_code');

			$booking_coupon_discounted_price = Appointy_Router_Helper::get_sanitize_data($woopostdata,'booking_coupon_discounted_price',0);

			$booking_coupon_applied = Appointy_Router_Helper::get_sanitize_data($woopostdata,'booking_coupon_applied','no');

			$couponcode_for = Appointy_Router_Helper::get_sanitize_data($woopostdata,'couponcode_for');

			$address = Appointy_Router_Helper::get_sanitize_data($woopostdata,'address');

			$description = Appointy_Router_Helper::get_sanitize_data($woopostdata,'description');

			

			

			$taxdata = ( !empty( $woopostdata['taxdata'] ) ) ? (array) $woopostdata['taxdata'] : array();

			

			$voucheramount = Appointy_Router_Helper::get_sanitize_data($woopostdata,'voucheramount');

			$voucher_applied = Appointy_Router_Helper::get_sanitize_data($woopostdata,'voucher_applied');

			$vouchernumber = Appointy_Router_Helper::get_sanitize_data($woopostdata,'vouchernumber');

			$voucheramountused = Appointy_Router_Helper::get_sanitize_data($woopostdata,'voucheramountused');

			

			$deposit_options = Appointy_Router_Helper::get_sanitize_data($woopostdata,'deposit_options');

			$deposit_type = Appointy_Router_Helper::get_sanitize_data($woopostdata,'deposit_type');

			$deposit_amount = Appointy_Router_Helper::get_sanitize_data($woopostdata,'deposit_amount');

			$due_amount = Appointy_Router_Helper::get_sanitize_data($woopostdata,'due_amount');

			

			$discountamount = 0;

			

			if($couponcode_for === 'booking') {

				if($booking_coupon_applied === 'yes') {

					$discountamount = floatval($totalamount) - floatval($booking_coupon_discounted_price);

					$totalamount = $booking_coupon_discounted_price;

				}

			}

			

			$meta_fields['description'] = $description;

			$meta_fields['address'] = $address;

			$meta_fields['taxdata'] = $taxdata;

			$meta_fields['couponcode'] = $booking_coupon_applied;

			$meta_fields['couponcode_for'] = $couponcode_for;

			$meta_fields['discountamount'] = $discountamount;

			

			if($deposit_options === 'deposit_only') {

			$meta_fields['deposit_options'] = $deposit_options;

			$meta_fields['deposit_type'] = $deposit_type;

			$meta_fields['deposit_amount'] = $deposit_amount;

			$meta_fields['due_amount'] = $due_amount;

			$meta_fields['deposit_payment_status'] = 'deposit_only';

			}

			

			if(!empty($woopostdata['booking_attachments'])) {

				$meta_fields['booking_attachments'] = $woopostdata['booking_attachments'];

			}

			

			if($voucher_applied === 'yes') {

			

				$meta_fields['voucher_applied'] = 'yes';

				$meta_fields['vouchernumber'] = $vouchernumber;

				$meta_fields['voucheramount'] = $voucheramount;

				$meta_fields['voucheramountused'] = $voucheramountused;

				

				$voucherrow = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM `'.$wpdb->prefix.'postmeta` WHERE `meta_key` = "code" AND `meta_value` = %s',$vouchernumber));

				if(!empty($voucherrow)) {

					$postid = Appointy_Router_Helper::get_sanitize_data( $voucherrow, 'post_id' );

					$totalspent = get_post_meta($postid,'spent',true);

					$totalspent = ($totalspent != '' ) ? floatval($totalspent) : 0;

					

					$totalspent = floatval($totalspent) + floatval($voucheramountused);

					update_post_meta($postid,'spent',$totalspent);

				}

			}

			

			$meta_fields['appointment_ref_id'] = self::get_appointment_ref_id();

			$meta_fields['booked_services'] = $updated_services;

			$meta_fields['totalamount'] = $totalamount;

			$meta_fields['order_id'] = $order_id;

			$meta_fields['payment_type'] = 'woocommerce';

			$meta_fields['payment_method'] = $payment_method;

			$meta_fields['booking_amount_status']	= $booking_amount_status;
			
			$meta_fields['bookingtype'] = 'hotelbooking';

			

			$email = Appointy_Router_Helper::get_request_data($woopostdata,'email');

			$email = sanitize_email($email);

			

			if(is_user_logged_in()) {

				$meta_fields['booking_customer_id'] = $current_user->ID;

			}else{

				if(email_exists($email)){

					$existing_user = get_user_by( 'email', $email );

					if(!empty($existing_user)){

						$meta_fields['booking_customer_id'] = $existing_user->ID;

					}

				} else {

					$user_id = self::create_new_user($woopostdata);

					$meta_fields['booking_customer_id'] = $user_id;

				}

			}

			

			$customer_fields = self::appointment_form_fields();

                        

			if( !empty($customer_fields) ) {

				foreach( $customer_fields as $key => $field ) {

					$meta_fields[$key] = $woopostdata[$key];

				}

			}

			$booking_post = array(

				'post_title' => 'Booking',

				'post_status' => $status,

				'post_type' => 'appointy_appointment',

				'post_author' => 1,

				'meta_input'   => $meta_fields

			);

			$appointment_id = wp_insert_post( $booking_post );

			

			$k = 0;

			

			if( !empty( $updated_services ) ) {

				foreach( $updated_services as $service ) {

					if( !empty( $service ) ){

						$service_id = Appointy_Router_Helper::get_sanitize_data($service,'service_id');

						$service_price = Appointy_Router_Helper::get_request_data($service,'service_price',0);

						

						$selectedDates = (!empty($service['selected_multiple_dates'])) ? $service['selected_multiple_dates'] : array();

					

						$startDate = $selectedDates[0];

						$endDate = end($selectedDates);

						

						$bookingdata['appointment_id'] 		= $appointment_id;

						$bookingdata['service_id'] 		= $service_id;

						

						$bookingdata['type'] 			= 'hotelbooking';

						$bookingdata['start_date'] 			= $startDate;

						$bookingdata['end_date'] 			= $endDate;

						

						$bookingdata['dayoff_type'] 	= 'fullday';

						

						$wpdb->insert($wpdb->prefix.'appointy_blocked_schedule',wp_unslash($bookingdata));

						

						if(!empty($service['selected_multiple_dates'])) {

							$selected_multiple_dates = $service['selected_multiple_dates'];

							

							foreach($selected_multiple_dates as $selected_multiple_date){

								$multiple_dates['appointment_id'] 	= $appointment_id;

								$multiple_dates['service_id'] 		= $service_id;

								$multiple_dates['date'] 			= $selected_multiple_date;

								$multiple_dates['time'] 			= $booking_start_time;

								

								$wpdb->insert($wpdb->prefix.'appointy_multiple_dates',wp_unslash($multiple_dates));

							}

						}

						

						$total_extra_service_amount = 0;

						if(!empty($service['selected_extra_services'])) {

							$selected_extra_services = $service['selected_extra_services'];

							

							foreach($selected_extra_services as $selected_extra_service){

								$extra_service_price = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_price');

								$extra_service_quantity = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_quantity');

								$total_extra_service_amount = floatval($total_extra_service_amount) + (floatval($extra_service_price) * floatval($extra_service_quantity));

								

								$extra_service['appointment_id'] 		= $appointment_id;

								$extra_service['service_id'] 			= $service_id;

								$extra_service['type'] 					= 'hotelbooking';

								$extra_service['extra_service_id'] 		= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'extra_post_id');

								$extra_service['extra_service_name'] 	= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_name');

								$extra_service['extra_service_unit_price'] 	= $extra_service_price;

								$extra_service['extra_service_quantity'] 	= $extra_service_quantity;

								$extra_service['extra_service_price'] 	= floatval($extra_service_price) * floatval($extra_service_quantity);

								

								$wpdb->insert($wpdb->prefix.'appointy_extra_services',wp_unslash($extra_service));

							}

						}

						

						/*booked services save to db*/

						$selectedDates = (!empty($service['selected_multiple_dates'])) ? $service['selected_multiple_dates'] : array();

					

						// Get the start date (first element) and end date (last element)

						$booking_start_date = $selectedDates[0];

						$booking_end_date = end($selectedDates);

						

						$booked_services = array();

						$booked_services['date'] 		= date('Y-m-d H:i:s');

						$booked_services['appointment_id'] 	= $appointment_id;

						$booked_services['has_repeat'] 		= 'no';

						$booked_services['service_id'] 	= $service_id;

						$booked_services['bookingtype']	=  'hotelbooking';

						$booked_services['service_name']	=  Appointy_Router_Helper::get_sanitize_data($service,'service_name');

						$booked_services['rooms']	=  Appointy_Router_Helper::get_sanitize_data($service,'rooms');

						$booked_services['adults']	=  Appointy_Router_Helper::get_sanitize_data($service,'adults');

						$booked_services['children']	=  Appointy_Router_Helper::get_sanitize_data($service,'children');

						$booked_services['booking_start_date'] 	= $booking_start_date;

						$booked_services['booking_end_date'] 	= $booking_end_date;

						$booked_services['service_status']	= 'pending';

						$booked_services['service_price']	= $service_price;

						$booked_services['booking_amount_status']	= $booking_amount_status;

						$booked_services['customeremail']	= Appointy_Router_Helper::get_sanitize_email($woopostdata,'email');

						$booked_services['customerid']		= (is_user_logged_in()) ? $current_user->ID : 0;

						$booked_services['oldserviceprice']	= Appointy_Router_Helper::get_sanitize_data($service,'old_service_price');

						

						if($couponcode_for === 'booking' && $k === 0) {

							if($booking_coupon_applied === true) {

								$totalamount = $booking_coupon_discounted_price;

								$booked_services['couponcode']		= $booking_coupon_code;

							}

							

						} else {

							$booked_services['couponcode']		= $booking_coupon_code;

						}

						

						$wpdb->insert($wpdb->prefix.'appointy_booked_services',wp_unslash($booked_services));

						$appointment_service_id = $wpdb->insert_id;

						if( is_plugin_active( 'video-conferencing-with-zoom-api/video-conferencing-with-zoom-api.php' ) ) {

							Appointy_Zoom_Helper::create_zoom_link($appointment_id,$appointment_service_id,$booked_services);

						}

						

						if (PHP_VERSION_ID >= 80100) {

						if($member_id > 0) {

						Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$member_id,$booked_services);

						}

						

						

						$user_roles = Appointy_Misc_Helper::get_user_roles($current_user->ID);

						if(in_array('appointy_customer',$user_roles)) {

							Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$current_user->ID,$booked_services);

						}

						

						$gcal_admin_id = Appointy_Misc_Helper::get_gcal_admin_id();

						if( $gcal_admin_id > 0 ) {

							Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$gcal_admin_id,$booked_services);

						}

						}

						

						$arg = array(

							'current_date'	=> ( !empty($service['booking_date']) ) ? $service['booking_date'] : '',

							'user_id'	=> $user_id,

							'service_id'	=> ( !empty($service['service_id']) ) ? $service['service_id'] : '',

						);

						

						$k++;

					}

				}

			}

			

			Appointy_Send_Email_Notification_Helper::send_new_appointment_email_notifications($appointment_id);

			

			} else {

			

			$existingbooking = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM '.$wpdb->prefix.'postmeta WHERE `meta_key` = "order_id" AND `meta_value` = %s',$order_id));		

			

			if(!empty($existingbooking) && ($order_status === 'completed' || $order_status === 'processing') && $woopostdata && ! isset ( $woopostdata['completed'] ) && ! isset ( $woopostdata['cancelled'] )) {

				

				$appointment_id = Appointy_Router_Helper::get_sanitize_data( $existingbooking, 'post_id' );

				

				$status = 'processing';

				

				$booking_post = array(

					'ID'           => $appointment_id,

					'post_status'  => $status

				);

				wp_update_post( $booking_post );

				

				update_post_meta($appointment_id,'booking_amount_status','paid');

				

				$booked_services['booking_amount_status']	= 'paid';

				

				$where = array(

					'appointment_id' => $appointment_id

				);

				

				$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($booked_services),$where);

			}	

		}

		

	}

	

	/**

	 * Process save appointment with no payment

	 *

	 * @return array

	 */

	public static function save_nopayment_appointment() {

		global $wpdb, $current_user;

		

		$status = 'processing';

		$booking_amount_status = 'unpaid';

		

		$totalamount = 0;

		$booked_services = ( !empty( $_POST['booked_services'] ) ) ? (array) $_POST['booked_services'] : array();

		

		$updated_services = array();

			

		if( !empty( $booked_services ) ) {

			foreach( $booked_services as $key => $value ) {

				if( !empty( $value ) ) {

					$updated_services[$key] = $value;

					if( !empty( $value['selected_multiple_dates'] ) ) {

						$selected_number_of_multiple_dates = count($value['selected_multiple_dates']);

						$totalamount += (floatval(sanitize_text_field($value['service_price'])) * intval($selected_number_of_multiple_dates));

					}else{

						$totalamount += floatval(sanitize_text_field($value['service_price']));

					}

					

					if( !empty( $value['selected_extra_services'] ) ) {

						foreach( $value['selected_extra_services'] as $selected_extra_service ) {

							$extra_service_price = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_price');

							$extra_service_quantity = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_quantity');

							$totalamount += floatval($extra_service_price) * floatval($extra_service_quantity);

						}

					}

					

				}

			}

		}

		

		$booking_coupon_code = Appointy_Router_Helper::get_sanitize_data($_POST,'booking_coupon_code');

		$booking_coupon_discounted_price = Appointy_Router_Helper::get_sanitize_data($_POST,'booking_coupon_discounted_price',0);

		$booking_coupon_applied = Appointy_Router_Helper::get_sanitize_data($_POST,'booking_coupon_applied','no');

		$serviceperformat = Appointy_Router_Helper::get_sanitize_data($_POST,'serviceperformat');

		$address = Appointy_Router_Helper::get_sanitize_data($_POST,'address');

		$description = Appointy_Router_Helper::get_sanitize_data($_POST,'description');

		

		$taxdata = ( !empty( $_POST['taxdata'] ) ) ? (array) $_POST['taxdata'] : array();

		

		$voucheramount = Appointy_Router_Helper::get_sanitize_data($_POST,'voucheramount');

		$voucher_applied = Appointy_Router_Helper::get_sanitize_data($_POST,'voucher_applied');

		$vouchernumber = Appointy_Router_Helper::get_sanitize_data($_POST,'vouchernumber');

		$voucheramountused = Appointy_Router_Helper::get_sanitize_data($_POST,'voucheramountused');

		

		$discountamount = 0;

		$couponcode_for = Appointy_Misc_Helper::get_settings( 'booking_settings', 'coupon_code_for' );

		if($couponcode_for === 'booking') {

			if($booking_coupon_applied === 'yes') {

				$discountamount = floatval($totalamount) - floatval($booking_coupon_discounted_price);

			

				$totalamount = $booking_coupon_discounted_price;

			}

		}

		

		$meta_fields['serviceperformat'] = $serviceperformat;

		$meta_fields['address'] = $address;

		$meta_fields['taxdata'] = $taxdata;

		$meta_fields['description'] = $description;

		

		$meta_fields['couponcode'] = $booking_coupon_applied;

		$meta_fields['couponcode_for'] = $couponcode_for;

		$meta_fields['discountamount'] = $discountamount;

		

		if(!empty($_POST['booking_attachments'])) {

			$meta_fields['booking_attachments'] = $_POST['booking_attachments'];

		}

		

		if($voucher_applied === 'yes') {

		

			$meta_fields['voucher_applied'] = 'yes';

			$meta_fields['vouchernumber'] = $vouchernumber;

			$meta_fields['voucheramount'] = $voucheramount;

			$meta_fields['voucheramountused'] = $voucheramountused;

			

			$voucherrow = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM `'.$wpdb->prefix.'postmeta` WHERE `meta_key` = "code" AND `meta_value` = %s',$vouchernumber));

			if(!empty($voucherrow)) {

				$postid = Appointy_Router_Helper::get_sanitize_data( $voucherrow, 'post_id' );

				$totalspent = get_post_meta($postid,'spent',true);

				$totalspent = ($totalspent != '' ) ? floatval($totalspent) : 0;

				

				$totalspent = floatval($totalspent) + floatval($voucheramountused);

				update_post_meta($postid,'spent',$totalspent);

			}

			

			$totalamount = $voucheramountused;

		

		}

		

		$meta_fields['appointment_ref_id'] = self::get_appointment_ref_id();

		$meta_fields['booked_services'] = $updated_services;

		$meta_fields['totalamount'] = $totalamount;

		//$meta_fields['order_id'] = $order_id;

		$meta_fields['payment_type'] = 'offline';

		$meta_fields['payment_method'] = 'offline';

		$meta_fields['booking_amount_status']	= $booking_amount_status;
		
		$meta_fields['bookingtype'] = 'booking';

		

		$email = Appointy_Router_Helper::get_request_data($_POST,'email');

		$email = sanitize_email($email);

		

		if(is_user_logged_in()) {

			$meta_fields['booking_customer_id'] = $current_user->ID;

		}else{

			if(email_exists($email)){

				$existing_user = get_user_by( 'email', $email );

				if(!empty($existing_user)){

					$meta_fields['booking_customer_id'] = $existing_user->ID;

				}

			} else {

				$user_id = self::create_new_user($_POST);

				$meta_fields['booking_customer_id'] = $user_id;

			}

		}

		$customer_fields = self::appointment_form_fields();

		if( !empty($customer_fields) ) {

			foreach( $customer_fields as $key => $field ) {

				$meta_fields[$key] = $_POST[$key];

			}

		}

		$booking_post = array(

			'post_title' => 'Booking',

			'post_status' => $status,

			'post_type' => 'appointy_appointment',

			'post_author' => 1,

			'meta_input'   => $meta_fields

		);

		$appointment_id = wp_insert_post( $booking_post );

		

		$k = 0;

		

		if( !empty( $updated_services ) ) {

			foreach( $updated_services as $service ) {

				if( !empty( $service ) ){

					$booking_start_time = Appointy_Router_Helper::get_sanitize_data($service,'booking_start_time');
					
					$service_period = Appointy_Router_Helper::get_sanitize_data($service,'service_period');
					
					$service_period = ($service_period != '') ? $service_period : 0;
					
					$minutesToAdd = $service_period;
					
					$dateTime = new DateTime($booking_start_time);
					
					$dateTime->modify("+{$minutesToAdd} minutes");
					
					$booking_end_time = $dateTime->format('H:i:s');
					
					$buffer_time = Appointy_Misc_Helper::get_settings( 'booking_settings', 'buffer_time' );
					
					if($buffer_time != '') {
						$minutesToAdd = intval($service_period) + intval($buffer_time);	
						
						$dateTime = new DateTime($booking_start_time);
					
						$dateTime->modify("+{$minutesToAdd} minutes");
						
						$booking_end_time_with_buffer = $dateTime->format('H:i:s');
					}else{
						$booking_end_time_with_buffer = $booking_end_time;
					}
					
					//$booking_end_time = Appointy_Router_Helper::get_sanitize_data($service,'booking_end_time');

					$service_id = Appointy_Router_Helper::get_sanitize_data($service,'service_id');

					$booking_date = Appointy_Router_Helper::get_sanitize_data($service,'booking_date');

					$member_id = Appointy_Router_Helper::get_sanitize_data($service,'member_id');

					$locationid = Appointy_Router_Helper::get_sanitize_data($service,'locationid');

					

					$service_price = Appointy_Router_Helper::get_sanitize_data($service,'service_price',0);

					

					if(!empty($service['selected_multiple_dates'])) {

						$selected_multiple_dates = $service['selected_multiple_dates'];

						

						foreach($selected_multiple_dates as $selected_multiple_date){

							$multiple_dates['appointment_id'] 	= $appointment_id;

							$multiple_dates['service_id'] 		= $service_id;

							$multiple_dates['date'] 			= $selected_multiple_date;

							$multiple_dates['time'] 			= $booking_start_time;

							

							$wpdb->insert($wpdb->prefix.'appointy_multiple_dates',wp_unslash($multiple_dates));

							

							$bookingdata['appointment_id'] 		= $appointment_id;

							$bookingdata['service_id'] 		= $service_id;

							

							$bookingdata['type'] 			= 'booking';

							$bookingdata['date'] 			= $selected_multiple_date;

							

							if(Appointy_Router_Helper::get_sanitize_data($service,'fullday_timeslots') === 'full_day'){

							$bookingdata['dayoff_type'] 	= 'fullday';	

							}else{

							$bookingdata['start_time'] 		= $booking_start_time;

							$bookingdata['end_time'] 		= $booking_end_time_with_buffer;

							$bookingdata['dayoff_type'] 	= 'timeslot';

							}

							

							if($member_id > 0) {

							$bookingdata['member_id'] 		= $member_id;

							}

							if($locationid > 0) {

							$bookingdata['branch_id'] 		= $locationid;

							}

							

							$wpdb->insert($wpdb->prefix.'appointy_blocked_schedule',wp_unslash($bookingdata));

						}

					}else{

						$bookingdata['appointment_id'] 		= $appointment_id;

						$bookingdata['service_id'] 		= $service_id;

						$bookingdata['dayoff_type'] 	= 'timeslot';

						$bookingdata['type'] 			= 'booking';

						$bookingdata['date'] 			= $booking_date;

						$bookingdata['start_time'] 		= $booking_start_time;

						$bookingdata['end_time'] 		= $booking_end_time_with_buffer;

						if($member_id > 0) {

						$bookingdata['member_id'] 		= $member_id;

						}

						if($locationid > 0) {

						$bookingdata['branch_id'] 		= $locationid;

						}

						

						$wpdb->insert($wpdb->prefix.'appointy_blocked_schedule',wp_unslash($bookingdata));

					}

					

					$total_extra_service_amount = 0;

					if(!empty($service['selected_extra_services'])) {

						$selected_extra_services = $service['selected_extra_services'];

						

						foreach($selected_extra_services as $selected_extra_service){

							
							$extra_service_price = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_price');

							$extra_service_quantity = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_quantity');

							$total_extra_service_amount = floatval($total_extra_service_amount) + (floatval($extra_service_price) * floatval($extra_service_quantity));
							

							$extra_service['appointment_id'] 		= $appointment_id;

							$extra_service['service_id'] 			= $service_id;

							$extra_service['extra_service_id'] 		= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'extra_post_id');

							$extra_service['extra_service_name'] 	= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_name');

							$extra_service['extra_service_unit_price'] 	= $extra_service_price;

							$extra_service['extra_service_quantity'] 	= $extra_service_quantity;

							$extra_service['extra_service_price'] 	= floatval($extra_service_price) * floatval($extra_service_quantity);

							$extra_service['hours'] 				= intval(Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'hours'));

							$extra_service['minutes'] 				= intval(Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'minutes'));

							$extra_service['display_service_period']= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'display_service_period');

							$extra_service['service_period'] 		= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_period');

							

							$wpdb->insert($wpdb->prefix.'appointy_extra_services',wp_unslash($extra_service));

						}

					}

					

					$active_repeat_service_id = 0;

					if(Appointy_Router_Helper::get_sanitize_data($service,'repeat_appointments') === 'yes') {

						$service_taxamount = Appointy_Appointments_Helper::get_service_price_tax($appointment_id,$service_price);

							

						$total_service_amount = floatval($service_taxamount) + floatval($service_price) + floatval($total_extra_service_amount);
						

					

						$active_repeat_schedule['appointment_id'] 		= $appointment_id;

						$active_repeat_schedule['service_id'] 			= $service_id;

						$active_repeat_schedule['frequency'] 			= Appointy_Router_Helper::get_sanitize_data($service,'frequency');

						$active_repeat_schedule['selected_weekday'] 	= intval(Appointy_Router_Helper::get_sanitize_data($service,'selected_weekday',0));

						$active_repeat_schedule['day_of_month'] 		= intval(Appointy_Router_Helper::get_sanitize_data($service,'day_of_month'));

						$active_repeat_schedule['num_times'] 			= intval(Appointy_Router_Helper::get_sanitize_data($service,'num_times'));

						$active_repeat_schedule['date'] 				= $booking_date;

						$active_repeat_schedule['start_time'] 			= $booking_start_time;

						$active_repeat_schedule['end_time'] 			= $booking_end_time;

						$active_repeat_schedule['status'] 				= 'active';

						$active_repeat_schedule['payment_status'] 		= 'default';

						$active_repeat_schedule['service_price'] 		= $service_price;

						$active_repeat_schedule['extra_service_total'] 	= $total_extra_service_amount;

						$active_repeat_schedule['tax_amount'] 			= $service_taxamount;

						$active_repeat_schedule['total_amount'] 		= $total_service_amount;

						

						$wpdb->insert($wpdb->prefix.'appointy_repeat_schedule',wp_unslash($active_repeat_schedule));

						$active_repeat_service_id = $wpdb->insert_id;

						

						if(!empty($service['schedule_dates'])) {

							foreach($service['schedule_dates'] as $schedule_date){

								$repeat_schedule['appointment_id'] 		= $appointment_id;

								$repeat_schedule['service_id'] 			= $service_id;

								$repeat_schedule['frequency'] 			= Appointy_Router_Helper::get_sanitize_data($service,'frequency');

								$repeat_schedule['selected_weekday'] 	= intval(Appointy_Router_Helper::get_sanitize_data($service,'selected_weekday',0));

								$repeat_schedule['day_of_month'] 		= intval(Appointy_Router_Helper::get_sanitize_data($service,'day_of_month'));

								$repeat_schedule['num_times'] 			= intval(Appointy_Router_Helper::get_sanitize_data($service,'num_times'));

								$repeat_schedule['date'] 				= wp_date('Y-m-d', strtotime($schedule_date));

								$repeat_schedule['start_time'] 			= $booking_start_time;

								$repeat_schedule['end_time'] 			= $booking_end_time;

								$repeat_schedule['status'] 				= 'upcoming';

								$repeat_schedule['payment_status'] 		= 'pending';

								$repeat_schedule['service_price'] 		= $service_price;

								$repeat_schedule['extra_service_total'] = $total_extra_service_amount;

								$repeat_schedule['tax_amount'] 			= $service_taxamount;

								$repeat_schedule['total_amount'] 		= $total_service_amount;

								

								$wpdb->insert($wpdb->prefix.'appointy_repeat_schedule',wp_unslash($repeat_schedule));

								$repeat_service_id = $wpdb->insert_id;

								

								/*Block schedule for repeat schedules*/

								$block_repeat_schedule['appointment_id']= $appointment_id;

								$block_repeat_schedule['service_id']	= $service_id;

								$block_repeat_schedule['dayoff_type'] 	= 'timeslot';

								$block_repeat_schedule['type'] 			= 'booking';

								$block_repeat_schedule['date'] 			= wp_date('Y-m-d', strtotime($schedule_date));

								$block_repeat_schedule['start_time'] 	= $booking_start_time;

								$block_repeat_schedule['end_time'] 		= $booking_end_time;

								if($member_id > 0) {

								$block_repeat_schedule['member_id'] 	= $member_id;

								}

								if($locationid > 0) {

								$block_repeat_schedule['branch_id'] 	= $locationid;

								}

								$block_repeat_schedule['repeat_service_id'] = $repeat_service_id;

								

								$wpdb->insert($wpdb->prefix.'appointy_blocked_schedule',wp_unslash($block_repeat_schedule));

							}

						}

					}

					

					/*booked services save to db*/

					$booked_services = array();

					$booked_services['date'] 		= date('Y-m-d H:i:s');

					$booked_services['appointment_id'] 	= $appointment_id;

					$booked_services['has_repeat'] 		= (Appointy_Router_Helper::get_sanitize_data($service,'repeat_appointments') === 'yes') ? 'yes' : 'no';

					$booked_services['repeat_service_id'] = $active_repeat_service_id;

					$booked_services['repeat_service_payment'] = 'default';

					$booked_services['service_id'] 		= $service_id;

					$booked_services['service_name']	=  Appointy_Router_Helper::get_sanitize_data($service,'service_name');

					$booked_services['servicetype'] 	=  Appointy_Router_Helper::get_sanitize_data($service,'servicetype');

					$booked_services['service_period'] 	=  Appointy_Router_Helper::get_sanitize_data($service,'service_period');

					$booked_services['variation_name'] 	=  Appointy_Router_Helper::get_sanitize_data($service,'variation_name');

					$booked_services['hours'] 			=  Appointy_Router_Helper::get_sanitize_data($service,'hours');

					$booked_services['minutes'] 		=  Appointy_Router_Helper::get_sanitize_data($service,'minutes');

					$booked_services['display_service_period'] 	= Appointy_Router_Helper::get_sanitize_data($service,'display_service_period');

					$booked_services['show_branches'] 			= Appointy_Router_Helper::get_sanitize_data($service,'show_branches');

					$booked_services['members_available'] 		= Appointy_Router_Helper::get_sanitize_data($service,'members_available');

					$booked_services['branch_id'] 		= Appointy_Router_Helper::get_sanitize_data($service,'locationid');

					$booked_services['member_id'] 		= Appointy_Router_Helper::get_sanitize_data($service,'member_id');

					$booked_services['booking_date'] 	= Appointy_Router_Helper::get_sanitize_data($service,'booking_date');

					$booked_services['booking_start_time'] 	= Appointy_Router_Helper::get_sanitize_data($service,'booking_start_time');

					$booked_services['booking_end_time']	= $booking_end_time;

					$booked_services['parent_category']	= Appointy_Router_Helper::get_sanitize_data($service,'parent_category');

					$booked_services['service_status']	= 'pending';

					$booked_services['service_price']	= $service_price;

					$booked_services['booking_amount_status']	= $booking_amount_status;

					$booked_services['customeremail']	= Appointy_Router_Helper::get_sanitize_email($_POST,'email');

					$booked_services['customerid']		= (is_user_logged_in()) ? $current_user->ID : 0;

					$booked_services['oldserviceprice']	= Appointy_Router_Helper::get_sanitize_data($service,'old_service_price');

					$booked_services['multidate_service']	= Appointy_Router_Helper::get_sanitize_data($service,'multidate_service');

					$booked_services['multidate_service_type']	= Appointy_Router_Helper::get_sanitize_data($service,'multidate_service_type');

					$booked_services['number_of_dates']	= Appointy_Router_Helper::get_sanitize_data($service,'number_of_dates');

					$booked_services['fullday_timeslots']	= Appointy_Router_Helper::get_sanitize_data($service,'fullday_timeslots');

					

					if($couponcode_for === 'booking' && $k === 0) {

						if($booking_coupon_applied === true) {

							$totalamount = $booking_coupon_discounted_price;

							$booked_services['couponcode']		= $booking_coupon_code;

						}

						

					} else {

						$booked_services['couponcode']		= $booking_coupon_code;

					}

					

					$wpdb->insert($wpdb->prefix.'appointy_booked_services',wp_unslash($booked_services));

					

					$appointment_service_id = $wpdb->insert_id;

					if( is_plugin_active( 'video-conferencing-with-zoom-api/video-conferencing-with-zoom-api.php' ) ) {

						Appointy_Zoom_Helper::create_zoom_link($appointment_id,$appointment_service_id,$booked_services);

					}

					

					if (PHP_VERSION_ID >= 80100) {

					if($member_id > 0) {

						Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$member_id,$booked_services);

					}

					

					$user_roles = Appointy_Misc_Helper::get_user_roles($current_user->ID);

					if(in_array('appointy_customer',$user_roles)) {

						Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$current_user->ID,$booked_services);

					}

					

					$gcal_admin_id = Appointy_Misc_Helper::get_gcal_admin_id();

					if( $gcal_admin_id > 0 ) {

						Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$gcal_admin_id,$booked_services);

					}

					}

					

					$arg = array(

						'current_date'	=> ( !empty($service['booking_date']) ) ? $service['booking_date'] : '',

						//'user_id'	=> $user_id,

						'member_id'	=> ( !empty($service['member_id']) ) ? $service['member_id'] : '',

						'branch_id'	=> ( !empty($service['locationid']) ) ? $service['locationid'] : '',

						'service_id'	=> ( !empty($service['service_id']) ) ? $service['service_id'] : '',

						'service_period'	=> ( !empty($service['service_period']) ) ? $service['service_period'] : '',

					);

					$k++;

				}

			}

		}

		

		Appointy_Send_Email_Notification_Helper::send_new_appointment_email_notifications($appointment_id);

		

		$pageid = Appointy_Misc_Helper::get_settings( 'booking_settings', 'redirect_after_booking', 'no' );

		if($pageid != 'no' && $pageid > 0) {

			$redirectlink = add_query_arg( array('appointment_id' => $appointment_id), get_permalink($pageid) );

		}else{

			$redirectlink = '';

		}

		

		$response = array(

						'message'   => esc_html__('Appointment booked successfully.','appointy'),

						'redirectlink'   => $redirectlink

					);

		wp_send_json_success($response);

		exit;

	}

	

	/**

	 * Process save appointment with no payment

	 *

	 * @return array

	 */

	public static function save_nopayment_hotel_booking() {

		global $wpdb, $current_user;

		

		$status = 'processing';

		$booking_amount_status = 'unpaid';

		

		$totalamount = 0;

		$booked_services = ( !empty( $_POST['booked_services'] ) ) ? (array) $_POST['booked_services'] : array();

		

		$updated_services = array();

			

		if( !empty( $booked_services ) ) {

			foreach( $booked_services as $key => $value ) {

				if( !empty( $value ) ) {

					$updated_services[$key] = $value;

					

					if( !empty( $value['selected_multiple_dates'] ) ) {

						$selected_number_of_multiple_dates = count($value['selected_multiple_dates']);

						$totalamount += (floatval(sanitize_text_field($value['service_price'])) * intval($selected_number_of_multiple_dates));

					}else{

						$totalamount += floatval(sanitize_text_field($value['service_price']));

					}

					

					if( !empty( $value['selected_extra_services'] ) ) {

						foreach( $value['selected_extra_services'] as $selected_extra_service ) {

							$extra_service_price = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_price');

							$extra_service_quantity = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_quantity');

							$totalamount += floatval($extra_service_price) * floatval($extra_service_quantity);

						}

					}

				}

			}

		}

		

		$booking_coupon_code = Appointy_Router_Helper::get_sanitize_data($_POST,'booking_coupon_code');

		$booking_coupon_discounted_price = Appointy_Router_Helper::get_sanitize_data($_POST,'booking_coupon_discounted_price',0);

		$booking_coupon_applied = Appointy_Router_Helper::get_sanitize_data($_POST,'booking_coupon_applied','no');

		$address = Appointy_Router_Helper::get_sanitize_data($_POST,'address');

		$description = Appointy_Router_Helper::get_sanitize_data($_POST,'description');

		

		$taxdata = ( !empty( $_POST['taxdata'] ) ) ? (array) $_POST['taxdata'] : array();

		

		$voucheramount = Appointy_Router_Helper::get_sanitize_data($_POST,'voucheramount');

		$voucher_applied = Appointy_Router_Helper::get_sanitize_data($_POST,'voucher_applied');

		$vouchernumber = Appointy_Router_Helper::get_sanitize_data($_POST,'vouchernumber');

		$voucheramountused = Appointy_Router_Helper::get_sanitize_data($_POST,'voucheramountused');

		

		$discountamount = 0;

		$couponcode_for = Appointy_Misc_Helper::get_settings( 'booking_settings', 'coupon_code_for' );

		if($couponcode_for === 'booking') {

			if($booking_coupon_applied === 'yes') {

				$discountamount = floatval($totalamount) - floatval($booking_coupon_discounted_price);

			

				$totalamount = $booking_coupon_discounted_price;

			}

		}

		

		$meta_fields['address'] = $address;

		$meta_fields['taxdata'] = $taxdata;

		$meta_fields['description'] = $description;

		

		$meta_fields['couponcode'] = $booking_coupon_applied;

		$meta_fields['couponcode_for'] = $couponcode_for;

		$meta_fields['discountamount'] = $discountamount;

		

		if(!empty($_POST['booking_attachments'])) {

			$meta_fields['booking_attachments'] = $_POST['booking_attachments'];

		}

		

		if($voucher_applied === 'yes') {

		

			$meta_fields['voucher_applied'] = 'yes';

			$meta_fields['vouchernumber'] = $vouchernumber;

			$meta_fields['voucheramount'] = $voucheramount;

			$meta_fields['voucheramountused'] = $voucheramountused;

			

			$voucherrow = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM `'.$wpdb->prefix.'postmeta` WHERE `meta_key` = "code" AND `meta_value` = %s',$vouchernumber));

			if(!empty($voucherrow)) {

				$postid = Appointy_Router_Helper::get_sanitize_data( $voucherrow, 'post_id' );

				$totalspent = get_post_meta($postid,'spent',true);

				$totalspent = ($totalspent != '' ) ? floatval($totalspent) : 0;

				

				$totalspent = floatval($totalspent) + floatval($voucheramountused);

				update_post_meta($postid,'spent',$totalspent);

			}

			

			$totalamount = $voucheramountused;

		

		}

		

		$meta_fields['appointment_ref_id'] = self::get_appointment_ref_id();

		$meta_fields['booked_services'] = $updated_services;

		$meta_fields['totalamount'] = $totalamount;

		//$meta_fields['order_id'] = $order_id;

		$meta_fields['payment_type'] = 'offline';

		$meta_fields['payment_method'] = 'offline';

		$meta_fields['booking_amount_status']	= $booking_amount_status;
		
		$meta_fields['bookingtype'] = 'hotelbooking';

		

		$email = Appointy_Router_Helper::get_request_data($_POST,'email');

		$email = sanitize_email($email);

		

		if(is_user_logged_in()) {

			$meta_fields['booking_customer_id'] = $current_user->ID;

		}else{

			if(email_exists($email)){

				$existing_user = get_user_by( 'email', $email );

				if(!empty($existing_user)){

					$meta_fields['booking_customer_id'] = $existing_user->ID;

				}

			} else {

				$user_id = self::create_new_user($_POST);

				$meta_fields['booking_customer_id'] = $user_id;

			}

		}

		$customer_fields = self::appointment_form_fields();

		if( !empty($customer_fields) ) {

			foreach( $customer_fields as $key => $field ) {

				$meta_fields[$key] = $_POST[$key];

			}

		}

		$booking_post = array(

			'post_title' => 'Booking',

			'post_status' => $status,

			'post_type' => 'appointy_appointment',

			'post_author' => 1,

			'meta_input'   => $meta_fields

		);

		$appointment_id = wp_insert_post( $booking_post );

		

		$k = 0;

		

		if( !empty( $updated_services ) ) {

				foreach( $updated_services as $service ) {

					if( !empty( $service ) ){

						$service_id = Appointy_Router_Helper::get_sanitize_data($service,'service_id');

						$service_price = Appointy_Router_Helper::get_request_data($service,'service_price',0);

						

						$selectedDates = (!empty($service['selected_multiple_dates'])) ? $service['selected_multiple_dates'] : array();

					

						$startDate = $selectedDates[0];

						$endDate = end($selectedDates);

						

						$bookingdata['appointment_id'] 		= $appointment_id;

						$bookingdata['service_id'] 		= $service_id;

						

						$bookingdata['type'] 			= 'hotelbooking';

						$bookingdata['start_date'] 			= $startDate;

						$bookingdata['end_date'] 			= $endDate;

						

						$bookingdata['dayoff_type'] 	= 'fullday';

						

						$wpdb->insert($wpdb->prefix.'appointy_blocked_schedule',wp_unslash($bookingdata));

						

						if(!empty($service['selected_multiple_dates'])) {

							$selected_multiple_dates = $service['selected_multiple_dates'];

							

							foreach($selected_multiple_dates as $selected_multiple_date){

								$multiple_dates['appointment_id'] 	= $appointment_id;

								$multiple_dates['service_id'] 		= $service_id;

								$multiple_dates['date'] 			= $selected_multiple_date;

								$multiple_dates['time'] 			= $booking_start_time;

								

								$wpdb->insert($wpdb->prefix.'appointy_multiple_dates',wp_unslash($multiple_dates));

							}

						}

						

						$total_extra_service_amount = 0;

						if(!empty($service['selected_extra_services'])) {

							$selected_extra_services = $service['selected_extra_services'];

							

							foreach($selected_extra_services as $selected_extra_service){

								$extra_service_price = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_price');

								$extra_service_quantity = Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_quantity');

								$total_extra_service_amount = floatval($total_extra_service_amount) + (floatval($extra_service_price) * floatval($extra_service_quantity));

								

								$extra_service['appointment_id'] 		= $appointment_id;

								$extra_service['service_id'] 			= $service_id;

								$extra_service['type'] 					= 'hotelbooking';

								$extra_service['extra_service_id'] 		= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'extra_post_id');

								$extra_service['extra_service_name'] 	= Appointy_Router_Helper::get_sanitize_data($selected_extra_service,'service_name');

								$extra_service['extra_service_unit_price'] 	= $extra_service_price;

								$extra_service['extra_service_quantity'] 	= $extra_service_quantity;

								$extra_service['extra_service_price'] 	= floatval($extra_service_price) * floatval($extra_service_quantity);

								

								$wpdb->insert($wpdb->prefix.'appointy_extra_services',wp_unslash($extra_service));

							}

						}

						

						/*booked services save to db*/

						$selectedDates = (!empty($service['selected_multiple_dates'])) ? $service['selected_multiple_dates'] : array();

					

						// Get the start date (first element) and end date (last element)

						$booking_start_date = $selectedDates[0];

						$booking_end_date = end($selectedDates);

						

						$booked_services = array();

						$booked_services['date'] 		= date('Y-m-d H:i:s');

						$booked_services['appointment_id'] 	= $appointment_id;

						$booked_services['has_repeat'] 		= 'no';

						$booked_services['service_id'] 	= $service_id;

						$booked_services['bookingtype']	=  'hotelbooking';

						$booked_services['service_name']	=  Appointy_Router_Helper::get_sanitize_data($service,'service_name');

						$booked_services['rooms']	=  Appointy_Router_Helper::get_sanitize_data($service,'rooms');

						$booked_services['adults']	=  Appointy_Router_Helper::get_sanitize_data($service,'adults');

						$booked_services['children']	=  Appointy_Router_Helper::get_sanitize_data($service,'children');

						$booked_services['booking_start_date'] 	= $booking_start_date;

						$booked_services['booking_end_date'] 	= $booking_end_date;

						$booked_services['service_status']	= 'pending';

						$booked_services['service_price']	= $service_price;

						$booked_services['booking_amount_status']	= $booking_amount_status;

						$booked_services['customeremail']	= Appointy_Router_Helper::get_sanitize_email($woopostdata,'email');

						$booked_services['customerid']		= (is_user_logged_in()) ? $current_user->ID : 0;

						$booked_services['oldserviceprice']	= Appointy_Router_Helper::get_sanitize_data($service,'old_service_price');

						

						if($couponcode_for === 'booking' && $k === 0) {

							if($booking_coupon_applied === true) {

								$totalamount = $booking_coupon_discounted_price;

								$booked_services['couponcode']		= $booking_coupon_code;

							}

							

						} else {

							$booked_services['couponcode']		= $booking_coupon_code;

						}

						

						$wpdb->insert($wpdb->prefix.'appointy_booked_services',wp_unslash($booked_services));

						$appointment_service_id = $wpdb->insert_id;

						if( is_plugin_active( 'video-conferencing-with-zoom-api/video-conferencing-with-zoom-api.php' ) ) {

							Appointy_Zoom_Helper::create_zoom_link($appointment_id,$appointment_service_id,$booked_services);

						}

						

						if (PHP_VERSION_ID >= 80100) {

						if($member_id > 0) {

						Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$member_id,$booked_services);

						}

						

						

						$user_roles = Appointy_Misc_Helper::get_user_roles($current_user->ID);

						if(in_array('appointy_customer',$user_roles)) {

							Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$current_user->ID,$booked_services);

						}

						

						$gcal_admin_id = Appointy_Misc_Helper::get_gcal_admin_id();

						if( $gcal_admin_id > 0 ) {

							Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$appointment_service_id,$gcal_admin_id,$booked_services);

						}

						}

						

						$arg = array(

							'current_date'	=> ( !empty($service['booking_date']) ) ? $service['booking_date'] : '',

							'user_id'	=> $user_id,

							'service_id'	=> ( !empty($service['service_id']) ) ? $service['service_id'] : '',

						);

						

						$k++;

					}

				}

			}

		

		Appointy_Send_Email_Notification_Helper::send_new_appointment_email_notifications($appointment_id);

		

		$pageid = Appointy_Misc_Helper::get_settings( 'booking_settings', 'redirect_after_booking', 'no' );

		if($pageid != 'no' && $pageid > 0) {

			$redirectlink = add_query_arg( array('appointment_id' => $appointment_id), get_permalink($pageid) );

		}else{

			$redirectlink = '';

		}

		

		$response = array(

						'message'   => esc_html__('Room booked successfully.','appointy'),

						'redirectlink'   => $redirectlink

					);

		wp_send_json_success($response);

		exit;

	}

	

	/**

	 * Process load booking time slots

	 *

	 * @return array

	 */

	public function load_booking_slots( ) {

		global $wpdb;

		

		$appointment_date = Appointy_Router_Helper::get_request_data( $_POST, 'current_date' );

		$member_id = Appointy_Router_Helper::get_request_data( $_POST, 'member_id' );

		$branch_id = Appointy_Router_Helper::get_request_data( $_POST, 'branch_id' );

		$service_id = Appointy_Router_Helper::get_request_data( $_POST, 'service_id' );

		$service_period = Appointy_Router_Helper::get_request_data( $_POST, 'service_period' );

		$booking_date = Appointy_Router_Helper::get_request_data( $_POST, 'booking_date' );

		$booking_start_time = Appointy_Router_Helper::get_request_data( $_POST, 'booking_start_time' );
		
		$booking_end_time = Appointy_Router_Helper::get_request_data( $_POST, 'booking_end_time' );

		$type = Appointy_Router_Helper::get_request_data( $_POST, 'type' );

		

		$multidate_service = Appointy_Router_Helper::get_request_data( $_POST, 'multidate_service' );

		$multidate_service_type = Appointy_Router_Helper::get_request_data( $_POST, 'multidate_service_type' );

		$selected_multiple_dates = (!empty($_POST['selected_multiple_dates'])) ? $_POST['selected_multiple_dates'] : array();

		

		if($multidate_service === 'yes') {

			$avl_dates_array = array();

			if(!empty($selected_multiple_dates)) {

				foreach($selected_multiple_dates as $appointment_date){

					$day = Appointy_Misc_Helper::get_day( $appointment_date );

			

					$service_availability = get_post_meta($service_id,'_service_availability',true);

					$service_availability_status = get_post_meta($service_id,'_service_availability_status',true);

					if( $service_availability_status === 'on' ) {

						$service_availability = ( !empty( $service_availability[$day] ) ) ? (array) $service_availability[$day] : array();

						

						$service_start_time = ( !empty( $service_availability[0] ) ) ? date('H:i:s',strtotime($service_availability[0])) : '';

						$service_end_time = ( !empty( $service_availability[1] ) ) ? date('H:i:s',strtotime($service_availability[1])) : '';

						$service_day_status = ( !empty( $service_availability[2] ) ) ? $service_availability[2] : '';

						

						if( $service_day_status === false ) {

							$response = array(

								'nodata'   => sprintf('<li class="no-servi-box-alert">%s</li>',esc_html__('Sorry, this service is not available on this day. Please choose another day.','appointy')),

							);

							wp_send_json_error($response);

							exit;

						}

					}else{

						$service_start_time = '';

						$service_end_time = '';

						$service_day_status = '';

					}

					

					$member_id = ( intval($member_id) > 0 ) ? $member_id : 0;

					

					$dateresponse = self::check_date_unavailability( $appointment_date,$member_id );

					if( $dateresponse === false ) {

						$response = array(

							'nodata'   => '<li class="no-servi-box-alert">'.esc_html__('Sorry, this date is unavailable for appointment. Please choose another date.','appointy').'</li>',

						);

						wp_send_json_error($response);

						exit;

					}

					

					//Get avaialable slots by custom schedule date

					if( intval($member_id) > 0 ) {

					$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `custom_date` = %s AND `member_id` = %d order by `start_time_number` asc',$appointment_date,$member_id));

					}else{

					$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `custom_date` = %s order by `start_time_number` asc',$appointment_date));

					}

					

					if( !empty( $results ) ) {

						$avl_dates_array[] = self::get_available_slots_for_multidate( $results, $appointment_date, $service_availability_status, $service_start_time, $service_end_time, $booking_date, $booking_start_time, $member_id, $type, $service_id, $service_period );

					} else {

						

						//Check if slots are avaialble on particular day if yes then render timeslots

						$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `weekday` = %s AND `member_id` = %d order by `start_time_number` asc',$day,$member_id));

						

						if( empty( $results ) ) {

							$response = array(

								'nodata'   => '<li class="no-servi-box-alert">'.esc_html__('Sorry, this service is not available on this day. Please choose another day.','appointy').'</li>',

							);

							wp_send_json_error($response);

							exit;

						} else {

							$avl_dates_array[] = self::get_available_slots_for_multidate( $results, $appointment_date, $service_availability_status, $service_start_time, $service_end_time, $booking_date, $booking_start_time, $member_id, $type, $service_id, $service_period );

						}

					}

					

				}

			}

			

			//echo '<pre>';print_r($avl_dates_array);echo '</pre>';

			

			// Flatten the array to get all time slots in a comparable format

			$flattenedSchedule = [];

			foreach ($avl_dates_array as $dateArray) {

				foreach ($dateArray as $date => $timeSlots) {

					$flattenedSchedule[] = $timeSlots;

				}

			}

			

			// Find the intersection of all time slots across all dates

			if (count($flattenedSchedule) > 0) {

				$commonTimeSlots = call_user_func_array('array_intersect', $flattenedSchedule);

			} else {

				$commonTimeSlots = [];

			}

			

			// Create DateTime objects from the common time slots

			$dateTimeObjects = [];

			if (!empty($commonTimeSlots)) {

				// Use the first date as the base date

				$baseDate = array_key_first($avl_dates_array[0]);

				foreach ($commonTimeSlots as $time) {

					$dateTimeString = $baseDate . ' ' . $time;

					$dateTimeObjects[] = new DateTime($dateTimeString);

				}

			}

			

			// Display the DateTime objects

			if (empty($dateTimeObjects)) {

				$response = array(

					'nodata'   => '<li class="no-servi-box-alert">'.esc_html__('There are no common available time slots on all dates.','appointy').'</li>',

				);

				wp_send_json_error($response);

			} else {

				ob_start();

				$interval = $results[0]->interval;

				foreach ($dateTimeObjects as $date) {

					$end_time = date('H:i:s', strtotime($date->format("H:i:s")." +".esc_html($interval)." minutes"));

					$formated_end_time = date(Appointy_Misc_Helper::get_wp_time_format(), strtotime($date->format("H:i:s")." +".esc_html($interval)." minutes"));

					

					if( $date->format("H:i:s") == $booking_start_time ) {

						$activeclass = 'active';

					} else {

						$activeclass = '';

					}	

					?><li class="col-lg-6 slotbox" data-start-time="<?php echo esc_attr( $date->format("H:i:s") ); ?>" data-end-time="<?php echo esc_attr( $end_time ); ?>" data-formated-starttime="<?php echo esc_attr( $date->format(Appointy_Misc_Helper::get_wp_time_format()) ); ?>" data-formated-endtime="<?php echo esc_attr( $formated_end_time ); ?>"><div class="sf-time-box <?php echo sanitize_html_class($activeclass); ?>"><?php echo $date->format( Appointy_Misc_Helper::get_wp_time_format() ); ?></div></li><?php

					

				}

				$html = ob_get_clean();

				

				$response = array( 'html' => $html );

				wp_send_json_success($response);

			}

			

			

		}else{

		

			$day = Appointy_Misc_Helper::get_day( $appointment_date );

			

			$service_availability = get_post_meta($service_id,'_service_availability',true);

			$service_availability_status = get_post_meta($service_id,'_service_availability_status',true);

			if( $service_availability_status === 'on' ) {

				$service_availability = ( !empty( $service_availability[$day] ) ) ? (array) $service_availability[$day] : array();

				

				$service_start_time = ( !empty( $service_availability[0] ) ) ? date('H:i:s',strtotime($service_availability[0])) : '';

				$service_end_time = ( !empty( $service_availability[1] ) ) ? date('H:i:s',strtotime($service_availability[1])) : '';

				$service_day_status = ( !empty( $service_availability[2] ) ) ? $service_availability[2] : '';

				

				if( $service_day_status === false ) {

					$response = array(

						'nodata'   => sprintf('<li class="no-servi-box-alert">%s</li>',esc_html__('Sorry, this service is not available on this day. Please choose another day.','appointy')),

					);

					wp_send_json_error($response);

					exit;

				}

			}else{

				$service_start_time = '';

				$service_end_time = '';

				$service_day_status = '';

			}

			

			$member_id = ( intval($member_id) > 0 ) ? $member_id : 0;

			

			$dateresponse = self::check_date_unavailability( $appointment_date,$member_id );

			if( $dateresponse === false ) {

				$response = array(

					'nodata'   => '<li class="no-servi-box-alert">'.esc_html__('Sorry, this date is unavailable for appointment. Please choose another date.','appointy').'</li>',

				);

				wp_send_json_error($response);

				exit;

			}

			

			//Get avaialable slots by custom schedule date

			if( intval($member_id) > 0 ) {

			$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `custom_date` = %s AND `member_id` = %d order by `start_time_number` asc',$appointment_date,$member_id));

			}else{

			$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `custom_date` = %s order by `start_time_number` asc',$appointment_date));

			}

			

			if( !empty( $results ) ) {

				$html = self::get_available_slots( $results, $appointment_date, $service_availability_status, $service_start_time, $service_end_time, $booking_date, $booking_start_time, $member_id, $type, $service_id, $service_period );

			} else {

				

				//Check if slots are avaialble on particular day if yes then render timeslots

				$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `weekday` = %s AND `member_id` = %d order by `start_time_number` asc',$day,$member_id));

				

				if( empty( $results ) ) {

					$response = array(

						'nodata'   => '<li class="no-servi-box-alert">'.esc_html__('Sorry, this service is not available on this day. Please choose another day.','appointy').'</li>',

					);

					wp_send_json_error($response);

					exit;

				} else {

					$html = self::get_available_slots( $results, $appointment_date, $service_availability_status, $service_start_time, $service_end_time, $booking_date, $booking_start_time, $member_id, $type, $service_id, $service_period );

				}

			}

			

			if( $html != '' ) {

				$response = array( 'html' => $html );

				wp_send_json_success($response);

			} else {

				$response = array(

					'nodata'   => '<li class="no-servi-box-alert">'.esc_html__('Sorry, service not available on this day. Please choose another day.','appointy').'</li>',

				);

				wp_send_json_error($response);

			}

		

		}

				

		die();

	}

	

	/**

	 * Get available timeslots

	 *

	 * @return array

	 */

	public static function get_available_slots( $results = array(), $appointment_date = '', $service_availability_status = '', $service_start_time = '', $service_end_time = '',  $existing_date = '', $existing_start_time = '', $member_id = 0, $type = '', $service_id = 0, $service_period = 0 ) {

		global $wpdb;

		$service_period = ($service_period != '') ? $service_period : 0;

		ob_start();
		
		$totalwork_periods = count($results);
		$workperiod_count = 1;

		if( !empty( $results ) ) {

			foreach( $results as $row ) {

				$begin = new \DateTime( esc_html($row->start_time) );

				$end = new \DateTime( esc_html($row->end_time) );
				
				$avl_end_time = $end->format('H:i:s');

				$intval = \DateInterval::createFromDateString( intval( esc_html($row->interval) ).' min' );

				$available_start_times = new \DatePeriod($begin, $intval ,$end);

				foreach($available_start_times as $date){

					

					if($member_id > 0) {

					

						if($type == 'editbooking') {

						$blockedrow = $wpdb->get_row($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `dayoff_type` = "timeslot" AND (`type` = "dayoff") AND `start_time` = %s AND `date` = %s',$member_id,$date->format("H:i:s"),$appointment_date));

						}else{

						$blockedrow = $wpdb->get_row($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `dayoff_type` = "timeslot" AND (`type` = "dayoff" OR `type` = "booking") AND `start_time` = %s AND `date` = %s',$member_id,$date->format("H:i:s"),$appointment_date));

						}

					

					}else{

					

						if($type == 'editbooking') {

						$blockedrow = $wpdb->get_row($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE (COALESCE(`member_id`, "") = "" OR `member_id` = 0) AND `dayoff_type` = "timeslot" AND (`type` = "dayoff") AND `start_time` = %s AND `date` = %s',$date->format("H:i:s"),$appointment_date));

						}else{

						$blockedrow = $wpdb->get_row($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE (COALESCE(`member_id`, "") = "" OR `member_id` = 0) AND `dayoff_type` = "timeslot" AND (`type` = "dayoff" OR `type` = "booking") AND `start_time` = %s AND `date` = %s',$date->format("H:i:s"),$appointment_date));

						}

					

					}

					

					

					if( empty( $blockedrow ) ) {

						$start_time = $date->format("H:i:s");

						$minutesToAdd = $service_period;
					
						$dateTime = new DateTime($start_time);
						
						$dateTime->modify("+{$minutesToAdd} minutes");
						
						$end_time = $dateTime->format('H:i:s');
						
						$formated_end_time = date(Appointy_Misc_Helper::get_wp_time_format(), strtotime($end_time));
						
						$buffer_time = Appointy_Misc_Helper::get_settings( 'booking_settings', 'buffer_time' );
						
						if($buffer_time != '') {
							$minutesToAdd = intval($service_period) + intval($buffer_time);	
							
							$dateTime = new DateTime($start_time);
						
							$dateTime->modify("+{$minutesToAdd} minutes");
							
							$end_time = $dateTime->format('H:i:s');
							
							$formated_end_time = date(Appointy_Misc_Helper::get_wp_time_format(), strtotime($end_time));
						}

						//$end_time = date('H:i:s', strtotime($date->format("H:i:s")." +".esc_html($row->interval)." minutes"));

						//$formated_end_time = date(Appointy_Misc_Helper::get_wp_time_format(), strtotime($date->format("H:i:s")." +".esc_html($row->interval)." minutes"));

						

						$slotresponse = self::check_slots_unavailability($appointment_date,$start_time,$end_time,$member_id,$service_availability_status,$service_id,$type,$service_period);

						
						if( $service_availability_status === 'on' ) {

							if( ( $slotresponse === true || ( $appointment_date == $existing_date && $start_time == $existing_start_time ) ) && ( strtotime($service_start_time) <= strtotime($date->format("H:i:s")) && strtotime($date->format("H:i:s")) <= strtotime($service_end_time ) ) && ( strtotime($service_start_time) <= strtotime($end_time) && strtotime($end_time) <= strtotime($service_end_time ) ) && ( ( strtotime($date->format("H:i:s")) > strtotime(wp_date('H:i:s')) && $appointment_date == wp_date('Y-m-d') ) || $appointment_date != wp_date('Y-m-d') ) && ((strtotime($end_time) <= strtotime($avl_end_time) && $workperiod_count == $totalwork_periods) || $workperiod_count != $totalwork_periods) ) {
								
								if( $appointment_date == $existing_date && $start_time == $existing_start_time ) {

									$activeclass = 'active';

								} else {

									$activeclass = '';

								}	

								?>

								<li class="col-lg-6 slotbox" data-start-time="<?php echo esc_attr( $date->format("H:i:s") ); ?>" data-end-time="<?php echo esc_attr( $end_time ); ?>" data-formated-starttime="<?php echo esc_attr( $date->format(Appointy_Misc_Helper::get_wp_time_format()) ); ?>" data-formated-endtime="<?php echo esc_attr( $formated_end_time ); ?>">

									<div class="sf-time-box <?php echo sanitize_html_class($activeclass); ?>">

										<?php echo $date->format( Appointy_Misc_Helper::get_wp_time_format() ); ?>

									</div>

								</li>

								<?php

							}						

						} else {
							if( ( $slotresponse === true || ( $appointment_date == $existing_date && $start_time == $existing_start_time ) ) && ( ( strtotime($date->format("H:i:s")) > strtotime(wp_date('H:i:s')) && $appointment_date == wp_date('Y-m-d') ) || $appointment_date != wp_date('Y-m-d') ) && ((strtotime($end_time) <= strtotime($avl_end_time) && $workperiod_count == $totalwork_periods) || $workperiod_count != $totalwork_periods)) {

								if( $appointment_date == $existing_date && $start_time == $existing_start_time ) {

									$activeclass = 'active';

								} else {

									$activeclass = '';

								}	

								?>

								<li class="col-lg-6 slotbox" data-start-time="<?php echo esc_attr( $date->format("H:i:s") ); ?>" data-end-time="<?php echo esc_attr( $end_time ); ?>" data-formated-starttime="<?php echo esc_attr( $date->format(Appointy_Misc_Helper::get_wp_time_format()) ); ?>" data-formated-endtime="<?php echo esc_attr( $formated_end_time ); ?>">

									<div class="sf-time-box <?php echo sanitize_html_class($activeclass); ?>">

										<?php echo $date->format( Appointy_Misc_Helper::get_wp_time_format() ); ?>

									</div>

								</li>

								<?php

							}

						}

						

					}

				}
				
				$workperiod_count++;

			}

		}

		

		$html = ob_get_clean();

		

		return $html;

	}

	

	/**

	 * Get available timeslots for multidate

	 *

	 * @return array

	 */

	public static function get_available_slots_for_multidate( $results = array(), $appointment_date = '', $service_availability_status = '', $service_start_time = '', $service_end_time = '',  $existing_date = '', $existing_start_time = '', $member_id = 0, $type = '', $service_id = 0, $service_period = 0 ) {

		global $wpdb;

		$service_period = ($service_period != '') ? $service_period : 0;

		$avl_date_slots = array();

		

		//ob_start();
		
		$totalwork_periods = count($results);
		$workperiod_count = 1;

		if( !empty( $results ) ) {

			foreach( $results as $row ) {

				$begin = new \DateTime( esc_html($row->start_time) );

				$end = new \DateTime( esc_html($row->end_time) );
				
				$avl_end_time = $end->format('H:i:s');

				$intval = \DateInterval::createFromDateString( intval( esc_html($row->interval) ).' min' );

				$available_start_times = new \DatePeriod($begin, $intval ,$end);

				foreach($available_start_times as $date){

					

					if($member_id > 0) {

					

					if($type == 'editbooking') {

					$blockedrow = $wpdb->get_row($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `dayoff_type` = "timeslot" AND (`type` = "dayoff") AND `start_time` = %s AND `date` = %s',$member_id,$date->format("H:i:s"),$appointment_date));

					}else{

					$blockedrow = $wpdb->get_row($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `dayoff_type` = "timeslot" AND (`type` = "dayoff" OR `type` = "booking") AND `start_time` = %s AND `date` = %s',$member_id,$date->format("H:i:s"),$appointment_date));

					}

					

					}else{

					

					if($type == 'editbooking') {

					$blockedrow = $wpdb->get_row($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE (COALESCE(`member_id`, "") = "" OR `member_id` = 0) AND `dayoff_type` = "timeslot" AND (`type` = "dayoff") AND `start_time` = %s AND `date` = %s',$date->format("H:i:s"),$appointment_date));

					}else{

					$blockedrow = $wpdb->get_row($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE (COALESCE(`member_id`, "") = "" OR `member_id` = 0) AND `dayoff_type` = "timeslot" AND (`type` = "dayoff" OR `type` = "booking") AND `start_time` = %s AND `date` = %s',$date->format("H:i:s"),$appointment_date));

					}

					

					}

					

					

					if( empty( $blockedrow ) ) {

						$start_time = $date->format("H:i:s");

						
						$minutesToAdd = $service_period;
					
						$dateTime = new DateTime($start_time);
						
						$dateTime->modify("+{$minutesToAdd} minutes");
						
						$end_time = $dateTime->format('H:i:s');
						
						$formated_end_time = date(Appointy_Misc_Helper::get_wp_time_format(), strtotime($end_time));
						
						$buffer_time = Appointy_Misc_Helper::get_settings( 'booking_settings', 'buffer_time' );
						
						if($buffer_time != '') {
							$minutesToAdd = intval($service_period) + intval($buffer_time);	
							
							$dateTime = new DateTime($start_time);
						
							$dateTime->modify("+{$minutesToAdd} minutes");
							
							$end_time = $dateTime->format('H:i:s');
							
							$formated_end_time = date(Appointy_Misc_Helper::get_wp_time_format(), strtotime($end_time));
						}
						
						//$end_time = date('H:i:s', strtotime($date->format("H:i:s")." +".esc_html($row->interval)." minutes"));

						//$formated_end_time = date(Appointy_Misc_Helper::get_wp_time_format(), strtotime($date->format("H:i:s")." +".esc_html($row->interval)." minutes"));

						

						$slotresponse = self::check_slots_unavailability($appointment_date,$start_time,$end_time,$member_id,$service_availability_status,$service_id,$type,$service_period);

						

						

						if( $service_availability_status === 'on' ) {

							if( ( $slotresponse === true || ( $appointment_date == $existing_date && $start_time == $existing_start_time ) ) && ( strtotime($service_start_time) <= strtotime($date->format("H:i:s")) && strtotime($date->format("H:i:s")) <= strtotime($service_end_time ) ) && ( strtotime($service_start_time) <= strtotime($end_time) && strtotime($end_time) <= strtotime($service_end_time ) ) && ( ( strtotime($date->format("H:i:s")) > strtotime(wp_date('H:i:s')) && $appointment_date == wp_date('Y-m-d') ) || $appointment_date != wp_date('Y-m-d') ) && ((strtotime($end_time) <= strtotime($avl_end_time) && $workperiod_count == $totalwork_periods) || $workperiod_count != $totalwork_periods) ) {

								if( $appointment_date == $existing_date && $start_time == $existing_start_time ) {

									$activeclass = 'active';

								} else {

									$activeclass = '';

								}

								$avl_date_slots[$appointment_date][] = 	$date->format("H:i:s");

								

							}						

						} else {

							if( ( $slotresponse === true || ( $appointment_date == $existing_date && $start_time == $existing_start_time ) ) && ( ( strtotime($date->format("H:i:s")) > strtotime(wp_date('H:i:s')) && $appointment_date == wp_date('Y-m-d') ) || $appointment_date != wp_date('Y-m-d') ) && ((strtotime($end_time) <= strtotime($avl_end_time) && $workperiod_count == $totalwork_periods) || $workperiod_count != $totalwork_periods) ) {

								if( $appointment_date == $existing_date && $start_time == $existing_start_time ) {

									$activeclass = 'active';

								} else {

									$activeclass = '';

								}	

								

								$avl_date_slots[$appointment_date][] = 	$date->format("H:i:s");

								

							}

						}

						

					}

				}
				
				$workperiod_count++;

			}

		}

		

		//$html = ob_get_clean();

		

		return $avl_date_slots;

	}

	

	

	/**

	 * Check slots unavailability

	 *

	 * @return array

	 */

	public static function check_slots_unavailability( $appointment_date = '',$start_time = '',$end_time = '',$member_id = 0,$service_availability_status = '',$service_id = 0,$type = '', $service_period = 0 ) {
		global $wpdb;	
		
		$service_period = ($service_period != '') ? $service_period : 0;
		
		$minutesToAdd = $service_period;
					
		$dateTime = new DateTime($start_time);
		
		$dateTime->modify("+{$minutesToAdd} minutes");
		
		$end_time = $dateTime->format('H:i:s');
		
		$buffer_time = Appointy_Misc_Helper::get_settings( 'booking_settings', 'buffer_time' );
		
		if($buffer_time != '') {
			$minutesToAdd = intval($service_period) + intval($buffer_time);	
			
			$dateTime = new DateTime($start_time);
		
			$dateTime->modify("+{$minutesToAdd} minutes");
			
			$end_time = $dateTime->format('H:i:s');
		}
		
		$current_day = Appointy_Misc_Helper::get_day( $appointment_date );

		

		if($type == 'editbooking') {

			if( $service_availability_status === 'on' ) {

				if($member_id > 0) {

					if(intval($service_period) > 0) {
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `service_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s" OR `end_time` = "%s") )',$member_id,$service_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time));
					}else{
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `service_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s") )',$member_id,$service_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time));		
					}
					

				}else{

					if(intval($service_period) > 0) {
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `service_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s" OR `end_time` = "%s") )',$service_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time));
					}else{
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `service_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s") )',$service_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time));
					}
					

				}	

			}else{

				if($member_id > 0) {

					if(intval($service_period) > 0) {
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s" OR `end_time` = "%s") )',$member_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time));
					}else{
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s") )',$member_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time));
					}
					

				}else{

					if(intval($service_period) > 0) {
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s" OR `end_time` = "%s") )',$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time));					
					}else{
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s") )',$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time));
					}

				}

			}

		}else{

			if( $service_availability_status === 'on' ) {

				if($member_id > 0) {
					
					if(intval($service_period) > 0) {
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `service_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff" OR `type` = "booking") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s" OR `end_time` = "%s") )',$member_id,$service_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time));
					}else{
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `service_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff" OR `type` = "booking") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s") )',$member_id,$service_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time));
					}
					

				}else{
					
					if(intval($service_period) > 0) {
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `service_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff" OR `type` = "booking") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s" OR `end_time` = "%s") )',$service_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time));
					}else{
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `service_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff" OR `type` = "booking") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s") )',$service_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time));
					}
					

				}	

			}else{

				if($member_id > 0) {

					if(intval($service_period) > 0) {
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff" OR `type` = "booking") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s" OR `end_time` = "%s") )',$member_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time));
					}else{
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff" OR `type` = "booking") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s") )',$member_id,$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time));
					}
					

				}else{

					if(intval($service_period) > 0) {
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff" OR `type` = "booking") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s" OR `end_time` = "%s") )',$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time));
					}else{
					$slot_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `dayoff_type` = "timeslot" AND ((`day` = %s) OR ((`type` = "dayoff" OR `type` = "booking") AND `date` = %s)) AND ((`start_time` > "%s" AND `start_time` < "%s") OR (`end_time` > "%s" AND `end_time` < "%s") OR (`start_time` < "%s" AND `end_time` > "%s") OR (`start_time` = "%s") )',$current_day,$appointment_date,$start_time,$end_time,$start_time,$end_time,$start_time,$end_time,$start_time));
					}
				}

			}			

		}

		

		if( empty( $slot_unavailability ) ) {

			return true;

		} else {

			return false;

		}

	}

	

	/**

	 * Check unavaialble dates

	 *

	 * @return array

	 */

	public static function check_date_unavailability( $appointment_date = '',$member_id = 0 ) {

		global $wpdb;

		

		$blockeddates = self::get_blocked_dates($member_id);

		if( in_array($appointment_date,$blockeddates) ) {

			return false;

		}

		

		$member_unavailability = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND ((`dayoff_type` = "multidate" AND `date` = %s) OR (`dayoff_type` = "daterange" AND `start_date` <= %s AND `end_date` >= %s))',$member_id,$appointment_date,$appointment_date,$appointment_date));

			

		if( empty($member_unavailability) ) {

			return true;

		} else {

			return false;

		}

	}

	

	/**

	 * Get blocked dates

	 *

	 * @return array

	 */

	public static function get_blocked_dates( $member_id = 0 ) {

		global $wpdb;

		

		$results = $wpdb->get_results($wpdb->prepare('SELECT `date` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND (`type` = "dayoff" AND `dayoff_type` = "multidate")',$member_id));

			

		$ranges = $wpdb->get_results($wpdb->prepare('SELECT `start_date`,`end_date` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND `type` = "dayoff" AND `dayoff_type` = "daterange"',$member_id));

		

		$blockedbookings = $wpdb->get_results($wpdb->prepare('SELECT `date` FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `member_id` = %d AND (`type` = "booking" AND `dayoff_type` = "fullday")',$member_id));

		

		$alldates = array();

		

		if(!empty($results)) {

			foreach($results as $row) {

				if(!empty($row->date)) {

					$alldates[] = $row->date;

				}

			}

		}

		

		if( !empty($ranges) ) {

			foreach( $ranges as $range ) {

				if( $range->start_date != '' && $range->end_date != '' ) {

					$start_date = $range->start_date;

					$end_date = $range->end_date;

					$dates = self::get_dates_from_range($start_date,$end_date); 

					

					if(!empty($dates)) {

						foreach($dates as $date) {

							$alldates[] = $date;

						}

					}				

				}

			}

		}

		

		if(!empty($blockedbookings)) {

			foreach($blockedbookings as $blockedbooking) {

				if(!empty($blockedbooking->date)) {

					$alldates[] = $blockedbooking->date;

				}

			}

		}

		

		return $alldates;

	}

	

	/**

	 * Get dates between date range

	 *

	 * @return array

	 */

	public static function get_dates_from_range($start, $end) { 

		  

		$array = array(); 

		  

		$interval = new \DateInterval('P1D'); 

	  

		$realEnd = new \DateTime($end); 

		$realEnd->add($interval); 

	  

		$period = new \DatePeriod(new \DateTime($start), $interval, $realEnd); 

	  

		foreach($period as $date) {                  

			$array[] = $date->format("Y-m-d");  

		} 

	  

		return $array; 

	}

	

	public static function get_service_location_staff( $service_id = 0,$locationid = 0 ) {

		global $wpdb;

		

		$service_location_satffs = $wpdb->get_results($wpdb->prepare('SELECT `staff_id` FROM `'.$wpdb->prefix.'appointy_service_location_satff` WHERE `service_id` = %d AND `location_id` = %d',$service_id,$locationid));

		

		if(empty($service_location_satffs)) {

			$service_location_satffs = $wpdb->get_results($wpdb->prepare('SELECT `staff_id` FROM `'.$wpdb->prefix.'appointy_service_location_satff` WHERE `service_id` = %d AND `location_id` = 0',$service_id));

		}

		

		return $service_location_satffs;

	}

	

	public static function get_service_location( $service_id = 0 ) {

		global $wpdb;

		

		$service_locations = $wpdb->get_results($wpdb->prepare('SELECT `location_id` FROM `'.$wpdb->prefix.'appointy_service_location_satff` WHERE `service_id` = %d GROUP BY `location_id`',$service_id));

		

		$location_ids = array();

		if(!empty($service_locations)) {

			foreach($service_locations as $service_location){

				$location_ids[] = Appointy_Router_Helper::get_sanitize_data($service_location,'location_id');

			}

		}

		

		return $location_ids;

	}	

	

	/**

	 * Process load location staff

	 *

	 * @return array

	 */

	public function load_service_staff( ) {

		global $wpdb;

		ob_start();

		

		$service_id = Appointy_Router_Helper::get_request_data( $_POST, 'service_id' );

		$locationid = Appointy_Router_Helper::get_request_data( $_POST, 'locationid' );

		$variation_id = Appointy_Router_Helper::get_request_data( $_POST, 'variation_id' );

		$servicetype = Appointy_Router_Helper::get_request_data( $_POST, 'servicetype' );

		

		$i = 0;

		if($service_id > 0) {

			$service_staff = self::get_service_location_staff($service_id,$locationid);

			

			if(!empty($service_staff)) {

				foreach( $service_staff as $row ) {

					$staff_id = Appointy_Router_Helper::get_sanitize_data($row,'staff_id');

				

					$userdata = get_userdata( $staff_id );

					$staff_name = Appointy_Router_Helper::get_request_data( $userdata, 'display_name' );

					$attachment_id = get_user_meta($staff_id, $wpdb->get_blog_prefix().'user_avatar', true);

					

					if($attachment_id > 0) {

						$image_url = Appointy_Image_Helper::get_image_url_by_id($attachment_id);

					} else {

						$image_url = Appointy_Image_Helper::get_image_url_by_id();

					}

					$ratingprefix = 'staffloop';

					

					$rating = get_user_meta( $staff_id,'avg_booking_rating',true );

					?>

					

					<li class="ap-team-col staffitem" data-staffid="<?php echo esc_attr($staff_id); ?>" data-staffname="<?php echo esc_attr($staff_name); ?>">

						<div class="sf-team-mamber-wrap">

							<div class="sf-team-mamber-pic"> <img src="<?php echo esc_url($image_url); ?>">

								<div class="sf-team-member-overlay"><span><i class="fa fa-check"></i></span></div>

							</div>

							<div class="sf-team-mamber-info">

								<h6><?php echo esc_html($staff_name); ?></h6>

								

								<div class="star-num-wrap">

									<div class="showrating" id="showrating-<?php echo esc_attr($ratingprefix); ?>-<?php echo esc_attr($staff_id); ?>" data-reviewid="<?php echo esc_attr($ratingprefix); ?>-<?php echo esc_attr($staff_id); ?>" data-rating="<?php echo esc_attr(floatval($rating)); ?>"></div>

									<span class="sf-rating-lable">(<?php echo trim($rating); ?>/5)</span>

								</div>

							</div>

						</div>

					</li>

					<?php

					$i++;

				}

				?>

				<a href="javascript:;" class="btn btn-primary staffitem" data-staffid="0" data-staffname="<?php echo esc_attr__( 'Any Member','appointy' ); ?>"><?php echo __( 'Any Member','appointy' ); ?></a>

				<?php

			}

		}

		

		if( $i === 0 ) {

			echo '<div class="sf-no-staff not-found">';

			echo __( 'There is no staff member available at this location.','appointy' );

			echo '</div>';	

		}

		$html = ob_get_clean();

		

		if($servicetype === 'hourly') {

			$location_price = $wpdb->get_row($wpdb->prepare('SELECT `final_price` FROM `'.$wpdb->prefix.'appointy_service_location_prices` WHERE `service_id` = %d AND `variation_id` = %d AND `location_id` = %d',$service_id,$variation_id,$locationid));

		

			if(!empty($location_price)) {

				$service_price = Appointy_Router_Helper::get_sanitize_data($location_price,'final_price');

			}else{

				$service_price = '';

			}		

		}else{

			$location_price = $wpdb->get_row($wpdb->prepare('SELECT `final_price` FROM `'.$wpdb->prefix.'appointy_service_location_prices` WHERE `service_id` = %d AND `location_id` = %d',$service_id,$locationid));

			

			if(!empty($location_price)) {

				$service_price = Appointy_Router_Helper::get_sanitize_data($location_price,'final_price');

			}else{

				$service_price = '';

			}

		}

		

		$response = array(

			'html'   => $html,

			'service_price'   => $service_price,

			'skipstaff'   => ($i === 0) ? 'yes' : 'no'

		);

		

		wp_send_json_success($response);

   		die();

	}

	

	/**

	 * Process load service location

	 *

	 * @return array

	 */

	public function load_service_locations( ) {

		global $wpdb;

		ob_start();

		

		$service_id = Appointy_Router_Helper::get_request_data( $_POST, 'service_id' );

		

		$i = 0;

		if($service_id > 0) {

			$service_locations = self::get_service_location($service_id);

			

			/*if(in_array(0,$service_locations)) {

				$nohtml =  '<div class="sf-no-staff not-found">';

				$nohtml .= __( 'There is no location available for this service.','appointy' );

				$nohtml .= '</div>';

				$response = array(

					'html'   => $nohtml

				);

				

				wp_send_json_success($response);

				exit;

			}*/

			

			$locations = Appointy_Booking_Form_Helper::get_locations();

			if(!empty($locations)) {

				foreach( $locations as $location ) {

					$locationid = Appointy_Router_Helper::get_request_data($location,'ID');

					

					if(in_array($locationid,$service_locations)) {

					

					$attachment_id = get_post_meta($locationid, 'image_id', true);

					$address = get_post_meta($locationid, 'friendly_address', true);

					

					if($attachment_id > 0) {

						$image_url = Appointy_Image_Helper::get_image_url_by_id($attachment_id);

					} else {

						$image_url = Appointy_Image_Helper::get_image_url_by_id();

					}

					?>

					<li class="ap-loca-col locationitem" data-locationid="<?php echo esc_attr($locationid); ?>" data-address="<?php echo esc_attr($address); ?>">

						<div class="ap-loca-box-wrap">

							<div class="sf-loca-box-icon"> <i class="feather-map-pin"></i> </div>

							<div class="sf-loca-box-info">

								<h6 class="sf-loca-box-title"><?php echo get_the_title($location); ?></h6>

								<span class="sf-loca-address-line"><?php echo esc_html($address); ?></span> </div>

						</div>

					</li>

					<?php

					$i++;

					}

				}

			}

		}

		

		if( $i === 0 ) {

			echo '<div class="sf-no-staff not-found">';

			echo __( 'There is no location available for this service.','appointy' );

			echo '</div>';	

		}

		$html = ob_get_clean();

		

		$response = array(

			'html'   => $html

		);

		

		wp_send_json_success($response);

   		die();

	}
	
	/**

	 * Has service location

	 *

	 * @return array

	 */
	public static function has_service_locations_available($service_id = 0) {
		global $wpdb;

		$falg = 0;

		if($service_id > 0) {

			$service_locations = self::get_service_location($service_id);

			$locations = Appointy_Booking_Form_Helper::get_locations();

			if(!empty($locations)) {

				foreach( $locations as $location ) {

					$locationid = Appointy_Router_Helper::get_request_data($location,'ID');

					

					if(in_array($locationid,$service_locations)) {

					$falg = 1;
					
					break;

					}

				}

			}

		}

		if($falg === 1) {
			return true;
		}else{
			return false;
		}

	}

	

	/**

	 * Process load extra services

	 *

	 * @return array

	 */

	public function load_extra_services( ) {

		global $wpdb;

		ob_start();

		

		$service_id = Appointy_Router_Helper::get_request_data( $_POST, 'service_id' );

		

		$i = 0;

		if($service_id > 0) {

			$extra_services = self::get_extra_services($service_id);

			

			if(!empty($extra_services)) {

				foreach( $extra_services as $extra_service ) {

					$extra_post_id = Appointy_Router_Helper::get_sanitize_data($extra_service,'post_id');

					$service_title = get_the_title($extra_post_id);

					

					$attachment_id = get_post_meta($extra_post_id, 'image_id', true);



					$serviethumb = Appointy_Image_Helper::get_image_url_by_id($attachment_id,'thumbnail');

					

					$extra_service_prices = self::get_extra_service_price( $extra_post_id );

					$service_price = Appointy_Router_Helper::get_sanitize_data($extra_service_prices,'service_price');

					$del_price = (!empty($extra_service_prices['del_price'])) ? $extra_service_prices['del_price'] : '';

					

					$service_fixed_hours = get_post_meta($extra_post_id,'_service_fixed_hours',true);

					$service_fixed_minutes = get_post_meta($extra_post_id,'_service_fixed_minutes',true);
					
					$service_max_quantity = get_post_meta($extra_post_id,'max_quantity',true);

					

					$period = Appointy_Booking_Form_Helper::get_duration($service_fixed_hours,$service_fixed_minutes);

					

					$service_period = Appointy_Booking_Form_Helper::display_service_hours($service_fixed_hours,$service_fixed_minutes);

					

					$hours = $service_fixed_hours;

					$minutes = $service_fixed_minutes;

					

					$options = array(

						'extra_post_id' 	=> $extra_post_id,

						'service_name' 		=> get_the_title($extra_post_id),

						'service_image' 	=> $serviethumb,

						'service_period' 	=> ( !empty( $period ) ) ? $period : '',

						'hours' 			=> $hours,

						'minutes' 			=> $minutes,

						'display_service_period' 	=> $service_period,

						'service_price' 	=> $service_price,
						
						'max_service_quantity' 	=> $service_max_quantity

					);

					?>

					<li class="ap-exser-col exserviceitem" data-options="<?php echo esc_attr(wp_json_encode( $options )); ?>">

						<div class="sf-exser-wrap">

							<div class="sf-exser-pic"> <img src="<?php echo esc_url($serviethumb); ?>">

								<div class="sf-exser-overlay"><span><i class="fa fa-check"></i></span></div>

							</div>

							<div class="sf-exser-info">

								<h6><?php echo esc_html($service_title); ?></h6>

								

								<div class="sf-exser-price">

									<div class="sf-service-price"><?php printf($del_price); ?></div>

									<div class="sf-service-price2"><span class="icon"></span><?php echo Appointy_Misc_Helper::get_price_format($service_price); ?></div>

								</div>
                                
                                <div class="sf-exser-quantity">

									<input type="number" name="extra_service_quantity" class="form-control" value="1" min="1" max="<?php echo esc_attr($service_max_quantity); ?>">

								</div>

							</div>

						</div>

					</li>

					<?php

				}

			}

		}	

		

		$html = ob_get_clean();

		

		$response = array(

			'html'   => $html

		);

		

		wp_send_json_success($response);

   		die();

	}

	

	/**

	 * Load blocked dates

	 *

	 * @return array

	 */

	public function load_blocked_dates( ) {

		global $wpdb;

		

		

		$selected_service = (!empty($_POST['selected_service'])) ? $_POST['selected_service'] : array();

		

		$member_id = Appointy_Router_Helper::get_request_data( $selected_service, 'member_id' );

		

		$member_id = intval($member_id);

		

		$blockeddates = self::get_blocked_dates($member_id);

		

		$response = array(

			'blockeddates'   => $blockeddates

		);

		

		wp_send_json_success($response);

   		die();

	}

	

	/**

	 * Process load hourly services

	 *

	 * @return array

	 */

	public function load_hourly_service( ) {

		global $wpdb;

		ob_start();

		$post_id = Appointy_Router_Helper::get_request_data( $_POST, 'postid' );

		$k = Appointy_Router_Helper::get_request_data( $_POST, 'k' );

		$term_id = Appointy_Router_Helper::get_request_data( $_POST, 'term_id' );

		

		$service_variations = get_post_meta($post_id,'_service_variations',true);

		if( !empty( $service_variations ) ) {

		?>

		<div class="hourly-services-box">

			<ul class="sf-extraservice-list">

				<?php

				foreach( $service_variations as $key => $service_variation ) {

				$variation_name = ( !empty( $service_variation[0] ) ) ? esc_html($service_variation[0]) : '';

				$hours = ( !empty( $service_variation[1] ) ) ? esc_html($service_variation[1]) : 0;

				$minutes = ( !empty( $service_variation[2] ) ) ? esc_html($service_variation[2]) : 0;

				$price = ( !empty( $service_variation[3] ) ) ? esc_html($service_variation[3]) : '';

				$delprice = ( !empty( $service_variation[4] ) ) ? esc_html($service_variation[4]) : '';

				$variation_id = $key;

				

				if((!$price > 0) || $price === '') {

					$tempprice = $price;

					$price = $delprice;

					$delprice = $tempprice;

				}

				

				if($delprice > 0) {

				$del_price = sprintf('<span><del>%s</del></span>',Appointy_Misc_Helper::get_price_format($delprice));

				} else {

				$del_price = '';

				}

				

				$period = Appointy_Booking_Form_Helper::get_duration($hours,$minutes);

				

				$service_period = Appointy_Booking_Form_Helper::display_service_hours($hours,$minutes);

				

				$attachment_id = get_post_meta($post_id, 'image_id', true);

				

				$servicetype = get_post_meta($post_id,'_servicetype',true);

				$serviethumb = Appointy_Image_Helper::get_image_url_by_id($attachment_id,'thumbnail');

				

				

				$hourly_options = array(

					'id' 	=> $k,

					'service_id' 		=> $post_id,

					'service_name' 		=> get_the_title(),

					'service_image' 	=> $serviethumb,

					'repeat' 			=> get_post_meta($post_id,'repeat',true),

					'frequencies' 		=> get_post_meta($post_id,'frequencies',true),

					'extra_service'		=> self::has_extra_service($post_id),

					'multidate_service'	=> get_post_meta($post_id,'multidate_service',true),

					'multidate_service_type'	=> get_post_meta($post_id,'multidate_service_type',true),

					'number_of_dates'	=> get_post_meta($post_id,'number_of_dates',true),

					'fullday_timeslots'	=> get_post_meta($post_id,'fullday_timeslots',true),

					'parent_category' 	=> $term_id,

					'servicetype'		=> $servicetype,

					'variation_name' 	=> $variation_name,

					'variation_id' 		=> $variation_id,

					'service_period' 	=> $period,

					'hours' 			=> $hours,

					'minutes' 			=> $minutes,

					'display_service_period' 	=> $service_period,

					'service_price' 	=> $price,

					'old_service_price' 	=> '',

					'coupon_verified' 	=> false,

					'couponcode' 		=> '',

					'couponcode_available' 	=> self::has_couponcode_available_for_service($post_id),

					'show_branches' 	=> self::has_service_locations_available($post_id),

					'members_available' => self::has_members_available($post_id)

				);

				?>

				<li>

					<div class="sf-extraservice-title">

						<h6 class="ap-extra-servi-title"><?php echo esc_html($service_variation[0]); ?></h6>

					</div>

					<div class="sf-extraservice-des">

						<div class="ap-extra-servi-time">

							<span><?php echo esc_html($service_period); ?></span>

						</div>

						

						<div class="ap-extra-servi-price">

							<?php printf($del_price); ?>

							<span><?php echo Appointy_Misc_Helper::get_price_format($price); ?></span>

						</div>

						

						<div class="ap-extra-servi-btn">

							<button id="addtocart-<?php echo esc_attr($k); ?>" class="book-btn addtocart" type="button" data-options="<?php echo esc_attr(wp_json_encode( $hourly_options )); ?>">

								<?php esc_html_e( 'Book','appointy' ) ?>

							</button>

						</div>

						

					</div>

				</li>

				<?php

				$k++;

				}

				?>

			</ul>

		</div>

		<?php

		}else{

			echo '<div class="sf-no-staff not-found">';

			echo esc_html__( 'There is no service.','appointy' );

			echo '</div>';	

		}

		$html = ob_get_clean();

		$response = array(

			'html'   => $html,

		);

		wp_send_json_success($response);

   		die();

	}

	/**

	 * Get booking categories

	 *

	 * @return void

	 */

	public static function get_booking_categories() {

	     global $wpdb;

		

		$args = array(

            'post_type' => 'appointy_services',

            'post_status' => 'publish',

            'posts_per_page' => -1,

        );

		

        $the_query = new \WP_Query($args);

		

		$categories = [];

		

		if ( $the_query->have_posts() ) {

			$nestedData = array();

			while ( $the_query->have_posts() ) : $the_query->the_post();

				$serviceid = get_the_id();

				$categories[] = get_the_terms($serviceid,'appointy_service_category');

			endwhile;

			wp_reset_postdata();

		}

		

		$child = $parent = [];

		

		if( !empty( $categories ) ) {

			foreach( $categories as $category ) {

				if( !empty( $category ) ) {

					foreach( $category as $cat ) {

						if( intval(Appointy_Router_Helper::get_request_data($cat,'parent')) === 0 ){

							$parent[] = Appointy_Router_Helper::get_request_data($cat,'term_id');

						} else {

							$child[] = Appointy_Router_Helper::get_request_data($cat,'term_id');

						}

					}

				}

			}

		}

		

		$response = array(

				'parent'	=> 	array_unique($parent),

				'child'		=> 	array_unique($child)

		);

		

		return $response;

	}

	

	/**

	 * Get total services in category

	 *

	 * @return void

	 */

	public static function get_total_category_services($term_id = 0) {

		$texonomy = 'appointy_service_category';

		

		$args = array(

			'post_status' => 'publish',

			'post_type' => 'appointy_services',

			'tax_query' => array(

				array(

					'taxonomy' => $texonomy,

					'field'    => 'term_id',

					'terms'    => $term_id,

				),

			),

		);

		$the_query = new WP_Query( $args );

		

		$total_category_serives = $the_query->found_posts;

		

		return $total_category_serives;

	}

	

	/**

	 * Get variations min and max period

	 *

	 * @return void

	 */

	public static function get_variation_min_max_period($post_id = 0)

	{

		$service_variations = get_post_meta($post_id,'_service_variations',true);

		$period = [];

		if( !empty( $service_variations ) ) {

			foreach( $service_variations as $service_variation ) {

				

			$hours = ( !empty( $service_variation[1] ) ) ? intval($service_variation[1]) : 0;

			$minutes = ( !empty( $service_variation[2] ) ) ? intval($service_variation[2]) : 0;

			

			$period[] = self::get_duration($hours,$minutes);

			

			}

		}

		

		if(!empty($period)) {

			$min = min($period);

			$max = max($period);

		} else {

			$min = 0;

			$max = 0;

		}

		

		return array('min' => $min, 'max' => $max);

		

	}

	

	/**

	 * Get duration by hours and minutes

	 *

	 * @return void

	 */

	public static function get_duration($hours = 0,$minutes = 0) {

		$duration = intval($minutes) + (intval($hours) * 60);

		

		return $duration;

	}

	

	/**

	 * Display service period format

	 *

	 * @return void

	 */

	public static function convert_minutes_to_hours($minutes = 0) {
		if(intval($minutes) > 0) {
			$hours = floor($minutes / 60);
	
			$minutes = ($minutes -   floor($minutes / 60) * 60);
	
			
	
			$format = self::display_service_hours($hours,$minutes);
	
			
	
			return $format;
		}else{
			return '';
		}
		

	}

	

	/**

	 * Display service duration by hours and minutes

	 *

	 * @return void

	 */

	public static function display_service_hours($hours = 0,$minutes = 0) {

		$format = '';

		$hours = intval($hours);

		$minutes = intval($minutes);

		if($hours > 0 && $minutes > 0) {

			$format = $hours.' '.esc_html__('hrs', 'appointy').' '.$minutes.' '.esc_html__('mins', 'appointy');

		} elseif($hours > 0 && $minutes === 0) {

			$format = $hours.' '.esc_html__('hrs', 'appointy');

		} elseif($minutes > 0 && $hours === 0) {

			$format = $minutes.' '.esc_html__('mins', 'appointy');

		}

		

		return $format;

	}

	

	/**

	 * Check service members avaialble or not also check members will be available at booking time

	 *

	 * @return void

	 */

	public static function has_couponcode_available_for_service($serviceid = 0,$couponcode = '') {

		global $wpdb;

		

		if($couponcode != '') {

			$args = array(

				'post_status' => 'publish',

				'post_type' => 'appointy_coupons',

				'meta_query' => array(

					'relation' => 'AND',

					'state_clause' => array(

						'key' => 'coupon_code',

						'value' => $couponcode,

						'compare' => '='

					),

					array(

						'key'     => 'services',

						'compare' => 'REGEXP',

						'value'   => '(^|,)'.preg_quote($serviceid).'(,|$)',

					)

				),

				'meta_query' => array(

					array(

						'key'     => 'services',

						'compare' => 'REGEXP',

						'value'   => '(^|,)'.preg_quote($serviceid).'(,|$)',

					),

				)

			);

			$the_query = new WP_Query( $args );

			

			$total_avl_coupons = $the_query->found_posts;

			

			if( $total_avl_coupons > 0 ) {

				return true;

			} else {

				return false;

			}

		} else {

			$args = array(

				'post_status' => 'publish',

				'post_type' => 'appointy_coupons',

				'meta_query' => array(

					array(

						'key'     => 'services',

						'compare' => 'REGEXP',

						'value'   => '(^|,)'.preg_quote($serviceid).'(,|$)',

					),

				)

			);

			$the_query = new WP_Query( $args );

			

			$total_avl_coupons = $the_query->found_posts;

			

			if( $total_avl_coupons > 0 ) {

				return true;

			} else {

				return false;

			}

		}

	}

	

	/**

	 * Check locations available for booking

	 *

	 * @return void

	 */

	public static function has_locations_available() {

		$args = array(

			'post_type'      => 'appointy_locations',

			'post_status'    => 'publish'

		);

		

		$locations = get_posts($args);

		

		if( !empty($locations) ) {

			return true;

		} else {

			return false;

		}

	}

	

	/**

	 * Get appointment ref id

	 *

	 * @return void

	 */

	public static function get_appointment_ref_id() {

		global $wpdb;

		

		$meta_key = 'appointment_ref_id';

		$row = $wpdb->get_row($wpdb->prepare('SELECT max(meta_value) as max_ref_id FROM `'.$wpdb->prefix.'postmeta` WHERE `meta_key` = %s',$meta_key));

		

		if( !empty($row) ) {

			$max_ref_id = Appointy_Router_Helper::get_request_data( $row, 'max_ref_id' );

		} else {

			$max_ref_id = 1000;

		}

		

		$max_ref_id = ($max_ref_id != '') ? $max_ref_id : 1000;

		

		$max_ref_id = intval($max_ref_id) + 1;

		

		return esc_html($max_ref_id);

	}

	

	/**

	 * Check service members avaialble or not also check members will be available at booking time

	 *

	 * @return void

	 */

	public static function has_members_available($serviceid = 0) {

		$service_staff = get_post_meta($serviceid,'_service_staff',true);

		

		if(!empty($service_staff)) {

			return true;

		} else {

			return false;

		}

	}

	

	/**

	 * Get all locations

	 *

	 * @return void

	 */

	public static function get_locations() {

		$args = array(

			'post_type'      => 'appointy_locations',

			'post_status'    => 'publish',

			'posts_per_page' => -1

		);

		

		$locations = get_posts($args);

		

		return $locations;

	}

	

	public static function appointment_form_fields() {

		

		$fields = apply_filters( 'appointy_staff_form_fields', array(

			'first_name' => array(

				'label' => esc_html__( 'First Name', 'appointy' ),

				'type'        => 'text',

				'icon'        => 'feather-user',

				'colum-width' => 'col-md-6',

				'required'    => true,

				'validation_message' => esc_html__( 'First name is required', 'appointy' ),

				'priority'    => 1

			),

			'last_name' => array(

				'label' => esc_html__( 'Last Name', 'appointy' ),

				'type'        => 'text',

				'icon'        => 'feather-user',

				'colum-width' => 'col-md-6',

				'required'    => true,

				'validation_message' => esc_html__( 'Last name is required', 'appointy' ),

				'priority'    => 2

			),

			'email' => array(

				'label' => esc_html__( 'Email Address', 'appointy' ),

				'type'        => 'email',

				'icon'        => 'feather-mail',

				'colum-width' => 'col-md-4',

				'required'    => true,

				'validation_message' => esc_html__( 'Email is required', 'appointy' ),

				'priority'    => 3

			),

			'country_code' => array(

				'label'       => esc_html__( 'Country Code', 'appointy' ),

				'type'        => 'select',

				'icon'        => 'feather-map-pin',

				'colum-width' => 'col-lg-4',

				'required'    => true,

				'priority'    => 4,

				'options' 	  => Appointy_Sms_Helper::get_country_code_dropdown(),

			),

			'phone' => array(

				'label'       => esc_html__( 'Contact No', 'appointy' ),

				'type'        => 'text',

				'icon'        => 'feather-phone-call',

				'colum-width' => 'col-lg-4',

				'required'    => true,

				'placeholder' => '',

				'priority'    => 5

			),

			'description' => array(

				'label'       => esc_html__( 'Description', 'appointy' ),

				'type'        => 'textarea',

				'colum-width' => 'col-lg-12',

				'icon'        => 'feather-edit',

				'required'    => false,

				'placeholder' => esc_html__( 'Description', 'appointy' ),

				'priority'    => 6

			)

		) );

		return Appointy_Form_Helper::get_fields( $fields );	

	}

	

	public static function create_new_user($woopostdata = array()){

		global $wpdb;

		

		$first_name = Appointy_Router_Helper::get_request_data($woopostdata,'first_name');

		$last_name = Appointy_Router_Helper::get_request_data($woopostdata,'last_name');

		$country_code = Appointy_Router_Helper::get_request_data($woopostdata,'country_code');

				

		$phone = Appointy_Router_Helper::get_request_data($woopostdata,'phone');

		$email = Appointy_Router_Helper::get_request_data($woopostdata,'email');

		$email = sanitize_email($email);

		$fullname = $first_name.' '.$last_name;

		

		$password = wp_generate_password();

		// Create account

		$new_user = array(

			'user_login' => $email,

			'user_pass'  => $password,

			'user_email' => $email,

			

			'display_name'  =>  $fullname,

			

			'role'   	  =>  'appointy_customer'

		);

	

		$user_id = wp_insert_user( $new_user );

	

		if ( is_wp_error( $user_id ) ) {

			return $user_id;

		}

		update_user_meta( $user_id,'country_code', $country_code );

		update_user_meta($user_id, 'first_name', $first_name);

		update_user_meta($user_id, 'last_name', $last_name);

		update_user_meta($user_id, 'phone', $phone);

		Appointy_Send_Email_Notification_Helper::send_new_user_email_notifications($user_id,$password);

		return $user_id;

	}

	

	public static function get_service_details() {

		$serviceid = Appointy_Router_Helper::get_request_data($_POST,'serviceid');

		$servicetype = get_post_meta($serviceid,'_servicetype',true);

		$attachment_id = get_post_meta($serviceid, 'image_id', true);

		$serviethumb = Appointy_Image_Helper::get_image_url_by_id($attachment_id,'thumbnail',true);

		ob_start();

		?>

		<div class="sf-detail-popup">

			<h2 class="m-t0 font-weight-400"><?php echo get_the_title($serviceid); ?></h2>

			<div class="m-b30">

				<div class="sf-detail-rating">

					<div class="sf-stats-rating text-left">

						<div class="sf-services-details-wrapper">

							<div class="sf-service-pic">

								<img src="<?php echo esc_url($serviethumb); ?>" alt="<?php echo esc_attr(get_the_title($serviceid)); ?>">

								<div class="sf-service-details-overlay"></div>

							</div>

							<div class="sf-service-info-wrap">

								<div class="sf-service-type"><span><?php echo esc_html__('Service Type: ','appointy')?></span><?php echo Appointy_Misc_Helper::translate_string($servicetype); ?></div>

								<h5><?php echo esc_html__('About this service','appointy')?></h5>

								<?php

								$content = get_post_field('post_content', $serviceid);

								echo apply_filters('the_content', $content);

								?>

							</div>

						</div>

					</div>

				</div>

			</div>

		</div>

		<?php

		$html = ob_get_clean();

		

		$response = array(

			'title'  => esc_html__('Service Details','appointy'),

			'html'   => $html,

		);

		wp_send_json_success($response); 

		exit;

	}

	

	public static function get_meeting_links($appointment_id = 0,$service_id = 0) {

		global $wpdb;

		

		$meetingrow = $wpdb->get_row($wpdb->prepare('SELECT `host_url`,`join_url` FROM `'.$wpdb->prefix.'appointy_zoom_meetings` WHERE `appointment_id` = %d AND `appointment_service_id` = %d',$appointment_id,$service_id));

		

		return $meetingrow;

	}

	

	public static function get_repeat_appointment() {

		

		$booked_services = ( !empty( $_POST['booked_services'] ) ) ? (array) $_POST['booked_services'] : array();

		$bookingdate = Appointy_Router_Helper::get_request_data($_POST,'bookingdate');

		$bookingtime = Appointy_Router_Helper::get_request_data($_POST,'bookingtime');

		$bookingformatedtime = Appointy_Router_Helper::get_request_data($_POST,'bookingformatedtime');

		$memberid = Appointy_Router_Helper::get_request_data($_POST,'memberid');

		

		$indexid = intval(Appointy_Router_Helper::get_sanitize_data($_POST,'indexid',0));

		$serviceid = Appointy_Router_Helper::get_request_data($_POST,'serviceid');

		$saved_frequencies = get_post_meta($serviceid,'frequencies',true);

		$saved_frequencies = explode(',',$saved_frequencies);

		

		$saved_frequency = Appointy_Router_Helper::get_request_data($booked_services[$indexid],'frequency');

		$saved_selected_weekday = Appointy_Router_Helper::get_request_data($booked_services[$indexid],'selected_weekday');

		$saved_day_of_month = Appointy_Router_Helper::get_request_data($booked_services[$indexid],'day_of_month');

		$saved_num_times = Appointy_Router_Helper::get_request_data($booked_services[$indexid],'num_times');

		$saved_num_times = ($saved_num_times != '') ? intval($saved_num_times) + 1 : '';

		

		$saved_schedule_dates = ( !empty( $booked_services[$indexid]['schedule_dates'] ) ) ? (array) $booked_services[$indexid]['schedule_dates'] : array();

		

		$service_availability = get_post_meta($serviceid,'_service_availability',true);

		$service_availability_status = get_post_meta($serviceid,'_service_availability_status',true);

		

		$avl_weekdays = self::check_weekday_avalability($_POST);

		

		ob_start();

		?>

		<div class="ap-freq-wrapper" id="ap-freq-wrapper-<?php echo esc_attr($serviceid); ?>">

			<div class="form-groupss">

			  	<label class="control-label"><?php echo esc_html__('Repeat','appointy'); ?>:</label>

				<select class="sf-select-box frequencySelect" name="frequency" data-serviceid="<?php echo esc_attr($serviceid); ?>" data-live-search="true" title="<?php _e('Select Frequency','appointy'); ?>">

					<?php

					echo '<option value="">'.__('Select Frequency','appointy').'</option>';

					$frequencies = Appointy_Misc_Helper::get_frequencies();

					$flag = 0;

					foreach($frequencies as $key => $value){

						if(in_array($key,$saved_frequencies)){

							$flag = 1;

							$selected = ($saved_frequency === $key) ? 'selected="selected"' : '';

							echo '<option '.$selected.' value="'.esc_attr($key).'">'.esc_html($value).'</option>';

						}

					}

					

					if($flag === 0) {

						echo '<option value="">'.__('Not available','appointy').'</option>';		

					}

					?>

				</select>

			</div>

			

			<div class="ap-freq-options-weekly ap-freq-options-biweekly ap-freq-options <?php echo ($saved_frequency === 'weekly' || $saved_frequency === 'biweekly') ? '' : 'collapse'; ?>">

				<label class="control-label"><?php _e('On', 'appointy'); ?>:</label>

				<?php

				$weekdays = Appointy_Service_Helper::get_weekdays();

				if( !empty($weekdays) ) {

					$weekdaynum = 1;

					foreach( $weekdays as $key => $value ) {

						if(in_array($key,$avl_weekdays)) {

						?>

						<div class="checkbox sf-radio-checkbox">

							<input <?php echo (intval($saved_selected_weekday) === intval($weekdaynum)) ? 'checked="checked"' : ''; ?> id="weekday_<?php echo esc_attr($indexid); ?>_<?php echo esc_attr($key); ?>" name="weekday" value="<?php echo esc_attr($key); ?>" type="radio">

							<label for="weekday_<?php echo esc_attr($indexid); ?>_<?php echo esc_attr($key); ?>"><?php echo esc_html($value); ?></label>

						</div>

						<?php

						$weekdaynum++;

						}

					}

				}	

				?>

			</div>

			

			<div class="ap-freq-options-monthly ap-freq-options-bimonthly ap-freq-options <?php echo ($saved_frequency === 'monthly' || $saved_frequency === 'bimonthly') ? '' : 'collapse'; ?>">

				<label class="control-label"><?php _e('On', 'appointy'); ?>:</label>

				<select class="sf-select-box" name="date" data-live-search="true" title="<?php _e('Select Day','appointy'); ?>">

					<?php

					for ($day = 1; $day <= 31; $day++) {

						$selected = (intval($saved_day_of_month) === intval($day)) ? 'selected="selected"' : '';

						echo '<option '.$selected.' value="'.esc_attr($day).'">'.esc_html($day).'</option>';

					}

					?>

				</select>

			</div>

			

			<div class="ap-freq-times <?php echo ($saved_frequency === 'weekly' || $saved_frequency === 'biweekly' || $saved_frequency === 'monthly' || $saved_frequency === 'bimonthly' || $saved_frequency === 'daily') ? '' : 'collapse'; ?>">

				<label class="control-label"><?php _e('Until', 'appointy'); ?>:</label>

				<input type="text" class="form-control" name="times" value="<?php echo esc_attr($saved_num_times); ?>" placeholder="<?php _e('Enter number of cycles.', 'appointy'); ?>">

				<label class="control-label"><?php _e('time(s)', 'appointy'); ?>:</label>

			</div>

			

			<?php $weekdays_json = json_encode($avl_weekdays);?>

			

			<div class="ap-freq-schedule"><button type="button" class="site-button setschedule" data-indexid="<?php echo esc_attr($indexid); ?>" data-serviceid="<?php echo esc_attr($serviceid); ?>" data-bookingdate="<?php echo esc_attr($bookingdate); ?>" data-bookingtime="<?php echo esc_attr($bookingtime); ?>" data-avlweekdaysforrepeat="<?php echo htmlspecialchars($weekdays_json, ENT_QUOTES, 'UTF-8'); ?>" data-bookingformatedtime="<?php echo esc_attr($bookingformatedtime); ?>" name="schedule"><?php _e('Schedule', 'appointy'); ?></button></div>

			

			<ul class="ap-freq-schedule-wrapper">

			<?php

			if(!empty($saved_schedule_dates)) {

				foreach($saved_schedule_dates as $saved_schedule_date){

					echo '<li><span>' . Appointy_Misc_Helper::get_date_format($saved_schedule_date) . '</span><span>' . $bookingformatedtime . '</span></li>';

				}

			}

			?>

			</ul>

		</div>

		<?php

		$html = ob_get_clean();

		

		$response = array(

			'html'   => $html,

			'avl_weekdays'   => $avl_weekdays

		);

		wp_send_json_success($response); 

		exit;

	}

	

	/**

	 * Process load booking time slots

	 *

	 * @return array

	 */

	public static function check_weekday_avalability($args = array()) {

		global $wpdb;

		

		$appointment_date = Appointy_Router_Helper::get_request_data( $_POST, 'bookingdate' );

		$member_id = Appointy_Router_Helper::get_request_data( $_POST, 'memberid' );

		$service_id = Appointy_Router_Helper::get_request_data( $_POST, 'serviceid' );

		$booking_date = Appointy_Router_Helper::get_request_data( $_POST, 'bookingdate' );

		$booking_start_time = Appointy_Router_Helper::get_request_data( $_POST, 'booking_start_time' );

		

		$member_id = ( intval($member_id) > 0 ) ? $member_id : 0;

				

		$avl_weekdays = array();

		

		$service_availability = get_post_meta($service_id,'_service_availability',true);

		$service_availability_status = get_post_meta($service_id,'_service_availability_status',true);

		

		$weekdays = Appointy_Service_Helper::get_weekdays();

		if( !empty($weekdays) ) {

			$weekdaynum = 1;

			foreach( $weekdays as $day => $value ) {

			

				if( $service_availability_status === 'on' ) {

					$service_availability_data = ( !empty( $service_availability[$day] ) ) ? (array) $service_availability[$day] : array();

					

					$service_start_time = ( !empty( $service_availability_data[0] ) ) ? date('H:i:s',strtotime($service_availability_data[0])) : '';

					$service_end_time = ( !empty( $service_availability_data[1] ) ) ? date('H:i:s',strtotime($service_availability_data[1])) : '';

					$service_day_status = ( !empty( $service_availability_data[2] ) ) ? $service_availability_data[2] : '';

					

					if( (bool) $service_day_status === false ) {

						continue;

					}

				}else{

					$service_start_time = '';

					$service_end_time = '';

					$service_day_status = '';

				}

				

				//Check if slots are avaialble on particular day if yes then render timeslots

				$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `weekday` = %s AND `member_id` = %d order by `start_time_number` asc',$day,$member_id));

				

				if( !empty( $results ) ) {

					$avl_weekdays[] = $day;

				}

			}

		}

		

		return $avl_weekdays;

	}

	

	/**

	 * Check service has extra service

	 *

	 * @return array

	 */

	public static function has_extra_service($post_id = 0) {

		global $wpdb;

		

		$row = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM `'.$wpdb->prefix.'postmeta` WHERE `meta_key` = "parent_service" AND `meta_value` = %s',$post_id));

		

		return (!empty($row)) ? true : false;

	}

	

	/**

	 * Get extra services

	 *

	 * @return array

	 */

	public static function get_extra_services( $post_id = 0 ) {

		global $wpdb;

		

		$results = $wpdb->get_results($wpdb->prepare('SELECT `post_id` FROM `'.$wpdb->prefix.'postmeta` WHERE `meta_key` = "parent_service" AND `meta_value` = %s',$post_id));

		

		return $results;

	}

	

	/**

	 * Get extra service price

	 *

	 * @return array

	 */

	public static function get_extra_service_price( $post_id = 0 ) {

		global $wpdb;

		

		$service_price = get_post_meta($post_id,'_service_fixed_price',true);

		$delprice = get_post_meta($post_id,'_service_fixed_regular_price',true);

		

		if((!$service_price > 0) || $service_price === '') {

			$tempprice = $service_price;

			$service_price = $delprice;

			$delprice = $tempprice;

		}

		

		if($delprice > 0) {

			$del_price = sprintf('<del><span class="icon"></span>%s</del>',Appointy_Misc_Helper::get_price_format($delprice));

		} else {

			$del_price = '';

		}

		

		return $prices = array('service_price' => $service_price, 'del_price' => $del_price);

	}

	

	/**

	 * Get extra service price

	 *

	 * @return array

	 */

	public static function get_available_weekdays() {

		global $wpdb;

		

		$initid = 0;

		$results = $wpdb->get_results($wpdb->prepare('SELECT `weekday` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `id` > %d order by `start_time_number` asc',$initid));

		

		$weekdaysInTable = [];

		if(!empty($results)) {

			foreach($results as $row){

				$weekdaysInTable[] = Appointy_Router_Helper::get_sanitize_data($row,'weekday');

			}

		}

		

		$weekdayMap = [

			"sunday" 	=> 0,

			"monday" 	=> 1,

			"tuesday" 	=> 2,

			"wednesday" => 3,

			"thursday" 	=> 4,

			"friday" 	=> 5,

			"saturday" 	=> 6

		];

		

		$weekdaysNumericInTable = array_map(function($day) use ($weekdayMap) {

			//return (!empty($weekdayMap[$day])) ? $weekdayMap[$day] : '';

			return isset($weekdayMap[$day]) ? $weekdayMap[$day] : '';

			//return (!empty($weekdayMap[$day]) || intval($weekdayMap[$day]) == 0) ? $weekdayMap[$day] : '';

		}, $weekdaysInTable);

		

		$allWeekdays = range(0, 6);

		

		$weekdaysNotInTable = array_diff($allWeekdays, $weekdaysNumericInTable);

		

		$disabledWeekDays = array_values($weekdaysNotInTable);

		

		return $disabledWeekDays;

	}

	

	

}

new Appointy_Booking_Form_Helper();