<?php 
class Appointy_Customer_Helper {

	/**
     * Initialize the class
     *
     * @since     1.0.0
     */
    public function __construct() {
		
		add_action('wp_ajax_get_customers', array($this, 'get_customers'));
		add_action('wp_ajax_appointy_delete_customer', array($this, 'delete_customer'));
		
		
    }
	
	/**
	 * Delete customer
	 *
	 * @return array
	 */
	public static function delete_customer() {
		global $wpdb;
		
		$data_ids = Appointy_Router_Helper::get_request_data( $_POST, 'data_ids' );
		
		$data_id_array = explode(",", $data_ids); 

		if(!empty($data_id_array)) {
			foreach($data_id_array as $user_id) {
				wp_delete_user( $user_id );
			}
		}
		
		wp_send_json_success();
		die();
	}
	
	/**
	 * Get customer
	 *
	 * @return void
	 */
	public static function get_customers() {
	    global $wpdb;
		
		$customers = get_users( array( 'role__in' => array( 'appointy_customer' ) ) );
		
		$data = array();
		if( !empty( $customers ) ) {
			$nestedData = array();
			foreach( $customers as $customer ) {
				$customerid = $customer->ID;
				
				$nestedData['delete'] = '<div class="checkbox sf-radio-checkbox">
											<input type="checkbox" id="customer-'.esc_attr($customerid).'" value="'.esc_attr($customerid).'" class="delete_row delete_customer">
											<label for="customer-'.esc_attr($customerid).'"></label>
										</div>';
				$nestedData['customer_name'] =  get_user_meta($customerid,'first_name',true).' '.get_user_meta($customerid,'last_name',true);
				$nestedData['email'] =  $customer->user_email;
				$nestedData['phone'] =  get_user_meta($customerid,'phone',true);
				
				$data[] = $nestedData;	
			}
		}
		
		$json_data = array( 'data' => $data );
		
		echo json_encode( $json_data );
		die();
	}
}
new Appointy_Customer_Helper();