<?php 
class Appointy_Image_Helper {

	/**
	 * Get image url by image id
	 *
	 * @return string
	 */
	public static function get_image_url_by_id($attachment_id = 0, $size = 'thumbnail', $placeholder = false){
		$image = $attachment_id ? wp_get_attachment_image_src($attachment_id, $size) : false;
		if($image){
		  	$url = $image[0];
		}else{
			if($placeholder){
				$url = $placeholder;
			}else{
				$url = APPOINTY_IMAGE_URL . 'default-avatar.jpg';
			}
		}
		return $url;
	}
	
	/**
	 * Get user profile picture
	 *
	 * @return string
	 */
	public static function get_user_avatar($user_id = 0,$size = 'appointy-300x300') {
		global $wpdb;
	
		$avatarid = get_user_meta($user_id, $wpdb->get_blog_prefix().'user_avatar', true);
		$src = '';
		if(!empty($avatarid) && $avatarid > 0){
			$src  = wp_get_attachment_image_src( $avatarid, $size );
			$src  = $src[0];
			
			$src = (!empty($src)) ? $src : get_avatar_url($user_id);
		} else {
			$defaultsize = self::get_default_avatar_size($size);
			
			$src = get_avatar_url($user_id,array('size' => $defaultsize));
		}
		
		return $src;
	}
	
	/**
	 * Get default avatar size
	 *
	 * @return size
	 */
	public static function get_default_avatar_size($size = 250) {
		switch($size) {
			case 'appointy-226x304':
				$defaultsize = 226;
				break;	
			case 'appointy-160x160':
				$defaultsize = 162;
				break;	
			case 'appointy-370x252':
				$defaultsize = 370;
				break;	
			case 'appointy-300x300':
				$defaultsize = 300;
				break;	
			case 'appointy-250x250':
				$defaultsize = 250;
				break;
			case 'appointy-600x600':
				$defaultsize = 600;
				break;	
			case 'appointy-700x500':
				$defaultsize = 700;
				break;	
			case 'appointy-800x1000':
				$defaultsize = 800;
				break;	
			case 'appointy-1200x300':
				$defaultsize = 1200;
				break;	
			default:
				$defaultsize = 250;
				break;			
		}
		
		return $defaultsize;
	}
}