<?php 

class Appointy_Room_Helper {



	/**

     * Initialize the class

     *

     * @since     1.0.0

     */

    public function __construct() {

		

		add_action('save_post', array($this, 'save_extra_service_details'));

		add_filter('cmb2_validate_room_capacity', array($this, 'cmb2_validate_room_capacity'), 10, 5);

		add_action('wp_ajax_appointy_load_room_services', array($this, 'load_room_services'));

		add_action('wp_ajax_nopriv_appointy_load_room_services', array($this, 'load_room_services'));

		add_action('wp_ajax_appointy_filter_rooms', array($this, 'load_filter_rooms'));

		add_action('wp_ajax_nopriv_appointy_filter_rooms', array($this, 'load_filter_rooms'));

		add_action('wp_ajax_appointy_get_hotel_bookings', array($this, 'get_hotel_bookings'));

		add_action('wp_ajax_appointy_check_room_availability', array($this, 'check_room_availability'));

		add_action('wp_ajax_nopriv_appointy_check_room_availability', array($this, 'check_room_availability'));

    }

	public static function get_hotel_bookings() {



	    global $wpdb;







		$the_query = Appointy_Appointments_Helper::get_appointments_query();



	



		$data = array();



		if ( $the_query->have_posts() ) {



			$nestedData = array();



			while ( $the_query->have_posts() ) : $the_query->the_post();



				$appointment_id = get_the_id();		



				



				$nestedData['appointment_id'] = $appointment_id;



				$nestedData['delete'] = '<div class="checkbox sf-radio-checkbox">



											<input type="checkbox" id="appointment-'.esc_attr($appointment_id).'" value="'.esc_attr($appointment_id).'" class="delete_row delete_appointments">



											<label for="appointment-'.esc_attr($appointment_id).'"></label>



										</div>';



				



				$nestedData['ref_id'] = '#'.get_post_meta($appointment_id,'appointment_ref_id',true);



				$nestedData['date_n_time'] = Appointy_Misc_Helper::get_date_format(get_the_date('',$appointment_id));



				



				$nestedData['customers_name'] = Appointy_Appointments_Helper::get_appointment_customername( $appointment_id );



				



				$booked_services = Appointy_Appointments_Helper::get_booked_services( $appointment_id );



				$services = '';



				if(!empty($booked_services)) {



					$services = '<ul class="booked-services">';



					foreach($booked_services as $booked_service) {



						$service_id = Appointy_Router_Helper::get_request_data($booked_service,'id');

						

						$service_name = Appointy_Router_Helper::get_request_data($booked_service,'service_name');



						$servicetype = Appointy_Router_Helper::get_request_data($booked_service,'servicetype');



						$variation_name = Appointy_Router_Helper::get_request_data($booked_service,'variation_name');

						

						$multidate_service = Appointy_Router_Helper::get_request_data($booked_service,'multidate_service');

						

						$service_post_id = Appointy_Router_Helper::get_request_data($booked_service,'service_id');



						



						$service_name = ($servicetype === 'hourly') ? $variation_name : $service_name;



						



						$booking_date = Appointy_Router_Helper::get_request_data($booked_service,'booking_date');

						$booking_start_date = Appointy_Router_Helper::get_request_data($booked_service,'booking_start_date');

						$booking_end_date = Appointy_Router_Helper::get_request_data($booked_service,'booking_end_date');



						$booking_start_time = Appointy_Router_Helper::get_request_data($booked_service,'booking_start_time');



						$service_price = Appointy_Router_Helper::get_request_data($booked_service,'service_price');


						$services .= sprintf('<li>%s / %s - %s</li>',$service_name,$booking_start_date,$booking_end_date);

					}



					$services .= '</ul>';



				}



				



				$nestedData['rooms_booked'] = $services;



				



				$nestedData['paymentmode'] = Appointy_Appointments_Helper::get_appointment_payment_method($appointment_id);



				



				$nestedData['paymentstatus'] = Appointy_Misc_Helper::translate_string(get_post_meta($appointment_id,'booking_amount_status',true));



				



				



				$nestedData['totalamount'] = Appointy_Misc_Helper::get_price_format(get_post_meta($appointment_id,'totalamount',true));



				



				$li = '';



				



				$params['appointment_id'] = $appointment_id;



				



				$viewdetailsurl = Appointy_Router_Helper::generate_link( ['appointments', 'view-hotelbooking'],$params );



				



				$li .= '<li><a href="'.esc_url( $viewdetailsurl ).'" class="action-btn-admin"><i class="feather-eye"></i> '.esc_html__( 'View Details','appointy' ).'</a></li>';



				



				if( get_post_meta($appointment_id,'order_id',true) != '' && get_post_meta($appointment_id,'order_id',true) > 0 ) {



					$order_id = get_post_meta($appointment_id,'order_id',true);



					



					$adminurl = admin_url('post.php');



					$orderpage = add_query_arg( array('post' => $order_id,'action' => 'edit'), $adminurl );



					



					$li .= '<li><a target="_blank" href="'.esc_url($orderpage).'" class="action-btn-admin"><i class="fa fa-shopping-cart"></i> '.esc_html__( 'View Order','appointy' ).'</a></li>';



				}



				



				$actions = '<div class="dropdown action-dropdown dropdown-left">



							  <button class="action-button btn btn-primary dropdown-toggle" type="button" data-bs-toggle="dropdown"><i class="fa fa-ellipsis-v"></i></button>



							  <ul class="dropdown-menu">



								'.$li.'



							  </ul>



							</div>';



				



				$nestedData['action'] = $actions;



				



				$data[] = $nestedData;



			endwhile;



		}



		



		$json_data = array( 'data' => $data );



		



		echo json_encode( $json_data );



		die();



	}

	public function cmb2_validate_room_capacity( $override_value, $value, $object_id, $field_args, $sanitized_value ) {

		if ( empty( $value ) ) {

			$field_args->add_error( 'Room capacity is required.' );

		}

		return $value;

	}

	

	/**

	 * CMB2 Meta fields save (Extras)

	 *

	 * @return void

	 */

	public function save_extra_service_details( $post_id ) {

		// Usual save post logic here (nonce check, autosave check, etc.)

		

		if ( isset( $_POST['service_price'] ) && isset( $_POST['service_quantity'] ) ) {

			// Sanitize and save each service's price and quantity

			$prices = array_map( 'sanitize_text_field', $_POST['service_price'] );

			$quantities = array_map( 'sanitize_text_field', $_POST['service_quantity'] );

	

			// Loop through services to save their respective prices and quantities

			foreach ( $prices as $service_id => $price ) {

				update_post_meta( $post_id, 'service_price_' . $service_id, $price );

			}

	

			foreach ( $quantities as $service_id => $quantity ) {

				update_post_meta( $post_id, 'service_quantity_' . $service_id, $quantity );

			}

		}

	}

	

	/**

	 * Get amenities

	 *

	 * @return void

	 */

	public static function get_amenities() {

	    global $wpdb;

		

		if( !empty($args['search']) )	{

			$args = array(

				'orderby'           => 'name',

				'name__like'        => Appointy_Router_Helper::get_request_data( $args, 'search' ),

				'order'             => 'ASC',

				'number'            => 0,

				'hide_empty'        => false,

			);		

		} else {

			$args = array(

				'orderby'           => 'name',

				'order'             => 'ASC',

				'number'            => 0,

				'hide_empty'        => false,

			);		

		}

			

		return $amenities = get_terms( 'appointy_room_amenities',$args );

	}

	

	/**

	 * Get room types

	 *

	 * @return void

	 */

	public static function get_room_types() {

	    global $wpdb;

		

		if( !empty($args['search']) )	{

			$args = array(

				'orderby'           => 'name',

				'name__like'        => Appointy_Router_Helper::get_request_data( $args, 'search' ),

				'order'             => 'ASC',

				'number'            => 0,

				'hide_empty'        => false,

			);		

		} else {

			$args = array(

				'orderby'           => 'name',

				'order'             => 'ASC',

				'number'            => 0,

				'hide_empty'        => false,

			);		

		}

			

		return $room_type = get_terms( 'appointy_room_type',$args );

	}

	

	/**

	 * Check service has extra service

	 *

	 * @return array

	 */

	public static function has_extra_service($post_id = 0) {

		global $wpdb;

		

		$appointy_room_services = wp_get_post_terms($post_id, 'appointy_room_services');

		if (!is_wp_error($appointy_room_services) && !empty($appointy_room_services)) {

			return true;

		}else{

			return false;

		}

	}

	

	/**

	 * Get extra services

	 *

	 * @return array

	 */

	public static function get_extra_services( $post_id = 0 ) {

		global $wpdb;

		

		$appointy_room_services = wp_get_post_terms($post_id, 'appointy_room_services');

		if (!is_wp_error($appointy_room_services) && !empty($appointy_room_services)) {

			return $appointy_room_services;

		}else{

			return array();

		}

	}

	

	/**

	 * Process load room services

	 *

	 * @return array

	 */

	public function load_room_services( ) {

		global $wpdb;

		ob_start();

		

		$service_id = Appointy_Router_Helper::get_request_data( $_POST, 'service_id' );

		

		$i = 0;

		if($service_id > 0) {

			$appointy_room_services = self::get_extra_services($service_id);

			

			

			if (!is_wp_error($appointy_room_services) && !empty($appointy_room_services)) {

				foreach ($appointy_room_services as $term) {

					$extra_service_id = $term->term_id;

					$extra_service_slug = $term->slug;

					$extra_service_title = $term->name;

					

					$extra_service_price = get_post_meta( $service_id, 'service_price_' . $extra_service_slug, true );

					$extra_service_quantity = get_post_meta( $service_id, 'service_quantity_' . $extra_service_slug, true );

					

					$options = array(

						'extra_post_id' 	=> $extra_service_id,

						'service_name' 		=> $extra_service_title,

						'service_price' 	=> $extra_service_price,

						'max_service_quantity' 	=> $extra_service_quantity

					);

					

					$activeClass = '';

					$singleQuantity = 1;

					if (!empty($_POST['selected_extras'])) {

						if(isset($_POST['selected_extras'][$extra_service_id])){

							$activeClass = 'active';

							$singleQuantity = intval($_POST['selected_extras'][$extra_service_id]['quantity']);

						}

					}

					?>

					<li class="ap-exser-col exserviceitem <?php echo sanitize_html_class($activeClass); ?>" data-options="<?php echo esc_attr(wp_json_encode( $options )); ?>">

						<div class="sf-exser-wrap">

							<div class="sf-exser-pic">

								<div class="sf-exser-overlay"><span><i class="fa fa-check"></i></span></div>

							</div>

							<div class="sf-exser-info">

								<h6><?php echo esc_html($extra_service_title); ?></h6>

								

								<div class="sf-exser-price">

									<div class="sf-service-price2"><span class="icon"></span><?php echo Appointy_Misc_Helper::get_price_format($extra_service_price); ?></div>

								</div>

								

								<div class="sf-exser-quantity">

									<input type="number" name="extra_service_quantity" class="form-control" value="<?php echo esc_attr($singleQuantity); ?>" min="1" max="<?php echo esc_attr($extra_service_quantity); ?>">

								</div>

							</div>

						</div>

					</li>

					<?php

				}

			}

		}	

		

		$html = ob_get_clean();

		

		$response = array(

			'html'   => $html

		);

		

		wp_send_json_success($response);

   		die();

	}

	

	/**

	 * Process load filter rooms

	 *

	 * @return array

	 */

	public function load_filter_rooms( ) {

		global $wpdb;

		ob_start();

		

		$startRange = Appointy_Router_Helper::get_request_data( $_POST, 'startRange' );

		$endRange = Appointy_Router_Helper::get_request_data( $_POST, 'endRange' );

		$rooms = Appointy_Router_Helper::get_request_data( $_POST, 'rooms' );

		$adults = Appointy_Router_Helper::get_request_data( $_POST, 'adults' );

		$children = Appointy_Router_Helper::get_request_data( $_POST, 'children' );

		

		$texonomy = 'appointy_room_type';

		$room_types = Appointy_Room_Helper::get_room_types();

		$booking_post_type = Appointy_Misc_Helper::get_settings( 'booking_settings', 'booking_post_type' );

		$k = 1;

		if( !empty( $room_types ) ) {
			echo '<ul>';
			foreach( $room_types as $term ) {

			$term_id = Appointy_Router_Helper::get_request_data( $term, 'term_id' );

			?>

				<?php

				$args = array(

					'post_status' => 'publish',

					'posts_per_page' => -1,

					'post_type' => $booking_post_type,

					'tax_query' => array(

						array(

							'taxonomy' => $texonomy,

							'field'    => 'term_id',

							'terms'    => $term_id,

						),

					)

				);

				$the_query = new WP_Query( $args );

				$total_booking_serives = $the_query->found_posts;

				

				$post_ids = [];

				$i = 0;

				$j = 1;

				if ( $the_query->have_posts() ) {

					while ( $the_query->have_posts() ) : $the_query->the_post();

						$post_id = get_the_id();		

						

						$appointy_room_types = wp_get_post_terms($post_id, 'appointy_room_type');

						if (!is_wp_error($appointy_room_types) && !empty($appointy_room_types)) {

							$class = [];

							foreach ($appointy_room_types as $term) {

								$room_type_id = $term->term_id;

								$room_type_slug = $term->slug;

								$room_type_name = $term->name;

								$class[] = sanitize_html_class($term->slug);

							}

						}

						

						

						$price_per_night = get_post_meta($post_id,'price_per_night',true);

						

						$attachment_id = get_post_thumbnail_id( $post_id );

						

						$serviethumb = Appointy_Image_Helper::get_image_url_by_id($attachment_id,'thumbnail');


						$maxAvailableRoom = self::get_max_available_room($_POST,$post_id);

						

						$options = array(

							'id' 	=> $k,

							'service_id' 		=> $post_id,

							'service_name' 		=> get_the_title(),

							'service_image' 	=> $serviethumb,

							'extra_service'		=> Appointy_Room_Helper::has_extra_service($post_id),

							'room_type_id'		=> $room_type_id,

							'service_price' 	=> $price_per_night,

							'max_available_room' => $maxAvailableRoom,

							'old_service_price' => '',

							'couponcode' 		=> '',

							'coupon_verified' 	=> false,

							'couponcode_available' 	=> Appointy_Booking_Form_Helper::has_couponcode_available_for_service($post_id)

						);

						

						?>
                        
                        <li class="sf-service-box service-box <?php echo esc_attr(implode(' ',$class)); ?>">
                            <div class="sf-slect-room-bx-list">
                                <div class="sf-r-top-section">
                                    <h3 class="sf-r-title"><?php the_title(); ?></h3>
                                    <div class="sf-r-price"><?php echo Appointy_Misc_Helper::get_price_format($price_per_night); ?></div>
                                </div>
                                <?php
								$room_capacity_adults = get_post_meta($post_id,'room_capacity_adults',true);
								$room_capacity_children = get_post_meta($post_id,'room_capacity_children',true);
								?>
                                <div class="sf-r-bot-section">
                                    <div class="sf-r-bot-section-left">
                                        <?php
                                        if(intval($room_capacity_adults) > 0) {
										?>
										<div class="sf-r-bot-section-adult">
                                            <img src="<?php echo APPOINTY_IMAGE_URL; ?>adult.png" alt="adult pic">
                                            <span><?php echo esc_html__( 'Adults','appointy' ); ?>:</span>
                                            <span class="count"><?php echo esc_html($room_capacity_adults); ?></span>
                                        </div>
										<?php
										}
										?>
                                        <?php
                                        if(intval($room_capacity_children) > 0) {
										?>
										<div class="sf-r-bot-section-adult">
                                            <img src="<?php echo APPOINTY_IMAGE_URL; ?>child.png" alt="adult pic">
                                            <span><?php echo esc_html__( 'Children','appointy' ); ?>:</span>
                                            <span class="count"><?php echo esc_html($room_capacity_children); ?></span>
                                        </div>
										<?php
										}
										?>
                                    </div>
                                    <div class="sf-r-bot-section-right">
                                        <div class="sf-r-bot-section-column s-detail">
                                            <a href="<?php echo get_the_permalink($post_id); ?>" class="service-detail-link"><?php esc_html_e( 'Show Details','appointy' ); ?></a>
                                        </div>
                                        <div class="sf-r-bot-section-column b-btn">
                                            <?php
											if($maxAvailableRoom > 0) {
											
											$isRoomAvailable = self::is_room_available($_POST,$post_id);
											if($isRoomAvailable == true) {
											?>
											<button id="addtocart-<?php echo esc_attr($k); ?>" class="addtocart addtocart-<?php echo esc_attr($post_id); ?>" data-avlroom="yes" type="button" data-options="<?php echo esc_attr(wp_json_encode( $options )); ?>"><?php esc_html_e( 'Book','appointy' ) ?></button>
											<?php }else{ ?>
											<button id="addtocart-<?php echo esc_attr($k); ?>" class="addtocart addtocart-<?php echo esc_attr($post_id); ?>" data-avlroom="no" type="button" data-options="<?php echo esc_attr(wp_json_encode( $options )); ?>"><?php esc_html_e( 'Book','appointy' ) ?></button>
											<?php } ?>
                                            
                                            <?php }else{ ?>
                                            <button type="button" class="addtocart" disabled="disabled"><?php esc_html_e( 'Sold Out','appointy' ) ?></button>
                                            <?php } ?>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

						<?php

						$k++;

						$i++;

						$j++;

					endwhile;

					wp_reset_postdata();

				}

				?>

			<?php	

				$k++;

				}
			echo '</ul>';	

		} else {

			echo '<div class="sf-no-result">';

			esc_html_e( 'Sorry, no room found.','appointy' );

			echo '</div>';

		}	

		

		$html = ob_get_clean();

		

		$response = array(

			'html'   => $html

		);

		

		wp_send_json_success($response);

   		die();

	}

	

	/**

	 * Process check room availability

	 *

	 * @return array

	 */

	public function check_room_availability( ) {

		global $wpdb;

		ob_start();

		

		$singleServiceId = Appointy_Router_Helper::get_request_data( $_POST, 'singleServiceId' );

		$startRange = Appointy_Router_Helper::get_request_data( $_POST, 'startRange' );

		$endRange = Appointy_Router_Helper::get_request_data( $_POST, 'endRange' );

		$rooms = Appointy_Router_Helper::get_request_data( $_POST, 'rooms' );

		$adults = Appointy_Router_Helper::get_request_data( $_POST, 'adults' );

		$children = Appointy_Router_Helper::get_request_data( $_POST, 'children' );

		

		$isRoomAvailable = self::is_room_available($_POST,$singleServiceId);

		if($isRoomAvailable == true) {

			$isRoomAvailable = 'yes';	

		}else{

			$isRoomAvailable = 'no';

		}

		

		$response = array(

			'isRoomAvailable'   => $isRoomAvailable

		);

		

		wp_send_json_success($response);

   		die();

	}

	

	public static function is_room_available($args = array(),$service_id = 0) {

		global $wpdb;

		

		$start_date = Appointy_Router_Helper::get_request_data( $args, 'startRange' );

		$end_date = Appointy_Router_Helper::get_request_data( $args, 'endRange' );

		$required_rooms = Appointy_Router_Helper::get_request_data( $args, 'rooms' );

		$adults = Appointy_Router_Helper::get_request_data( $args, 'adults' );

		$children = Appointy_Router_Helper::get_request_data( $args, 'children' );

		

		$total_rooms = get_post_meta($service_id,'total_rooms',true);

		$room_capacity_adults = get_post_meta($service_id,'room_capacity_adults',true);

		$room_capacity_children = get_post_meta($service_id,'room_capacity_children',true);

		

		// Ensure dates are properly formatted

		$start_date = date('Y-m-d', strtotime($start_date));

		$end_date = date('Y-m-d', strtotime($end_date));

	

		// Query blocked rooms in the date range

		$blocked_rooms_query = $wpdb->prepare(

			"SELECT count(id) as totalnum

			FROM {$wpdb->prefix}appointy_blocked_schedule

			WHERE `service_id` = %d AND  %s <= end_date AND %s >= start_date",

			$service_id, $start_date, $end_date

		);

		

		$blocked_rooms = $wpdb->get_row($blocked_rooms_query);

		//print_r($blocked_rooms);

		$blocked_num_rooms = Appointy_Router_Helper::get_request_data( $blocked_rooms, 'totalnum' );

		

		$available_rooms = intval($total_rooms) - intval($blocked_num_rooms);

		$avlflag = 1;

		if ($required_rooms > $available_rooms) {

			$avlflag = 0;

		}

		

		if($adults > $room_capacity_adults) {

			$avlflag = 0;

		}

		

		if($children > $room_capacity_children) {

			$avlflag = 0;

		}

		

		if($avlflag == 1) {

			return true;

		}else{

			return false;

		}

	}

	

	public static function get_max_available_room($args = array(),$service_id = 0) {

		global $wpdb;

		

		$start_date = Appointy_Router_Helper::get_request_data( $args, 'startRange' );

		$end_date = Appointy_Router_Helper::get_request_data( $args, 'endRange' );

		$required_rooms = Appointy_Router_Helper::get_request_data( $args, 'rooms' );

		$adults = Appointy_Router_Helper::get_request_data( $args, 'adults' );

		$children = Appointy_Router_Helper::get_request_data( $args, 'children' );

		

		$total_rooms = get_post_meta($service_id,'total_rooms',true);

		$room_capacity_adults = get_post_meta($service_id,'room_capacity_adults',true);

		$room_capacity_children = get_post_meta($service_id,'room_capacity_children',true);

		

		// Ensure dates are properly formatted

		$start_date = date('Y-m-d', strtotime($start_date));

		$end_date = date('Y-m-d', strtotime($end_date));

	

		// Query blocked rooms in the date range

		$blocked_rooms_query = $wpdb->prepare(

			"SELECT count(id) as totalnum

			FROM {$wpdb->prefix}appointy_blocked_schedule

			WHERE `service_id` = %d AND  %s <= end_date AND %s >= start_date",

			$service_id, $start_date, $end_date

		);

		

		$blocked_rooms = $wpdb->get_row($blocked_rooms_query);

		//print_r($blocked_rooms);

		$blocked_num_rooms = Appointy_Router_Helper::get_request_data( $blocked_rooms, 'totalnum' );

		

		$available_rooms = intval($total_rooms) - intval($blocked_num_rooms);

		

		return $available_rooms;

	}

}

new Appointy_Room_Helper();

