<?php
class Appointy_Template_Loader {

	/**
	 * Loads template part
	 *
	 * @return string
	 */
	public static function get_template_part( $filepath, $args = array(), $plugin_dir = APPOINTY_PLUGIN_DIR ) {
		if ( is_array( $args ) && count( $args ) > 0 ) {
			extract( $args, EXTR_SKIP );
		}

		$templatepath = self::locate( $filepath, $plugin_dir );
		
		if ( $templatepath ) {
			include $templatepath;
		}
	}
	
	/**
	 * Gets template path
	 *
	 * @return string
	 */
	public static function locate( $filepath, $plugin_dir = APPOINTY_PLUGIN_DIR ) {
		$template = '';

		$theme_folder_name = 'appointy-templates';
		// Current theme base dir
		if ( ! empty( $filepath ) ) {
			$template = locate_template( array("{$filepath}.php") );
		}

		// Child theme
		if ( ! $template && ! empty( $filepath ) && file_exists( get_stylesheet_directory() . "/".$theme_folder_name."/{$filepath}.php" ) ) {
			$template = get_stylesheet_directory() . "/".$theme_folder_name."/{$filepath}.php";
		}

		// Original theme
		if ( ! $template && ! empty( $filepath ) && file_exists( get_template_directory() . "/".$theme_folder_name."/{$filepath}.php" ) ) {
			$template = get_template_directory() . "/".$theme_folder_name."/{$filepath}.php";
		}

		// Plugin
		if ( ! $template && ! empty( $filepath ) && file_exists( $plugin_dir . "templates/{$filepath}.php" ) ) {
			$template = $plugin_dir . "templates/{$filepath}.php";
		}

		// Nothing found
		if ( empty( $template ) ) {
			throw new Exception( "Template /templates/{$filepath}.php in plugin dir {$plugin_dir} not found." );
		}

		return $template;
	}

}
