(function( $ ) {
	'use strict';
	
	var toggleLoading = function( status = '' ) {
		if(status == 'show') {
			jQuery('.ap-loading-area').show();
		} else if(status == 'hide') {
			jQuery('.ap-loading-area').hide();	
		}
	}
	
	var togglePanelLoading = function( status = '' ) {
		if(status == 'show') {
			jQuery('.panel-loading-area').show();
		} else if(status == 'hide') {
			jQuery('.panel-loading-area').hide();	
		}
	}
	
	var renderValidationMessage = function( msg = '' ) {
		$('.appointy-error li').remove();
		$('.appointy-error').append('<li class="error">'+msg+'</li>').show();
		$(".sf-alert-box-wrap").show('slow');
		$('.sf-alert-box-wrap').animate({right: '0'} , 1000);
	}
	
	var renderSuccessMessage = function( msg = '' ) {
		$('.sf-success-msg').html(msg).show();
		$(".sf-sucess-box").show('slow');
		$('.sf-sucess-box').animate({right: '0'} , 1000);
	}
	
	var hideSuccessMessage = function() {
			$('body').on('click', '.sf-sucess-box', function() {
				jQuery(this).hide('slow');
			});
		}

	var hideValidationMessage = function() {
			$('body').on('click', '.sf-alert-box-wrap', function() {
				jQuery(this).hide('slow');
			});
		}
	
	var submitLoginForm= function() {
		$('body').on('click', '.showhidepass', function(){
			var fieldId = $(this).data('fieldid');
			var pass1 = $('#'+fieldId);
			
			if ( 'password' === pass1.attr( 'type' ) ) {
				pass1.attr( 'type', 'text' );
				$(this).find('i').removeClass('feather-eye').addClass('feather-eye-off');
			} else {
				pass1.attr( 'type', 'password' );
				$(this).find('i').removeClass('feather-eye-off').addClass('feather-eye');
			}
		});
		
		$('form.site-login-form').validate({
			submitHandler: function() { 
				var $this = $('form.site-login-form');
				$.ajax({
					url: appointy_options.ajaxurl,
					type:'POST',
					dataType: 'json',
					beforeSend: toggleLoading('show'),
					data:  $this.serialize()+"&action=appointy_user_login"
				}).done(function(response) {
					toggleLoading('hide');
					if ( response.success ) {
						renderSuccessMessage(response.data.msg);
						if( response.data.redirect != '' ) {
							setTimeout(function(){
								 window.location.href = response.data.redirect;                            
							}, 500);
						}
					} else {
						renderValidationMessage(response.data.msg);
					}
				}).always(function() {
					toggleLoading('hide');
				});
				return false; 
			}
		});	
	}
	
	/**
     * Document ready
     */
    $(function () {
		submitLoginForm();
		
		hideSuccessMessage();
			
		hideValidationMessage();
    });

})( jQuery );
