(function( $ ) {
	'use strict';
	
	var toggleLoading = function( status = '' ) {
		if(status === 'show') {
			jQuery('.ap-loading-area').show();
		} else if(status === 'hide') {
			jQuery('.ap-loading-area').hide();	
		}
	}
	
	var togglePanelLoading = function( status = '' ) {
		if(status === 'show') {
			jQuery('.panel-loading-area').show();
		} else if(status === 'hide') {
			jQuery('.panel-loading-area').hide();	
		}
	}
	
	var renderValidationMessage = function( msg = '' ) {
		$('.appointy-error li').remove();
		$('.appointy-error').append('<li class="error">'+msg+'</li>').show();
		$(".sf-alert-box-wrap").show('slow');
		$('.sf-alert-box-wrap').animate({right: '0'} , 1000);
	}
	
	var renderSuccessMessage = function( msg = '' ) {
		$('.sf-success-msg').html(msg).show();
		$(".sf-sucess-box").show('slow');
		$('.sf-sucess-box').animate({right: '0'} , 1000);
	}
	
	var submitGiftCardPaymentForm = function() {
		$('form[name="giftcard__purchase"]').validate({
			submitHandler: function() { 
			    var $this = $('#giftcard__purchase');
				
				var data = {
					action       	: 'addto_woo_cart',
					wootype			: 'giftcard'
				};
				var formdata = $this.serialize()+'&'+$.param(data);
				
				jQuery.ajax({
					type : "post",
					dataType : "json",
					url : appointy_options.ajaxurl,
					data : formdata,
					beforeSend: togglePanelLoading('show'),
				}).done(function(response) {
					if ( response.success ) {
						window.location.href = appointy_options.cart_url;
					} else {
						renderValidationMessage(response.data.msg);
					}
				}).complete(function() {
					togglePanelLoading('hide');
				});	
			}
		});
	}
	
	var submitInvoicePaymentForm = function() {
		$('body').on('click','.payinvoice', function(event){
			var invoiceId = jQuery( this ).data('invoiceid');													  
			
			var data = {
				action       	: 'addto_woo_cart',
				wootype			: 'invoice',
				invoiceid 		: invoiceId
			};
			
			var formdata = $.param(data);
			
			jQuery.ajax({
				type : "post",
				dataType : "json",
				url : appointy_options.ajaxurl,
				data : formdata,
				beforeSend: togglePanelLoading('show'),
			}).done(function(response) {
				if ( response.success ) {
					window.location.href = appointy_options.cart_url;
				} else {
					renderValidationMessage(response.data.msg);
				}
			}).complete(function() {
				togglePanelLoading('hide');
			});	
		});
		
		jQuery('body').on('click','.viewinvoice', function(event){
			jQuery('#invoice-datatable-outer').hide();
			jQuery('#invoice-view-outer').show();
			var invoiceId = jQuery(this).data('invoiceid');
			
			var data = {
				action       	: 'appointy_view_invoice',
				invoiceid		: invoiceId
			};
			
			$.ajax({
				url: appointy_options.ajaxurl,
				type:'POST',
				dataType: 'json',
				beforeSend: togglePanelLoading('show'),
				data : data,
			}).done(function(response) {
				if ( response.success ) {
					jQuery('#invoice-view-container').html(response.data);
				}
			}).complete(function() {
				togglePanelLoading('hide');
			});	
		});
	}
	
	var payRepeatPayment = function() {
		jQuery('body').on('click', '.payrepeatpayment', function(){
		
			var appointmentId = jQuery(this).data('appointment_id');
			var repeatServiceId = jQuery(this).data('repeat_service_id');
			var serviceId = jQuery(this).data('serviceid');
			
			var data = {
				action       	: 'addto_woo_cart',
				wootype			: 'payrepeatpayment',
				appointment_id	: appointmentId,
				repeat_service_id	: repeatServiceId,
				service_id		: serviceId
			};
			var formdata = $.param(data);
			
			jQuery.ajax({
				type : "post",
				dataType : "json",
				url : appointy_options.ajaxurl,
				data : formdata,
				beforeSend: toggleLoading('show'),
			}).done(function(response) {
				if ( response.success ) {
					window.location.href = appointy_options.cart_url;
				} else {
					renderValidationMessage(response.data.msg);
				}
			}).complete(function() {
				toggleLoading('hide');
			});
		});	
	}
	
	/**
     * Document ready
     */
    $(function () {
		submitGiftCardPaymentForm();
		submitInvoicePaymentForm();
		payRepeatPayment();
    });

})( jQuery );
