(function( $ ) {

	'use strict';

	

	var appointyThisOptions, appointyTotalServices, appointyTotalAmount;

	var checkAvlFlag = false;

	

	bootbox.setLocale(appointy_options.locale);

	

	var togglePanelLoading = function( status = '' ) {

		if(status === 'show') {

			jQuery('.panel-loading-area').show();

		} else if(status === 'hide') {

			jQuery('.panel-loading-area').hide();	

		}

	}

	

	var formSubmit = function() {

		

		$( 'body' ).on( 'click', '.booksinglehotel', function (e) {

			// Remove any previous hidden fields to avoid duplication

			$('.extra-hidden-fields').remove();

	

			// Loop through the checked checkboxes

			$('input[name="exservice[]"]:checked').each(function(index) {

				var extraId = $(this).val();

				

				var quantity = $(this).closest('.single-extra-box').find('input[name="extra_service_quantity[]"]').val();

	

				$('<input>').attr({

					type: 'hidden',

					name: 'selected_extras[' + extraId + '][extra_post_id]',

					value: extraId,

					class: 'extra-hidden-fields'

				}).appendTo('#hotel_booking__form');

				

				$('<input>').attr({

					type: 'hidden',

					name: 'selected_extras[' + extraId + '][quantity]',

					value: quantity,

					class: 'extra-hidden-fields'

				}).appendTo('#hotel_booking__form');

			});

			// Allow the form to be submitted as usual

			if(checkAvlFlag == false) {

				checkRoomAvailability();	

			}else{

				$('#hotel_booking__form').submit();	

			}

			

			

		});

		

	}

	

	var checkRoomAvailability = function() {

		

		var startRange = jQuery('input[name="start_range"]').val();

		var endRange = jQuery('input[name="end_range"]').val();

		var rooms = jQuery('input[name="rooms"]').val();

		var adults = jQuery('input[name="adults"]').val();

		var children = jQuery('input[name="children"]').val();

		

		var data = {

		  "action": "appointy_check_room_availability",

		  "singleServiceId": bookingformdata.singleServiceId,

		  "startRange": startRange,

		  "endRange": endRange,

		  "rooms": rooms,

		  "adults": adults,

		  "children": children

		};

		

		var formdata = jQuery.param(data);

		

		jQuery.ajax({

			type : "post",

			dataType : "json",

			url : appointy_options.ajaxurl,

			beforeSend: togglePanelLoading('show'),

			data : data,

			success: function(response) {

				togglePanelLoading('hide');

				if( response.success ) {

					if(response.data.isRoomAvailable == 'no') {

						bootbox.confirm(appointy_options.room_not_suit_requirement, function(result) {

							if(result){

								checkAvlFlag = true;

								$('#hotel_booking__form').submit();

							}else{

								return false;	

							}

						});

					}else{

						checkAvlFlag = true;

						$('#hotel_booking__form').submit();

					}

				}

			},

			complete: function() {

				togglePanelLoading('hide');

			}

	   	})	

		

	}

	

	var calculateCost = function() {

		appointyThisOptions = $('#hotel_booking__form').data('options');

		

		var basePrice = appointyThisOptions.service_price;

		var numberOfSelectedDates = getNumberOfDays();

		var totalRooms = $('input[name="rooms"]').val();

		

		var totalExservicePrice = 0;

		

		$('input[name="exservice[]"]:checked').each(function(index) {

			var extraId = $(this).val();

			

			var exserviceOptions = $('#exserviceitem-'+extraId).data('options');

			var exservicePrice = exserviceOptions.service_price;

			

			var exserviceQuantity = $(this).closest('.single-extra-box').find('input[name="extra_service_quantity[]"]').val();

			var totalExPrice = (parseFloat(exservicePrice) * parseInt(exserviceQuantity));

			

			totalExservicePrice = parseInt(totalExservicePrice) + parseInt(totalExPrice);

		});

		

		var totalPrice = ((parseFloat(basePrice) * parseInt(numberOfSelectedDates)) * parseInt(totalRooms)) + parseInt(totalExservicePrice);



		$('#single-total-cost').html(appointy_options.currency_symbol+totalPrice);

	}

	

	var getNumberOfDays = function() {

		// Get the check-in and check-out date values

        var checkinDate = $('input[name="start_range"]').val();

        var checkoutDate = $('input[name="end_range"]').val();

		var totalDays = 0;

        // Ensure both dates are selected

        if (checkinDate && checkoutDate) {

            // Convert the date strings into Date objects

            var checkin = new Date(checkinDate);

            var checkout = new Date(checkoutDate);



            // Calculate the difference in time (milliseconds)

            var timeDiff = checkout - checkin;



            // Convert the time difference from milliseconds to days

            totalDays = timeDiff / (1000 * 60 * 60 * 24);

        }

		

		return totalDays;

	}

	

	var miscActivities = function() {

		$( 'body' ).on( 'change', 'input[name="adults"],input[name="children"],input[name="rooms"],input[name="start_range"],input[name="end_range"],input[name="extra_service_quantity[]"]', function () {

			calculateCost();														  

		});

		

		$( 'body' ).on( 'click', 'input[name="exservice[]"]', function () {

			calculateCost();														  

		});

	}

	

	/**

     * Document ready

     */

    $(function () {

		formSubmit();

		miscActivities();

    });





})( jQuery );

