(function( $ ) {
	'use strict';
	var appointyBookedService = [];
	var appointyCurrentDate;
	var appointySlotFlag = 1;
	var appointyMemberFlag = 0;
	
	var appointyTableStaff, appointyTableCustomer, appointyTableLocation, appointyTableService, appointyTableCoupon, appointyTableGiftCard, appointyTableTax, appointyTableAppointments, appointyTableRecentAppointments, appointyTableEmailTemplates, appointyTableNotificationTemplates, appointyTableSmsTemplates, appointyTableInvoice;
	
	if (typeof addedLocations === 'undefined') {
		var appointyAddedLocations = [];
    }else{
		var appointyAddedLocations = addedLocations;
	}
	
	if (typeof locationStaffArray === 'undefined') {
        var appointyLocationStaffArray = [];
    }else{
		var appointyLocationStaffArray = locationStaffArray;
	}
	
	if (typeof addedPriceLocations === 'undefined') {
		var appointyAddedPriceLocations = [];
    }else{
		var appointyAddedPriceLocations = addedPriceLocations;
	}
	
	if (typeof locationPriceArray === 'undefined') {
        var appointyLocationPricesArray = [];
    }else{
		var appointyLocationPricesArray = locationPriceArray;
	}
	
	if (typeof locationHourlyPriceArray === 'undefined') {
        var appointyLocationHourlyPricesArray = [];
    }else{
		var appointyLocationHourlyPricesArray = locationHourlyPriceArray;
	}
	
	bootbox.setLocale(appointy_options.locale);
	
    function AppointyAdmin() {
        var self = this;
        self.init();
    };
    AppointyAdmin.prototype = {
        /**
         *  Initialize
         */
        init: function() {
            var self = this;
			
			self.miscFunction();
			
			self.setDatePicker();
			
			self.setFutureDatePicker();
			
			self.setTimePicker();
			
			self.setMultiDatePicker();
			
			self.setDateRangePicker();
			
			self.setAvailability();
			
			self.hideSuccessMessage();
			
			self.hideValidationMessage();
			
        },
		
		toggleLoading: function( status = '' ) {
			if(status === 'show') {
				$('.ap-loading-area').show();
			} else if(status === 'hide') {
				$('.ap-loading-area').hide();	
			}
		},
		
		togglePanelLoading: function( status = '' ) {
			if(status === 'show') {
				$('.panel-loading-area').show();
			} else if(status === 'hide') {
				$('.panel-loading-area').hide();	
			}
		},
		
		resetForm: function( formid = '' ) {
			 if( formid != '' ) {
				 $('#'+formid).trigger('reset');
				 $('#'+formid+' select').val('');
			 }
		},
		
		renderValidationMessage: function( msg = '' ) {
			$('.appointy-error li').remove();
			$('.appointy-error').append('<li class="error">'+msg+'</li>').show();
			$(".sf-alert-box-wrap").show('slow');
			$('.sf-alert-box-wrap').animate({right: '0'} , 1000);
		},
		
		renderSuccessMessage: function( msg = '' ) {
			$('.sf-success-msg').html(msg).show();
			$(".sf-sucess-box").show('slow');
			$('.sf-sucess-box').animate({right: '0'} , 1000);
		},
		
		hideSuccessMessage: function() {
			$('body').on('click', '.sf-sucess-box', function() {
				jQuery(this).hide('slow');
			});
		},
		
		hideValidationMessage: function() {
			$('body').on('click', '.sf-alert-box-wrap', function() {
				jQuery(this).hide('slow');
			});
		},
		
		geteNumberByTime: function( time = '' ) {
			var timeNumber = 0;
			if( time != '' ) {
				var  tempTime = time.split(':');
				
				var  tempTimePostFix = time.split(' ');
				
				if( tempTime.length > 0 ) {
					var hourNumber = parseInt( tempTime[0], 10 ) * 60;
					var minNumber = parseInt( tempTime[1], 10 );
					
					if(parseInt(tempTime[0], 10) === 12){
						hourNumber = 0;
					}
					timeNumber = parseInt(hourNumber, 10) + parseInt(minNumber, 10);
				}
				
				if( tempTimePostFix.length > 0 ) {
					var postFix = tempTimePostFix[1];
					if( postFix === 'PM' || postFix === 'pm' ) {
						timeNumber = parseInt( timeNumber, 10 ) + 720; 
					}
				}
			}
			return timeNumber;
		},
		
		setMultiDatePicker: function() {
			var date = new Date();
			date.setDate(date.getDate());
			
			$('.multidatepicker').datepicker({
				multidate: true,
				multidateSeparator: ",",
				toggleActive: true,
				format: appointy_options.dateformat,
				startDate: date
			});
		},
		
		setDateRangePicker: function() {
			var date = new Date();
			date.setDate(date.getDate());
	
			$('.input-daterange').datepicker({
				multidate: false,
				multidateSeparator: ",",
				toggleActive: true,
				format: appointy_options.dateformat,
				startDate: date
			});
		},
		
		setDatePicker: function() {
			if ( $('.datepicker').length > 0 ) {
				$('.datepicker').datepicker({
					format: appointy_options.dateformat
				});
			}
		},
		
		setFutureDatePicker: function() {
			if ( $('.futuredatepicker').length > 0 ) {
				var date = new Date();
				date.setDate(date.getDate());
				
				$('.futuredatepicker').datepicker({
					format: appointy_options.dateformat,
					startDate: date
				});
			}
		},
		
		setTimePicker: function() {
			if ( $('.timepicker').length > 0 ) {
				$('.timepicker').datetimepicker({
					format: appointy_options.time_format,
				});
			}
		},
		
		miscFunction: function() {
			$(".modal").on('hidden.bs.modal', function () {
			  $('.formeditid').remove();
			});
		},
		
		setAvailability: function() {
			var self = this;
			var timeslots = [];
			
			$('#toggle-event').change(function() {
			  $('#console-event').html('Toggle: ' + $(this).prop('checked'))
			})
			// Toggle work period section on weekday status change
			$( 'body' ).on( 'change', '.weekdaystatus input', function () {
				var weekday = $( this ).data( 'weekday' );
				
				if( $(this).prop('checked') ){
					$( '#workperiod-'+weekday ).show('slow');	
				} else {
					$( '#workperiod-'+weekday ).hide('slow');	
				}
			} );
			
			// Toggle work period section
			$( 'body' ).on( 'click', '.openworkperiod', function () {
				var weekday = $( this ).data( 'weekday' );
				$( '#workperiod-'+weekday ).toggle('slow');
				
				if( $( '#workperiod-'+weekday ).is(":visible") ) {
					if( $('#weekdaytoggle_'+weekday).prop('checked') === false ) {
						$('#weekdaytoggle_'+weekday).bootstrapToggle('on');
					}
				}
				
			} );
			
			// Toggle custom schedule work period section
			$( 'body' ).on( 'click', '.loadcustomslots', function () {
				var slotOptions = $( this ).data( 'options' );
				var customDate = $( this ).data( 'customdate' );
				var interval = $( this ).data( 'interval' );
				
				$('.display-custom-date').html( customDate );
				$('.customscheduleslotsform input[name="custom_date"]').val( customDate );
				$('.customscheduleslotsform input[name="interval"]').val( interval );
				var data = {
					'action'       : 'appointy_load_custom_schedule_slots',
					'options'		 : slotOptions,
					'user_id'      : jsdata.user_id
				};
				var formdata = jQuery.param(data);
				$.ajax({
					url: appointy_options.ajaxurl,
					type:'POST',
					dataType: 'json',
					beforeSend: self.toggleLoading('show'),
					data:  formdata
				}).done(function(response) {
					self.toggleLoading('hide');
					if ( response.success ) {
						$('.display-customschedule-periods').html( response.data.html );
					} else {
						self.renderValidationMessage(response.data.msg);
					}
				});
			} );
			
			$( 'body' ).on( 'click', 'ul.showhideslot li', function () {
				var $this = $(this);
				$this.toggleClass('edit-time-hide');
				$this.toggleClass('active');
				$this.find('i').toggleClass('feather-eye-off').toggleClass('feather-eye');
				
				timeslots = [];
				$('ul.showhideslot li').each(function(){
					var $this = $(this);
					var timeslot = $( this ).data( 'timeslot' );
					
					if ( $this.hasClass('active') ) {
                        timeslots.push(timeslot);
                    } 
					
				} );
			} );
			
			// Save show/hide slots
			$('form.timeslotsform').validate({
				submitHandler: function() { 
					var $this = $('form.timeslotsform');
					
					var data = {
						'action'       : 'appointy_save_workperiod_timeslots',
						'timeslots'		 : timeslots,
					};
					var formdata = $('form.timeslotsform').serialize()+'&'+jQuery.param(data);
					
					$.ajax({
						url: appointy_options.ajaxurl,
						type:'POST',
						dataType: 'json',
						beforeSend: self.togglePanelLoading('show'),
						data:  formdata
					}).done(function(response) {
						self.togglePanelLoading('hide');
						if ( response.success ) {
							self.renderSuccessMessage(response.data.msg);
							
							setTimeout(function() {
								$('#timeslots_modal').modal('hide');
							}, 3000);
						} else {
							self.renderValidationMessage(response.data.msg);
						}
					});
					return false; 
				}
			});
			
			// Save show/hide slots for custom schedule
			$('form.customscheduleslotsform').validate({
				submitHandler: function() { 
					var $this = $('form.customscheduleslotsform');
					
					var data = {
						'action'       : 'appointy_save_customschedule_timeslots',
						'timeslots'		 : timeslots,
					};
					var formdata = $('form.customscheduleslotsform').serialize()+'&'+jQuery.param(data);
					
					$.ajax({
						url: appointy_options.ajaxurl,
						type:'POST',
						dataType: 'json',
						beforeSend: self.togglePanelLoading('show'),
						data:  formdata
					}).done(function(response) {
						self.togglePanelLoading('hide');
						if ( response.success ) {
							self.renderSuccessMessage(response.data.msg);
						} else {
							self.renderValidationMessage(response.data.msg);
						}
					});
					return false; 
				}
			});
			
			$('#startpicker_sunday').on("dp.change", function (e) {
				$('#endpicker_sunday').data("DateTimePicker").minDate(e.date);
			});
				
			$('#endpicker_sunday').on("dp.change", function (e) {
				$('#startpicker_sunday').data("DateTimePicker").maxDate(e.date);
			});
			
			$('#startpicker_saturday').on("dp.change", function (e) {
				$('#endpicker_saturday').data("DateTimePicker").minDate(e.date);
			});
				
			$('#endpicker_saturday').on("dp.change", function (e) {
				$('#startpicker_saturday').data("DateTimePicker").maxDate(e.date);
			});
			
			$('#startpicker_friday').on("dp.change", function (e) {
				$('#endpicker_friday').data("DateTimePicker").minDate(e.date);
			});
				
			$('#endpicker_friday').on("dp.change", function (e) {
				$('#startpicker_friday').data("DateTimePicker").maxDate(e.date);
			});
			
			$('#startpicker_thursday').on("dp.change", function (e) {
				$('#endpicker_thursday').data("DateTimePicker").minDate(e.date);
			});
				
			$('#endpicker_thursday').on("dp.change", function (e) {
				$('#startpicker_thursday').data("DateTimePicker").maxDate(e.date);
			});
			
			$('#startpicker_wednesday').on("dp.change", function (e) {
				$('#endpicker_wednesday').data("DateTimePicker").minDate(e.date);
			});
				
			$('#endpicker_wednesday').on("dp.change", function (e) {
				$('#startpicker_wednesday').data("DateTimePicker").maxDate(e.date);
			});
			
			$('#startpicker_tuesday').on("dp.change", function (e) {
				$('#endpicker_tuesday').data("DateTimePicker").minDate(e.date);
			});
				
			$('#endpicker_tuesday').on("dp.change", function (e) {
				$('#startpicker_tuesday').data("DateTimePicker").maxDate(e.date);
			});	
			
			$('#startpicker_monday').on("dp.change", function (e) {
				$('#endpicker_monday').data("DateTimePicker").minDate(e.date);
			});
			
			$('#endpicker_monday').on("dp.change", function (e) {
				$('#startpicker_monday').data("DateTimePicker").maxDate(e.date);
			});
			
			$('#startpicker_custom').on("dp.change", function (e) {
				$('#endpicker_custom').data("DateTimePicker").minDate(e.date);
			});
			
			$('#endpicker_custom').on("dp.change", function (e) {
				$('#startpicker_custom').data("DateTimePicker").maxDate(e.date);
			});
			
			$('form.workperiodform').validate({
				submitHandler: function() { 
					var $this = $('form.workperiodform');
					
					$.ajax({
						url: appointy_options.ajaxurl,
						type:'POST',
						dataType: 'json',
						beforeSend: self.toggleLoading('show'),
						data: $this.serialize()+'&action=appointy_save_workperiod',
					}).done(function(response) {
						self.toggleLoading('hide');
						if ( response.success ) {
							self.renderSuccessMessage(response.data.msg);
							location.reload(true);
						} else {
							self.renderValidationMessage(response.data.msg);
						}
					});
					return false; 
				}
			});
			
			var mondayNext = 0;
			var tuesdayNext = 0;
			var wednesdayNext = 0;
			var thursdayNext = 0;
			var fridayNext = 0;
			var saturdayNext = 0;
			var sundayNext = 0;
			var customNext = 0;
			var mondaySlotsArray = [];
			var tuesdaySlotsArray = [];
			var wednesdaySlotsArray = [];
			var thursdaySlotsArray = [];
			var fridaySlotsArray = [];
			var saturdaySlotsArray = [];
			var sundaySlotsArray = [];
			var customSlotsArray = [];
			
			$(".add-more-time").click(function(e){
				e.preventDefault();
				mondaySlotsArray = [];
				tuesdaySlotsArray = [];
				wednesdaySlotsArray = [];
				thursdaySlotsArray = [];
				fridaySlotsArray = [];
				saturdaySlotsArray = [];
				sundaySlotsArray = [];
				
				var $this = $('.workperiodform');
				
				$this.find('.alert').remove();
				
				var weekday = $(this).data('weekday');
				var starttime = $('#startpicker_'+weekday+' input').val();
				var endtime = $('#endpicker_'+weekday+' input').val();
				var interval = $('#interval_'+weekday+' select').val();
				
				if( starttime === '' || endtime === '' ) {
					self.renderValidationMessage(appointy_options.select_startendtime);
					return false;
				}
				if( endtime === starttime ) {
					self.renderValidationMessage(appointy_options.endtime_greater_than_starttime);
					return false;
				}
				if( interval === '' ) {
					self.renderValidationMessage(appointy_options.select_interval);
					return false;
				}
				
				var startnumber = self.geteNumberByTime(starttime);
				var endnumber = self.geteNumberByTime(endtime);
				
				$('#startpicker_'+weekday+' input').val('');
				$('#endpicker_'+weekday+' input').val('');
				
				var addto = "#field-"+ weekday;
				var addRemove = "#field-"+ weekday;
				
				var arrayStr = starttime + '-'  + endtime + '-' + interval
				
				if( weekday === 'monday' ) {
					var flag = 1;
					$('#field-monday li:not(#field-monday0)').each(function(){
						var $this = $(this);
						var loopStartTime = $this.find( '.starttimeinput' ).val();
						var loopEndTime = $this.find( '.endtimeinput' ).val();
						
						var loopstartnumber = self.geteNumberByTime(loopStartTime);
						var loopendnumber = self.geteNumberByTime(loopEndTime);
						
						if ( ( startnumber >= loopstartnumber && startnumber < loopendnumber ) || ( endnumber > loopstartnumber && endnumber < loopendnumber ) || ( startnumber <= loopstartnumber && endnumber >= loopendnumber ) ) {
							flag = 0;
							self.renderValidationMessage(appointy_options.timeslot_exist);
							return false;
						}
						
					} );
					
					if( flag === 0 ) {
						return false;	
					}
					
					mondaySlotsArray.push(arrayStr);
					
					jQuery.each( mondaySlotsArray, function( key, slotstr ) {
						
						var  myArray = slotstr.split('-');
						var starttime = myArray[0];
						var endtime = myArray[1];
						var interval = myArray[2];
						
						var newIn = ' <li class="row field-working-hours" id="remove-add' + weekday + key + '"><div class="col-md-4 availibility-start"><div class="form-group"><div class="aon-inputicon-box"> <input readonly class="form-control sf-form-control starttimeinput" name="start_time[' + weekday + '][]" value="'+starttime+'" type="text" placeholder="00:00"></div></div></div><div class="col-md-4 availibility-end"><div class="form-group"><div class="aon-inputicon-box"> <input class="form-control sf-form-control endtimeinput" name="end_time[' + weekday + '][]" readonly value="'+endtime+'" type="text" placeholder="00:00"></div></div></div><div class="col-lg-4 col-md-4 col-sm-6 sf-daytime-has"><input readonly class="form-control sf-form-control" name="interval[' + weekday + '][]" value="'+interval+'" type="text" placeholder="00:00"><div class="appointy-interval-suffix">' + appointy_options.minutes_short + '</div></div><button type="button" data-removeid="remove-add' + weekday + key + '" class="btn-time-remove remove-me" ><i class="feather-x"></i></button></li>';
						
						var newInput = $(newIn);
						$(addto).append(newInput);
					});
					
				} else if( weekday === 'tuesday' ) {
					
					var flag = 1;
					$('#field-tuesday li:not(#field-tuesday0)').each(function(){
						var $this = $(this);
						var loopStartTime = $this.find( '.starttimeinput' ).val();
						var loopEndTime = $this.find( '.endtimeinput' ).val();
						
						var loopstartnumber = self.geteNumberByTime(loopStartTime);
						var loopendnumber = self.geteNumberByTime(loopEndTime);
						
						if ( ( startnumber >= loopstartnumber && startnumber < loopendnumber ) || ( endnumber > loopstartnumber && endnumber < loopendnumber ) || ( startnumber <= loopstartnumber && endnumber >= loopendnumber ) ) {
							flag = 0;
							self.renderValidationMessage(appointy_options.timeslot_exist);
							return false;
						}
						
					} );
					
					if( flag === 0 ) {
						return false;	
					}
					
					tuesdaySlotsArray.push(arrayStr);
					
					jQuery.each( tuesdaySlotsArray, function( key, slotstr ) {
						
						var  myArray = slotstr.split('-');
						var starttime = myArray[0];
						var endtime = myArray[1];
						var interval = myArray[2];
						
						var newIn = ' <li class="row field-working-hours" id="remove-add' + weekday + key + '"><div class="col-md-4 availibility-start"><div class="form-group"><div class="aon-inputicon-box"> <input readonly class="form-control sf-form-control starttimeinput" name="start_time[' + weekday + '][]" value="'+starttime+'" type="text" placeholder="00:00"></div></div></div><div class="col-md-4 availibility-end"><div class="form-group"><div class="aon-inputicon-box"> <input class="form-control sf-form-control endtimeinput" name="end_time[' + weekday + '][]" readonly value="'+endtime+'" type="text" placeholder="00:00"></div></div></div><div class="col-lg-4 col-md-4 col-sm-6 sf-daytime-has"><input readonly class="form-control sf-form-control" name="interval[' + weekday + '][]" value="'+interval+'" type="text" placeholder="00:00"><div class="appointy-interval-suffix">' + appointy_options.minutes_short + '</div></div><button type="button" data-removeid="remove-add' + weekday + key + '" class="btn-time-remove remove-me" ><i class="feather-x"></i></button></li>';
						
						var newInput = $(newIn);
						$(addto).append(newInput);
					});
					
				} else if( weekday === 'wednesday' ) {
					
					var flag = 1;
					$('#field-wednesday li:not(#field-wednesday0)').each(function(){
						var $this = $(this);
						var loopStartTime = $this.find( '.starttimeinput' ).val();
						var loopEndTime = $this.find( '.endtimeinput' ).val();
						
						var loopstartnumber = self.geteNumberByTime(loopStartTime);
						var loopendnumber = self.geteNumberByTime(loopEndTime);
						
						if ( ( startnumber >= loopstartnumber && startnumber < loopendnumber ) || ( endnumber > loopstartnumber && endnumber < loopendnumber ) || ( startnumber <= loopstartnumber && endnumber >= loopendnumber ) ) {
							flag = 0;
							self.renderValidationMessage(appointy_options.timeslot_exist);
							return false;
						}
						
					} );
					
					if( flag === 0 ) {
						return false;	
					}
					
					wednesdaySlotsArray.push(arrayStr);
					
					jQuery.each( wednesdaySlotsArray, function( key, slotstr ) {
						
						var  myArray = slotstr.split('-');
						var starttime = myArray[0];
						var endtime = myArray[1];
						var interval = myArray[2];
						
						var newIn = ' <li class="row field-working-hours" id="remove-add' + weekday + key + '"><div class="col-md-4 availibility-start"><div class="form-group"><div class="aon-inputicon-box"> <input readonly class="form-control sf-form-control starttimeinput" name="start_time[' + weekday + '][]" value="'+starttime+'" type="text" placeholder="00:00"></div></div></div><div class="col-md-4 availibility-end"><div class="form-group"><div class="aon-inputicon-box"> <input class="form-control sf-form-control endtimeinput" name="end_time[' + weekday + '][]" readonly value="'+endtime+'" type="text" placeholder="00:00"></div></div></div><div class="col-lg-4 col-md-4 col-sm-6 sf-daytime-has"><input readonly class="form-control sf-form-control" name="interval[' + weekday + '][]" value="'+interval+'" type="text" placeholder="00:00"><div class="appointy-interval-suffix">' + appointy_options.minutes_short + '</div></div><button type="button" data-removeid="remove-add' + weekday + key + '" class="btn-time-remove remove-me" ><i class="feather-x"></i></button></li>';
						
						var newInput = $(newIn);
						$(addto).append(newInput);
					});
					
				} else if( weekday === 'thursday' ) {
					
					var flag = 1;
					$('#field-thursday li:not(#field-thursday0)').each(function(){
						var $this = $(this);
						var loopStartTime = $this.find( '.starttimeinput' ).val();
						var loopEndTime = $this.find( '.endtimeinput' ).val();
						
						var loopstartnumber = self.geteNumberByTime(loopStartTime);
						var loopendnumber = self.geteNumberByTime(loopEndTime);
						
						if ( ( startnumber >= loopstartnumber && startnumber < loopendnumber ) || ( endnumber > loopstartnumber && endnumber < loopendnumber ) || ( startnumber <= loopstartnumber && endnumber >= loopendnumber ) ) {
							flag = 0;
							self.renderValidationMessage(appointy_options.timeslot_exist);
							return false;
						}
						
					} );
					
					if( flag === 0 ) {
						return false;	
					}
					
					thursdaySlotsArray.push(arrayStr);
					
					jQuery.each( thursdaySlotsArray, function( key, slotstr ) {
						
						var  myArray = slotstr.split('-');
						var starttime = myArray[0];
						var endtime = myArray[1];
						var interval = myArray[2];
						
						var newIn = ' <li class="row field-working-hours" id="remove-add' + weekday + key + '"><div class="col-md-4 availibility-start"><div class="form-group"><div class="aon-inputicon-box"> <input readonly class="form-control sf-form-control starttimeinput" name="start_time[' + weekday + '][]" value="'+starttime+'" type="text" placeholder="00:00"></div></div></div><div class="col-md-4 availibility-end"><div class="form-group"><div class="aon-inputicon-box"> <input class="form-control sf-form-control endtimeinput" name="end_time[' + weekday + '][]" readonly value="'+endtime+'" type="text" placeholder="00:00"></div></div></div><div class="col-lg-4 col-md-4 col-sm-6 sf-daytime-has"><input readonly class="form-control sf-form-control" name="interval[' + weekday + '][]" value="'+interval+'" type="text" placeholder="00:00"><div class="appointy-interval-suffix">' + appointy_options.minutes_short + '</div></div><button type="button" data-removeid="remove-add' + weekday + key + '" class="btn-time-remove remove-me" ><i class="feather-x"></i></button></li>';
						
						var newInput = $(newIn);
						$(addto).append(newInput);
					});
					
				} else if( weekday === 'friday' ) {
					
					var flag = 1;
					$('#field-friday li:not(#field-friday0)').each(function(){
						var $this = $(this);
						var loopStartTime = $this.find( '.starttimeinput' ).val();
						var loopEndTime = $this.find( '.endtimeinput' ).val();
						
						var loopstartnumber = self.geteNumberByTime(loopStartTime);
						var loopendnumber = self.geteNumberByTime(loopEndTime);
						
						if ( ( startnumber >= loopstartnumber && startnumber < loopendnumber ) || ( endnumber > loopstartnumber && endnumber < loopendnumber ) || ( startnumber <= loopstartnumber && endnumber >= loopendnumber ) ) {
							flag = 0;
							self.renderValidationMessage(appointy_options.timeslot_exist);
							return false;
						}
						
					} );
					
					if( flag === 0 ) {
						return false;	
					}
					
					fridaySlotsArray.push(arrayStr);
					
					jQuery.each( fridaySlotsArray, function( key, slotstr ) {
						
						var  myArray = slotstr.split('-');
						var starttime = myArray[0];
						var endtime = myArray[1];
						var interval = myArray[2];
						
						var newIn = ' <li class="row field-working-hours" id="remove-add' + weekday + key + '"><div class="col-md-4 availibility-start"><div class="form-group"><div class="aon-inputicon-box"> <input readonly class="form-control sf-form-control starttimeinput" name="start_time[' + weekday + '][]" value="'+starttime+'" type="text" placeholder="00:00"></div></div></div><div class="col-md-4 availibility-end"><div class="form-group"><div class="aon-inputicon-box"> <input class="form-control sf-form-control endtimeinput" name="end_time[' + weekday + '][]" readonly value="'+endtime+'" type="text" placeholder="00:00"></div></div></div><div class="col-lg-4 col-md-4 col-sm-6 sf-daytime-has"><input readonly class="form-control sf-form-control" name="interval[' + weekday + '][]" value="'+interval+'" type="text" placeholder="00:00"><div class="appointy-interval-suffix">' + appointy_options.minutes_short + '</div></div><button type="button" data-removeid="remove-add' + weekday + key + '" class="btn-time-remove remove-me" ><i class="feather-x"></i></button></li>';
						
						var newInput = $(newIn);
						$(addto).append(newInput);
					});
					
				} else if( weekday === 'saturday' ) {
					
					var flag = 1;
					$('#field-saturday li:not(#field-saturday0)').each(function(){
						var $this = $(this);
						var loopStartTime = $this.find( '.starttimeinput' ).val();
						var loopEndTime = $this.find( '.endtimeinput' ).val();
						
						var loopstartnumber = self.geteNumberByTime(loopStartTime);
						var loopendnumber = self.geteNumberByTime(loopEndTime);
						
						if ( ( startnumber >= loopstartnumber && startnumber < loopendnumber ) || ( endnumber > loopstartnumber && endnumber < loopendnumber ) || ( startnumber <= loopstartnumber && endnumber >= loopendnumber ) ) {
							flag = 0;
							self.renderValidationMessage(appointy_options.timeslot_exist);
							return false;
						}
						
					} );
					
					if( flag === 0 ) {
						return false;	
					}
					
					saturdaySlotsArray.push(arrayStr);
					
					jQuery.each( saturdaySlotsArray, function( key, slotstr ) {
						
						var  myArray = slotstr.split('-');
						var starttime = myArray[0];
						var endtime = myArray[1];
						var interval = myArray[2];
						
						var newIn = ' <li class="row field-working-hours" id="remove-add' + weekday + key + '"><div class="col-md-4 availibility-start"><div class="form-group"><div class="aon-inputicon-box"> <input readonly class="form-control sf-form-control starttimeinput" name="start_time[' + weekday + '][]" value="'+starttime+'" type="text" placeholder="00:00"></div></div></div><div class="col-md-4 availibility-end"><div class="form-group"><div class="aon-inputicon-box"> <input class="form-control sf-form-control endtimeinput" name="end_time[' + weekday + '][]" readonly value="'+endtime+'" type="text" placeholder="00:00"></div></div></div><div class="col-lg-4 col-md-4 col-sm-6 sf-daytime-has"><input readonly class="form-control sf-form-control" name="interval[' + weekday + '][]" value="'+interval+'" type="text" placeholder="00:00"><div class="appointy-interval-suffix">' + appointy_options.minutes_short + '</div></div><button type="button" data-removeid="remove-add' + weekday + key + '" class="btn-time-remove remove-me" ><i class="feather-x"></i></button></li>';
						
						var newInput = $(newIn);
						$(addto).append(newInput);
					});
					
				} else if( weekday === 'sunday' ) {
					
					var flag = 1;
					$('#field-sunday li:not(#field-sunday0)').each(function(){
						var $this = $(this);
						var loopStartTime = $this.find( '.starttimeinput' ).val();
						var loopEndTime = $this.find( '.endtimeinput' ).val();
						
						var loopstartnumber = self.geteNumberByTime(loopStartTime);
						var loopendnumber = self.geteNumberByTime(loopEndTime);
						
						if ( ( startnumber >= loopstartnumber && startnumber < loopendnumber ) || ( endnumber > loopstartnumber && endnumber < loopendnumber ) || ( startnumber <= loopstartnumber && endnumber >= loopendnumber ) ) {
							flag = 0;
							self.renderValidationMessage(appointy_options.timeslot_exist);
							return false;
						}
						
					} );
					
					if( flag === 0 ) {
						return false;	
					}
					
					sundaySlotsArray.push(arrayStr);
					
					jQuery.each( sundaySlotsArray, function( key, slotstr ) {
						
						var  myArray = slotstr.split('-');
						var starttime = myArray[0];
						var endtime = myArray[1];
						var interval = myArray[2];
						
						var newIn = ' <li class="row field-working-hours" id="remove-add' + weekday + key + '"><div class="col-md-4 availibility-start"><div class="form-group"><div class="aon-inputicon-box"> <input readonly class="form-control sf-form-control starttimeinput" name="start_time[' + weekday + '][]" value="'+starttime+'" type="text" placeholder="00:00"></div></div></div><div class="col-md-4 availibility-end"><div class="form-group"><div class="aon-inputicon-box"> <input class="form-control sf-form-control endtimeinput" name="end_time[' + weekday + '][]" readonly value="'+endtime+'" type="text" placeholder="00:00"></div></div></div><div class="col-lg-4 col-md-4 col-sm-6 sf-daytime-has"><input readonly class="form-control sf-form-control" name="interval[' + weekday + '][]" value="'+interval+'" type="text" placeholder="00:00"><div class="appointy-interval-suffix">' + appointy_options.minutes_short + '</div></div><button type="button" data-removeid="remove-add' + weekday + key + '" class="btn-time-remove remove-me" ><i class="feather-x"></i></button></li>';
						var newInput = $(newIn);
						$(addto).append(newInput);
					});
					
				}
				
			});
			
			$('body').on('click', '.add-another-custom-time', function(e){
				e.preventDefault();
				customSlotsArray = [];
				
				var $this = $('.customscheduleform');
				
				$this.find('.alert').remove();
				
				var weekday = $(this).data('weekday');
				var starttime = $('#startpicker_'+weekday+' input').val();
				var endtime = $('#endpicker_'+weekday+' input').val();
				var interval = $('#interval_'+weekday+' select').val();
				
				if( starttime === '' || endtime === '' ) {
					self.renderValidationMessage(appointy_options.select_startendtime);
					return false;
				}
				if( interval === '' ) {
					self.renderValidationMessage(appointy_options.select_interval);
					return false;
				}
				
				var startnumber = self.geteNumberByTime(starttime);
				var endnumber = self.geteNumberByTime(endtime);
				
				$('#startpicker_'+weekday+' input').val('');
				$('#endpicker_'+weekday+' input').val('');
				
				var addto = "#customfield-"+ weekday;
				var addRemove = "#customfield-"+ weekday;
				
				var arrayStr = starttime + '-'  + endtime + '-' + interval
				
				if( weekday === 'custom' ) {
					var flag = 1;
					$('#customfield-custom li:not(#customfield-custom0)').each(function(){
						var $this = $(this);
						var loopStartTime = $this.find( '.starttimeinput' ).val();
						var loopEndTime = $this.find( '.endtimeinput' ).val();
						
						var loopstartnumber = self.geteNumberByTime(loopStartTime);
						var loopendnumber = self.geteNumberByTime(loopEndTime);
						
						if ( ( startnumber >= loopstartnumber && startnumber < loopendnumber ) || ( endnumber > loopstartnumber && endnumber < loopendnumber ) || ( startnumber <= loopstartnumber && endnumber >= loopendnumber ) ) {
							flag = 0;
							self.renderValidationMessage(appointy_options.timeslot_exist);
							return false;
						}
						
					} );
					
					if( flag === 0 ) {
						return false;	
					}
					
					customSlotsArray.push(arrayStr);
					
					jQuery.each( customSlotsArray, function( key, slotstr ) {
						
						var  myArray = slotstr.split('-');
						var starttime = myArray[0];
						var endtime = myArray[1];
						var interval = myArray[2];
						
						var newIn = ' <li class="row field-working-hours editcustomfield-custom" id="remove-addcustom'+ key +'"><div class="col-md-4 availibility-start"><div class="form-group"><div class="aon-inputicon-box"><input readonly class="form-control sf-form-control starttimeinput" name="start_time[' + weekday + '][]" value="'+starttime+'" type="text" placeholder="00:00"></div></div></div><div class="col-md-4 availibility-end"><div class="form-group"><div class="aon-inputicon-box"> <input class="form-control sf-form-control endtimeinput" name="end_time[' + weekday + '][]" readonly value="'+endtime+'" type="text" placeholder="00:00"></div></div></div><div class="col-lg-4 col-md-4 col-sm-6 sf-daytime-has"><input readonly class="form-control sf-form-control" name="interval[' + weekday + '][]" value="'+interval+'" type="text" placeholder="00:00"><div class="appointy-interval-suffix">' + appointy_options.minutes_short + '</div></div><button type="button" data-removeid="remove-addcustom'+ key +'" class="btn-time-remove remove-me" ><i class="feather-x"></i></button></li>';
						
						var newInput = $(newIn);
						$(addto).append(newInput);
						
					});
					
					if( customSlotsArray.length > 0 ) {
						$('#customscheduleformsubmit').removeClass("disabled");
						$('#customscheduleformsubmit').prop("disabled", false);
					} else {
						$('#customscheduleformsubmit').addClass("disabled");
						$('#customscheduleformsubmit').prop("disabled", true);	
					}
					
				}
				
			});
			
			$('#custom_schedule_modal').on('shown.bs.modal', function () {
				$('#customscheduleformsubmit').addClass("disabled");
				$('#customscheduleformsubmit').prop("disabled", true);
			})
			
			$('#holidays_modal').on('shown.bs.modal', function (event) {
				var button = $(event.relatedTarget);
				var formid = button.data('formid');
				self.resetForm(formid);
			})
			
			$('#timeslots_modal').on('shown.bs.modal', function (event) {
				var button = $(event.relatedTarget);
				var formid = button.data('formid');
				self.resetForm(formid);
				
				var slotOptions = button.data( 'options' );
				var weekday = button.data( 'weekday' );
				var weekdaykey = button.data( 'weekdaykey' );
				var interval = button.data( 'interval' );
				
				$('.display-weekday').html( weekday );
				$('.timeslotsform input[name="day"]').val( weekdaykey );
				$('.timeslotsform input[name="interval"]').val( interval );
				var data = {
					'action'       : 'appointy_load_work_period_slots',
					'options'		 : slotOptions,
					'user_id'      : jsdata.user_id
				};
				var formdata = jQuery.param(data);
				$.ajax({
					url: appointy_options.ajaxurl,
					type:'POST',
					dataType: 'json',
					beforeSend: self.togglePanelLoading('show'),
					data:  formdata
				}).done(function(response) {
					self.togglePanelLoading('hide');
					if ( response.success ) {
						$('.display-working-periods').html( response.data.html );
					} else {
						self.renderValidationMessage(response.data.msg);
					}
				});
			})
			
			$('body').on('click', '.remove-me', function(e) {
				var removeid = $(this).data('removeid');
				$('#'+removeid).remove();
			});
			
			// Save custom schedule
			$('form.customscheduleform').validate({
				submitHandler: function() { 
					var $this = $('form.customscheduleform');
					$.ajax({
						url: appointy_options.ajaxurl,
						type:'POST',
						dataType: 'json',
						beforeSend: self.togglePanelLoading('show'),
						data: $this.serialize()+'&action=appointy_save_custom_schedule',
					}).done(function(response) {
						self.togglePanelLoading('hide');
						if ( response.success ) {
							self.renderSuccessMessage(response.data.msg);
							window.setTimeout(function(){
								window.location.reload();
							}, 2000);
						} else {
							self.renderValidationMessage(response.data.msg);
						}
					});
					return false; 
				}
			});
			
			var nextRange = 0;
   			$("#add-more-unavl-range").click(function(e){
			e.preventDefault();
	
			var addto = $('#dayoff_daterange_field').children().last().attr('id');
			addto = '#'+addto;
	
			var addRemove = "#dayoff_daterange_field" + (nextRange);
	
			nextRange = nextRange + 1;
	
			var newIn = ' <div class="sf-dayoff-daterange sf-dayoff-daterange-area" id="dayoff_daterange_field'+ nextRange +'" name="dayoff_daterange_field'+ nextRange +'"><div class="col-lg-12 sf-dayoff-daterange-inners"><div class="form-group "><div class="input-daterange input-group" id="datepicker"><input type="text" class="input-sm form-control" name="start_range['+ nextRange +']" placeholder="'+ appointy_options.start_date +'" /><span class="input-group-addon">'+ appointy_options.to +'</span><input type="text" class="input-sm form-control" name="end_range['+ nextRange +']" placeholder="'+ appointy_options.end_date +'" /></div></div></div></div>';
	
			var newInput = $(newIn);
	
			var removeBtn = '<button id="remove' + (nextRange) + '" class="btn btn-danger remove-me" ><i class="fa fa-close"></i></button>';
	
			var removeButton = $(removeBtn);
	
			$(addto).after(newInput);
	
			$(addto).after(removeButton);
	
			$("#dayoff_daterange_field" + nextRange).attr('data-source',$(addto).attr('data-source'));
	
			$("#count").val(nextRange);  
	
			
	
			$('.remove-me').click(function(e){
	
				e.preventDefault();
	
				var fieldNum = this.id.charAt(this.id.length-1);
	
				var fieldID = "#dayoff_daterange_field" + fieldNum;
	
				$(this).remove();
	
				$(fieldID).remove();
	
			});
	
			self.setDateRangePicker();
	
		});
			
			// Save holidays
			$('form.holidaysform').validate({
				submitHandler: function() { 
					var $this = $('form.holidaysform');
					$.ajax({
						url: appointy_options.ajaxurl,
						type:'POST',
						dataType: 'json',
						beforeSend: self.togglePanelLoading('show'),
						data:  $this.serialize()+"&action=appointy_save_holidays"
					}).done(function(response) {
						self.togglePanelLoading('hide');
						if ( response.success ) {
							self.renderSuccessMessage(response.data.msg);
							window.setTimeout(function(){
								window.location.reload();
							}, 2000);
						} else {
							self.renderValidationMessage(response.data.msg);
						}
					});
					return false; 
				}
			});
			
			// Delete holidays
			$('body').on('click', '.removeholidayrow', function() {
				var $this = $(this);
				bootbox.confirm(appointy_options.are_you_sure, function( result ) {
					if(result){
						var removeholidayid = $this.data('removeholidayid');
						
						var container = $('.holidays-wrapper');
						
						$.ajax({
							url: appointy_options.ajaxurl,
							type:'POST',
							dataType: 'json',
							beforeSend: self.toggleLoading('show'),
							data: "action=appointy_delete_holidays&removeholidayid="+removeholidayid
						}).done(function(response) {
							self.toggleLoading('hide');
							if ( response.success ) {
								self.renderSuccessMessage(response.data.msg);
								$('#holidayrow-' + removeholidayid).remove();
							} else {
								self.renderValidationMessage(response.data.msg);
							}
						});
					}
				});
            });
			
			// Delete custom schedule date
			$('body').on('click', '.removecustomdate', function() {
				var $this = $(this);
				bootbox.confirm(appointy_options.are_you_sure, function( result ) {
					if(result){
						var removeCustomDate = $this.data('removecustomdate');
						
						var container = $('.customer-schedule-wrapper');
						
						$.ajax({
							url: appointy_options.ajaxurl,
							type:'POST',
							dataType: 'json',
							beforeSend: self.toggleLoading('show'),
							data: "action=appointy_delete_custom_schedule&removecustomdate="+removeCustomDate+"&user_id="+jsdata.user_id
						}).done(function(response) {
							self.toggleLoading('hide');
							if ( response.success ) {
								self.renderSuccessMessage(response.data.msg);
								window.setTimeout(function(){
									window.location.reload();
								}, 2000);
							} else {
								self.renderValidationMessage(response.data.msg);
							}
						});
					}
				});
            });
			
			$('body').on('click', '.editcustomschedule', function() {
				var $this = $(this), formcontainer = $('.customscheduleform');
				var editCustomDate = $this.data('editcustomdate');
				
				$('#customscheduleformsubmit').removeClass("disabled");
				$('#customscheduleformsubmit').prop("disabled", false);
				
				$.ajax({
					url: appointy_options.ajaxurl,
					type:'POST',
					dataType: 'json',
					beforeSend: self.toggleLoading('show'),
					data: "action=appointy_load_custom_schedule&editcustomdate="+editCustomDate+"&user_id="+jsdata.user_id
				}).done(function(response) {
					self.toggleLoading('hide');
					if ( response.success ) {
						$('#customfield-custom .editcustomfield-custom').remove();
						$('#customfield-custom').append(response.data.html);
						formcontainer.find('input[name="custom_date"]').val(response.data.custom_date);
						$('#custom_schedule_modal').modal('toggle');
					} else {
						self.renderValidationMessage(response.data.msg);
					}
				});
            });
		},

	}
    $.AppointyAdmin = AppointyAdmin.prototype;
    
    $(document).ready(function() {
        // Initialize script
        new AppointyAdmin();
    });
// > page loader function by = custom.js ========================= //		
	function pageLoader() {
		jQuery('.ap-loading-area').fadeOut(1000);
	}	
/*--------------------------------------------------------------------------------------------
	Window Load START
---------------------------------------------------------------------------------------------*/
	jQuery(window).on('load', function () {
		
		//page loader function by = custom.js		
		pageLoader();
		
});
})( jQuery );
