<?php 

wp_enqueue_script('bootstrap-slider');

wp_enqueue_style( 'bootstrap-slider' );



$invoiceid = Appointy_Router_Helper::get_request_data( $_GET, 'invoiceid' );



$invoice_fields = Appointy_Invoice_Helper::invoice_fields();

$invoice_customer_fields = Appointy_Invoice_Helper::invoice_customer_fields();



if( !empty($invoiceid) && $invoiceid > 0 ) {

	$invoice_object = get_post( $invoiceid );

	

	if(isset($_GET['invoiceid'])) {

		if(!empty($invoice_fields)) {

			foreach ( $invoice_fields as $key => $field ) {

				if ( ! isset( $invoice_fields[ $key ]['value'] ) || 'invoice_id' === $key ) {

					if( 'invoice_title' === $key ) {

						$invoice_fields[ $key ]['value'] = get_the_title($invoiceid);

					} else {

						$invoice_fields[ $key ]['value'] = get_post_meta( $invoiceid, '_' . $key, true );

					}

				}

			}

		}

	}

	

	if(isset($_GET['invoiceid'])) {

		if(!empty($invoice_customer_fields)) {

			foreach ( $invoice_customer_fields as $key => $field ) {

				if ( ! isset( $invoice_customer_fields[ $key ]['value'] ) ) {

					$invoice_customer_fields[ $key ]['value'] = get_post_meta( $invoiceid, '_' . $key, true );

				}

			}

		}

	}

}

?>

<div class="content-admin-main">

    

    <form name="invoice__create" id="invoice__create">

    	<?php if( !empty($invoiceid) && $invoiceid > 0 ) { ?>

        <input type="hidden" name="invoiceid" value="<?php echo esc_attr($invoiceid); ?>">

        <?php } ?>

    


        <div class="aon-admin-heading d-flex justify-content-between align-items-center">

            <div class="aon-admin-headLeft">

                <?php if( Appointy_Router_Helper::get_request_data( $_GET, 'mode' ) === 'edit' ) { ?>

                <h3><?php esc_html_e('Edit Invoice', 'appointy'); ?></h3>

                <?php } else { ?>

                <h3><?php esc_html_e('Add Invoice', 'appointy'); ?></h3>

                <?php } ?>

            </div>
			
			<div class="aon-admin-headRight">
				<button type="submit" class="site-button"><?php esc_html_e('Save Changes','appointy'); ?></button>
            </div>

        </div> 

        <div class="row">
			<div class="col-md-6">	
				<!--Left Part-->
				<div class="panel cards aon-card panel-default about-me-here">

					<div class="panel-heading sf-panel-heading">
						<h4 class="panel-tittle m-a0"><span class="fa fa-vcard-o"></span> <?php esc_html_e('Basic Information','appointy'); ?></h4>
					</div>

					<div class="card-body aon-card-body panel-body sf-panel-body p-a30">

						<div class="row">

							<?php

							if( !empty( $invoice_fields ) ) {

								foreach( $invoice_fields as $key => $field ){

									Appointy_Form_Helper::get_form_structure($key,$field);

								}

							}

							?>

						</div>

					</div>

				</div>
				<?php do_action('appointy_after_invoice_title' ); ?>
			</div>
			<div class="col-md-6">	
			<!--Right Part-->
			<div class="panel cards aon-card panel-default customer-info-here"> 

				<div class="panel-heading sf-panel-heading">

					<h4 class="panel-tittle m-a0"><span class="fa fa-user-o"></span> <?php esc_html_e('Customer Information','appointy'); ?></h4>

				</div>

				<div class="panel-body sf-panel-body p-a30">

					<div class="row cl_invoice_customer_info" id="cl_invoice_customer_info">

						<?php
						if(isset($invoiceid)) {
							$invoicedata['user_email'] = get_post_meta($invoiceid, '_email',true);	
							$userinfo = get_user_by('email', $invoicedata['user_email']);
						}

						$customer_id = array();

						$args = array(

							'posts_per_page'   => -1,

							'post_type'        => 'appointy_appointment',

							'post_status' => array( 'cancelled', 'pending', 'declined', 'processing', 'on-hold', 'completed' ),

						);



						$all_appointments = get_posts($args);

						if(!empty($all_appointments)){

							foreach($all_appointments as $appointment){

								$customerid = get_post_meta($appointment->ID,'booking_customer_id',true);



								$customeremail = Appointy_Misc_Helper::get_email_by_user_id($customerid);

								if($customeremail === ''){

									$customeremail = get_post_meta($appointment->ID,'email',true);

								}

								$customer_id[$customerid] = $customeremail;

							}

						}

						$all_customers = array_unique($customer_id);

						?>

						<div class="col-lg-12">

							<div class="form-group ">

								<label><?php esc_html_e('Select Customer','appointy'); ?></label>

								<div class="aon-inputicon-box">

								<select class="form-select cl_customer_email" name="cl_customer[user_data][user_email]" data-live-search="true" title="<?php esc_html_e('Please Select Customer Email','appointy'); ?>">

								<option value=""><?php esc_attr(esc_html_e("Select customer", 'appointy')) ?></option>

								<option value="new"><?php esc_attr(esc_html_e("New customer", 'appointy')) ?></option>

								<?php

								if(!empty($all_customers)){

									foreach($all_customers as $key => $customeremail){

										$select = '';

										if(!empty($userinfo)){

											if(intval($userinfo->ID) === intval($key)){

												$select = 'selected="selected"';						

											}else{

												$select = '';

											}

										}

										echo '<option '.$select.' value="'.esc_attr($key).'">'.Appointy_Misc_Helper::get_fullname_by_user_id($key).' ('.esc_html($customeremail).')</option>';

									}

								}

								?>

								</select>

								<i class="aon-input-icon  fa fa-user"></i>

								</div>                                                    

							</div>

						</div>

						<?php

						if( !empty($invoice_customer_fields) ){

							foreach( $invoice_customer_fields as $key => $field ){

								Appointy_Form_Helper::get_form_structure($key,$field);

							}

						}

						?>

					</div>

				</div>

			</div>
			<?php do_action('appointy_after_invoice_customer_info' ); ?>
			</div>	
		</div>	
        

        <div class="row">                

            <div class="col-md-12">                    

                <div class="panel cards aon-card panel-default invo-des-here">

                    <div class="panel-heading sf-panel-heading">

                        <h4 class="panel-tittle m-a0"><span class="fa fa-file-text-o"></span> <?php esc_html_e('Invoice Description','appointy'); ?></h4>

                    </div>

                    <div class="panel-body sf-panel-body p-a30">

                        <div class="editer-wrap">

                                <div class="editer-textarea">

                                    <?php

                                    if( !empty($invoiceid) && $invoiceid > 0 ) {

										$content = apply_filters('the_content', $invoice_object->post_content);

                                    } else {

                                    	$content = '';

                                    }

                                    $editor_id = 'invoice_description';

                                    $settings = array( 'media_buttons' => true );

                                    wp_editor( $content, $editor_id, $settings );

                                    ?>

                                </div>

                          </div>

                    </div>

                </div>

            </div>                

        </div>

        

        <?php do_action('appointy_after_invoice_description' ); ?>

        

        <div class="panel cards aon-card panel-default invoice-des-here">

            <div class="panel-heading sf-panel-heading">

                <h4 class="panel-tittle m-a0"><span class="fa fa-file-text-o"></span> <?php esc_html_e('Invoice Items','appointy'); ?></h4>

            </div>

            <div class="panel-body sf-panel-body p-a30">

                <div class="p-a30 sf-predefined-services">

                    <select id="cl_predefined_services" class="sf-select-box" data-live-search="true" title="<?php esc_html_e('Select Predefined Services','appointy'); ?>">
					<option value=""><?php esc_html_e('Select Service','appointy'); ?></option>

                    <?php

                    $args = array(

                        'posts_per_page'   => -1,

                        'post_type'        => 'appointy_services',

                        'post_status' => 'publish',

                    );

                    $all_services = get_posts($args);

                    if(!empty($all_services)) {

                        foreach($all_services as $service) {

                        

							$servicetype = get_post_meta($service->ID,'_servicetype',true);

							

							$args['description'] = apply_filters('the_content', $service->post_content);

							$args['servicetype'] = $servicetype;

							$options = '';

							if( $servicetype === 'hourly' ) {

								$ser_variations = get_post_meta($service->ID,'_service_variations',true);

								if( !empty($ser_variations) ) {

									foreach( $ser_variations as $variation ) {

										$args['title'] = esc_html($variation[0]);

										$args['price'] = esc_html($variation[4]);

										

										$hours = esc_html($variation[1]);

										$minutes = esc_html($variation[2]);

										

										$duration = Appointy_Booking_Form_Helper::get_duration($hours,$minutes);

										

										$args['duration_type'] = 'minutes';

										$args['duration'] = $duration;

										

										if($variation[0] !== '' && $variation[4] !== '' && $variation[4] > 0)

										{

											$options .= '<option value="'.esc_attr($args['title']).'|'.esc_attr($args['description']).'|'.esc_attr($args['duration']).'|'.esc_attr($args['price']).'|'.esc_attr($args['duration_type']).'|'.esc_attr($args['servicetype']).'">'.esc_html($args['title']).'</option>';

										}

										

									}

								}

							

							} elseif( $servicetype === 'fix' ) {

								$args['title'] = Appointy_Router_Helper::get_request_data($service,'post_title');

								$args['price'] = get_post_meta($service->ID,'_service_fixed_regular_price',true);

								

								$service_fixed_hours = get_post_meta($service->ID,'_service_fixed_hours',true);

								$service_fixed_minutes = get_post_meta($service->ID,'_service_fixed_minutes',true);

								

								$duration = Appointy_Booking_Form_Helper::get_duration($service_fixed_hours,$service_fixed_minutes);

								

								$args['duration_type'] = 'minutes';

								$args['duration'] = $duration;

								

								$options .= '<option value="'.esc_attr($args['title']).'|'.esc_attr($args['description']).'|'.esc_attr($args['duration']).'|'.esc_attr($args['price']).'|'.esc_attr($args['duration_type']).'|'.esc_attr($args['servicetype']).'">'.esc_html($args['title']).'</option>';

							

							} elseif( $servicetype === 'package' ) {

								$args['title'] = Appointy_Router_Helper::get_request_data($service,'post_title');

								$args['price'] = get_post_meta($service->ID,'_package_regular_price',true);

								

								$package_hours = get_post_meta($service->ID,'_package_hours',true);

								$package_minutes = get_post_meta($service->ID,'_package_minutes',true);

								

								$duration = Appointy_Booking_Form_Helper::get_duration($package_hours,$package_minutes);

										

								$args['duration_type'] = 'minutes';

								$args['duration'] = $duration;

				

								$options .= '<option value="'.esc_attr($args['title']).'|'.esc_attr($args['description']).'|'.esc_attr($args['duration']).'|'.esc_attr($args['price']).'|'.esc_attr($args['duration_type']).'|'.esc_attr($args['servicetype']).'">'.esc_html($args['title']).'</option>';

							

							}

							echo wp_kses($options,Appointy_Misc_Helper::get_allowed_tags());

                        }

                    }

                    ?>

                    </select>

                </div>

                <div class="row">

                <?php

                if(isset($invoiceid)) {

					$invoicedata['invoice_items'] = get_post_meta($invoiceid, 'invoice_items',true);

		

					$invoicedata['tax'] = get_post_meta($invoiceid, 'tax',true);

					$invoicedata['total_tax'] = get_post_meta($invoiceid, 'total_tax',true);

					$invoicedata['discount'] = get_post_meta($invoiceid, 'discount',true);

					$invoicedata['total_discount'] = get_post_meta($invoiceid, 'total_discount',true);

					$invoicedata['subtotal'] = get_post_meta($invoiceid, 'subtotal',true);

					$invoicedata['grand_total'] = get_post_meta($invoiceid, 'grand_total',true);

                } else {

					$invoicedata['invoice_items'] = array();

					$invoicedata['tax'] = '';

					$invoicedata['total_tax'] = '';

					$invoicedata['discount'] = '';

					$invoicedata['total_discount'] = '';

					$invoicedata['subtotal'] = '';

					$invoicedata['grand_total'] = '';

                }

                $currency = Appointy_Misc_Helper::get_currency_symbol();

                ?>

                <ul id="cl_invoice_items" class="itemized_list clearfix">

					<?php

					if( empty($invoicedata['invoice_items']) || !is_array($invoicedata['invoice_items']))  {

						$k = 1;

						while($k <= 2) {

							if ($invoicedata['invoice_items'] === false) {
								$invoicedata['invoice_items'] = array();
							}
							$invoicedata['invoice_items'][$k++] = true;

						}

					}

					$counter = 1;

					?>

					<?php foreach((array)$invoicedata['invoice_items'] as $invoice_items) { ?>

                        <li class="cl_invoice_item_row clearfix" id="cl_invoice_meta_item_row_<?php echo esc_attr($counter); ?>">

                          <span class="cl_id hidden"><?php echo esc_attr($counter); ?></span>

                          <div class="flexible_width_holder">

                            <div class="flexible_width_holder_content">

                              <div class="col-lg-1 col-md-1">

                              <span class="cl_row_delete"><img src="<?php echo esc_url(APPOINTY_IMAGE_URL.'delete.png'); ?>" alt="<?php esc_attr_e('Delete', 'appointy') ?>" /></span>

                              </div>

                              <div class="col-lg-5 col-md-5">

                              <input data-rule-required="true" data-msg-required="<?php esc_html_e('Please enter invoice item title','appointy'); ?>" class="cl_item_title input_field item_name form-control" placeholder="<?php esc_html_e('Item Title','appointy'); ?>" name="cl_invoice_meta_item[invoice_items][<?php echo esc_attr($counter); ?>][title]" value="<?php echo esc_attr( Appointy_Router_Helper::get_request_data( $invoice_items, 'title' ) ); ?>" />

                              <span class="cl_toggle_description wpi_add_description_text">&nbsp;<span class="content"><strong class="sf-toggle-down"><?php esc_html_e('Toggle Description', 'appointy') ?> <i class="fa fa-angle-down"></i></strong></span></span>

                              </div>

                            </div>

                          </div>

                          <span class="fixed_width_holder">

                            <div class="col-lg-2 col-md-2">

                            <span class="cl_row_price"><input data-rule-required="true" placeholder="<?php esc_html_e('Item Cost','appointy'); ?>" data-msg-required="<?php esc_html_e('Please enter invoice item cost','appointy'); ?>" <?php echo ( Appointy_Router_Helper::get_request_data( $invoice_items, 'predefined_service' ) === 'yes' ) ? 'readonly="readonly"' : '';?> autocomplete="off" value="<?php echo esc_attr( Appointy_Router_Helper::get_request_data( $invoice_items, 'unit_price' ) ); ?>"  name="cl_invoice_meta_item[invoice_items][<?php echo esc_attr($counter); ?>][unit_price]" id="cl_invoice_unit_price_item_<?php echo esc_attr($counter); ?>"  class="cl_item_unit_price item_unit_price input_field form-control"></span>

                            </div>

                            <div class="col-lg-2 col-md-2">

                            <span class="cl_row_total" id="cl_invoice_total_item_<?php echo esc_attr($counter); ?>" ><span class="rowtotal"><?php echo (!empty(Appointy_Router_Helper::get_request_data( $invoice_items, 'item_total' ))) ? $currency.esc_attr( Appointy_Router_Helper::get_request_data( $invoice_items, 'item_total' ) ) : $currency.'0.00'; ?></span><input value="<?php echo esc_attr(Appointy_Router_Helper::get_request_data( $invoice_items, 'item_total' )); ?>" type="hidden" name="cl_invoice_meta_item[invoice_items][<?php echo esc_attr($counter); ?>][item_total]" id="cl_invoice_item_total_item_<?php echo esc_attr($counter); ?>"  class="cl_item_item_total item_item_total input_field form-control"><input value="<?php echo (Appointy_Router_Helper::get_request_data( $invoice_items, 'predefined_service' ) === 'yes') ? esc_attr(Appointy_Router_Helper::get_request_data( $invoice_items, 'predefined_service' )) : 'no'; ?>" type="hidden" name="cl_invoice_meta_item[invoice_items][<?php echo esc_attr($counter); ?>][predefined_service]" id="cl_invoice_predefined_service_item_<?php echo esc_attr($counter); ?>"  class="cl_item_predefined_service item_predefined_service input_field form-control"></span>

                            </div>

                          </span>

                          <div class="col-lg-12 col-md-12">

                          <?php $description_item_style = empty(Appointy_Router_Helper::get_request_data( $invoice_items, 'description' )) ? 'none' : 'block'; ?>

                          <textarea placeholder="<?php esc_html_e('Item Description','appointy'); ?>" style="display: <?php echo esc_attr($description_item_style); ?>" name="cl_invoice_meta_item[invoice_items][<?php echo esc_attr($counter); ?>][description]" class="cl_item_description form-control"><?php echo esc_attr(Appointy_Router_Helper::get_request_data( $invoice_items, 'description' )); ?></textarea>

                          </div>

                        </li>

                    <?php $counter++; ?>

                  <?php } ?>

                  <?php  

                  $no_tax = false; 

                  if( empty($invoicedata['tax']) || !is_array($invoicedata['tax']))  {

                    if ((bool) $invoicedata['tax'] === false) {
						$invoicedata['tax'] = array();
					}
							
					$no_tax = true;

                    $invoicedata['tax'][1] = true;

                  }

                  ?>  

                  <li style=" <?php echo ($no_tax) ? 'display:none' : ''; ?>" class="cl_invoice_tax_row clearfix" id="cl_invoice_tax_row">

                      <div class="flexible_width_holder">

                        <div class="flexible_width_holder_content" style="margin-right:250px;">

                          <div class="col-lg-1 col-md-1">

                          <span class="cl_row_delete"><img src="<?php echo esc_url(APPOINTY_IMAGE_URL.'delete.png'); ?>" alt="<?php esc_attr_e('Delete', 'appointy') ?>" /></span>

                          </div>

                          <div class="col-lg-5 col-md-5">

                          <input class="cl_item_name input_field form-control" name="cl_invoice[meta][tax][name]" placeholder="<?php esc_attr_e('Tax Name', 'appointy') ?>" value="<?php echo (!empty($invoicedata['tax']['name'])) ? esc_attr($invoicedata['tax']['name']) : ''; ?>" />

                          </div>

                        </div>

                      </div>

                      <span class="fixed_width_holder">

                        <div class="col-lg-3 col-md-3">

                        <span class="cl_item_type">

                          <select id="item_type" class="cl_item_type sf-select-box" name="cl_invoice[meta][tax][type]" data-live-search="true" title="<?php esc_html_e('Tax Percentage/Fix Amount','appointy'); ?>">

                          <?php $taxtype = (!empty($invoicedata['tax']['type'])) ? $invoicedata['tax']['type'] : '';?>

                          <option value="amount" <?php echo ($taxtype === 'amount') ? 'selected="selected"' : ''; ?> >$</option>

                          <option value="percent" <?php echo ($taxtype === 'percent') ? 'selected="selected"' : ''; ?>>%</option>

                          </select>

                        </span>

                        </div>

                        <div class="col-lg-3 col-md-3">

                        <span class="cl_item_amount">

                        <input class="cl_item_amount input_field form-control" autocomplete="off" name="cl_invoice[meta][tax][amount]" placeholder="<?php esc_attr_e('Amount/Percentage', 'appointy') ?>" value="<?php echo (!empty($invoicedata['tax']['amount'])) ? esc_attr($invoicedata['tax']['amount']) : ''; ?>" />

                        </span>

                        </div>

                      </span>

                    </li>	

                  <?php

                  //add discounts, adding one blank line if none exist

                  $no_discounts = false;

                  if( empty($invoicedata['discount']) || !is_array($invoicedata['discount']))  {

                    if ((bool) $invoicedata['discount'] === false) {
						$invoicedata['discount'] = array();
					}
					
					$no_discounts = true;

                    $invoicedata['discount'][1] = true;

                  }

                  $discount_types = serialize(array('amount' => esc_html__('Amount of Discount', 'appointy'), 'percent' => esc_html__('Percent Discount', 'appointy')));

                  ?>

                  <li style=" <?php echo ($no_discounts) ? 'display:none' : ''; ?>" class="cl_invoice_discount_row clearfix" id="cl_invoice_discount_row">

                      <div class="flexible_width_holder">

                        <div class="flexible_width_holder_content" style="margin-right:250px;">

                          <div class="col-lg-1 col-md-1">

                          <span class="cl_row_delete"><img src="<?php echo esc_url(APPOINTY_IMAGE_URL.'delete.png'); ?>" alt="<?php esc_attr_e('Delete', 'appointy') ?>" /></span>

                          </div>

                          <div class="col-lg-5 col-md-12">

                          <input class="cl_item_name input_field form-control" name="cl_invoice[meta][discount][name]" placeholder="<?php esc_attr_e('Discount Info', 'appointy') ?>" value="<?php echo (!empty($invoicedata['discount']['name'])) ? esc_attr($invoicedata['discount']['name']) : ''; ?>" />

                          </div>

                        </div>

                      </div>

                      <span class="fixed_width_holder">

                        <div class="col-lg-3 col-md-3 sf-invoice-discount">

                        <span class="cl_item_type">

                          <select id="item_type" class="cl_item_type sf-select-box" name="cl_invoice[meta][discount][type]" data-live-search="true" title="<?php esc_html_e('Discount Percentage/Fix Amount','appointy'); ?>">

                          <?php $discounttype = (!empty($invoicedata['discount']['type'])) ? esc_html($invoicedata['tax']['type']) : '';?>

                          <option value="amount" <?php echo ($discounttype === 'amount') ? 'selected="selected"' : ''; ?> >$</option>

                          <option value="percent" <?php echo ($discounttype === 'percent') ? 'selected="selected"' : ''; ?>>%</option>

                          </select>

                        </span>

                        </div>

                        <div class="col-lg-3 col-md-3">

                        <span class="cl_item_amount">

                        <input class="cl_item_amount input_field form-control" placeholder="<?php esc_attr_e('Amount/Percentage', 'appointy') ?>" autocomplete="off" name="cl_invoice[meta][discount][amount]" value="<?php echo (!empty($invoicedata['discount']['amount'])) ? esc_attr($invoicedata['discount']['amount']) : ''; ?>" />

                        </span>

                        </div>

                      </span>

                    </li>

                  <li class="cl_invoice_totals clearfix">

                    <dl>

                      <div class="col-lg-3 col-md-3">

                      <dt class="<?php echo empty( $invoicedata['subtotal'] ) ? 'hidden' : ''; ?> cl-invoice-details-subtotal"><?php esc_html_e("Subtotal Excluding Tax:", 'appointy') ?></dt>

                      <dd class="<?php echo empty( $invoicedata['subtotal'] ) ? 'hidden' : ''; ?> cl-invoice-details-subtotal"><input class="calculate_invoice_subtotal wpi_no_input form-control" disabled="true" value="<?php echo !empty( $invoicedata['subtotal'] ) ? esc_attr($invoicedata['subtotal']) : ''; ?>"/></dd>

                      </div>

                      

                      <div class="col-lg-3 col-md-3">

                      <dt class="<?php echo empty( $invoicedata['total_tax'] ) ? 'hidden' : ''; ?> cl-invoice-details-tax"><?php esc_html_e("Tax:", 'appointy') ?></dt>

                      <dd class="<?php echo empty( $invoicedata['total_tax'] ) ? 'hidden' : ''; ?> cl-invoice-details-tax"><input class="calculate_invoice_tax wpi_no_input form-control" disabled="true" value="<?php echo !empty( $invoicedata['total_tax'] ) ? esc_attr($invoicedata['total_tax']) : '';?>"/></dd>

                      </div>

                      

                      <div class="col-lg-3 col-md-3">

                      <dt class="<?php echo empty( $invoicedata['total_discount'] ) ? 'hidden' : ''; ?> cl-invoice-details-discounts"><?php esc_html_e("Discount:", 'appointy') ?></dt>

                      <dd class="<?php echo empty( $invoicedata['total_discount'] ) ? 'hidden' : ''; ?> cl-invoice-details-discounts"><input class="wpi_no_input calculate_discount_total form-control" disabled="true" value="<?php echo !empty( $invoicedata['total_discount'] ) ? esc_attr($invoicedata['total_discount']) : '';?>"/></dd>

                      </div>

                      

                      <div class="col-lg-3 col-md-3">

                      <dt><b><?php esc_html_e("Balance:", 'appointy') ?></b></dt>

                      <dd><input class="calculate_invoice_total wpi_no_input form-control" disabled="true" value="<?php echo !empty( $invoicedata['grand_total'] ) ? $currency.esc_attr($invoicedata['grand_total']) : $currency.'0.00';?>"/></dd>

                      </div>

                      

                    </dl>

                  </li>

                  

                  <li class="footer clearfix">

                    <div class="col-lg-5 col-md-4 col-xs-4 col-break-480 sf-invoiceitems-btnLeft">

                    	<input type="button"  class="buttons-secondary site-button" id="cl_add_new_invoice_item" value="<?php esc_attr(esc_html_e("Add New", 'appointy')) ?>"/>

                    </div>

                    <div class="col-lg-7 col-md-8 col-xs-8  sf-invoiceitems-btnRight col-break-480 text-right">

                    <input type="button" class="buttons-secondary site-button m-r15" id="cl_add_tax_row" value="<?php esc_attr(esc_html_e("Add Tax", 'appointy')) ?>"/>

                    <input type="button" class="buttons-secondary site-button" id="cl_add_discount_row" value="<?php esc_attr(esc_html_e("Add Discount", 'appointy')) ?>"/>

                    </div>

                    <span id="wpi_discount_mismatch_error"></span>

                  </li>

                </ul>

                </div>    

            </div>

        </div>                    

        <?php do_action('appointy_after_invoice_items' ); ?>

        <?php wp_nonce_field( 'ajax-save-invoice-nonce', 'secure_save_invoice' ); ?>

    

    </form>
	
	<?php Appointy_Template_Loader::get_template_part( 'admin/notification-box' ); ?>
	
	<?php Appointy_Template_Loader::get_template_part( 'panel-loading' ); ?>

    

</div>