<?php 

global $wpdb;

wp_enqueue_script('bootstrap-slider');

wp_enqueue_style( 'bootstrap-slider' );

$roomid = Appointy_Router_Helper::get_request_data( $_GET, 'roomid' );

if( !empty($roomid) && $roomid > 0 ) {

	$room_object = get_post( $roomid );

	$heading = __('Edit Room', 'appointy');

	$attachment_id = get_post_meta($roomid, 'image_id', true);

} else {

	$heading = __('Add Room', 'appointy');

	$roomid = 0;

	$attachment_id = 0;

}

?>

<div class="content-admin-main">

    <form name="room__create" id="room__create" > 

	<input type="hidden" name="numberoferrors" value="">

	

	<?php if( !empty($roomid) && $roomid > 0 ) { ?>

	<input type="hidden" name="roomid" value="<?php echo esc_attr($roomid); ?>">

	<?php } ?>

    

    <div class="aon-admin-heading d-flex justify-content-between align-items-center">

        <div class="aon-admin-headLeft">

            <h3 class="panel-tittle m-a0"><span class="fa fa-cog"></span> <?php echo trim($heading); ?></h3>

        </div>  

		

        <div class="aon-admin-headRight saveserbtn-wrapper">

            <button type="submit" class="site-button saveserbtn"><?php esc_html_e('Save Changes','appointy'); ?></button>

        </div>  		

    </div> 

    

    <div class="panel cards aon-card panel-default about-me-here">

        <div class="card-body aon-card-body panel-body sf-panel-body p-a30">

            <div class="row">

                <div class="col-lg-12 ">

                    <div class="form-group ">

                        <label><?php _e('Title', 'appointy'); ?></label><br />

                        <div class="aon-inputicon-box"> 

                            <input data-rule-required="1" data-msg-required="<?php _e('Please enter title', 'appointy'); ?>" type="text" class="form-control" name="room_title" value="<?php echo ( !empty($roomid) && $roomid > 0 ) ? get_the_title($roomid) : ''; ?>" placeholder="<?php _e('Title', 'appointy'); ?>">

                            <i class="aon-input-icon fa fa-globe"></i>

                        </div>

                    </div>

                </div>

            </div>

        </div>

    </div>

    

                    

    <div class="row feImg-serDes-wrap">                

        <div class="equal-wraper row">

        <div class="col-lg-6">

            <div class="aon-admin-heading d-flex justify-content-between align-items-center">

                <div class="aon-admin-headLeft">

                    <h3 class="panel-tittle m-a0"><span class="feather-user"></span> <?php _e('Thumbnail', 'appointy'); ?></h3>

                </div>  

            </div> 

            <div class="cards aon-card panel panel-default sf-featuredimage-box equal-col">

                <div class="aon-card-body panel-body sf-panel-body p-a30">

                    <div class="sf-author-avatar-wrap d-flex">

                        <?php echo Appointy_Media_Upload_Helper::media_uploader_field('image_id', $roomid, __('Upload Image', 'appointy'), __('Remove', 'appointy'), $attachment_id); ?>

                    </div>

                </div>

            </div>

        </div>

        <div class="col-lg-6">

            <div class="aon-admin-heading d-flex justify-content-between align-items-center">

                <div class="aon-admin-headLeft">

                    <h3 class="panel-tittle m-a0"><span class="fa fa-file-text-o"></span> <?php _e('Description', 'appointy'); ?></h3>

                </div>  

            </div>

            <div class="cards aon-card panel panel-default about-me-here equal-col">

                <div class="cards aon-card-body panel-body sf-panel-body p-a30">

                    <div class="editer-wrap">

                    	<div class="editer-textarea">

							<?php

                            $editor_id = 'room_description';

                            $settings = array( 'media_buttons' => true );

                            $room_content = ( !empty($roomid) && $roomid > 0 ) ? Appointy_Router_Helper::get_request_data( $room_object, 'post_content' ) : '';

                            wp_editor( $room_content, $editor_id, $settings );

                            ?>

                        </div>        

                    </div>

                </div>

            </div>

        </div>               

        </div> 

    </div>

	<div class="aon-admin-heading justify-content-between align-items-center main-room">

        <div class="aon-admin-headLeft">

            <h3 class="panel-tittle m-a0"><span class="fa fa-sitemap"></span> <?php _e('Room Details', 'appointy'); ?></h3>

        </div>  

    </div>                                   

    <div class="cards aon-card panel panel-default about-me-here main-room">

        <div class="cards aon-card-body panel-body sf-panel-body p-a30">

            <div class="row">

                <div class="col-lg-6 ">

                    <div class="form-group ">

                        <label><?php _e('Room Capacity', 'appointy'); ?></label><br />

                        <div class="aon-inputicon-box"> 

                            <input min="1" data-rule-required="1" data-msg-required="<?php _e('Please enter room capacity', 'appointy'); ?>" type="number" class="form-control" name="room_capacity" value="<?php echo ( !empty($roomid) && $roomid > 0 ) ? get_post_meta($roomid,'room_capacity',true) : ''; ?>" placeholder="<?php _e('Room Capacity', 'appointy'); ?>">

                            <i class="aon-input-icon fa fa-users"></i>

                        </div>

                    </div>

                </div>
				
				<div class="col-lg-6 ">

                    <div class="form-group ">

                        <label><?php _e('Room Price per Night', 'appointy'); ?></label><br />

                        <div class="aon-inputicon-box"> 

                            <input min="1" data-rule-required="1" data-msg-required="<?php _e('Please enter room price per night', 'appointy'); ?>" type="number" class="form-control" name="price_per_night" value="<?php echo ( !empty($roomid) && $roomid > 0 ) ? get_post_meta($roomid,'price_per_night',true) : ''; ?>" placeholder="<?php _e('Room Price per Night', 'appointy'); ?>">

                            <i class="aon-input-icon fa fa-money"></i>

                        </div>

                    </div>

                </div>
				
				<div class="col-lg-6 ">

                    <div class="form-group ">

                        <label><?php _e('Minimum Stay', 'appointy'); ?></label><br />

                        <div class="aon-inputicon-box"> 

                            <input min="1" data-rule-required="1" data-msg-required="<?php _e('Minimum number of nights required to book', 'appointy'); ?>" type="number" class="form-control" name="minimum_stay" value="<?php echo ( !empty($roomid) && $roomid > 0 ) ? get_post_meta($roomid,'minimum_stay',true) : ''; ?>" placeholder="<?php _e('Minimum number of nights required to book', 'appointy'); ?>">

                            <i class="aon-input-icon fa fa-users"></i>

                        </div>

                    </div>

                </div>
				
				<div class="col-lg-6 ">

                    <div class="form-group ">

                        <label><?php _e('Maximum Stay', 'appointy'); ?></label><br />

                        <div class="aon-inputicon-box"> 

                            <input min="1" data-rule-required="1" data-msg-required="<?php _e('Maximum number of nights allowed for booking', 'appointy'); ?>" type="number" class="form-control" name="maximum_stay" value="<?php echo ( !empty($roomid) && $roomid > 0 ) ? get_post_meta($roomid,'maximum_stay',true) : ''; ?>" placeholder="<?php _e('Maximum number of nights allowed for booking', 'appointy'); ?>">

                            <i class="aon-input-icon fa fa-users"></i>

                        </div>

                    </div>

                </div>
				
				<div class="col-md-6">
				
					<div class="form-group ">

                        <label><?php _e('Room Type', 'appointy'); ?></label><br />

                        <div class="aon-selecticon-box"> 

                            <select required class="sf-select-box form-control" name="room_type" data-live-search="true" title="<?php _e('Select Room Type','appointy'); ?>">
									
								<option value=""><?php _e('Select Room Type','appointy'); ?></option>
	
								<?php
								$room_types = Appointy_Room_Helper::get_room_types();
	
								if( !empty($room_types) ) {
	
									foreach( $room_types  as $room_type ) {
	
										$term_id = Appointy_Router_Helper::get_request_data( $room_type, 'term_id' );
	
										$term_name = Appointy_Router_Helper::get_request_data( $room_type, 'name' );
										
										$select = (get_post_meta($roomid,'room_type',true) == $term_id) ? 'selected="selected"' : '';
	
										echo '<option '.$select.' value="'.esc_attr($term_id).'">'.trim($term_name).'</option>';
	
									}
	
								} else {
	
									echo '<option value="">'.__('Not available','appointy').'</option>';
	
								}
	
								?>
	
								</select>

                        </div>

                    </div>

                </div>
				
            </div>

        </div>

    </div>
	
	<div class="aon-admin-heading justify-content-between align-items-center main-room">

        <div class="aon-admin-headLeft">

            <h3 class="panel-tittle m-a0"><span class="fa fa-sitemap"></span> <?php _e('Amenities', 'appointy'); ?></h3>

        </div>  

    </div>                                   

    <div class="cards aon-card panel panel-default about-me-here main-room">

        <div class="cards aon-card-body panel-body sf-panel-body p-a30">

            <div class="row">
				<div class="col-md-12 ap-multidate-one">

                    <div class="form-groupss ap-extra-servi-left">

						<?php
						$selected_amenities_array = array();
						$selected_amenities = get_post_meta($roomid,'amenities',true);
						if(!empty($selected_amenities)) {
							$selected_amenities_array = explode(',',$selected_amenities);
						}
						
						$amenities = Appointy_Room_Helper::get_amenities();
						
						if( !empty($amenities) ) {

							foreach( $amenities as $amenity) {

								$term_id = Appointy_Router_Helper::get_request_data( $amenity, 'term_id' );

								$term_name = Appointy_Router_Helper::get_request_data( $amenity, 'name' );
								
								$checked = (in_array($term_id,$selected_amenities_array)) ? 'checked="checked"' : '';
								
								?>
								<div class="checkbox sf-radio-checkbox">

									<input <?php echo esc_attr($checked); ?> id="amenities<?php echo esc_attr($term_id); ?>" name="amenities[]" value="<?php echo esc_attr($term_id); ?>" type="checkbox">
		
									<label for="amenities<?php echo esc_attr($term_id); ?>"><?php echo esc_html($term_name); ?></label>
		
								</div>
								<?php
							}
						} else {

							echo '<option value="">'.__('Not available','appointy').'</option>';

						}
						?>

					</div>

                </div>
			</div>

        </div>

    </div>
	
	</form>

	<?php Appointy_Template_Loader::get_template_part( 'admin/notification-box' ); ?>

    <?php Appointy_Template_Loader::get_template_part( 'panel-loading' ); ?>

</div>

