<?php

wp_enqueue_script( 'plupload' );

wp_enqueue_script( 'appointy-image-manager' );

wp_enqueue_script( 'appointy-upload-files' );



$disabledWeekDays = Appointy_Booking_Form_Helper::get_available_weekdays();



$service_id = get_the_ID();



wp_localize_script('appointy-single-hotel-booking-form', 'bookingformdata', array(

	'weekdaysNotInTable' => $disabledWeekDays,

	'singleServiceId' => $service_id

));



$post_id = $service_id;



$current_date = current_time('Y-m-d');

$date_after_one_day = date('Y-m-d', strtotime($current_date . ' +1 day'));

$date_after_two_day = date('Y-m-d', strtotime($current_date . ' +2 day'));

$price_per_night = get_post_meta($service_id,'price_per_night',true);

$room_type_id = 0;

$appointy_room_types = wp_get_post_terms($post_id, 'appointy_room_type');

if (!is_wp_error($appointy_room_types) && !empty($appointy_room_types)) {

	$class = [];

	foreach ($appointy_room_types as $term) {

		$room_type_id = $term->term_id;

		$room_type_slug = $term->slug;

		$room_type_name = $term->name;

		$class[] = sanitize_html_class($term->slug);

	}

}





$price_per_night = get_post_meta($post_id,'price_per_night',true);



$attachment_id = get_post_thumbnail_id( $post_id );



$serviethumb = Appointy_Image_Helper::get_image_url_by_id($attachment_id,'thumbnail');



$options = array(

	'service_id' 		=> $post_id,

	'service_name' 		=> get_the_title(),

	'service_image' 	=> $serviethumb,

	'extra_service'		=> Appointy_Room_Helper::has_extra_service($post_id),

	'room_type_id'		=> $room_type_id,

	'service_price' 	=> $price_per_night,

	'old_service_price' => '',

	'couponcode' 		=> '',

	'coupon_verified' 	=> false,

	'couponcode_available' 	=> Appointy_Booking_Form_Helper::has_couponcode_available_for_service($post_id)

);

?>



<div class="room-details-sidbar-form">

	<div class="room-sidbar-title"> <span><?php _e('Booking','appointy'); ?></span>

		<p><?php echo Appointy_Misc_Helper::get_price_format($price_per_night); ?> <span class="two">/<?php _e('NIGHT','appointy'); ?></span></p>

	</div>

	<form name="hotel_booking__form" id="hotel_booking__form" action="<?php echo Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-booking-form' ); ?>" method="post" data-options="<?php echo esc_attr(wp_json_encode( $options )); ?>">

		<input type="hidden" name="service_id" value="<?php echo esc_attr($service_id); ?>">

		<div class="single-input-box">

			<label><?php echo esc_html__( 'Check In','appointy' ); ?></label>

			<input type="date" name="start_range" value="<?php echo esc_attr($date_after_one_day); ?>" placeholder="<?php _e('Check In','appointy'); ?>" />

		</div>

		<div class="single-input-box">

			<label><?php echo esc_html__( 'Check Out','appointy' ); ?></label>

			<input type="date" class="input-sm form-control" name="end_range" value="<?php echo esc_attr($date_after_two_day); ?>" placeholder="<?php _e('Check Out','appointy'); ?>" />

		</div>

		<div class="single-input-box">

			<label><?php echo esc_html__( 'Rooms','appointy' ); ?></label>

			<br>

			<input type="number" min="1" class="form-control" name="rooms" placeholder="<?php _e('Rooms','appointy'); ?>" value="1" />

		</div>

		<div class="row">

			<div class="col-lg-6">

				<div class="single-input-box">

					<label><?php echo esc_html__( 'Adults','appointy' ); ?></label>

					<br>

					<input type="number" min="1" class="form-control" name="adults" placeholder="<?php _e('Adults','appointy'); ?>" value="2" />

				</div>

			</div>

			<div class="col-lg-6">

				<div class="single-input-box">

					<label><?php echo esc_html__( 'Children','appointy' ); ?></label>

					<br>

					<input type="number" min="0" class="form-control" name="children" placeholder="<?php _e('Children','appointy'); ?>" value="0" />

				</div>

			</div>

		</div>

		

		<?php

		$i = 0;

		if($service_id > 0) {

			$appointy_room_services = Appointy_Room_Helper::get_extra_services($service_id);

			

			

			if (!is_wp_error($appointy_room_services) && !empty($appointy_room_services)) {

				echo '<div class="row">';

				echo '<div class="room-details-extra-service">

						<h4>Extra Service</h4>

					</div>';

				foreach ($appointy_room_services as $term) {

					$extra_service_id = $term->term_id;

					$extra_service_slug = $term->slug;

					$extra_service_title = $term->name;

					

					$extra_service_price = get_post_meta( $service_id, 'service_price_' . $extra_service_slug, true );

					$extra_service_quantity = get_post_meta( $service_id, 'service_quantity_' . $extra_service_slug, true );

					

					$options = array(

						'extra_post_id' 	=> $extra_service_id,

						'service_name' 		=> $extra_service_title,

						'service_price' 	=> $extra_service_price,

						'max_service_quantity' 	=> $extra_service_quantity

					);

					?>

					<div class="single-extra-box exserviceitem" id="exserviceitem-<?php echo esc_attr($extra_service_id); ?>" data-options="<?php echo esc_attr(wp_json_encode( $options )); ?>">

						<div class="extra-check">

							<input type="checkbox" name="exservice[]" value="<?php echo esc_attr($extra_service_id); ?>">

							<label><?php echo esc_html($extra_service_title); ?></label>

						</div>

						<div class="txtra-title">

							<label><?php echo Appointy_Misc_Helper::get_price_format($extra_service_price); ?></label>

							<input type="number" name="extra_service_quantity[]" class="form-control" value="1" min="1" max="<?php echo esc_attr($extra_service_quantity); ?>">

						</div>

					</div>

					<?php

				}

				echo '</div>';

			}

		}

		?>

		

		<div class="row">

			<div class="single-extra-box two">

				<div class="extra-check">

					<h4><?php _e('Total Cost','appointy'); ?> </h4>

				</div>

				<div class="txtra-price"> <span id="single-total-cost"><?php echo Appointy_Misc_Helper::get_price_format($price_per_night); ?></span> </div>

			</div>

			<div class="info-submit-button">

				<button type="button" class="booksinglehotel"><?php echo esc_html__( 'Book Now','appointy' ); ?></button>

			</div>

		</div>

	</form>

</div>

