<?php

if ( ! defined( 'ABSPATH' ) ) {

exit;

}

?>



<div class="content-admin-main">

	<div class="aon-admin-heading">

		<h3><?php echo esc_html__( 'Feedback', 'appointy' ) ?></h3>

	</div>

	<?php

	$user_id = get_current_user_id();

	$customer_reviews = Appointy_Appointments_Helper::get_customer_reviews($user_id);

	$customer_dashboard_url = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-customer-dashboard' );

	if ( $customer_reviews->have_posts() ) {

		echo '<ul class="aon-feedback-list">';

		while ( $customer_reviews->have_posts() ) : $customer_reviews->the_post();

			$reviewid = get_the_id();

			$reviewerid = get_post_field( 'post_author', $reviewid );

			

			$service_id = get_post_meta( $reviewid,'review_to',true );

			$member_id = get_post_meta( $reviewid,'review_to_member',true );

			

			$servicedata = Appointy_Appointments_Helper::get_booked_service($service_id);

			

			$service_name = Appointy_Router_Helper::get_sanitize_data( $servicedata, 'service_name' );

			$appointment_id = Appointy_Router_Helper::get_sanitize_data( $servicedata, 'appointment_id' );


			$servicetype = Appointy_Router_Helper::get_sanitize_data($servicedata,'servicetype');
		
			$variation_name = Appointy_Router_Helper::get_sanitize_data($servicedata,'variation_name');

			$service_name = ($servicetype === 'hourly') ? $variation_name : $service_name;
		

			$rating = get_post_meta( $reviewid,'rating',true );

			$ratingprefix = 'feedbackloop';

			

			$viewbooking = add_query_arg( array( 'navitem' => 'view-appointment','appointment_id' => $appointment_id ), $customer_dashboard_url );

			?>

			<li class="aon-feedback-row">

				<div class="aon-feedback-head d-flex justify-content-between">

					<div class="aon-feedback-top">

						<div class="aon-feedback-date">

							<span class="aon-day"><?php the_time( 'd' ); ?></span> 

							<span class="aon-month"><?php the_time( 'M' ); ?></span> 

							<span class="aon-year"><?php the_time( 'Y' ); ?></span>

						</div>
						
						<div class="aon-feed-top-left">
							<h4 class="aon-feedback-title"><i class="fa fa-user-md"></i> <?php echo esc_html($service_name); ?></h4>
							<?php if($member_id > 0) { ?>
								<div class="ap-assign-staff">
									<div class="ap-assign-staff-pic"> <img src="<?php echo Appointy_Staff_Helper::get_user_avatar( $member_id,'appointy-300x300' ); ?>"> </div> 
									<div class="memberinfo-right">
									<span><?php echo Appointy_Misc_Helper::get_fullname_by_user_id( $member_id ); ?></span>
								</div>

								</div>
							<?php } ?>
						</div>
						
						<div class="aon-feed-top-right">
						<div class="star-num-wrap">
							<div class="showrating" id="showrating-<?php echo esc_attr($ratingprefix); ?>-<?php echo esc_attr($reviewid); ?>" data-reviewid="<?php echo esc_attr($ratingprefix); ?>-<?php echo esc_attr($reviewid); ?>" data-rating="<?php echo esc_attr(floatval($rating)); ?>"></div>

							<span class="sf-rating-lable">(<?php echo trim($rating); ?>/5)</span>
						</div>
						
						<a class="site-button-outline button-sm m-l15" href="<?php echo esc_url($viewbooking); ?>">
							<i class="feather-eye"></i> 
							<?php echo esc_html__( 'View Appointment Detail', 'appointy' ) ?>
						</a>
						</div>	

					</div>

				</div>



				<div class="create-feedback-body">

					<h6><?php echo get_the_title(); ?></h6>

					<?php echo get_the_content(); ?>

				</div>

				<div class="create-feedback-footer"></div>

			</li>

			<?php

		endwhile;

		wp_reset_postdata();

		echo '</ul>';

	} else {

		echo '<div class="no-data">';

		echo esc_html__( 'There is no feedback', 'appointy' );

		echo '</div>';

	}

	?>

</div>

