<?php
if ( ! defined( 'ABSPATH' ) ) {
exit;
}

wp_enqueue_style('jquery-ui');
wp_enqueue_script('jquery-ui');

wp_enqueue_style('fullcalendar-main');
wp_enqueue_script('fullcalendar-main');

$user_id = get_current_user_id();

$jsdata = 'var jsdata = { 
			"user_id": '.$user_id.',
			};';
wp_add_inline_script('appointy-dashboard', $jsdata, 'before');

require_once APPOINTY_PLUGIN_DIR . '/library/google/vendor/autoload.php';

$clientID = Appointy_Misc_Helper::get_settings( 'google_calendar_settings', 'google_calendar_client_id' );
$clientSecret = Appointy_Misc_Helper::get_settings( 'google_calendar_settings', 'google_calendar_client_secret' );
$redirectUri = APPOINTY_GCAL_REDIRECT_URI;

// Create Google Client
$client = new Google_Client();
$client->setClientId($clientID);
$client->setClientSecret($clientSecret);
$client->setRedirectUri($redirectUri);
$client->setAccessType("offline");
$client->setApprovalPrompt('force');
$client->addScope(Google_Service_Calendar::CALENDAR);

$auth_url = $client->createAuthUrl();

$isConnected = false;
?>

<div class="content-admin-main">
	<div class="aon-admin-heading">
		<h3><?php echo esc_html__( 'Google Calendar', 'appointy' ) ?></h3>
	</div>
	<div class="form-group appointy-js-google-calendar-row">
		<label><?php esc_html_e( 'Google Calendar integration', 'appointy' ) ?></label>
		<div class="form-group border-left ml-4 pl-3">
			<small class="form-text text-muted mb-2"><?php esc_html_e( 'Synchronize appointments with Google Calendar.', 'appointy' ) ?></small>
			<?php 
				$accessToken = get_user_meta($user_id,'gcal_access_token',true);
				
				try {
				if($accessToken != '') {
					if(Appointy_Router_Helper::get_sanitize_data( $accessToken, 'refresh_token' ) != '') {
						$client->setAccessToken($accessToken);
						
						if($client->isAccessTokenExpired()) {
						 $client->fetchAccessTokenWithRefreshToken($client->getRefreshToken());
						 $newAccessToken = $client->getAccessToken();
						 $client->setAccessToken($newAccessToken); 
						}
						$service = new Google_Service_Calendar($client);
		
						$calendarList = $service->calendarList->listCalendarList();
						
						$google_calendar_id = get_user_meta($user_id,'google_calendar_id',true);
						
						$isConnected = true;
					}
				}
				?>
				<?php if($isConnected === true){ 
					echo '<select name="google_calendar_id" id="google_calendar_id" title="'.esc_html__('Select Calendar', 'appointy').'">';
					echo '<option value="">'.esc_html__('Select Calendar', 'appointy').'</option>';
					foreach ($calendarList->getItems() as $calendar) {
						if($google_calendar_id === $calendar->id) {
							$select = 'selected="selected"';
						}else{
							$select = '';
						}
						echo '<option '.$select.' value="'.$calendar->id.'">'.$calendar->getSummary().'</option>';
					}
					echo '</select>';
					
					echo '<div class="ap-goo-btn-wrap">'; 
					echo '<a href="javascript:;" class="admin-button margin-r-10 disconnectgcal">'.esc_html__('Disconnect Google Calendar', 'service-finder').'</a>';
					echo '</div>';
					
				}else{
					if ( $auth_url ) {
						echo '<a href="'.esc_url( $auth_url ).'" class="ap-google-signin-button site-button">'.esc_html__( 'Connect Google Calendar', 'bookly' ).'</a>';
					}else{
						esc_html_e( 'Please configure Google Calendar settings first.', 'appointy' );
					}
				}
				}catch(Exception $e){
					echo esc_html($e->getMessage());
				}
			?>
		</div>
	</div>

</div>
