<?php

if ( ! defined( 'ABSPATH' ) ) {

exit;

}

?>



<div class="content-admin-main">

	<div class="aon-admin-heading">

		<h3><?php echo esc_html__( 'Bookings', 'appointy' ) ?></h3>

	</div>

	<?php

	$user_id = get_current_user_id();

	$post_per_page = Appointy_Appointments_Helper::get_appointment_per_page();

	$the_query = Appointy_Appointments_Helper::get_customer_appointments( $user_id, $post_per_page);

	

	$total_post = $the_query->found_posts;

	$post_count = $the_query->post_count;

	

	$bookingurl = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-booking-form' );

	$customer_dashboard_url = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-customer-dashboard' );

	

	if ( $the_query->have_posts() ) {

		echo '<div class="pagination_container" id="appointy_appointments_table">';

		while ( $the_query->have_posts() ) : $the_query->the_post();

			$appointment_id = get_the_id();	

			$viewbooking = add_query_arg( array( 'navitem' => 'view-appointment','appointment_id' => $appointment_id ), $customer_dashboard_url );

			

			$appointment_date = get_the_date('',$appointment_id);

			$appointment_time = get_the_time('',$appointment_id);

			

			$booked_services = Appointy_Appointments_Helper::get_booked_services( $appointment_id );

			

			$customer_id = get_post_meta($appointment_id,'booking_customer_id',true);

			$customer_id = ( $customer_id != '' ) ? $customer_id : 0;

			?>

			<div class="sf-appoi-row">

				<div class="d-flex justify-content-between align-items-center">

					<div class="sf-appoi-first d-flex align-items-center">

						<div class="aon-date-box"> <strong><?php echo wp_date('d',strtotime($appointment_date)); ?></strong> <span><?php echo wp_date('M',strtotime($appointment_date)); ?></span> </div>

						<?php if(!empty($booked_services)) { ?>

						<div class="aon-sername-box">

							<?php 

							foreach($booked_services as $booked_service) {

								$service_name = Appointy_Router_Helper::get_request_data($booked_service,'service_name');

								$servicetype = Appointy_Router_Helper::get_request_data($booked_service,'servicetype');

								$variation_name = Appointy_Router_Helper::get_request_data($booked_service,'variation_name');

								$service_name = ($servicetype === 'hourly') ? $variation_name : $service_name;

								$service_price = Appointy_Router_Helper::get_request_data($booked_service,'service_price');

								?>

								<div class="sf-servicebooking-text"><?php echo esc_html($service_name); ?></div>

								<div class="sf-servicebook-price"><strong><?php echo Appointy_Misc_Helper::get_price_format($service_price); ?></strong></div>

								<?php

							}

							?>

						</div>

						<?php } ?>

					</div>

					<div class="sf-appoi-second">

						<i class="fa fa-calendar-o"></i> <?php echo wp_date('l',strtotime($appointment_date)); ?>, <i class="fa fa-clock-o"></i> <?php echo Appointy_Misc_Helper::get_time_format($appointment_time); ?>

					</div>

					<div class="sf-appoi-second"> <span class="btn-pending"><?php echo Appointy_Appointments_Helper::get_appointment_payment_method($appointment_id); ?></span> </div>

					<div class="sf-appoi-third">

						<div class="dropdown action-dropdown dropdown-left">

							<button  type="button" class="action-button btn btn-primary dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false"> <i class="fa fa-ellipsis-v"></i> </button>

							<ul class="dropdown-menu" >

								<li><a class="dropdown-item" href="<?php echo esc_url($bookingurl); ?>"><i class="feather-calendar"></i> <?php echo esc_html__( 'Book Agian', 'appointy' ) ?></a></li>

								<li><a class="dropdown-item" href="<?php echo esc_url($viewbooking); ?>"><i class="feather-eye"></i> <?php echo esc_html__( 'View Detail', 'appointy' ) ?></a></li>

							</ul>

						</div>

					</div>

				</div>

			</div>

			<?php

		endwhile;

		Appointy_Appointments_Helper::ajax_pagination( 'appointments', $total_post, $post_count, $post_per_page, 1 );

		echo '</div>';

		wp_reset_postdata();

	}else{

		echo '<div class="no-data">';

		echo esc_html__( 'There is no appointment.', 'appointy' );

		echo '</div>';

	}

	?>

</div>

