<?php

/**

 * Filter htnl for footer

 *

 * @package appointy

 */
wp_enqueue_style( 'appointy-cmb2', APPOINTY_PLUGIN_URL . 'admin/css/appointy-cmb2.css', array(), '', 'all' );

$booking_post_type = Appointy_Misc_Helper::get_settings( 'booking_settings', 'booking_post_type' );



// Create the meta box

$cmb = new_cmb2_box( array(

	'id'            => 'appointy_room_meta_box',

	'title'         => __( 'Room Details', 'appointy' ),

	'object_types'  => array( $booking_post_type ),

	'context'       => 'normal',

	'priority'      => 'high',

	'show_names'    => true

) );



// Add fields to the meta box

$cmb->add_field( array(

	'name'       => __( 'Total Rooms', 'appointy' ),

	'desc'       => __( 'Enter the total number of rooms', 'appointy' ),

	'id'         => 'total_rooms',

	'type'       => 'text_small',

) );



$cmb->add_field( array(

	'name'       => __( 'Room Capacity (For Adults)', 'appointy' ),

	'desc'       => __( 'Enter the number of guests this room can accommodate', 'appointy' ),

	'id'         => 'room_capacity_adults',

	'type'       => 'text_small',

) );



$cmb->add_field( array(

	'name'       => __( 'Room Capacity (For Children)', 'appointy' ),

	'desc'       => __( 'Enter the number of children this room can accommodate', 'appointy' ),

	'id'         => 'room_capacity_children',

	'type'       => 'text_small',

) );



$cmb->add_field( array(

	'name'       => __( 'Room Price', 'appointy' ),

	'desc'       => __( 'Enter the price per night for the room', 'appointy' ),

	'id'         => 'price_per_night',

	'type'       => 'text_small',

	'before_field' => Appointy_Misc_Helper::get_currency_symbol()

) );



$cmb->add_field( array(

	'name'       => __( 'Minimum Stay', 'appointy' ),

	'desc'       => __( 'Minimum number of nights required to book', 'appointy' ),

	'id'         => 'minimum_stay',

	'type'       => 'text_small',

) );



$cmb->add_field( array(

	'name'       => __( 'Maximum Stay', 'appointy' ),

	'desc'       => __( 'Maximum number of nights allowed for booking', 'appointy' ),

	'id'         => 'maximum_stay',

	'type'       => 'text_small',

) );



$cmb->add_field( array(

	'name'           => __('Room Type', 'appointy'),

	'id'             => 'room_type',

	'taxonomy'       => 'appointy_room_type',

	'type'           => 'taxonomy_select',

	'remove_default' => 'true',

	'query_args' => array(

		 'orderby' => 'slug',

		 'hide_empty' => false,

	),

) );



$cmb->add_field( array(

	'name'    => __( 'Select Extras', 'cmb2' ),

	'id'      => 'appointy_room_extra_services',

	'taxonomy' => 'appointy_room_services',  // Taxonomy slug

	'type'    => 'taxonomy_multicheck',  // Multicheck for taxonomy terms

	'remove_default' => 'true',  // Remove default metabox

	'text'    => array(

		'no_terms_text' => __( 'No extras available', 'cmb2' ),  // Text if no terms found

	),

) );

?>