<?php
if ( ! defined( 'ABSPATH' ) ) {
exit;
}

$invoiceid = Appointy_Router_Helper::get_request_data( $_GET, 'invoiceid' );
$invoice_object = get_post( $invoiceid );

$invoicefooterlefttext = Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_footer_lefttext' );
$invoicecopyrighttext = Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_footer_righttext' );
?>
<div class="section-full p-t90 p-b60 bg-white">
	<div class="container">
		<?php if($invoiceid > 0) { ?>
        <?php 
		if(!empty($invoice_object)) {
		?>
        <div class="sf-myaccount-heading ap-invoice-wrapper">
			<div class="sf-myaccount-heading-right">
			<?php
			if( get_post_status($invoiceid) != 'invoice-paid' && get_post_status($invoiceid) != 'invoice-payment-hold' ) {
				echo '<a href="javascript:;" class="btn site-button payinvoice" data-invoiceid="'.esc_attr($invoiceid).'"><i class="feather-credit-card"></i> '.esc_html__( 'Pay Now','appointy' ).'</a>';
			}
			?>
		</div>
			
		<div class="panel panel-default">
							
			<div class="panel-body aon-panel-body p-lr0 p-tb30">
				
			<div id="view-invoice-row">
				<div class="row">
					<div class="col-md-7">
						<div class="sf-invoice-text"><?php esc_html_e( 'Invoice','appointy' ); ?></div>
						<div class="sf-invoice-compay-info">
							<ul>
								<?php if(Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_name' ) != '') : ?>
								<li><i class="feather-user"></i> <?php echo Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_name' ); ?></li>
								<?php endif; ?>
								<?php if(Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_email' ) != '') : ?>
								<li><i class="feather-mail"></i> <?php echo Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_email' ); ?></li>
								<?php endif; ?>
								<?php if(Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_phone' ) != '') : ?>
								<li><i class="feather-phone"></i> <?php echo Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_phone' ); ?></li>
								<?php endif; ?>
								<?php if(Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_address' ) != '') : ?>
								<li><i class="feather-map-pin"></i> <?php echo Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_address' ); ?></li>
								<?php endif; ?>
							</ul>
						</div>
					</div>
					<div class="col-md-5">
						<div class="sf-invoice-logo"><?php echo get_bloginfo('name'); ?></div>
					</div>
					<?php if(Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_extra_details' ) != '') : ?>
					<div class="col-md-12">
						<div class="sf-invoice-compay-info"><?php echo Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_extra_details' ); ?></div>
					</div>
					<?php endif; ?>
				</div>
				
				<div class="row">
					<div class="p-tb30 m-lr15 clearfix bg-invoice invoice-top-bg">
						<div class="row invoice-top-row">
						<div class="col-md-6">
							<div class="p-lr15">
							   <ul class="invoice-top-left">
								<li><strong><?php esc_html_e( 'Issued Date','appointy' ); ?>:</strong><span> <?php echo Appointy_Misc_Helper::get_date_format(get_the_date( '', $invoiceid )); ?></span></li>
								<li><strong><?php esc_html_e( 'Order','appointy' ); ?>:</strong><span> #<?php echo get_post_meta($invoiceid,'_invoice_id',true); ?></span></li>
								<li><strong><?php esc_html_e( 'Due Date','appointy' ); ?>:</strong><span> <?php echo Appointy_Misc_Helper::get_date_format(get_post_meta($invoiceid,'_due_date',true)); ?></span></li>
								<li class="invoice-total"><strong><?php esc_html_e( 'Total','appointy' ); ?></strong><span> <?php echo Appointy_Misc_Helper::get_price_format(get_post_meta( $invoiceid,'grand_total',true )); ?></span></li>
							</ul>
							</div> 
						</div>
						<div class="col-md-6">
							<div class="p-lr15">
							   <h6><?php esc_html_e( 'Bill To','appointy' ); ?></h6>
								<ul class="list-unstyled invoice-user-info">
									<li><i class="feather-user"></i> <?php echo get_post_meta($invoiceid,'_first_name',true).' '.get_post_meta($invoiceid,'_last_name',true); ?></li>
									<li><i class="feather-mail"></i> <?php echo get_post_meta($invoiceid,'_email',true); ?></li>
                                    <li><i class="feather-phone"></i> <?php echo get_post_meta($invoiceid,'_phone',true); ?></li>
								</ul>
							</div> 
						</div>
						</div>
						<div class="col-md-12">
							<div class="p-lr15">
							   <?php echo apply_filters('the_content', $invoice_object->post_content); ?>
							</div> 
						</div>
					</div>
				</div>
				<?php echo Appointy_Invoice_Helper::get_invoice_items($invoiceid); ?>                       
			</div>
			
			<div class="p-tb30 m-lr15 clearfix invoice-footer">
				<?php
				$invoicefooterlefttext = Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_footer_lefttext' );
				$invoicecopyrighttext = Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_footer_righttext' );
				?>
				 <h5><?php echo wp_kses($invoicefooterlefttext,Appointy_Misc_Helper::get_allowed_tags()); ?></h5>
				 <span><?php echo wp_kses($invoicecopyrighttext,Appointy_Misc_Helper::get_allowed_tags()); ?></span>
			</div>
							
			</div>
		</div>
        <?php } else { ?>
        <div class="no-invoice data">
        	<?php echo esc_html__('Sorry, this invoice not exist.','appointy'); ?>
        </div>
        <?php } ?>
        <?php } else { ?>
        <div class="">
        	<?php echo esc_html__('Not found.','appointy'); ?>
        </div>
        <?php } ?>
	</div>
	</div>
</div>