<?php
if ( ! defined( 'ABSPATH' ) ) {
exit;
}

$staff_dashboard_url = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-staff-dashboard' );
$appointments_url = add_query_arg( array( 'navitem' => 'appointments' ), $staff_dashboard_url );
$availability_url = add_query_arg( array( 'navitem' => 'availability' ), $staff_dashboard_url );
$feedback_url = add_query_arg( array( 'navitem' => 'feedback' ), $staff_dashboard_url );
$password_url = add_query_arg( array( 'navitem' => 'password' ), $staff_dashboard_url );
$calendar_url = add_query_arg( array( 'navitem' => 'calendar' ), $staff_dashboard_url );
$google_calendar_url = add_query_arg( array( 'navitem' => 'google-calendar' ), $staff_dashboard_url );
?>
<div class="cus-top-nav">
	<div class="container">
		<ul class="cus-nav row">
			<li class="col <?php echo (Appointy_Router_Helper::get_sanitize_data( $_GET, 'navitem' ) == '') ? 'active' : ''; ?>"><a href="<?php echo esc_url($staff_dashboard_url); ?>"><?php echo esc_html__( 'View/Edit Profile', 'appointy' ); ?></a></li>
			<li class="col <?php echo (Appointy_Router_Helper::get_sanitize_data( $_GET, 'navitem' ) === 'availability') ? 'active' : ''; ?>"><a href="<?php echo esc_url($availability_url); ?>"><?php echo esc_html__( 'Availability', 'appointy' ); ?></a></li>
			<li class="col <?php echo (Appointy_Router_Helper::get_sanitize_data( $_GET, 'navitem' ) === 'appointments' || Appointy_Router_Helper::get_sanitize_data( $_GET, 'navitem' ) === 'view-appointment') ? 'active' : ''; ?>"><a href="<?php echo esc_url($appointments_url); ?>"><?php echo esc_html__( 'Appointments', 'appointy' ); ?></a></li>
			<li class="col <?php echo (Appointy_Router_Helper::get_sanitize_data( $_GET, 'navitem' ) === 'calendar') ? 'active' : ''; ?>"><a href="<?php echo esc_url($calendar_url); ?>"><?php echo esc_html__( 'Calendar', 'appointy' ); ?></a></li>
			<li class="col <?php echo (Appointy_Router_Helper::get_sanitize_data( $_GET, 'navitem' ) === 'feedback') ? 'active' : ''; ?>"><a href="<?php echo esc_url($feedback_url); ?>"><?php echo esc_html__( 'My Feedback', 'appointy' ); ?></a></li>
			<?php if ( PHP_VERSION_ID >= 80100) { ?>
			<li class="col <?php echo (Appointy_Router_Helper::get_sanitize_data( $_GET, 'navitem' ) === 'google-calendar') ? 'active' : ''; ?>"><a href="<?php echo esc_url($google_calendar_url); ?>"><?php echo esc_html__( 'Google Calendar', 'appointy' ); ?></a></li>
			<?php } ?>
			<li class="col <?php echo (Appointy_Router_Helper::get_sanitize_data( $_GET, 'navitem' ) === 'password') ? 'active' : ''; ?>"><a href="<?php echo esc_url($password_url); ?>"><?php echo esc_html__( 'Change Password', 'appointy' ); ?></a></li>
		</ul>
	</div>
</div>
