<?php
if ( ! defined( 'ABSPATH' ) ) {
  	exit;
}
global $wpdb, $current_user;

extract( $args = shortcode_atts( apply_filters( 'appointy_uploader_defaults', array(
			'field_id'                => 'customupload',
			'max_file_uploads'        => 1,
			'extensions'         	  => 'jpg,jpeg,gif,png',
			'user_id'            	  => $current_user->ID,
			'post_id'            	  => 0,
			'edit_attachment_id'	  => 0,
			'branchid'            	  => 0,
			'articleid'            	  => 0,
			'placeholder'         	  => esc_html__('Upload image','appointy'),
		) ), $args ) );

//print_r($args);
$uploader_fields = array(
		'runtimes'            => 'html5,silverlight,flash,html4',
		'file_data_name'      => 'async-upload',
		'browse_button'       => $field_id . '-pickfiles',
		'drop_element'        => $field_id . '-container',
		'multiple_queues'     => true,
		'max_file_size'       => wp_max_upload_size() . 'b',
		'url'                 => esc_url(admin_url( 'admin-ajax.php' )),
		'flash_swf_url'       => includes_url( 'js/plupload/plupload.flash.swf' ),
		'silverlight_xap_url' => includes_url( 'js/plupload/plupload.silverlight.xap' ),
		'multipart'           => true,
		'urlstream_upload'    => true,
		'filters'             => array(
			array(
				'title'      => _x( 'Allowed Image Files', 'image upload', 'appointy' ),
				'extensions' => $extensions,
			),
		),
		'multipart_params'    => array(
			'field_id' => $field_id,
			'action'   => 'image_upload',
			'user_id'  => $user_id
		)
	);

$hiddenclass = '';

switch( $field_id ){
	case 'useravatar':
		$attachmentid = get_user_meta($user_id, $wpdb->get_blog_prefix().'user_avatar', true);
		break;
	default:
		$attachmentid = get_user_meta($user_id, $field_id, true);
		break;	
}

if($post_id > 0) {
	$attachmentid = get_post_thumbnail_id( $post_id );
}

if($edit_attachment_id > 0) {
	$attachmentid = explode(',',$edit_attachment_id);
}

if(is_array($attachmentid)) {
	$totaluploads = count($attachmentid);
	if($max_file_uploads <= $totaluploads){
		$hiddenclass = 'collapse';
	}
}else{
	if($attachmentid > 0 && !empty($attachmentid) && wp_get_attachment_image_src( $attachmentid ) != '')
	{
	$hiddenclass = 'collapse';
	}
}
?>
<div id="<?php echo esc_attr($field_id); ?>-container">
<?php
if($field_id == 'useravatar') {
	$profilethumb = get_avatar_url($user_id,array('size' => 250));
	ob_start();
	printf(
		'<ul id="%s-pickfiles" class="image-upload-text sk-uploader new-files %s" data-js_options="%s">
			<li>
			<div class="aon-proAvtar-media">
				<img src="%s" alt="">
			</div>
			<button class="admin-button aon-proAvtar-btn has-toltip" type="button">
				<i class="fa fa-camera"></i>
				<span class="header-toltip">%s</span>
			</button>
			</li>
		</ul>',	
		esc_attr( $field_id ),
		sanitize_html_class($hiddenclass),
		esc_attr( wp_json_encode( $uploader_fields ) ),
		esc_url( $profilethumb ),
		esc_attr( $placeholder )
	);
}else{
$imgplaceholder = Appointy_Manage_Uploads::get_image_placeholder();
printf(
	'<div id="%s-pickfiles" class="aon-pro-team-pic new-files sk-uploader %s" data-js_options="%s"><img src="%s" alt="">
                <button class="admin-button has-toltip" type="button">
                    <i class="fa fa-camera"></i>
                    <span class="header-toltip">%s</span>
                </button></div>',	
	esc_attr( $field_id ),
	sanitize_html_class($hiddenclass),
	esc_attr( wp_json_encode( $uploader_fields ) ),
	esc_url( $imgplaceholder ),
	esc_attr( $placeholder )
);
}


?>
<div class="image-upload-thums sk-uploaded">
	<ul class="<?php echo ( $field_id == 'useravatar' ) ? 'sf-add-avtar' : 'sf-add-gallery-list'; ?> clearfix" data-field_id="<?php echo esc_attr($field_id); ?>" data-max_file_uploads="<?php echo esc_attr($max_file_uploads); ?>">
		<?php
		$hiddenclass = '';
		
		switch( $field_id ){
			case 'useravatar':
				$attachmentid = get_user_meta($user_id, $wpdb->get_blog_prefix().'user_avatar', true);
				break;
			default:
				$attachmentid = get_user_meta($user_id, $field_id, true);
				break;	
		}

		if($post_id > 0) {
			$attachmentid = get_post_thumbnail_id( $post_id );
		}
		
		if($edit_attachment_id > 0) {
			$attachmentid = explode(',',$edit_attachment_id);
		}

		if(is_array($attachmentid)) {
			$totaluploads = count($attachmentid);
			foreach($attachmentid as $attachment) {
				$imagesrc = Appointy_Manage_Uploads::get_icon_for_attachment($attachment,'appointy-300x300');
				if($max_file_uploads <= $totaluploads) {
					$hiddenclass = 'collapse';
				}
				
				$title_delete = apply_filters( 'rwmb_image_delete_string', _x( 'Delete', 'image upload', 'appointy' ) );
				
				$li = '<li id="item_%s">
							<div class="aon-proAvtar-media">
								<img src="%s" alt="">
							</div>
							<div class="rwmb-image-bar">
								<a title="%s" class="sk-delete-file sf-author-avatar-remove" href="javascript:;" data-attachment_id="%d" data-field_id="%s" data-user_id="%d"><i class="fa fa-close"></i></a>
								<input type="hidden" name="%s" value="%s">
							</div>
						</li>';
				echo sprintf(
						$li,
						esc_attr($attachment),
						esc_url($imagesrc),
						esc_attr($title_delete), esc_attr($attachment), esc_attr($field_id),esc_attr($user_id), $field_id.'[]', esc_attr($attachment)
					);		
			}
		}else{
		if($attachmentid > 0 && !empty($attachmentid) && wp_get_attachment_image_src( $attachmentid ) != '') {
		$imagesrc = Appointy_Manage_Uploads::get_icon_for_attachment($attachmentid,'appointy-300x300');
		$totaluploads = 1;
		if($max_file_uploads <= $totaluploads){
			$hiddenclass = 'collapse';
		}
		
		$title_delete = apply_filters( 'rwmb_image_delete_string', _x( 'Delete', 'image upload', 'appointy' ) );
		
		$li = '<li id="item_%s">
					<div class="aon-proAvtar-media">
						<img src="%s" alt="">
					</div>
					<div class="rwmb-image-bar">
						<a title="%s" class="sk-delete-file sf-author-avatar-remove" href="javascript:;" data-attachment_id="%d" data-field_id="%s" data-user_id="%d"><i class="fa fa-close"></i></a>
						<input type="hidden" name="%s" value="%s">
					</div>
				</li>';
		
		if($field_id == 'useravatar') {
			$pass_field_id = 'useravatarid';
		} else {
			$pass_field_id = $field_id.'[]';
		}
		echo sprintf(
				$li,
				esc_attr($attachmentid),
				esc_url($imagesrc),
				esc_attr($title_delete), esc_attr($attachmentid), esc_attr($field_id),esc_attr($user_id), $pass_field_id, esc_attr($attachmentid)
			);		
		}
		}
		?>
	</ul>
</div>
</div>