<?php 

/*******************************************************************
Register Post Type
********************************************************************/


function restu_portfolio_post_type() 
{
	$labels = array(
		'name'               => _x( 'Portfolio', 'post type general name', 'restu' ),
		'singular_name'      => _x( 'Portfolio', 'post type singular name', 'restu' ),
		'menu_name'          => _x( 'Portfolio', 'admin menu', 'restu' ),
		'name_admin_bar'     => _x( 'Portfolio', 'add new on admin bar', 'restu' ),
		'add_new'            => _x( 'Add New', 'Portfolio', 'restu' ),
		'add_new_item'       => __( 'Add New Portfolio', 'restu' ),
		'new_item'           => __( 'New Portfolio', 'restu' ),
		'edit_item'          => __( 'Edit Portfolio', 'restu' ),
		'view_item'          => __( 'View Portfolio', 'restu' ),
		'all_items'          => __( 'All Portfolio', 'restu' ),
		'search_items'       => __( 'Search Portfolio', 'restu' ),
		'parent_item_colon'  => __( 'Parent Portfolio:', 'restu' ),
		'not_found'          => __( 'No Portfolio found.', 'restu' ),
		'not_found_in_trash' => __( 'No Portfolio found in Trash.', 'restu' )
	);
	
	$args = array(
		'labels'             => $labels,
		'public'             => true,
		'menu_icon'          =>'dashicons-images-alt2',		
		'exclude_from_search'=> true,
		'show_ui'            => true,
		'show_in_menu'       => true,
		'query_var'          => true,
		'rewrite'            => array( 'slug' => 'em_portfolios' ),
		'capability_type'    => 'post',
		'has_archive'        => true,
		'hierarchical'       => false,
		'menu_position'      => null,
		'supports'           => array('title','editor', 'thumbnail')
	);
	
	register_post_type( 'em_portfolio' , $args );
	
	$labels = array(
		'name'              => _x( 'Categories', 'taxonomy general name', 'restu' ),
		'singular_name'     => _x( 'Category', 'taxonomy singular name', 'restu' ),
		'search_items'      => __( 'Search Categories', 'restu' ),
		'all_items'         => __( 'All Categories', 'restu' ),
		'parent_item'       => __( 'Parent Category', 'restu' ),
		'parent_item_colon' => __( 'Parent Category:', 'restu' ),
		'edit_item'         => __( 'Edit Category', 'restu' ),
		'update_item'       => __( 'Update Category', 'restu' ),
		'add_new_item'      => __( 'Add New Category', 'restu' ),
		'new_item_name'     => __( 'New Category Name', 'restu' ),
		'menu_name'         => __( 'Categories', 'restu' ),
	);

	$args = array(
		'public'            => false,
		'hierarchical'      => true,
		'labels'            => $labels,
		'show_ui'           => true,
		'show_admin_column' => true,
		'show_in_nav_menus' => false,
		'query_var'         => false,
		'rewrite'           => array( 'slug' => 'portfolio-category' ),
	);
	
	register_taxonomy( 'em_portfolio_cat', array( 'em_portfolio' ), $args );
}
add_action('init', 'restu_portfolio_post_type');


// Case Study
function restu_case_study_post_type() 
{
	$labels = array(
		'name'               => _x( 'Case Study', 'post type general name', 'restu' ),
		'singular_name'      => _x( 'Case Study', 'post type singular name', 'restu' ),
		'menu_name'          => _x( 'Case Study', 'admin menu', 'restu' ),
		'name_admin_bar'     => _x( 'Case Study', 'add new on admin bar', 'restu' ),
		'add_new'            => _x( 'Add New', 'Case Study', 'restu' ),
		'add_new_item'       => __( 'Add New Case Study', 'restu' ),
		'new_item'           => __( 'New Case Study', 'restu' ),
		'edit_item'          => __( 'Edit Case Study', 'restu' ),
		'view_item'          => __( 'View Case Study', 'restu' ),
		'all_items'          => __( 'All Case Study', 'restu' ),
		'search_items'       => __( 'Search Case Study', 'restu' ),
		'parent_item_colon'  => __( 'Parent Case Study:', 'restu' ),
		'not_found'          => __( 'No Case Study found.', 'restu' ),
		'not_found_in_trash' => __( 'No Case Study found in Trash.', 'restu' )
	);
	
	$args = array(
		'labels'             => $labels,
		'public'             => true,
		'menu_icon'          =>'dashicons-format-status',		
		'exclude_from_search'=> true,
		'show_ui'            => true,
		'show_in_menu'       => true,
		'query_var'          => true,
		'rewrite'            => array( 'slug' => 'em_case_study' ),
		'capability_type'    => 'post',
		'has_archive'        => true,
		'hierarchical'       => false,
		'menu_position'      => null,
		'supports'           => array('title','editor', 'thumbnail')
	);
	
	register_post_type( 'em_case_study' , $args );
	
	$labels = array(
		'name'              => _x( 'Categories', 'taxonomy general name', 'restu' ),
		'singular_name'     => _x( 'Category', 'taxonomy singular name', 'restu' ),
		'search_items'      => __( 'Search Categories', 'restu' ),
		'all_items'         => __( 'All Categories', 'restu' ),
		'parent_item'       => __( 'Parent Category', 'restu' ),
		'parent_item_colon' => __( 'Parent Category:', 'restu' ),
		'edit_item'         => __( 'Edit Category', 'restu' ),
		'update_item'       => __( 'Update Category', 'restu' ),
		'add_new_item'      => __( 'Add New Category', 'restu' ),
		'new_item_name'     => __( 'New Category Name', 'restu' ),
		'menu_name'         => __( 'Categories', 'restu' ),
	);

	$args = array(
		'public'            => false,
		'hierarchical'      => true,
		'labels'            => $labels,
		'show_ui'           => true,
		'show_admin_column' => true,
		'show_in_nav_menus' => false,
		'query_var'         => false,
		'rewrite'           => array( 'slug' => 'casestudy-category' ),
	);
	
	register_taxonomy( 'em_case_study_cat', array( 'em_case_study' ), $args );
}
add_action('init', 'restu_case_study_post_type');


// product
function toshiba_product_post_type() 
{
	$labels = array(
		'name'               => _x( 'Product ', 'post type general name', 'restu' ),
		'singular_name'      => _x( 'Product ', 'post type singular name', 'restu' ),
		'menu_name'          => _x( 'Product', 'admin menu', 'restu' ),
		'name_admin_bar'     => _x( 'Product ', 'add new on admin bar', 'restu' ),
		'add_new'            => _x( 'Add New', 'Product ', 'restu' ),
		'add_new_item'       => __( 'Add New Product ', 'restu' ),
		'new_item'           => __( 'New Product ', 'restu' ),
		'edit_item'          => __( 'Edit Product ', 'restu' ),
		'view_item'          => __( 'View Product ', 'restu' ),
		'all_items'          => __( 'All Product ', 'restu' ),
		'search_items'       => __( 'Search Product ', 'restu' ),
		'parent_item_colon'  => __( 'Parent Product :', 'restu' ),
		'not_found'          => __( 'No Product  found.', 'restu' ),
		'not_found_in_trash' => __( 'No Product  found in Trash.', 'restu' )
	);
	
	$args = array(
		'labels'             => $labels,
		'public'             => true,
		'menu_icon'          =>'dashicons-admin-page',		
		'exclude_from_search'=> true,
		'show_ui'            => true,
		'show_in_menu'       => true,
		'query_var'          => true,
		'rewrite'            => array( 'slug' => 'em_product_post' ),
		'capability_type'    => 'post',
		'has_archive'        => true,
		'hierarchical'       => false,
		'menu_position'      => null,
		'supports'           => array('title','editor', 'thumbnail')
	);
	
	register_post_type( 'em_product_post' , $args );
	
	$labels = array(
		'name'              => _x( 'Categories', 'taxonomy general name', 'restu' ),
		'singular_name'     => _x( 'Category', 'taxonomy singular name', 'restu' ),
		'search_items'      => __( 'Search Categories', 'restu' ),
		'all_items'         => __( 'All Categories', 'restu' ),
		'parent_item'       => __( 'Parent Category', 'restu' ),
		'parent_item_colon' => __( 'Parent Category:', 'restu' ),
		'edit_item'         => __( 'Edit Category', 'restu' ),
		'update_item'       => __( 'Update Category', 'restu' ),
		'add_new_item'      => __( 'Add New Category', 'restu' ),
		'new_item_name'     => __( 'New Category Name', 'restu' ),
		'menu_name'         => __( 'Categories', 'restu' ),
	);

	$args = array(
		'public'            => false,
		'hierarchical'      => true,
		'labels'            => $labels,
		'show_ui'           => true,
		'show_admin_column' => true,
		'show_in_nav_menus' => false,
		'query_var'         => false,
		'rewrite'           => array( 'slug' => 'product-category' ),
	);
	register_taxonomy( 'em_product_post_cat', array( 'em_product_post' ), $args );
}
add_action('init', 'toshiba_product_post_type');

