<?php

use Elementor\Widget_Base;
use Elementor\Controls_Manager;

if(!defined('ABSPATH')) exit;

class ServiceCar extends Widget_Base{

	public function get_name(){
		return "ServiceCar";
	}
	
	public function get_title(){
		return "ServiceCar";
	}
	
	public function get_icon(){
		return "eicon-star-o";
	}
	
	public function get_categories(){
		return ['dreamit-category'];
	}

	protected function register_controls(){

		$this->start_controls_section(
			'service_section',
			[
				'label' => esc_html__( 'Service', 'dreamit-elementor-extension' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		$repeater = new \Elementor\Repeater();

		$repeater->add_control(
			'sub_title', [
				'label' => esc_html__( 'Sub Title', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => esc_html__( 'Service Sub Title' , 'dreamit-elementor-extension' ),
				'label_block' => true,
			]
		);
		$repeater->add_control(
			'service_title', [
				'label' => esc_html__( 'Service title', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => esc_html__( 'Service Name' , 'dreamit-elementor-extension' ),
				'label_block' => true,
			]
		);
		$repeater->add_control(
				'icons_type',
				[
				    'label' => esc_html__('Icon Type','dreamit-elementor-extension'),
				    'type' => Controls_Manager::CHOOSE,
				    'options' =>[
					  'img' =>[
						'title' =>esc_html__('Image','dreamit-elementor-extension'),
						'icon' =>'fa fa-picture-o',
					  ],
					  'icon' =>[
						'title' =>esc_html__('Icon','dreamit-elementor-extension'),
						'icon' =>'fa fa-info',
					  ]
				    ],
				    'default' => 'icon',
				]
			 );
		$repeater->add_control(
				'select_icon',
				[
					'label' => esc_html__( 'Icon', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::ICONS,
					'condition'=>[
						'icons_type'=> 'icon',
					],
					'label_block' => true,
				]
			);
		$repeater->add_control(
			'service_description', [
				'label' => esc_html__( 'Service Description', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::TEXTAREA,
				'default' => esc_html__( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.', 'dreamit-elementor-extension' ),
				'label_block' => true,
			]
		);
		$repeater->add_control(
			'service_image',
			[
				'label' => esc_html__( 'Service Image', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::MEDIA,
				'default' => [
					'url' => \Elementor\Utils::get_placeholder_image_src(),
				],
			]
		);
		$repeater->add_control(
				'show_price',
				[
					'label' => __( 'Show Price', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::SWITCHER,
					'label_on' => __( 'Show', 'dreamit-elementor-extension' ),
					'label_off' => __( 'Hide', 'dreamit-elementor-extension' ),
					'return_value' => 'yes',
					'default' => 'yes',
				]
			);
		$repeater->add_control(
			'price',
			[
				'label' => __( 'Price', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => __( '50', 'dreamit-elementor-extension' ),
				'placeholder' => __( '50', 'dreamit-elementor-extension' ),
			]
		);
		$repeater->add_control(
			'price_title',
			[
				'label' => __( 'Price Title', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => __( 'Give Price', 'dreamit-elementor-extension' ),
				'placeholder' => __( 'Give Price', 'dreamit-elementor-extension' ),
			]
		);
		$repeater->add_control(
				'link',
				[
					'label' => __( 'Text Link', 'dreamit-elementor-extension' ),
					'type' => Controls_Manager::URL,
					'dynamic' => [
						'active' => true,
					],
					'placeholder' => __( 'https://your-link.com', 'dreamit-elementor-extension' ),
				]
			);
		$repeater->add_control(
			'service_icon',
			[
				'label' => esc_html__( 'Service Icon', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::MEDIA,
				'default' => [
					'url' => \Elementor\Utils::get_placeholder_image_src(),
				],
			]
		);
		$repeater->add_control(
			'price_title_two',
			[
				'label' => __( 'Price Two', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => __( 'Give Price', 'dreamit-elementor-extension' ),
				'placeholder' => __( 'Give Price', 'dreamit-elementor-extension' ),
			]
		);

		$repeater->add_control(
				'button_text',
				[
					'label' => __( 'Button Text', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::TEXT,
					'dynamic' => [
						'active' => true,
					],
					'placeholder' => __( 'Enter your button text', 'dreamit-elementor-extension' ),
					'label_block' => true,
					'default' => __( 'Button', 'dreamit-elementor-extension' ),
				]
			);
			
			$repeater->add_control(
				'show_button',
				[
					'label' => __( 'Show Button', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::SWITCHER,
					'label_on' => __( 'Show', 'dreamit-elementor-extension' ),
					'label_off' => __( 'Hide', 'dreamit-elementor-extension' ),
					'return_value' => 'yes',
					'default' => 'yes',
				]
			);
			$repeater->add_control(
				'rating',
				[
					'label' => esc_html__( 'Rating', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::NUMBER,
					'min' => 1,
					'max' => 5,
					'step' => 1,
					'default' => 3,
				]
			);
			$repeater->add_control(
				'select_country',
				[
				'label' => __( 'Country', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => __( 'Usa', 'dreamit-elementor-extension' ),
				'placeholder' => __( 'Usa', 'dreamit-elementor-extension' ),
			    ]
			);
			$repeater->add_control(
				'select_offer',
				[
				'label' => __( 'Offer', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => __( '200', 'dreamit-elementor-extension' ),
				'placeholder' => __( '200', 'dreamit-elementor-extension' ),
			    ]
			);
			$repeater->add_control(
			'button_icon',
			[
				'label' => esc_html__( 'Button Icon', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::ICONS,
				'default' => [
					'value' => 'fas fa-circle',
					'library' => 'fa-solid',
				],
				'recommended' => [
					'fa-solid' => [
						'circle',
						'dot-circle',
						'square-full',
					],
					'fa-regular' => [
						'circle',
						'dot-circle',
						'square-full',
					],
				],
			]
		);
		$this->add_control(
			'service_list',
			[
				'label' => esc_html__( 'Service List', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::REPEATER,
				'fields' => $repeater->get_controls(),
				'default' => [
					[
						'service_name' => esc_html__( 'Title #1', 'dreamit-elementor-extension' ),
						'list_content' => esc_html__( 'Item content. Click the edit button to change this text.', 'dreamit-elementor-extension' ),
					],
					[
						'service_name' => esc_html__( 'Title #2', 'dreamit-elementor-extension' ),
						'list_content' => esc_html__( 'Item content. Click the edit button to change this text.', 'dreamit-elementor-extension' ),
					],
				],
				'title_field' => '{{{ service_name }}}',
			]
		);

		$this->end_controls_section();


/*
==========
Style Tab
==========
*/

		$this->start_controls_section(
			'style_section',
			[
				'label' => __( 'Style', 'dreamit-elementor-extension' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'select_style',
				[
					'label' => __( 'Select Style', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::SELECT,
					'options' => [
						'one' => __( 'One', 'dreamit-elementor-extension' ),
						'two' => __( 'Two', 'dreamit-elementor-extension' ),
						'three' => __( 'Three', 'dreamit-elementor-extension' ),
						'four' => __( 'Four', 'dreamit-elementor-extension' ),
					],
					'default' => 'one',
					
				]
			);
		$this->add_responsive_control(
				'text_align',
				[
					'label' => __( 'Alignment', 'dreamit-elementor-extension' ),
					'type' => Controls_Manager::CHOOSE,
					'options' => [
						'left' => [
							'title' => __( 'Left', 'dreamit-elementor-extension' ),
							'icon' => 'eicon-text-align-left',
						],
						'center' => [
							'title' => __( 'Center', 'dreamit-elementor-extension' ),
							'icon' => 'eicon-text-align-center',
						],
						'right' => [
							'title' => __( 'Right', 'dreamit-elementor-extension' ),
							'icon' => 'eicon-text-align-right',
						],
						'justify' => [
							'title' => __( 'Justified', 'dreamit-elementor-extension' ),
							'icon' => 'eicon-text-align-justify',
						],
					],
					'selectors' => [
						'{{WRAPPER}} .service_item' => 'text-align: {{VALUE}};',
					],
				]
			);
		$this->end_controls_section();
		$this->start_controls_section(
			'title_section_style',
			[
				'label' => __( 'Title', 'dreamit-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'title_color',
				[
					'label' => __( 'Color', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .service_item .service_title h2' => 'color: {{VALUE}};',
					],
				]
			);
			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'title_typography',
					'selector' => '{{WRAPPER}} .service_item .service_title h2, {{WRAPPER}} .elementor-icon-box-content .elementor-icon-box-title a',
				]
			);
			$this->add_responsive_control(
				'title_margin',
				[
					'label' => __( 'Margin', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .service_item .service_title h2' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);
		$this->end_controls_section();

		$this->start_controls_section(
			'description_section_style',
			[
				'label' => __( 'Description', 'dreamit-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'description_color',
				[
					'label' => __( 'Color', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .service_item .description' => 'color: {{VALUE}};',
					],
				]
			);
			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'description_typography',
					'selector' => '{{WRAPPER}} .service_item .description, {{WRAPPER}} .elementor-icon-box-content .elementor-icon-box-title a',
				]
			);
			$this->add_responsive_control(
				'description_margin',
				[
					'label' => __( 'Margin', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .service_item .description' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);
		$this->end_controls_section();


		$this->start_controls_section(
			'subtitle_section_style',
			[
				'label' => __( 'Sub Title', 'dreamit-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'sub_title_color',
				[
					'label' => __( 'Color', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .service_item .service_title .sub_title' => 'color: {{VALUE}};',
					],
				]
			);
			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'sub_title_typography',
					'selector' => '{{WRAPPER}} .service_item .service_title .sub_title, {{WRAPPER}} .elementor-icon-box-content .elementor-icon-box-title a',
				]
			);
			$this->add_responsive_control(
				'sub_title_margin',
				[
					'label' => __( 'Margin', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .service_item .service_title .sub_title' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);
		$this->end_controls_section();
		$this->start_controls_section(
			'price_section_style',
			[
				'label' => __( 'Price', 'dreamit-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'price_color',
				[
					'label' => __( 'Color', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .service_item .room-pricing .dolar' => 'color: {{VALUE}};',
					],
				]
			);
			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'price_typography',
					'selector' => '{{WRAPPER}} .service_item .room-pricing .dolar, {{WRAPPER}} .elementor-icon-box-content .elementor-icon-box-title a',
				]
			);
			$this->add_responsive_control(
				'price_margin',
				[
					'label' => __( 'Margin', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .service_item .room-pricing .dolar' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);
		$this->end_controls_section();
		$this->start_controls_section(
			'price_title_section_style',
			[
				'label' => __( 'Price Title', 'dreamit-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'price_title_color',
				[
					'label' => __( 'Color', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .service_item .room-pricing .title' => 'color: {{VALUE}};',
					],
				]
			);
			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'price_title_typography',
					'selector' => '{{WRAPPER}} .service_item .room-pricing .title, {{WRAPPER}} .elementor-icon-box-content .elementor-icon-box-title a',
				]
			);
			$this->add_responsive_control(
				'price_title_margin',
				[
					'label' => __( 'Margin', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .service_item .room-pricing .title' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);
		$this->end_controls_section();
		$this->start_controls_section(
			'country_section_style',
			[
				'label' => __( 'Country', 'dreamit-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'country_title_color',
				[
					'label' => __( 'Color', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .service_item .country_name' => 'color: {{VALUE}};',
					],
				]
			);
			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'country_title_typography',
					'selector' => '{{WRAPPER}} .service_item .country_name, {{WRAPPER}} .elementor-icon-box-content .elementor-icon-box-title a',
				]
			);
			$this->add_responsive_control(
				'country_title_margin',
				[
					'label' => __( 'Margin', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .service_item .country_name' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);
		$this->end_controls_section();
		$this->start_controls_section(
			'offer_section_style',
			[
				'label' => __( 'Offer', 'dreamit-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'offer_color',
				[
					'label' => __( 'Color', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .service_item .offer' => 'color: {{VALUE}};',
					],
				]
			);
			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'offer_typography',
					'selector' => '{{WRAPPER}} .service_item .offer, {{WRAPPER}} .elementor-icon-box-content .elementor-icon-box-title a',
				]
			);
			$this->add_responsive_control(
				'offer_margin',
				[
					'label' => __( 'Margin', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .service_item .offer' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);
		$this->end_controls_section();
		$this->start_controls_section(
			'button_section_style',
			[
				'label' => __( 'Button', 'dreamit-elementor-extension' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
			$this->start_controls_tabs(
				'button_style_tabs'
			);
				$this->start_controls_tab(
					'button_style_normal_tab',
					[
						'label' => __( 'Normal', 'dreamit-elementor-extension' ),
					]
				);
				
					$this->add_control(
						'button_text_color',
						[
							'label' => __( 'Text Color', 'dreamit-elementor-extension' ),
							'type' => \Elementor\Controls_Manager::COLOR,
							'default' => '',
							'selectors' => [
								'{{WRAPPER}} .service_item .room-details-button a' => 'color: {{VALUE}};',
							],
						]
					);
					$this->add_control(
						'button_background_color',
						[
							'label' => __( 'Background Color', 'dreamit-elementor-extension' ),
							'type' => \Elementor\Controls_Manager::COLOR,
							'default' => '',
							'selectors' => [
								'{{WRAPPER}} .service_item .room-details-button a' => 'background-color: {{VALUE}};',
							],
						]
					);
					$this->add_group_control(
						\Elementor\Group_Control_Border::get_type(),
						[
							'name' => 'button_border',
							'label' => __( 'Border', 'dreamit-elementor-extension' ),
							'selector' => '{{WRAPPER}} .service_item .room-details-button a',
						]
					);
					$this->add_responsive_control(
						'button_border_radius',
						[
							'label' => __( 'Border Radius', 'dreamit-elementor-extension' ),
							'type' => \Elementor\Controls_Manager::DIMENSIONS,
							'size_units' => [ 'px', 'em', '%' ],
							'selectors' => [
								'{{WRAPPER}} .service_item .room-details-button a' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
							],
						]
					);
				$this->end_controls_tab();
				
				$this->start_controls_tab(
					'button_style_hover_tab',
					[
						'label' => __( 'Hover', 'dreamit-elementor-extension' ),
					]
				);

					$this->add_control(
						'hover_button_text_color',
						[
							'label' => __( 'Text Color', 'dreamit-elementor-extension' ),
							'type' => \Elementor\Controls_Manager::COLOR,
							'default' => '',
							'selectors' => [
								'{{WRAPPER}} .service_item .room-details-button a:hover' => 'color: {{VALUE}};',
							],
						]
					);
					$this->add_control(
						'hover_button_background_color',
						[
							'label' => __( 'Background Color', 'dreamit-elementor-extension' ),
							'type' => \Elementor\Controls_Manager::COLOR,
							'default' => '',
							'selectors' => [
								'{{WRAPPER}} .service_item .room-details-button a:hover' => 'background-color: {{VALUE}};',
							],
						]
					);
					$this->add_group_control(
						\Elementor\Group_Control_Border::get_type(),
						[
							'name' => 'hover_button_border',
							'label' => __( 'Border', 'dreamit-elementor-extension' ),
							'selector' => '{{WRAPPER}} .service_item .room-details-button a:hover',
						]
					);
					$this->add_responsive_control(
						'hover_button_border_radius',
						[
							'label' => __( 'Border Radius', 'dreamit-elementor-extension' ),
							'type' => \Elementor\Controls_Manager::DIMENSIONS,
							'size_units' => [ 'px', 'em', '%' ],
							'selectors' => [
								'{{WRAPPER}} .service_item .room-details-button a:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
							],
						]
					);
				$this->end_controls_tab();
				
			$this->end_controls_tabs();

			$this->add_responsive_control(
				'button_margin',
				[
					'label' => __( 'Margin', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .service_item .room-details-button a' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
					'separator' => 'before',
				]
			);
			$this->add_responsive_control(
				'button_padding',
				[
					'label' => __( 'Padding', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .service_item .room-details-button a' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
					'separator' => 'before',
				]
			);
			$this->add_control(
				'button_height',
				[
					'label' => __( 'Height', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 5,
						],
						'%' => [
							'min' => 0,
							'max' => 100,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .service_item .room-details-button a' => 'height: {{SIZE}}{{UNIT}};',
					],
				]
			);
			$this->add_control(
				'button_width',
				[
					'label' => __( 'Width', 'dreamit-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 5,
						],
						'%' => [
							'min' => 0,
							'max' => 100,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .service_item .room-details-button a' => 'width: {{SIZE}}{{UNIT}};',
					],
				]
			);

			$this->add_group_control(
				\Elementor\Group_Control_Typography::get_type(),
				[
					'name' => 'button_typography',
					'selector' => '{{WRAPPER}} .service_item .room-details-button a',
				]
			);

		$this->end_controls_section();
		
		$this->start_controls_section(
			'content_section_style',
			[
				'label' => __( 'Content', 'dreamit-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->start_controls_tabs(
				'content_style_tabs'
			);
				$this->start_controls_tab(
					'content_style_normal_tab',
					[
						'label' => __( 'Normal', 'dreamit-elementor-extension' ),
					]
				);
				
					$this->add_group_control(
						\Elementor\Group_Control_Border::get_type(),
						[
							'name' => 'content_border',
							'label' => __( 'Border', 'dreamit-elementor-extension' ),
							'selector' => '{{WRAPPER}} .service_item .service_content',
						]
					);

					$this->add_responsive_control(
						'content_border_radius',
						[
							'label' => __( 'Border Radius', 'dreamit-elementor-extension' ),
							'type' => \Elementor\Controls_Manager::DIMENSIONS,
							'size_units' => [ 'px', 'em', '%' ],
							'selectors' => [
								'{{WRAPPER}} .service_item .service_content' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
							],
						]
					);

					$this->add_group_control(
						\Elementor\Group_Control_Box_Shadow::get_type(),
						[
							'name' => 'content_shadow',
							'label' => __( 'Box Shadow', 'dreamit-elementor-extension' ),
							'selector' => '{{WRAPPER}} .service_item .service_content',
						]
					);

					$this->add_group_control(
						\Elementor\Group_Control_Background::get_type(),
						[
							'name' => 'content_background',
							'label' => __( 'Background', 'dreamit-elementor-extension' ),
							'types' => [ 'classic', 'gradient', 'video' ],
							'selector' => '{{WRAPPER}} .service_item .service_content',
						]
					);
				
				$this->end_controls_tab();
				

			$this->add_responsive_control(
				'content_margin',
				[
					'label' => __( 'Margin', 'dreamit-elementor-extension' ),
					'type' => Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .service_item .service_content' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
					'separator' => 'before',
				]
			);
			$this->add_responsive_control(
				'content_padding',
				[
					'label' => __( 'Padding', 'dreamit-elementor-extension' ),
					'type' => Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .service_item .service_content' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);
		$this->end_controls_section();


	}

	protected function render(){

		$settings = $this->get_settings_for_display();
		
		?>

			<?php if($settings['select_style']=='one'){ ?>

			<div class="service_carousel style1">

				<div class="service-carousel owl-carousel style_one">
					<?php foreach (  $settings['service_list'] as $item ) { ?>
						<div class="service_item style_one">
							<div class="service_img">
								<img src="<?php echo $item['service_image']['url']; ?>" alt="<?php esc_attr_e('restu', 'restu'); ?>">
								<div class="service_content">
									<div class="service_title">
										<h2 class="title"> <a href="<?php echo esc_url($item['link']['url']); ?>"><?php echo $item['service_title'];?></a></h2>
										<p class="description"><?php echo $item['service_description'];?></p>
									</div>
									<div class="room-pricing">
										<span class="dolar"><?php echo $item['price'];?></span>
										<?php if(!empty($item['price_title'])) { ?> 
											<span class="title"><?php echo $item['price_title'];?></span>
										<?php }?>
									</div>
									<?php if( 'yes'===$item['show_button'] ){ ?>
										<div class="room-details-button">
											<a href="<?php echo esc_url($item['link']['url']); ?>">
												<?php echo $item['button_text']; ?>
												<?php \Elementor\Icons_Manager::render_icon( $item['button_icon'], [ 'aria-hidden' => 'true' ] ); ?>
											</a>
										</div>
									<?php } ?>
								</div>
							</div>		
						</div>
					<?php } ?>
				</div>
			</div>
			<script>
				jQuery(document).ready(function($) {
					"use strict";
                    $('.service-carousel').owlCarousel({
                    	loop: true,
                    	autoplay: false,
                    	autoplayTimeout: 4000,
                    	dots: false,
                    	nav: true,
                    	dotsEach:true,
                    	navText: ["<i class='flaticon flaticon-left-arrow'></i>", "<i class='flaticon flaticon-right-arrow''></i>"],
                    	responsive: {
                    		0: {
                    			items: 1
                    		},
                    		768: {
                    			items: 2
                    		},
                    		992: {
                    			items: 2
                    		},
                    		1500: {
                    			items: 2
                    		},
                    		1920: {
                    			items: 2
                    		}
                    	}
                    })
				});
			</script>
		<?php } elseif($settings['select_style']=='two'){ ?>
			<div class="service_carousel style2">
				<div class="service-carousel owl-carousel style_2">
					<?php foreach (  $settings['service_list'] as $item ) { ?>
						<div class="service_item style_2">
							<div class="service_img">
								<img src="<?php echo $item['service_image']['url']; ?>" alt="<?php esc_attr_e('restu', 'restu'); ?>">
								<?php if( 'yes'===$item['show_price'] ){ ?>
								<div class="room-pricing">
									<span class="dolar"><?php echo $item['price'];?></span>
									<span class="title"><?php echo $item['price_title'];?></span>
								</div>
								<?php } ?>
								 <div class="picon">					
									<a class="service-icon venobox" data-gall="service" href="<?php echo $item['service_image']['url']; ?>"><i class="fa fa-photo"></i></a>
								</div> 
							</div>
							<div class="service_content">
								<div class="service_title">
									<h4 class="sub_title"><?php echo $item['sub_title'];?></h4>
									<h2 class="title"> <a href="<?php echo esc_url($item['link']['url']); ?>"><?php echo $item['service_title'];?></a></h2>
									<?php if(!empty($item['service_description'])) { ?> 
										<p class="description"><?php echo $item['service_description'];?></p>
									<?php }?>
									<ul>
										<li><i class="fas fa-check"></i>1500 SQ.FT/Rooms</li>
										<li><i class="fas fa-check"></i>2 King Size Bed</li>
										<li><i class="fas fa-check"></i>5+ Guests Allowed</li>
									</ul>
								</div>
							</div>
							<div class="inner_content">
								<?php if( 'yes'===$item['show_button'] ){ ?>
									<div class="room-details-button">
										<a href="<?php echo esc_url($item['link']['url']); ?>">
											<?php echo $item['button_text']; ?>
											<?php \Elementor\Icons_Manager::render_icon( $item['button_icon'], [ 'aria-hidden' => 'true' ] ); ?>
										</a>
									</div><!-- .service-btn	-->
								<?php } ?>
								<div class="title"><h4 class="title"><?php echo $item['price_title_two'];?></h4>
								</div>
								<div class="reviews_rating">
									<?php if( $item['rating']==5 ){ ?>
										<div class="rooms-star">
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
										</div>
									<?php } ?>
									<?php if( $item['rating']==4 ){ ?>
										<div class="rooms-star">
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star"></i>
										</div>
									<?php } ?>
									<?php if( $item['rating']==3 ){ ?>
										<div class="rooms-star">
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
										</div>												
									<?php } ?>
									<?php if( $item['rating']==2 ){ ?>
										<div class="rooms-star">
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
										</div>												
									<?php } ?>
									<?php if( $item['rating']==1 ){ ?>
										<div class="rooms-star">
											<i class="fa fa-star active"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
										</div>
									<?php } ?>
								</div>
							</div>

						</div>
						<?php } ?>
					</div>
				</div>
			<script>
				jQuery(document).ready(function($) {
					"use strict";
                    	
                    $('.service-carousel').owlCarousel({
                    	loop: true,
                    	autoplay: false,
                    	autoplayTimeout: 4000,
                    	dots: true,
                    	nav: false,
                    	navText: ["<i class='flaticon flaticon-left-arrow'></i>", "<i class='flaticon flaticon-right-arrow''></i>"],
                    	responsive: {
                    		0: {
                    			items: 1
                    		},
                    		768: {
                    			items: 2
                    		},
                    		992: {
                    			items: 2
                    		},
                    		1500: {
                    			items: 3
                    		},
                    		1500: {
                    			items: 3
                    		},
                    		1920: {
                    			items: 3
                    		}
                    	}
                    })
				});
			</script>

			<?php }elseif($settings['select_style']=='three'){ ?>
			<div class="service_carousel style3">
				<div class="service-carousel2 owl-carousel style_3">
					<?php foreach (  $settings['service_list'] as $item ) { ?>
						<div class="service_item style_3">
							<div class="service_img">
								<img src="<?php echo $item['service_image']['url']; ?>" alt="<?php esc_attr_e('restu', 'restu'); ?>">
								<?php if( 'yes'===$item['show_price'] ){ ?>
								<div class="room-pricing">
									<span class="dolar"><?php echo $item['price'];?></span>
									<span class="title"><?php echo $item['price_title'];?></span>
								</div>
								<?php } ?>
								 <?php if( 'yes'===$item['show_button'] ){ ?>
									<div class="room-details-button">
										<a href="<?php echo esc_url($item['link']['url']); ?>">
											<?php echo $item['button_text']; ?>
											<?php \Elementor\Icons_Manager::render_icon( $item['button_icon'], [ 'aria-hidden' => 'true' ] ); ?>
										</a>
									</div><!-- .service-btn	-->
								<?php } ?>
							</div>
							<div class="service_content">
								<div class="service_title">
									<h4 class="sub_title"><?php echo $item['sub_title'];?></h4>
									<h2 class="title"> <a href="<?php echo esc_url($item['link']['url']); ?>"><?php echo $item['service_title'];?></a></h2>
									<?php if(!empty($item['service_description'])) { ?> 
										<p class="description"><?php echo $item['service_description'];?></p>
									<?php }?>
								</div>
							</div>
							<div class="inner_content">
								
								<div class="btn_img">
									<img src="<?php echo $item['service_icon']['url'];?>" alt="<?php esc_attr_e('restu', 'restu'); ?>">
								</div>
								<div class="title"><h4 class="title"><?php echo $item['price_title_two'];?></h4>
								</div>
								<div class="reviews_rating">
									<?php if( $item['rating']==5 ){ ?>
										<div class="rooms-star">
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
										</div>
									<?php } ?>
									<?php if( $item['rating']==4 ){ ?>
										<div class="rooms-star">
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star"></i>
										</div>
									<?php } ?>
									<?php if( $item['rating']==3 ){ ?>
										<div class="rooms-star">
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
										</div>												
									<?php } ?>
									<?php if( $item['rating']==2 ){ ?>
										<div class="rooms-star">
											<i class="fa fa-star active"></i>
											<i class="fa fa-star active"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
										</div>												
									<?php } ?>
									<?php if( $item['rating']==1 ){ ?>
										<div class="rooms-star">
											<i class="fa fa-star active"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
											<i class="fa fa-star"></i>
										</div>
									<?php } ?>
								</div>
							</div>

						</div>
						<?php } ?>
					</div>
				</div>
			<script>
				jQuery(document).ready(function($) {
					"use strict";
                    	
                    $('.service-carousel2').owlCarousel({
                    	loop: true,
                    	autoplay: false,
                    	autoplayTimeout: 4000,
                    	dots: false,
                    	nav: false,
                    	navText: ["<i class='flaticon flaticon-left-arrow'></i>", "<i class='flaticon flaticon-right-arrow''></i>"],
                    	responsive: {
                    		0: {
                    			items: 1
                    		},
                    		768: {
                    			items: 2
                    		},
                    		992: {
                    			items: 2
                    		},
                    		1364: {
                    			items: 3
                    		},
                    		1500: {
                    			items: 3
                    		},
                    		1920: {
                    			items: 3
                    		}
                    	}
                    })
				});
			</script>

			<?php }elseif($settings['select_style']=='four'){ ?>
			<div class="service_carousel style4">
				<div class="service-carousel2 owl-carousel style_4">
					<?php foreach (  $settings['service_list'] as $item ) { ?>
						<div class="service_item style_4">
							<div class="service_img">
								<img src="<?php echo $item['service_image']['url']; ?>" alt="<?php esc_attr_e('restu', 'restu'); ?>">
								<?php if( 'yes'===$item['show_button'] ){ ?>
									<div class="room-details-button">
										<a href="<?php echo esc_url($item['link']['url']); ?>">
											<?php echo $item['button_text']; ?>
											<i <?php echo $this->get_render_attribute_string( 'j' ); ?>></i>
										</a>
									</div><!-- .service-btn	-->
								<?php } ?>
								<div class="room-pricing">
									<span class="dolar"><?php echo $item['price'];?></span>
									<span class="title"><?php echo $item['price_title'];?></span>
								</div>
							</div>
							<div class="service_content">
								<div class="service_title">
									<a href="#"><h2 class="title"><?php echo $item['service_title'];?></h2></a>
								</div>
							</div>
						</div>
						<?php } ?>
					</div>
				</div>
			<script>
				jQuery(document).ready(function($) {
					"use strict";
                    	
                    $('.service-carousel2').owlCarousel({
                    	loop: true,
                    	autoplay: false,
                    	autoplayTimeout: 4000,
                    	dots: false,
                    	nav: false,
                    	navText: ["<i class='flaticon flaticon-left-arrow'></i>", "<i class='flaticon flaticon-right-arrow''></i>"],
                    	responsive: {
                    		0: {
                    			items: 1
                    		},
                    		768: {
                    			items: 2
                    		},
                    		992: {
                    			items: 2
                    		},
                    		1364: {
                    			items: 3
                    		},
                    		1500: {
                    			items: 4
                    		},
                    		1920: {
                    			items: 4
                    		}
                    	}
                    })
				});
			</script>

			<?php }?>

		<?php
	}
	
}