<?php



add_action( 'cmb2_admin_init', 'restu_metabox' );

/*

**	Setting up custom fields for custom post types belongs to fantasic child theme for restu

*/ 



if ( !function_exists('restu_metabox') ) {

	function restu_metabox() {

		$prefix = '_restu_';



	//header metabox

 	$page_heading_style = new_cmb2_box( array(

	'id'            => $prefix . 'em_header_style_option',

	'title'         => esc_html__( 'Header Style Option', 'restu' ),

	'object_types'  => array( 'page','restu-room' ), // Post type

	'priority'   => 'high',

	) );

	



	

		$page_heading_style->add_field( array(

			'name'    => esc_html__('Top Menu Style ','restu'),

			'id'      => $prefix . 'restu_header_topa',

			'type'    => 'radio_inline',

			'options' => array(

			'1' => esc_html__( 'Show Top Menu This Page', 'restu' ),

			'2'   => esc_html__( 'Hide Top Menu This Page', 'restu' ),

			),

			'default' =>'2',

		) );

		$page_heading_style->add_field( array(

			'name'    => esc_html__('Header Style','restu'),

			'id'      => $prefix . 'restu_header_style',

			'show_option_none' => true,

			'desc'   => esc_html__( 'Note: When you select 1-1,3,4,6 style menu, that time you need to set top bar menu, otherwise you can not find our real menu style.', 'restu' ), 			

			'type'    => 'select',

			'options' => array(

				'1' => esc_html__( 'Default Header Menu', 'restu' ),				

				'2' => esc_html__( 'Header Menu Transparent', 'restu' ),					

				'3' => esc_html__( 'Header Style Two', 'restu' ),			

				'4' => esc_html__( 'Header OnePage Menu', 'restu' ),			

			),

			'default' =>'1',

		) );	

		$page_heading_style->add_field( array(

			'name' => 'Full Width Header',

			'desc' => 'Active',

			'id'   => 'full_header',

			'type' => 'checkbox',

		) );

		

		  //page metabox

		  $page_breadcrumb = new_cmb2_box( array(

		   'id'            => $prefix . 'pageid1',

		   'title'         => esc_html__( 'Breadcumb Option', 'restu' ),

		   'object_types'  => array( 'post','page','em_event','em_portfolio','restu-room','restu-room' ), // Post type

		   'priority'   => 'high',

		  ) );

		  

		  $page_breadcrumb->add_field( array(

		   'name'    => esc_html__('Page Title','restu'),

		   'id'      => $prefix . 'ptitle',

		   'type'    => 'radio_inline',

		   'options' => array(

			'ptitles' => esc_html__( 'Hide Title', 'restu' ),

			'ptitleh'   => esc_html__( 'Show Title', 'restu' ),

		   ),

		   'default' =>'ptitleh',

		  ) );   

		  

		  

		$page_breadcrumb->add_field( array(

			'name'    => esc_html__('Breadcrumb','restu'),

			'id'      => $prefix . 'breadcrumbs',

			'type'    => 'radio_inline',

			'options' => array(

			'0' => esc_html__( 'Show breadcrumb', 'restu' ),

			'1'   => esc_html__( 'Hide breadcrumb', 'restu' ),

			),

			'default' =>0,

		) );

		$page_breadcrumb->add_field( array(

			'name'    => esc_html__('Breadcrumb Title','restu'),

			'id'      => $prefix . 'btitle',

			'type'    => 'radio_inline',

			'options' => array(

			'btitles' => esc_html__( 'Show Title', 'restu' ),

			'btitleh'   => esc_html__( 'Hide Title', 'restu' ),

			),

			'default' =>'btitleh',

		) );    

		$page_breadcrumb->add_field(array(

			'name' => esc_html__( 'Page Breadcrumb Image', 'restu' ),

			'id'   => $prefix .'pageimagess',

			'desc'       => esc_html__( 'insert image here', 'restu' ),  

			'type' => 'file',

		) );  

		$page_breadcrumb->add_field( array(

			'name'             => esc_html__('Text Align','restu'),

			'desc'             => esc_html__('Select an option','restu'),

			'id'   => $prefix .'page_text_align',

			'type'             => 'select',

			'show_option_none' => true,

			'default'          => 'text-center',

			'options'          => array(

			'text-left' => esc_html__( 'Align Left', 'restu' ),

			'text-center'   => esc_html__( 'Align Middle', 'restu' ),

			'text-right'     => esc_html__( 'Alige Right', 'restu' ),

			),

		) );

		$page_breadcrumb->add_field( array(

			'name'             => esc_html__('Text Transform','restu'),

			'desc'             => esc_html__('Select an option','restu'),

			'id'   => $prefix .'page_text_transform',

			'type'             => 'select',

			'show_option_none' => true,

			'default'          => 'ccase',

			'options'          => array(

			'lcase' => esc_html__( 'Transform lowercase', 'restu' ),

			'ucase'   => esc_html__( 'Transform uppercase', 'restu' ),

			'ccase'     => esc_html__( 'Transform capitalize', 'restu' ),

			),

		) );	

		



		//Testimonial

		$testimonial = new_cmb2_box( array(

			'id'            => $prefix . 'em_testimonial',

			'title'         => esc_html__( 'Testimonial Option', 'restu' ),

			'object_types'  => array( 'em_testimonial' ), // Post type

			'priority'   => 'high',

		) );

		$testimonial->add_field( array(

			'name'       => esc_html__( 'Degignation', 'restu' ),

			'desc'       => esc_html__( 'insert Degignation here', 'restu' ),

			'id'         => $prefix . 'testi_deg',

			'type'       => 'text',

		) );	

			

							

		//Case Study

			$casestudy = new_cmb2_box( array(

				'id'            => $prefix . 'em_case_study',

				'title'         => esc_html__( 'Case Study Option', 'restu' ),

				'object_types'  => array( 'em_case_study' ), // Post type

				'priority'   => 'high',

			) );

				$casestudy->add_field( array(

					'name'       => esc_html__( 'Case Study Description', 'restu' ),

					'desc'       => esc_html__( 'Description', 'restu' ),

					'id'         => $prefix . 'casedesc',

					'type'       => 'wysiwyg',

				) );



			$casestudy->add_field( array(

					'name' => 'oEmbed',

					'id'   => 'embed',

					'type' => 'oembed',

				) );

			$casestudy->add_field( array(

				'name'    => 'Icon Field',

				'desc'    => 'Upload an image or enter an URL.',

				'id'      => 'icon_field',

				'type'    => 'file',

			) );

					

			//===================================

			//Portfolio Metaboxes

			//===================================  



			$portfolio = new_cmb2_box( array(

				'id'            => $prefix . 'portfolio',

				'title'         => esc_html__( 'Portfolio Option', 'restu' ),

				'object_types'  => array( 'em_portfolio', ), // Post type

				'priority'   => 'high',

			) );

			// $portfolio->add_field( array(

			// 	'name'       => esc_html__( 'Portfolio Description', 'restu' ),

			// 	'desc'       => esc_html__( 'Description', 'restu' ),

			// 	'id'         => $prefix . 'portdesc',

			// 	'type'       => 'wysiwyg',

			// ) );				

			

			$portfolio->add_field( array(

				'name'    => esc_html__('Show/Hide All Option','restu'),			  

				'id'      => $prefix . 'saloption',

				'type'    => 'radio_inline',

				'options' => array(

					'm_alshow' => esc_html__( 'Show', 'restu' ),

					'm_alhide'   => esc_html__( 'Hide', 'restu' ),

				),

				'default' =>'m_alhide',

			) );

			$portfolio->add_field( array(

				'name'       => esc_html__( 'Portfolio Description', 'restu' ),

				'desc'       => esc_html__( 'Description', 'restu' ),

				'id'         => 'pdetails',

				'type'       => 'wysiwyg',

			) );

			$portfolio->add_field( array(

				'name' => 'Test Money',

				'desc' => 'field description (optional)',

				'id' => 'hotel_money',

				'type' => 'text_money',

			) );

			$portfolio->add_field( array(

				'name'    => esc_html__('Show/Hide Popup Image','restu'),			  

				'id'      => $prefix . 'siimagepop',

				'type'    => 'radio_inline',

				'options' => array(

					'm_ishow' => esc_html__( 'Show', 'restu' ),

					'm_ihide'   => esc_html__( 'Hide', 'restu' ),

				),

				'default' =>'m_ishow',

			) );

			$portfolio->add_field( array(

				'name'    => esc_html__('Show/Hide Link Page','restu'),			  

				'id'      => $prefix . 'sllink',

				'type'    => 'radio_inline',

				'options' => array(

					'm_lshow' => esc_html__( 'Show', 'restu' ),

					'm_lhide'   => esc_html__( 'Hide', 'restu' ),

				),

				'default' =>'m_lshow',

			) );				  

			$portfolio->add_field( array(

				'name'    => esc_html__('Show/Hide Popup Youtube','restu'),			  

				'id'      => $prefix . 'shyoutub',

				'type'    => 'radio_inline',

				'options' => array(

					'm_yshow' => esc_html__( 'Show', 'restu' ),

					'm_yhide'   => esc_html__( 'Hide', 'restu' ),

				),

				'default' =>'m_yhide',

			) );				

			$portfolio->add_field( array(

				'name'       => esc_html__( 'Youtube Video', 'restu' ),

				'desc'       => esc_html__( 'insert video link. ex-https://youtu.be/OJ9ejTy4J98', 'restu' ),

				'id'         => $prefix . 'pyoutube',

				'type'       => 'text_url',

			) );

			$portfolio->add_field( array(

				'name'    => esc_html__('Show/Hide Popup Vimeo','restu'),			  

				'id'      => $prefix . 'svvimeo',

				'type'    => 'radio_inline',

				'options' => array(

					'm_vshow' => esc_html__( 'Show', 'restu' ),

					'm_vhide'   => esc_html__( 'Hide', 'restu' ),

				),

				'default' =>'m_vhide',

			) );				   

			$portfolio->add_field( array(

				'name'       => esc_html__( 'Vimeo Video', 'restu' ),

				'desc'       => esc_html__( 'insert video link. ex-https://youtu.be/OJ9ejTy4J98', 'restu' ),

				'id'         => $prefix . 'pvimeo',

				'type'       => 'text_url',

			) );		   



			$portfolio->add_field( array(

				'name'    => esc_html__('Select Multi Gellary','restu'),			  

				'id'      => $prefix . 'm_g_image_pop',

				'type'    => 'radio_inline',

				'options' => array(

					'm_gshow' => esc_html__( 'Show', 'restu' ),

					'm_ghide'   => esc_html__( 'Hide', 'restu' ),

				),

				'default' =>'m_ghide',

			) );				   

			$portfolio->add_field( array(

				'name'       => esc_html__( 'Multiple Gellary Image', 'restu' ),

				'desc'       => esc_html__( 'insert multiple gellary image here for single page', 'restu' ),

				'id'         => $prefix . 'pgellaryu',

				'type'       => 'file_list',

			) );

			$portfolio->add_field( array(

				'name'    => esc_html__('Show/Hide Title','restu'),			  

				'id'      => $prefix . 'pshow_title',

				'type'    => 'radio_inline',

				'options' => array(

					'ptitle_show' => esc_html__( 'Show', 'restu' ),

					'ptitle_hide'   => esc_html__( 'Hide', 'restu' ),

				),

				'default' =>'ptitle_show',

			) );					

			$portfolio->add_field( array(

				'name'    => esc_html__('Show/Hide Category','restu'),			  

				'id'      => $prefix . 'pshow_cat',

				'type'    => 'radio_inline',

				'options' => array(

					'pcat_show' => esc_html__( 'Show', 'restu' ),

					'pcat_hide'   => esc_html__( 'Hide', 'restu' ),

				),

				'default' =>'pcat_show',

			) );



	//Product

			$product = new_cmb2_box( array(

				'id'            => $prefix . 'em_product_post',

				'title'         => esc_html__( 'Product Option', 'restu' ),

			'object_types'  => array( 'em_product_post' ), // Post type

			'priority'   => 'high',

		) );

			$product->add_field( array(

				'name' => __( 'Website URL', 'restu' ),

				'id'   => 'facebook',

				'type' => 'text_url',

			) );

			$product->add_field( array(

				'name'       => esc_html__( 'Product  Description', 'restu' ),

				'desc'       => esc_html__( 'Description', 'restu' ),

				'id'         => 'dreamit_product',

				'type'       => 'wysiwyg',

			) );

			$product->add_field( array(

				'name'    => 'Icon Field',

				'desc'    => 'Upload an image or enter an URL.',

				'id'      => 'icon_field',

				'type'    => 'file',

			) );



			$product->add_field( array(

				'name' => 'Test Money',

				'desc' => 'field description (optional)',

				'id' => 'dreamit_money',

				'type' => 'text_money',

			) );

			

		//curser metabox

			  $page_curser_style = new_cmb2_box( array(

			  	'id'            => $prefix . 'em_curser_style_option',

			  	'title'         => esc_html__( 'Curser Style Option', 'restu' ),

				'object_types'  => array( 'post','page','em_event','em_portfolio','restu-room' ), // Post type

					'priority'   => 'high',

				) );



			  $page_curser_style->add_field( array(

			  	'name'    => esc_html__('Curser Style ','restu'),

			  	'id'      => $prefix . 'restu_Curser_topa',

			  	'type'    => 'radio_inline',

			  	'options' => array(

			  		'1' => esc_html__( 'Show Curser This Page', 'restu' ),

			  		'2'   => esc_html__( 'Hide Curser This Page', 'restu' ),

			  	),

			  	'default' =>'1',

			  ) );



//===================================

//Pricing table metabox

//===================================

		$pricing = new_cmb2_box( array(

			'id'            => $prefix . 'pricing',

			'title'         => esc_html__( 'Price Option', 'restu' ),

			'object_types'  => array( 'em_pricing', ), // Post type

			'priority'   => 'high',

		) );

				$pricing->add_field( array(

					'name'       => esc_html__( 'Price Currency', 'restu' ),

					'desc'       => esc_html__( 'insert Currency here e.g $', 'restu' ),

					'id'         => $prefix . 'currency',

					'type'       => 'text',

				) );	

				$pricing->add_field( array(

					'name'       => esc_html__( 'Price Amount', 'restu' ),

					'desc'       => esc_html__( 'insert Amount here', 'restu' ),

					'id'         => $prefix . 'price_amount',

					'type'       => 'text',

				) );	

				$pricing->add_field( array(

					'name'       => esc_html__( 'Price Delay', 'restu' ),

					'desc'       => esc_html__( 'insert Year, Month, Week or Day here', 'restu' ),

					'id'         => $prefix . 'day',

					'type'       => 'text',

				) );						

				$pricing->add_field( array(

					'name'       => esc_html__( 'pricing content', 'restu' ),

					'desc'       => esc_html__( 'insert pricing Item', 'restu' ),

					'id'         => $prefix . 'pricing_item_loop',

					'type'       => 'text',

					'repeatable'      => true,

				) );

				$pricing->add_field( array(

					'name' => esc_html__( 'Button Text', 'restu' ),

					'desc' => esc_html__( 'Insert Text Here', 'restu' ),

					'id'   => $prefix . 'button_text',

					'type' => 'text',

				) );					

				$pricing->add_field( array(

					'name' => esc_html__( 'Button Link', 'restu' ),

					'desc' => esc_html__( 'Insert register Link', 'restu' ),

					'id'   => $prefix . 'button_link',

					'type' => 'text_url',

				) );

				$pricing->add_field( array(

					'name' => esc_html__( 'Active Class', 'restu' ),

					'desc' => esc_html__( 'Add Active Class here "active"', 'restu' ),

					'id'   => $prefix . 'active',

					'type' => 'text',

				) );



				

				

		//post tab metabox

			$emtab = new_cmb2_box( array(

				'id'            => $prefix . 'em_tab',

				'title'         => esc_html__( 'Tab Option', 'restu' ),

				'object_types'  => array( 'em_tab' ), // Post type

				'priority'   => 'high',

			) );



				$emtab->add_field( array(

					'name'       => esc_html__( 'Tab Menu Name', 'restu' ),

					'desc'       => esc_html__( 'insert tab menu here', 'restu' ),

					'id'         => $prefix . 'em_tab_menu',

					'type'       => 'text',

				) );					

									

				$emtab->add_field(array(

					'name' => esc_html__( 'Tab Menu Image', 'restu' ),

					'id'   => $prefix .'em_tab_image',

					'desc'       => esc_html__( 'insert image here', 'restu' ),  

					'type' => 'file',

				) );

				$emtab->add_field( array(

					'name'       => esc_html__( 'Tab Menu Active', 'restu' ),

					'desc'       => esc_html__( 'must be set "active in" class into one post from all post, for active tab item', 'restu' ),

					'id'         => $prefix . 'em_tab_active',

					'type'       => 'text',

				) );

				$emtab->add_field( array(

					'name'       => esc_html__( 'Tab Icon Name', 'restu' ),

					'desc'       => esc_html__( 'Type Your favorite Font awesome Icon name', 'restu' ),

					'id'         => $prefix . 'em_tab_icon',

					'type'       => 'text',

				) );

				

					

				

				

								

//slider table metabox

	$slider = new_cmb2_box( array(

		'id'            => $prefix . 'restu_slider',

		'title'         => esc_html__( 'Slider Option', 'restu' ),

		'object_types'  => array( 'em_slider', ), // Post type

		'priority'   => 'high',

	) );

	

	

			$slider->add_field( array(

				'name'       => esc_html__( 'Title', 'restu' ),

				'desc'       => esc_html__( 'insert title here. for highlight text use <span> ex-<span>Design</span>', 'restu' ),

				'id'         => $prefix . 'em_slide_title',

				'type'       => 'textarea_small',

			) );



			$slider->add_field( array(

				'name'    => esc_html__('Title Animate','restu'),

				'id'      => $prefix . 'em_aimate_title',

				'show_option_none' => true,					

				'type'    => 'select',

				'options' => array(

					'bounceIn' => esc_html__( 'bounceIn', 'restu' ),				

					'bounceInDown' => esc_html__( 'bounceInDown', 'restu' ),				

					'bounceInLeft' => esc_html__( 'bounceInLeft', 'restu' ),				

					'bounceInRight' => esc_html__( 'bounceInRight', 'restu' ),				

					'bounceInUp' => esc_html__( 'bounceInUp', 'restu' ),				

					'fadeIn' => esc_html__( 'fadeIn', 'restu' ),				

					'fadeInDown' => esc_html__( 'fadeInDown', 'restu' ),				

					'fadeInDownBig' => esc_html__( 'fadeInDownBig', 'restu' ),				

					'fadeInLeft' => esc_html__( 'fadeInLeft', 'restu' ),				

					'fadeInLeftBig' => esc_html__( 'fadeInLeftBig', 'restu' ),				

					'fadeInRight' => esc_html__( 'fadeInRight', 'restu' ),				

					'fadeInRightBig' => esc_html__( 'fadeInRightBig', 'restu' ),				

					'fadeInUp' => esc_html__( 'fadeInUp', 'restu' ),				

					'fadeInUpBig' => esc_html__( 'fadeInUpBig', 'restu' ),				

					'rotateIn' => esc_html__( 'rotateIn', 'restu' ),				

					'rotateInDownLeft' => esc_html__( 'rotateInDownLeft', 'restu' ),				

					'rotateInDownRight' => esc_html__( 'rotateInDownRight', 'restu' ),				

					'rotateInUpLeft' => esc_html__( 'rotateInUpLeft', 'restu' ),				

					'rotateInUpRight' => esc_html__( 'rotateInUpRight', 'restu' ),				

					'rollIn' => esc_html__( 'rollIn', 'restu' ),				

					'zoomIn' => esc_html__( 'zoomIn', 'restu' ),				

					'zoomInDown' => esc_html__( 'zoomInDown', 'restu' ),				

					'zoomInLeft' => esc_html__( 'zoomInLeft', 'restu' ),				

					'zoomInRight' => esc_html__( 'zoomInRight', 'restu' ),				

					'zoomInUp' => esc_html__( 'zoomInUp', 'restu' ),				

					'slideInDown' => esc_html__( 'slideInDown', 'restu' ),				

					'slideInLeft' => esc_html__( 'slideInLeft', 'restu' ),				

					'slideInRight' => esc_html__( 'slideInRight', 'restu' ),				

					'slideInUp' => esc_html__( 'slideInUp', 'restu' ),				

				),

				'default' =>'slideInRight',

			) );

			



			$slider->add_field( array(

				'name'    => esc_html__('Title Animate Duration','restu'),

				'id'      => $prefix . 'em_durations_title',

				'show_option_none' => false,					

				'type'    => 'select',

				'options' => array(

					'0.1' => esc_html__( 'point 1s', 'restu' ),							

					'0.2' => esc_html__( 'point 2s', 'restu' ),							

					'0.3' => esc_html__( 'point 3s', 'restu' ),							

					'0.4' => esc_html__( 'point 4s', 'restu' ),							

					'0.5' => esc_html__( 'point 5s', 'restu' ),							

					'0.6' => esc_html__( 'point 6s', 'restu' ),							

					'0.7' => esc_html__( 'point 7s', 'restu' ),							

					'0.8' => esc_html__( 'point 8s', 'restu' ),							

					'0.9' => esc_html__( 'point 9s', 'restu' ),							

					'1.2' => esc_html__( '1 point 2s', 'restu' ),							

					'1.3' => esc_html__( '1 point 3s', 'restu' ),							

					'1.4' => esc_html__( '1 point 4s', 'restu' ),							

					'1.5' => esc_html__( '1 point 5s', 'restu' ),							

					'1.8' => esc_html__( '1 point 8s', 'restu' ),							

					'2' => esc_html__( '2s', 'restu' ),							

					'2.2' => esc_html__( '2 point 2s', 'restu' ),							

					'2.3' => esc_html__( '2 point 5s', 'restu' ),							

					'3' => esc_html__( '3s', 'restu' ),							

				),

				'default' =>'2',

			) );

			$slider->add_field( array(

				'name'    => esc_html__('Title Animate Delay','restu'),

				'id'      => $prefix . 'em_dealy_title',

				'show_option_none' => false,					

				'type'    => 'select',

				'options' => array(

					'0' => esc_html__( 'point 0s', 'restu' ),							

					'0.1' => esc_html__( 'point 1s', 'restu' ),							

					'0.2' => esc_html__( 'point 2s', 'restu' ),							

					'0.3' => esc_html__( 'point 3s', 'restu' ),							

					'0.4' => esc_html__( 'point 4s', 'restu' ),							

					'0.5' => esc_html__( 'point 5s', 'restu' ),							

					'0.6' => esc_html__( 'point 6s', 'restu' ),							

					'0.7' => esc_html__( 'point 7s', 'restu' ),							

					'0.8' => esc_html__( 'point 8s', 'restu' ),							

					'0.9' => esc_html__( 'point 9s', 'restu' ),							

					'1.2' => esc_html__( '1 point 2s', 'restu' ),							

					'1.3' => esc_html__( '1 point 3s', 'restu' ),							

					'1.4' => esc_html__( '1 point 4s', 'restu' ),							

					'1.5' => esc_html__( '1 point 5s', 'restu' ),							

					'1.8' => esc_html__( '1 point 8s', 'restu' ),							

					'2' => esc_html__( '2s', 'restu' ),							

					'2.2' => esc_html__( '2 point 2s', 'restu' ),							

					'2.3' => esc_html__( '2 point 5s', 'restu' ),							

					'3' => esc_html__( '3s', 'restu' ),							

				),

				'default' =>'0',

			) );		



		

		

		

			

			$slider->add_field( array(

				'name'       => esc_html__( 'Sub Title', 'restu' ),

				'desc'       => esc_html__( 'insert sub-title here. for highlight text use <span> ex-<span>website</span>', 'restu' ),

				'id'         => $prefix . 'em_slide_subtitle',

				'type'       => 'textarea_small',

			) );

			$slider->add_field( array(

				'name'    => esc_html__('Sub Title Animate','restu'),

				'id'      => $prefix . 'em_aimate_subtitle',

				'show_option_none' => true,					

				'type'    => 'select',

				'options' => array(

					'bounceIn' => esc_html__( 'bounceIn', 'restu' ),				

					'bounceInDown' => esc_html__( 'bounceInDown', 'restu' ),				

					'bounceInLeft' => esc_html__( 'bounceInLeft', 'restu' ),				

					'bounceInRight' => esc_html__( 'bounceInRight', 'restu' ),				

					'bounceInUp' => esc_html__( 'bounceInUp', 'restu' ),				

					'fadeIn' => esc_html__( 'fadeIn', 'restu' ),				

					'fadeInDown' => esc_html__( 'fadeInDown', 'restu' ),				

					'fadeInDownBig' => esc_html__( 'fadeInDownBig', 'restu' ),				

					'fadeInLeft' => esc_html__( 'fadeInLeft', 'restu' ),				

					'fadeInLeftBig' => esc_html__( 'fadeInLeftBig', 'restu' ),				

					'fadeInRight' => esc_html__( 'fadeInRight', 'restu' ),				

					'fadeInRightBig' => esc_html__( 'fadeInRightBig', 'restu' ),				

					'fadeInUp' => esc_html__( 'fadeInUp', 'restu' ),				

					'fadeInUpBig' => esc_html__( 'fadeInUpBig', 'restu' ),				

					'rotateIn' => esc_html__( 'rotateIn', 'restu' ),				

					'rotateInDownLeft' => esc_html__( 'rotateInDownLeft', 'restu' ),				

					'rotateInDownRight' => esc_html__( 'rotateInDownRight', 'restu' ),				

					'rotateInUpLeft' => esc_html__( 'rotateInUpLeft', 'restu' ),				

					'rotateInUpRight' => esc_html__( 'rotateInUpRight', 'restu' ),				

					'rollIn' => esc_html__( 'rollIn', 'restu' ),				

					'zoomIn' => esc_html__( 'zoomIn', 'restu' ),				

					'zoomInDown' => esc_html__( 'zoomInDown', 'restu' ),				

					'zoomInLeft' => esc_html__( 'zoomInLeft', 'restu' ),				

					'zoomInRight' => esc_html__( 'zoomInRight', 'restu' ),				

					'zoomInUp' => esc_html__( 'zoomInUp', 'restu' ),				

					'slideInDown' => esc_html__( 'slideInDown', 'restu' ),				

					'slideInLeft' => esc_html__( 'slideInLeft', 'restu' ),				

					'slideInRight' => esc_html__( 'slideInRight', 'restu' ),				

					'slideInUp' => esc_html__( 'slideInUp', 'restu' ),				

				),

				'default' =>'slideInRight',

			) );

			



			$slider->add_field( array(

				'name'    => esc_html__('Sub Title Animate Duration','restu'),

				'id'      => $prefix . 'em_durations_subtitle',

				'show_option_none' => false,					

				'type'    => 'select',

				'options' => array(

					'0.1' => esc_html__( 'point 1s', 'restu' ),							

					'0.2' => esc_html__( 'point 2s', 'restu' ),							

					'0.3' => esc_html__( 'point 3s', 'restu' ),							

					'0.4' => esc_html__( 'point 4s', 'restu' ),							

					'0.5' => esc_html__( 'point 5s', 'restu' ),							

					'0.6' => esc_html__( 'point 6s', 'restu' ),							

					'0.7' => esc_html__( 'point 7s', 'restu' ),							

					'0.8' => esc_html__( 'point 8s', 'restu' ),							

					'0.9' => esc_html__( 'point 9s', 'restu' ),							

					'1.2' => esc_html__( '1 point 2s', 'restu' ),							

					'1.3' => esc_html__( '1 point 3s', 'restu' ),							

					'1.4' => esc_html__( '1 point 4s', 'restu' ),							

					'1.5' => esc_html__( '1 point 5s', 'restu' ),							

					'1.8' => esc_html__( '1 point 8s', 'restu' ),							

					'2' => esc_html__( '2s', 'restu' ),							

					'2.2' => esc_html__( '2 point 2s', 'restu' ),							

					'2.3' => esc_html__( '2 point 5s', 'restu' ),							

					'3' => esc_html__( '3s', 'restu' ),							

				),

				'default' =>'2',

			) );

			$slider->add_field( array(

				'name'    => esc_html__('Sub Title Animate Delay','restu'),

				'id'      => $prefix . 'em_dealy_subtitle',

				'show_option_none' => false,					

				'type'    => 'select',

				'options' => array(

					'0' => esc_html__( 'point 0s', 'restu' ),							

					'0.1' => esc_html__( 'point 1s', 'restu' ),							

					'0.2' => esc_html__( 'point 2s', 'restu' ),							

					'0.3' => esc_html__( 'point 3s', 'restu' ),							

					'0.4' => esc_html__( 'point 4s', 'restu' ),							

					'0.5' => esc_html__( 'point 5s', 'restu' ),							

					'0.6' => esc_html__( 'point 6s', 'restu' ),							

					'0.7' => esc_html__( 'point 7s', 'restu' ),							

					'0.8' => esc_html__( 'point 8s', 'restu' ),							

					'0.9' => esc_html__( 'point 9s', 'restu' ),							

					'1.2' => esc_html__( '1 point 2s', 'restu' ),							

					'1.3' => esc_html__( '1 point 3s', 'restu' ),							

					'1.4' => esc_html__( '1 point 4s', 'restu' ),							

					'1.5' => esc_html__( '1 point 5s', 'restu' ),							

					'1.8' => esc_html__( '1 point 8s', 'restu' ),							

					'2' => esc_html__( '2s', 'restu' ),							

					'2.2' => esc_html__( '2 point 2s', 'restu' ),							

					'2.3' => esc_html__( '2 point 5s', 'restu' ),							

					'3' => esc_html__( '3s', 'restu' ),							

				),

				'default' =>'0',

			) );				

			$slider->add_field( array(

				'name'       => esc_html__( 'Content', 'restu' ),

				'desc'       => esc_html__( 'insert content here', 'restu' ),

				'id'         => $prefix . 'em_slide_textarea',

				'type'       => 'textarea',

			) );

			$slider->add_field( array(

				'name'    => esc_html__('Content Animate','restu'),

				'id'      => $prefix . 'em_aimate_content',

				'show_option_none' => true,					

				'type'    => 'select',

				'options' => array(

					'bounceIn' => esc_html__( 'bounceIn', 'restu' ),				

					'bounceInDown' => esc_html__( 'bounceInDown', 'restu' ),				

					'bounceInLeft' => esc_html__( 'bounceInLeft', 'restu' ),				

					'bounceInRight' => esc_html__( 'bounceInRight', 'restu' ),				

					'bounceInUp' => esc_html__( 'bounceInUp', 'restu' ),				

					'fadeIn' => esc_html__( 'fadeIn', 'restu' ),				

					'fadeInDown' => esc_html__( 'fadeInDown', 'restu' ),				

					'fadeInDownBig' => esc_html__( 'fadeInDownBig', 'restu' ),				

					'fadeInLeft' => esc_html__( 'fadeInLeft', 'restu' ),				

					'fadeInLeftBig' => esc_html__( 'fadeInLeftBig', 'restu' ),				

					'fadeInRight' => esc_html__( 'fadeInRight', 'restu' ),				

					'fadeInRightBig' => esc_html__( 'fadeInRightBig', 'restu' ),				

					'fadeInUp' => esc_html__( 'fadeInUp', 'restu' ),				

					'fadeInUpBig' => esc_html__( 'fadeInUpBig', 'restu' ),				

					'rotateIn' => esc_html__( 'rotateIn', 'restu' ),				

					'rotateInDownLeft' => esc_html__( 'rotateInDownLeft', 'restu' ),				

					'rotateInDownRight' => esc_html__( 'rotateInDownRight', 'restu' ),				

					'rotateInUpLeft' => esc_html__( 'rotateInUpLeft', 'restu' ),				

					'rotateInUpRight' => esc_html__( 'rotateInUpRight', 'restu' ),				

					'rollIn' => esc_html__( 'rollIn', 'restu' ),				

					'zoomIn' => esc_html__( 'zoomIn', 'restu' ),				

					'zoomInDown' => esc_html__( 'zoomInDown', 'restu' ),				

					'zoomInLeft' => esc_html__( 'zoomInLeft', 'restu' ),				

					'zoomInRight' => esc_html__( 'zoomInRight', 'restu' ),				

					'zoomInUp' => esc_html__( 'zoomInUp', 'restu' ),				

					'slideInDown' => esc_html__( 'slideInDown', 'restu' ),				

					'slideInLeft' => esc_html__( 'slideInLeft', 'restu' ),				

					'slideInRight' => esc_html__( 'slideInRight', 'restu' ),				

					'slideInUp' => esc_html__( 'slideInUp', 'restu' ),				

				),

				'default' =>'slideInRight',

			) );

			



			$slider->add_field( array(

				'name'    => esc_html__('Content Animate Duration','restu'),

				'id'      => $prefix . 'em_durations_content',

				'show_option_none' => false,					

				'type'    => 'select',

				'options' => array(

					'0.1' => esc_html__( 'point 1s', 'restu' ),							

					'0.2' => esc_html__( 'point 2s', 'restu' ),							

					'0.3' => esc_html__( 'point 3s', 'restu' ),							

					'0.4' => esc_html__( 'point 4s', 'restu' ),							

					'0.5' => esc_html__( 'point 5s', 'restu' ),							

					'0.6' => esc_html__( 'point 6s', 'restu' ),							

					'0.7' => esc_html__( 'point 7s', 'restu' ),							

					'0.8' => esc_html__( 'point 8s', 'restu' ),							

					'0.9' => esc_html__( 'point 9s', 'restu' ),							

					'1.2' => esc_html__( '1 point 2s', 'restu' ),							

					'1.3' => esc_html__( '1 point 3s', 'restu' ),							

					'1.4' => esc_html__( '1 point 4s', 'restu' ),							

					'1.5' => esc_html__( '1 point 5s', 'restu' ),							

					'1.8' => esc_html__( '1 point 8s', 'restu' ),							

					'2' => esc_html__( '2s', 'restu' ),							

					'2.2' => esc_html__( '2 point 2s', 'restu' ),							

					'2.3' => esc_html__( '2 point 5s', 'restu' ),							

					'3' => esc_html__( '3s', 'restu' ),							

				),

				'default' =>'3',

			) );

			$slider->add_field( array(

				'name'    => esc_html__('Content Animate Delay','restu'),

				'id'      => $prefix . 'em_dealy_content',

				'show_option_none' => false,					

				'type'    => 'select',

				'options' => array(

					'0' => esc_html__( 'point 0s', 'restu' ),							

					'0.1' => esc_html__( 'point 1s', 'restu' ),							

					'0.2' => esc_html__( 'point 2s', 'restu' ),							

					'0.3' => esc_html__( 'point 3s', 'restu' ),							

					'0.4' => esc_html__( 'point 4s', 'restu' ),							

					'0.5' => esc_html__( 'point 5s', 'restu' ),							

					'0.6' => esc_html__( 'point 6s', 'restu' ),							

					'0.7' => esc_html__( 'point 7s', 'restu' ),							

					'0.8' => esc_html__( 'point 8s', 'restu' ),							

					'0.9' => esc_html__( 'point 9s', 'restu' ),							

					'1.2' => esc_html__( '1 point 2s', 'restu' ),							

					'1.3' => esc_html__( '1 point 3s', 'restu' ),							

					'1.4' => esc_html__( '1 point 4s', 'restu' ),							

					'1.5' => esc_html__( '1 point 5s', 'restu' ),							

					'1.8' => esc_html__( '1 point 8s', 'restu' ),							

					'2' => esc_html__( '2s', 'restu' ),							

					'2.2' => esc_html__( '2 point 2s', 'restu' ),							

					'2.3' => esc_html__( '2 point 5s', 'restu' ),							

					'3' => esc_html__( '3s', 'restu' ),							

				),

				'default' =>'0',

			) );				

			

			$slider->add_field( array(

				'name'       => esc_html__( 'Button Text 1', 'restu' ),

				'desc'       => esc_html__( 'insert button text here', 'restu' ),

				'id'         => $prefix . 'em_slide_btn1',

				'type'       => 'text',

			) );

			$slider->add_field( array(

				'name'       => esc_html__( 'Slide Image', 'restu' ),

				'desc'       => esc_html__( 'insert single slide image here', 'restu' ),

				'id'         => $prefix . 'em_slide_img',

				'type'       => 'file',

			) );

			$slider->add_field( array(

				'name'    => esc_html__('Image Animate','restu'),

				'id'      => $prefix . 'em_aimate_image',

				'show_option_none' => true,					

				'type'    => 'select',

				'options' => array(

					'bounceIn' => esc_html__( 'bounceIn', 'restu' ),				

					'bounceInDown' => esc_html__( 'bounceInDown', 'restu' ),				

					'bounceInLeft' => esc_html__( 'bounceInLeft', 'restu' ),				

					'bounceInRight' => esc_html__( 'bounceInRight', 'restu' ),				

					'bounceInUp' => esc_html__( 'bounceInUp', 'restu' ),				

					'fadeIn' => esc_html__( 'fadeIn', 'restu' ),				

					'fadeInDown' => esc_html__( 'fadeInDown', 'restu' ),				

					'fadeInDownBig' => esc_html__( 'fadeInDownBig', 'restu' ),				

					'fadeInLeft' => esc_html__( 'fadeInLeft', 'restu' ),				

					'fadeInLeftBig' => esc_html__( 'fadeInLeftBig', 'restu' ),				

					'fadeInRight' => esc_html__( 'fadeInRight', 'restu' ),				

					'fadeInRightBig' => esc_html__( 'fadeInRightBig', 'restu' ),				

					'fadeInUp' => esc_html__( 'fadeInUp', 'restu' ),				

					'fadeInUpBig' => esc_html__( 'fadeInUpBig', 'restu' ),				

					'rotateIn' => esc_html__( 'rotateIn', 'restu' ),				

					'rotateInDownLeft' => esc_html__( 'rotateInDownLeft', 'restu' ),				

					'rotateInDownRight' => esc_html__( 'rotateInDownRight', 'restu' ),				

					'rotateInUpLeft' => esc_html__( 'rotateInUpLeft', 'restu' ),				

					'rotateInUpRight' => esc_html__( 'rotateInUpRight', 'restu' ),				

					'rollIn' => esc_html__( 'rollIn', 'restu' ),				

					'zoomIn' => esc_html__( 'zoomIn', 'restu' ),				

					'zoomInDown' => esc_html__( 'zoomInDown', 'restu' ),				

					'zoomInLeft' => esc_html__( 'zoomInLeft', 'restu' ),				

					'zoomInRight' => esc_html__( 'zoomInRight', 'restu' ),				

					'zoomInUp' => esc_html__( 'zoomInUp', 'restu' ),				

					'slideInDown' => esc_html__( 'slideInDown', 'restu' ),				

					'slideInLeft' => esc_html__( 'slideInLeft', 'restu' ),				

					'slideInRight' => esc_html__( 'slideInRight', 'restu' ),				

					'slideInUp' => esc_html__( 'slideInUp', 'restu' ),				

				),

				'default' =>'slideInRight',

			) );

			



			$slider->add_field( array(

				'name'    => esc_html__('Image Animate Duration','restu'),

				'id'      => $prefix . 'em_durations_image',

				'show_option_none' => false,					

				'type'    => 'select',

				'options' => array(

					'0.1' => esc_html__( 'point 1s', 'restu' ),							

					'0.2' => esc_html__( 'point 2s', 'restu' ),							

					'0.3' => esc_html__( 'point 3s', 'restu' ),							

					'0.4' => esc_html__( 'point 4s', 'restu' ),							

					'0.5' => esc_html__( 'point 5s', 'restu' ),							

					'0.6' => esc_html__( 'point 6s', 'restu' ),							

					'0.7' => esc_html__( 'point 7s', 'restu' ),							

					'0.8' => esc_html__( 'point 8s', 'restu' ),							

					'0.9' => esc_html__( 'point 9s', 'restu' ),							

					'1.2' => esc_html__( '1 point 2s', 'restu' ),							

					'1.3' => esc_html__( '1 point 3s', 'restu' ),							

					'1.4' => esc_html__( '1 point 4s', 'restu' ),							

					'1.5' => esc_html__( '1 point 5s', 'restu' ),							

					'1.8' => esc_html__( '1 point 8s', 'restu' ),							

					'2' => esc_html__( '2s', 'restu' ),							

					'2.2' => esc_html__( '2 point 2s', 'restu' ),							

					'2.3' => esc_html__( '2 point 5s', 'restu' ),							

					'3' => esc_html__( '3s', 'restu' ),							

				),

				'default' =>'2',

			) );

			$slider->add_field( array(

				'name'    => esc_html__('Image Animate Delay','restu'),

				'id'      => $prefix . 'em_dealy_image',

				'show_option_none' => false,					

				'type'    => 'select',

				'options' => array(

					'0' => esc_html__( 'point 0s', 'restu' ),							

					'0.1' => esc_html__( 'point 1s', 'restu' ),							

					'0.2' => esc_html__( 'point 2s', 'restu' ),							

					'0.3' => esc_html__( 'point 3s', 'restu' ),							

					'0.4' => esc_html__( 'point 4s', 'restu' ),							

					'0.5' => esc_html__( 'point 5s', 'restu' ),							

					'0.6' => esc_html__( 'point 6s', 'restu' ),							

					'0.7' => esc_html__( 'point 7s', 'restu' ),							

					'0.8' => esc_html__( 'point 8s', 'restu' ),							

					'0.9' => esc_html__( 'point 9s', 'restu' ),							

					'1.2' => esc_html__( '1 point 2s', 'restu' ),							

					'1.3' => esc_html__( '1 point 3s', 'restu' ),							

					'1.4' => esc_html__( '1 point 4s', 'restu' ),							

					'1.5' => esc_html__( '1 point 5s', 'restu' ),							

					'1.8' => esc_html__( '1 point 8s', 'restu' ),							

					'2' => esc_html__( '2s', 'restu' ),							

					'2.2' => esc_html__( '2 point 2s', 'restu' ),							

					'2.3' => esc_html__( '2 point 5s', 'restu' ),							

					'3' => esc_html__( '3s', 'restu' ),							

				),

				'default' =>'0',

			) );		



			

			

			$slider->add_field( array(

				'name'       => esc_html__( 'Button url 1', 'restu' ),

				'desc'       => esc_html__( 'insert button text url here', 'restu' ),

				'id'         => $prefix . 'em_slide_btn1utl',

				'type'       => 'text_url',

			) );			

			$slider->add_field( array(

				'name'       => esc_html__( 'Button Text 2', 'restu' ),

				'desc'       => esc_html__( 'insert button text here', 'restu' ),

				'id'         => $prefix . 'em_slide_btn2',

				'type'       => 'text',

			) );

			$slider->add_field( array(

				'name'       => esc_html__( 'Button url 2', 'restu' ),

				'desc'       => esc_html__( 'insert button text url here', 'restu' ),

				'id'         => $prefix . 'em_slide_btn2url',

				'type'       => 'text_url',

			) );

			$slider->add_field( array(

				'name'    => esc_html__('Button Animate','restu'),

				'id'      => $prefix . 'em_aimate_btn',

				'show_option_none' => true,					

				'type'    => 'select',

				'options' => array(

					'bounceIn' => esc_html__( 'bounceIn', 'restu' ),				

					'bounceInDown' => esc_html__( 'bounceInDown', 'restu' ),				

					'bounceInLeft' => esc_html__( 'bounceInLeft', 'restu' ),				

					'bounceInRight' => esc_html__( 'bounceInRight', 'restu' ),				

					'bounceInUp' => esc_html__( 'bounceInUp', 'restu' ),				

					'fadeIn' => esc_html__( 'fadeIn', 'restu' ),				

					'fadeInDown' => esc_html__( 'fadeInDown', 'restu' ),				

					'fadeInDownBig' => esc_html__( 'fadeInDownBig', 'restu' ),				

					'fadeInLeft' => esc_html__( 'fadeInLeft', 'restu' ),				

					'fadeInLeftBig' => esc_html__( 'fadeInLeftBig', 'restu' ),				

					'fadeInRight' => esc_html__( 'fadeInRight', 'restu' ),				

					'fadeInRightBig' => esc_html__( 'fadeInRightBig', 'restu' ),				

					'fadeInUp' => esc_html__( 'fadeInUp', 'restu' ),				

					'fadeInUpBig' => esc_html__( 'fadeInUpBig', 'restu' ),				

					'rotateIn' => esc_html__( 'rotateIn', 'restu' ),				

					'rotateInDownLeft' => esc_html__( 'rotateInDownLeft', 'restu' ),				

					'rotateInDownRight' => esc_html__( 'rotateInDownRight', 'restu' ),				

					'rotateInUpLeft' => esc_html__( 'rotateInUpLeft', 'restu' ),				

					'rotateInUpRight' => esc_html__( 'rotateInUpRight', 'restu' ),				

					'rollIn' => esc_html__( 'rollIn', 'restu' ),				

					'zoomIn' => esc_html__( 'zoomIn', 'restu' ),				

					'zoomInDown' => esc_html__( 'zoomInDown', 'restu' ),				

					'zoomInLeft' => esc_html__( 'zoomInLeft', 'restu' ),				

					'zoomInRight' => esc_html__( 'zoomInRight', 'restu' ),				

					'zoomInUp' => esc_html__( 'zoomInUp', 'restu' ),				

					'slideInDown' => esc_html__( 'slideInDown', 'restu' ),				

					'slideInLeft' => esc_html__( 'slideInLeft', 'restu' ),				

					'slideInRight' => esc_html__( 'slideInRight', 'restu' ),				

					'slideInUp' => esc_html__( 'slideInUp', 'restu' ),				

				),

				'default' =>'bounceInUp',

			) );

			



			$slider->add_field( array(

				'name'    => esc_html__('Button Animate Duration','restu'),

				'id'      => $prefix . 'em_durations_btn',

				'show_option_none' => false,					

				'type'    => 'select',

				'options' => array(

					'0.1' => esc_html__( 'point 1s', 'restu' ),							

					'0.2' => esc_html__( 'point 2s', 'restu' ),							

					'0.3' => esc_html__( 'point 3s', 'restu' ),							

					'0.4' => esc_html__( 'point 4s', 'restu' ),							

					'0.5' => esc_html__( 'point 5s', 'restu' ),							

					'0.6' => esc_html__( 'point 6s', 'restu' ),							

					'0.7' => esc_html__( 'point 7s', 'restu' ),							

					'0.8' => esc_html__( 'point 8s', 'restu' ),							

					'0.9' => esc_html__( 'point 9s', 'restu' ),							

					'1.2' => esc_html__( '1 point 2s', 'restu' ),							

					'1.3' => esc_html__( '1 point 3s', 'restu' ),							

					'1.4' => esc_html__( '1 point 4s', 'restu' ),							

					'1.5' => esc_html__( '1 point 5s', 'restu' ),							

					'1.8' => esc_html__( '1 point 8s', 'restu' ),							

					'2' => esc_html__( '2s', 'restu' ),							

					'2.2' => esc_html__( '2 point 2s', 'restu' ),							

					'2.3' => esc_html__( '2 point 5s', 'restu' ),							

					'3' => esc_html__( '3s', 'restu' ),							

				),

				'default' =>'3',

			) );

			$slider->add_field( array(

				'name'    => esc_html__('Button Animate Delay','restu'),

				'id'      => $prefix . 'em_dealy_btn',

				'show_option_none' => true,					

				'type'    => 'select',

				'options' => array(

					'0' => esc_html__( 'point 0s', 'restu' ),							

					'0.1' => esc_html__( 'point 1s', 'restu' ),							

					'0.2' => esc_html__( 'point 2s', 'restu' ),							

					'0.3' => esc_html__( 'point 3s', 'restu' ),							

					'0.4' => esc_html__( 'point 4s', 'restu' ),							

					'0.5' => esc_html__( 'point 5s', 'restu' ),							

					'0.6' => esc_html__( 'point 6s', 'restu' ),							

					'0.7' => esc_html__( 'point 7s', 'restu' ),							

					'0.8' => esc_html__( 'point 8s', 'restu' ),							

					'0.9' => esc_html__( 'point 9s', 'restu' ),							

					'1.2' => esc_html__( '1 point 2s', 'restu' ),							

					'1.3' => esc_html__( '1 point 3s', 'restu' ),							

					'1.4' => esc_html__( '1 point 4s', 'restu' ),							

					'1.5' => esc_html__( '1 point 5s', 'restu' ),							

					'1.8' => esc_html__( '1 point 8s', 'restu' ),							

					'2' => esc_html__( '2s', 'restu' ),							

					'2.2' => esc_html__( '2 point 2s', 'restu' ),							

					'2.3' => esc_html__( '2 point 5s', 'restu' ),							

					'3' => esc_html__( '3s', 'restu' ),							

				),

				'default' =>'1',

			) );				

			$slider->add_field( array(

				'name'    => esc_html__('Text Alignment Style','restu'),

				'id'      => $prefix . 'em_slider_posi',

				'show_option_none' => true,					

				'type'    => 'select',

				'options' => array(

					'' => esc_html__( 'Select alignment', 'restu' ),

					'text-left' => esc_html__( 'Left Alignment', 'restu' ),

					'text-center' => esc_html__( 'Center Alignment', 'restu' ),

					'text-right' => esc_html__( 'Right Alignment', 'restu' ),

				),

				'default' =>'text-center',

			) );				

			$slider->add_field( array(

				'name'       => esc_html__( 'More Sliders Option, Please see slider widget area', 'restu' ),

				'id'         => $prefix . 'title_heading_line',

				'type'       => 'title',

			) );				

	

			

	}

}





