<?php

add_action('init', 'restu_post_type');


/*

**	Setting up custom post types

*/ 



if ( !function_exists('restu_post_type') ) {

	function restu_post_type() {
		$post_types_fields = array(

            array(

                'slug'                  => 'restu-room',

                'singular'              => __( 'Restu Room', 'restu' ),

                'plural'                => __( 'Restu Rooms', 'restu' ),

                'menu_name'             => __( 'Restu Rooms', 'restu' ),

                'description'           => __( 'Restu Rooms', 'restu' ),

                'has_archive'           => true,

                'hierarchical'          => false,

                'menu_icon'             => 'dashicons-tag',

                'rewrite' => array(

                    'slug'                  => 'restu-room',

                    'with_front'            => true,

                    'pages'                 => true,

                    'feeds'                 => true,

                    'ep_mask'               => EP_PERMALINK,

                ),

                'menu_position'         => 21,

                'public'                => true,

                'publicly_queryable'    => true,

                'exclude_from_search'   => true,

                'show_ui'               => true,

                'show_in_menu'          => true,

                'query_var'             => true,

                'show_in_admin_bar'     => true,

                'show_in_nav_menus'     => true,

                'supports'              => array(

                    'title',

                    'editor',

                    'excerpt',

                    'author',

                    'thumbnail',

                    'comments',

                    'trackbacks',

                    'custom-fields',

                    'revisions',

                    'page-attributes'

                ),

                'custom_caps'           => true,

                'custom_caps_users'     => array(

                    'administrator'

                ),

                'taxonomies'            => array(

                    array(

                        'taxonomy'          => 'appointy_room_type',

                        'plural'            => __( 'Room Types', 'restu' ),

                        'single'            => __( 'Room Type', 'restu' ),

						'hierarchical' 		=> false,

                        'post_types'        => array( 'restu-room' ),

                    ),

					array(

                        'taxonomy'          => 'appointy_room_services',

                        'plural'            => __( 'Extra Services', 'restu' ),

                        'single'            => __( 'Extra Service', 'restu' ),

						'hierarchical' 		=> false,

                        'post_types'        => array('restu-room' ),

                    ),

                ),

            )

        );



        foreach ( $post_types_fields as $fields ) {

			restu_register_single_post_type( $fields );

        }
	}

}

if ( !function_exists('restu_register_single_post_type') ) {

	function restu_register_single_post_type( $fields ) {



        $labels = array(

            'name'                  => $fields['plural'],

            'singular_name'         => $fields['singular'],

            'menu_name'             => $fields['menu_name'],

            'new_item'              => sprintf( __( 'New %s', 'restu' ), $fields['singular'] ),

            'add_new_item'          => sprintf( __( 'Add new %s', 'restu' ), $fields['singular'] ),

            'edit_item'             => sprintf( __( 'Edit %s', 'restu' ), $fields['singular'] ),

            'view_item'             => sprintf( __( 'View %s', 'restu' ), $fields['singular'] ),

            'view_items'            => sprintf( __( 'View %s', 'restu' ), $fields['plural'] ),

            'search_items'          => sprintf( __( 'Search %s', 'restu' ), $fields['plural'] ),

            'not_found'             => sprintf( __( 'No %s found', 'restu' ), strtolower( $fields['plural'] ) ),

            'not_found_in_trash'    => sprintf( __( 'No %s found in trash', 'restu' ), strtolower( $fields['plural'] ) ),

            'all_items'             => sprintf( __( 'All %s', 'restu' ), $fields['plural'] ),

            'archives'              => sprintf( __( '%s Archives', 'restu' ), $fields['singular'] ),

            'attributes'            => sprintf( __( '%s Attributes', 'restu' ), $fields['singular'] ),

            'insert_into_item'      => sprintf( __( 'Insert into %s', 'restu' ), strtolower( $fields['singular'] ) ),

            'uploaded_to_this_item' => sprintf( __( 'Uploaded to this %s', 'restu' ), strtolower( $fields['singular'] ) ),

            'parent_item'           => sprintf( __( 'Parent %s', 'restu' ), $fields['singular'] ),

            'parent_item_colon'     => sprintf( __( 'Parent %s:', 'restu' ), $fields['singular'] ),

			'archive_title'        => $fields['plural'],

        );



        $args = array(

            'labels'             => $labels,

            'description'        => ( isset( $fields['description'] ) ) ? $fields['description'] : '',

            'public'             => ( isset( $fields['public'] ) ) ? $fields['public'] : true,

            'publicly_queryable' => ( isset( $fields['publicly_queryable'] ) ) ? $fields['publicly_queryable'] : true,

            'exclude_from_search'=> ( isset( $fields['exclude_from_search'] ) ) ? $fields['exclude_from_search'] : false,

            'show_ui'            => ( isset( $fields['show_ui'] ) ) ? $fields['show_ui'] : true,

            'show_in_menu'       => ( isset( $fields['show_in_menu'] ) ) ? $fields['show_in_menu'] : true,

            'query_var'          => ( isset( $fields['query_var'] ) ) ? $fields['query_var'] : true,

            'show_in_admin_bar'  => ( isset( $fields['show_in_admin_bar'] ) ) ? $fields['show_in_admin_bar'] : true,

            'capability_type'    => ( isset( $fields['capability_type'] ) ) ? $fields['capability_type'] : 'post',

            'has_archive'        => ( isset( $fields['has_archive'] ) ) ? $fields['has_archive'] : true,

            'hierarchical'       => ( isset( $fields['hierarchical'] ) ) ? $fields['hierarchical'] : true,

            'supports'           => ( isset( $fields['supports'] ) ) ? $fields['supports'] : array(

                    'title',

                    'editor',

                    'excerpt',

                    'author',

                    'thumbnail',

                    'comments',

                    'trackbacks',

                    'custom-fields',

                    'revisions',

                    'page-attributes',

                    'post-formats',

            ),

            'menu_position'      => ( isset( $fields['menu_position'] ) ) ? $fields['menu_position'] : 21,

            'menu_icon'          => ( isset( $fields['menu_icon'] ) ) ? $fields['menu_icon']: 'dashicons-admin-generic',

            'show_in_nav_menus'  => ( isset( $fields['show_in_nav_menus'] ) ) ? $fields['show_in_nav_menus'] : true,

            'show_in_rest'       => ( isset( $fields['show_in_rest'] ) ) ? $fields['show_in_rest'] : true,

        );



        if ( isset( $fields['rewrite'] ) ) {



            $args['rewrite'] = $fields['rewrite'];

        }



        if ( $fields['custom_caps'] ) {



            $args['capabilities'] = array(

                // Meta capabilities

                'edit_post'                 => 'edit_' . strtolower( $fields['singular'] ),

                'read_post'                 => 'read_' . strtolower( $fields['singular'] ),

                'delete_post'               => 'delete_' . strtolower( $fields['singular'] ),

                // Primitive capabilities used outside of map_meta_cap():

                'edit_posts'                => 'edit_' . strtolower( $fields['plural'] ),

                'edit_others_posts'         => 'edit_others_' . strtolower( $fields['plural'] ),

                'publish_posts'             => 'publish_' . strtolower( $fields['plural'] ),

                'read_private_posts'        => 'read_private_' . strtolower( $fields['plural'] ),

                // Primitive capabilities used within map_meta_cap():

                'delete_posts'              => 'delete_' . strtolower( $fields['plural'] ),

                'delete_private_posts'      => 'delete_private_' . strtolower( $fields['plural'] ),

                'delete_published_posts'    => 'delete_published_' . strtolower( $fields['plural'] ),

                'delete_others_posts'       => 'delete_others_' . strtolower( $fields['plural'] ),

                'edit_private_posts'        => 'edit_private_' . strtolower( $fields['plural'] ),

                'edit_published_posts'      => 'edit_published_' . strtolower( $fields['plural'] ),

                'create_posts'              => 'edit_' . strtolower( $fields['plural'] )

            );



            /**

             * Adding map_meta_cap will map the meta correctly.

             * @link https://wordpress.stackexchange.com/questions/108338/capabilities-and-custom-post-types/108375#108375

             */

            //$args['map_meta_cap'] = true;



            /**

             * Assign capabilities to users

             * Without this, users - also admins - can not see post type.

             */

            restu_assign_capabilities( $args['capabilities'], $fields['custom_caps_users'] );

        }





        /**

         * Register Taxnonmies if any

         */

        if ( isset( $fields['taxonomies'] ) && is_array( $fields['taxonomies'] ) ) {



            foreach ( $fields['taxonomies'] as $taxonomy ) {



                restu_register_single_post_type_taxnonomy( $taxonomy );



            }



        }

	    

		register_post_type( $fields['slug'], $args );



    }

}

if ( !function_exists('restu_register_single_post_type_taxnonomy') ) {

	function restu_register_single_post_type_taxnonomy( $tax_fields ) {

        $labels = array(

            'name'                       => $tax_fields['plural'],

            'singular_name'              => $tax_fields['single'],

            'menu_name'                  => $tax_fields['plural'],

            'all_items'                  => sprintf( __( 'All %s' , 'restu' ), $tax_fields['plural'] ),

            'edit_item'                  => sprintf( __( 'Edit %s' , 'restu' ), $tax_fields['single'] ),

            'view_item'                  => sprintf( __( 'View %s' , 'restu' ), $tax_fields['single'] ),

            'update_item'                => sprintf( __( 'Update %s' , 'restu' ), $tax_fields['single'] ),

            'add_new_item'               => sprintf( __( 'Add New %s' , 'restu' ), $tax_fields['single'] ),

            'new_item_name'              => sprintf( __( 'New %s Name' , 'restu' ), $tax_fields['single'] ),

            'parent_item'                => sprintf( __( 'Parent %s' , 'restu' ), $tax_fields['single'] ),

            'parent_item_colon'          => sprintf( __( 'Parent %s:' , 'restu' ), $tax_fields['single'] ),

            'search_items'               => sprintf( __( 'Search %s' , 'restu' ), $tax_fields['plural'] ),

            'popular_items'              => sprintf( __( 'Popular %s' , 'restu' ), $tax_fields['plural'] ),

            'separate_items_with_commas' => sprintf( __( 'Separate %s with commas' , 'restu' ), $tax_fields['plural'] ),

            'add_or_remove_items'        => sprintf( __( 'Add or remove %s' , 'restu' ), $tax_fields['plural'] ),

            'choose_from_most_used'      => sprintf( __( 'Choose from the most used %s' , 'restu' ), $tax_fields['plural'] ),

            'not_found'                  => sprintf( __( 'No %s found' , 'restu' ), $tax_fields['plural'] ),

        );



        $args = array(

        	'label'                 => $tax_fields['plural'],

        	'labels'                => $labels,

        	'hierarchical'          => ( isset( $tax_fields['hierarchical'] ) )          ? $tax_fields['hierarchical']          : true,

        	'public'                => ( isset( $tax_fields['public'] ) )                ? $tax_fields['public']                : true,

        	'show_ui'               => ( isset( $tax_fields['show_ui'] ) )               ? $tax_fields['show_ui']               : true,

        	'show_in_nav_menus'     => ( isset( $tax_fields['show_in_nav_menus'] ) )     ? $tax_fields['show_in_nav_menus']     : true,

        	'show_tagcloud'         => ( isset( $tax_fields['show_tagcloud'] ) )         ? $tax_fields['show_tagcloud']         : true,

        	'meta_box_cb'           => ( isset( $tax_fields['meta_box_cb'] ) )           ? $tax_fields['meta_box_cb']           : null,

        	'show_admin_column'     => ( isset( $tax_fields['show_admin_column'] ) )     ? $tax_fields['show_admin_column']     : true,

        	'show_in_quick_edit'    => ( isset( $tax_fields['show_in_quick_edit'] ) )    ? $tax_fields['show_in_quick_edit']    : true,

        	'update_count_callback' => ( isset( $tax_fields['update_count_callback'] ) ) ? $tax_fields['update_count_callback'] : '',

        	'show_in_rest'          => ( isset( $tax_fields['show_in_rest'] ) )          ? $tax_fields['show_in_rest']          : true,

        	'rest_base'             => $tax_fields['taxonomy'],

        	'rest_controller_class' => ( isset( $tax_fields['rest_controller_class'] ) ) ? $tax_fields['rest_controller_class'] : 'WP_REST_Terms_Controller',

        	'query_var'             => $tax_fields['taxonomy'],

        	'rewrite'               => ( isset( $tax_fields['rewrite'] ) )               ? $tax_fields['rewrite']               : true,

        	'sort'                  => ( isset( $tax_fields['sort'] ) )                  ? $tax_fields['sort']                  : '',

        );



        $args = apply_filters( $tax_fields['taxonomy'] . '_args', $args );



        register_taxonomy( $tax_fields['taxonomy'], $tax_fields['post_types'], $args );



    }

}

if ( !function_exists('restu_assign_capabilities') ) {

	function restu_assign_capabilities( $caps_map, $users  ) {



        foreach ( $users as $user ) {



            $user_role = get_role( $user );



            foreach ( $caps_map as $cap_map_key => $capability ) {



                $user_role->add_cap( $capability );



            }



        }



    }

}